unit acrACR;

interface
uses
     TossAPI,

     PlugAPI,
     PlugSIDE,

     acrCmn,
     acrAnn,
     acrAPI,

     jtMHLcmn;

procedure AutoCreateLast(var Block: TTosserAutoCreateBlock);

implementation

{ AutoCreateLast }

procedure AutoCreateLast(var Block: TTosserAutoCreateBlock);
 var
  st, Masks, Area, LinkArea: Pointer;
  Format: TAreaFormat;
  AreaName: String;
  Address: TAddress;
  Subscribes: PAutoCreateSubscribes;
 procedure PerformSubscribe(const Subscribe: PAutoCreateSubscribe); far;
  var
   Link, LinkArea: Pointer;
  begin
   if not jt.list.ex.Check(Subscribe^.List, AreaName) then
    Exit;

   Link:=jt.link.Seek(Subscribe^.Address);

   if (Link <> nil) and (Link <> Block.Link) then
    begin
     LinkArea:=jt.link.CreateLinkArea(Link, Area);

     jt.link.area.SetReadable(LinkArea, True);
     jt.link.area.SetWriteable(LinkArea, True);
     jt.link.area.SetSubscribed(LinkArea, True);

     jt.LogWrite(acrLetter, AreaName + ': ' + AddressToStrEx(Subscribe^.Address) + ' autosubscribed');
    end;
  end;
 begin
  if Block.Link = nil then
   Exit;

  jt.link.GetAddress(Block.Link, Address);

  Debugger.Log('got message from ' + AddressToStrEx(Address) + ' to ' + jt.msg.GetArea(Block.msg)^);

  st:=jt.link.st(Block.Link);

  if not LongBool(jt.st.Get(st, acrAutoCreate)) then
   begin
    Debugger.Log('autocreate disabled for ' + AddressToStrEx(Address));

    Exit;
   end;

  Format:=PAreaFormat(jt.st.Get(st, acrAutoCreateFormat))^;

  Masks:=jt.st.Get(st, acrAutoCreateMasks);

  if (Masks <> nil) and not jt.list.ex.Check(Masks, jt.msg.GetArea(Block.msg)^) then
   begin
    Debugger.Log('autocreate disabled for ' + jt.msg.GetArea(Block.msg)^ + ' from ' + AddressToStrEx(Address));

    Exit;
   end;

  { create the area }

  PrepareAreaFormat(Format, jt.msg.GetArea(Block.msg)^, @Address);

  Debugger.Log('calculated area path for ' + jt.msg.GetArea(Block.msg)^ + ': ' + Format.Path);

  Area:=jt.area.Create(jt.msg.GetArea(Block.msg)^, @Format);

  AreaName:=jt.area.GetName(Area)^;

  Debugger.Log('created area ' + AreaName + ', setting it up');

  { setting it up }

  jt.area.SetUplink(Area, Address);

  Block.Area:=Area;
  Block.Done:=True;

  LinkArea:=jt.link.CreateLinkArea(Block.Link, Area);

  jt.link.area.SetReadable(LinkArea, True);
  jt.link.area.SetWriteable(LinkArea, True);
  jt.link.area.SetSubscribed(LinkArea, True);

  jt.area.SetChanged(acfFull, 'acr/area created');
  jt.link.SetChanged(lcfFull, 'acr/area created');

  jt.LogWrite(acrLetter, AreaName + ': created by ' + AddressToStrEx(Address));

  Debugger.Log('performing subscribes to ' + AreaName);

  Subscribes:=jt.st.Get(jt.link.st(Block.Link), acrAutoCreateSubscribes);

  if Subscribes <> nil then
   Subscribes^.ForEach(@PerformSubscribe);

  { writing announce }

  Debugger.Log('writing announce of ' + AreaName);

  AddAnnounce(Area, Address, Format);
 end;

end.