unit acrAnn;

interface
uses
     Objects,

     PlugAPI,
     PlugSIDE,

     RStream,
     Thunks,

     acrCmn,
     annAPI,

     jtMHLcmn,

     Wizard;

procedure AddAnnounce(const Area: Pointer; Uplink: TAddress; const Format: TAreaFormat);

procedure ProcessFirstAnnounce(const Block: TProcessAnnounceFirstBlock);
procedure ProcessAnnounce(const Block: TProcessAnnounceBlock);
procedure ProcessLastAnnounce(const Block: TProcessAnnounceLastBlock);

implementation

{ AddAnnounce }

procedure AddAnnounce(const Area: Pointer; Uplink: TAddress; const Format: TAreaFormat);
 var
  Stream: PStream;
  Passthrough: System.Boolean;
 begin
  Stream:=New(PRamStream, Init);

  Stream^.WriteStr(jt.area.GetName(Area));
  Stream^.Write(Uplink, SizeOf(Uplink));

  Passthrough:=Format.Format = afPassthrough;

  Stream^.Write(Passthrough, SizeOf(Passthrough));

  AddAnnounceRecord('AreaCreated', Stream);

  Dispose(Stream, Done);
 end;

{ ProcessFirstAnnounce }

procedure ProcessFirstAnnounce(const Block: TProcessAnnounceFirstBlock);
 begin
  if Block.Count = 1 then
   jt.msg.SetSubject(Block.msg, 'area created')
  else
   jt.msg.SetSubject(Block.msg, Long2Str(Block.Count) + ' areas created');

  jt.msg.Add(Block.msg, '');
  jt.msg.Add(Block.msg, ' Action     Name                                                            By');
  jt.msg.Add(Block.msg, ' ---------- ------------------------------------------------- ----------------');
 end;

{ ProcessAnnounce }

procedure ProcessAnnounce(const Block: TProcessAnnounceBlock);
 var
  Stream: PRamStream;
  Area: PString;
  Address: TAddress;
  Passthrough: System.Boolean;
  S: String;
 begin
  Stream:=New(PRamStream, Init);

  jt.rf.Get(Block.rf, Block.ResourceName^, Stream, StreamLinker);

  Stream^.Seek(0);

  Area:=Stream^.ReadStr;

  Stream^.Read(Address, SizeOf(Address));
  Stream^.Read(Passthrough, SizeOf(Passthrough));

  Dispose(Stream, Done);

  if Passthrough then
   S:=' created PT '
  else
   S:=' created    ';

  S:=S +
     Pad(Area^, 49) + ' ' +
     LeftPad(AddressToStrEx(Address), 16);

  jt.msg.Add(Block.msg, S);

  DisposeStr(Area);
 end;

{ ProcessLastAnnounce }

procedure ProcessLastAnnounce(const Block: TProcessAnnounceLastBlock);
 begin
  jt.msg.Add(Block.msg, '');
 end;

end.