unit acrAPI;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,

     jtMHLcmn;

type
 PacrPrepareAreaFormatBlock = ^TacrPrepareAreaFormatBlock;
 TacrPrepareAreaFormatBlock = packed record
  Format: PAreaFormat;
  AreaName: PString;
  LinkAddress: PAddress
 end;

const
 acrcPrepareAreaFormat = $1500;

function acrAvailable: Boolean;
procedure acrPrepareAreaFormat(var Format: TAreaFormat; const AreaName: String; const LinkAddress: PAddress);

implementation

{ acrAvailable }

function acrAvailable: Boolean;
 begin
  acrAvailable:=jt.plugs.Seek('AutoCreator') <> nil;
 end;

{ acrPrepareAreaFormat }

procedure acrPrepareAreaFormat(var Format: TAreaFormat; const AreaName: String; const LinkAddress: PAddress);
 var
  Plugin: Pointer;
  PluginHandleCommand: TPluginHandleCommand;
  Block: TacrPrepareAreaFormatBlock;
 begin
  Plugin:=jt.plugs.Seek('AutoCreator');

  if Plugin = nil then
   jt.LogWrite('?', 'no AutoCreator loaded, acrPrepareAreaFormat failed')
  else
   begin
    jt.plugs.GetPluginHandleCommand(Plugin, PluginHandleCommand);

    Block.Format:=@Format;
    Block.AreaName:=@AreaName;
    Block.LinkAddress:=LinkAddress;

    PluginHandleCommand(acrcPrepareAreaFormat, Longint(@Block));
   end;
 end;

end.