unit aeGolded;

interface
uses
     Objects,

     PlugAPI,
     PlugSIDE,

     jtmhlCmn,
     aeCmn;

type
 PGoldedExporter = ^TGoldedExporter;
 TGoldedExporter = object(TExporter)
  procedure PerformArea(const Area: Pointer; const Format: TAreaFormat); virtual;
  function Name: String; virtual;
 end;

implementation
uses
     mbAPI;

{ TGoldedExporter }

procedure TGoldedExporter.PerformArea(const Area: Pointer; const Format: TAreaFormat);
 var
  Aka: TAddress;
  mbi: PMessageBaseInterface;
  S: String;
 begin
  mbi:=jt.area.mbi(Area);

  if mbi^.AreaType = atPassthrough then
   Exit;

  S:='AreaDef ' + GetAreaName(Area) + ' "' + GetAreaDesc(Area) + '" ' + GetAreaGroup(Area) + ' ';

  case Format.Style of
   asNetmail: S:=S + 'Net ';
   asEchomail: S:=S + 'Echo ';
   asLocal: S:=S + 'Local ';
  end;

  S:=S + mbi^.FullName^ + ' ';

  if Pos(' ', Format.Path) > 0 then
   S:=S + '"' + Format.Path + '"'
  else
   S:=S + Format.Path;

  if Format.Style <> asNetmail then
   begin
    jt.area.GetAka(Area, Aka);

    S:=S + ' ' + AddressToStrEx(Aka);
   end;

  WriteLn(Link, S);
 end;

function TGoldedExporter.Name: String;
 begin
  Name:='GoldEd';
 end;

end.