unit aeSquish;

interface
uses
     Objects,

     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     jtmhlCmn,
     aeCmn;

type
 PSquishExporter = ^TSquishExporter;
 TSquishExporter = object(TExporter)
  procedure Valid(const Linker: Pointer); virtual;
 public
  procedure PerformArea(const Area: Pointer; const Format: TAreaFormat); virtual;
  function Name: String; virtual;
 end;

implementation
uses
     mbAPI;

{ TSquishExporter }

procedure TSquishExporter.Valid(const Linker: Pointer);
 var
  ValidFormats: PNumbers;
 procedure Add(const AreaType: Longint);
  var
   id: Longint;
   mbi: PMessageBaseInterface;
  begin
   id:=0;

   repeat
    mbi:=jt.core.mbi(id);

    if (mbi <> nil) and (mbi^.AreaType = AreaType) then
     ValidFormats^.Add(id);

    Inc(id);
   until mbi = nil;
  end;
 begin
  inherited Valid(Linker);

  Styles:=Styles and (asNetmail or asEchomail or asLocal);

  ValidFormats:=New(PNumbers, Init($10, $10));

  Add(atMSG);
  Add(atSquish);
  Add(atPassthrough);

  Formats^.Intersect(ValidFormats);

  Dispose(ValidFormats, Done);
 end;

{ public methods }

procedure TSquishExporter.PerformArea(const Area: Pointer; const Format: TAreaFormat);
 var
  S: String;
  Aka: TAddress;
  mbi: PMessageBaseInterface;
 begin
  case Format.Style of
   asNetmail: S:='NetArea ';
   asEchomail: S:='EchoArea ';
   asLocal: S:='LocalArea ';
  end;

  S:=Concat(S, GetAreaName(Area), ' ', Format.Path);

  mbi:=jt.area.mbi(Area);

  if (mbi^.AreaType = atSquish) or (mbi^.AreaType = atPassthrough) then
   begin
    S:=Concat(S, ' -$');

    if mbi^.AreaType = afPassthrough then
     S:=Concat(S, ' -0');

    jt.area.GetAka(Area, Aka);

    S:=Concat(S, ' -p', AddressToStrEx(Aka));
   end;

  WriteLn(Link, S);
 end;

function TSquishExporter.Name: String;
 begin
  Name:='Squish';
 end;

end.