unit aeUni;

interface
uses
     Objects,

     PlugAPI,
     PlugSIDE,

     Wizard,

     jtmhlCmn,
     aeCmn;

type
 PUniformExporter = ^TUniformExporter;
 TUniformExporter = object(TExporter)
  Template: PString;

  destructor Done; virtual;
 public
  procedure Parse(const Keyword: String; Value: String; const Linker: Pointer); virtual;
 public
  procedure PerformArea(const Area: Pointer; const Format: TAreaFormat); virtual;
  function Name: String; virtual;
 end;

implementation
uses
     mbAPI;

{ TUniformExporter }

destructor TUniformExporter.Done;
 begin
  DisposeStr(Template);

  inherited Done;
 end;

{ public methods }

procedure TUniformExporter.Parse(const Keyword: String; Value: String; const Linker: Pointer);
 begin
  if Keyword = 'TEMPLATE' then
   if Template = nil then
    Template:=NewStr(jt.linker.ParseStringToken(Linker, Value))
   else
    jt.linker.Error(Linker, 'redefinition of TEMPLATE')
  else
   inherited Parse(Keyword, Value, Linker);
 end;

{ public methods }

procedure TUniformExporter.PerformArea(const Area: Pointer; const Format: TAreaFormat);
 const
  Junk: String[1] = '';
 function AreaStyle(const Netmail, Echomail, Local: String): PString;
  begin
   case Format.Style of
    asNetmail     : AreaStyle:=@Netmail;
    asEchomail    : AreaStyle:=@Echomail;
    asLocal       : AreaStyle:=@Local;
   else
    AreaStyle:=@Junk;
   end;
  end;
 function AreaFormat(const Jam, Squish, MSG, Passthrough: String): PString;
  begin
   case PMessageBaseInterface(jt.area.mbi(Area))^.AreaType of
    atJam         : AreaFormat:=@Jam;
    atSquish      : AreaFormat:=@Squish;
    atMSG         : AreaFormat:=@MSG;
    atPassthrough : AreaFormat:=@Passthrough;
   else
    AreaFormat:=@Junk;
   end;
  end;
 var
  Aka: TAddress;
  S: String;
 begin
  jt.area.GetAka(Area, Aka);

  S:=Template^;

  ReplaceEx(S, '@type1', AreaStyle('Netmail', 'Echomail', 'Local')^);
  ReplaceEx(S, '@type2', AreaStyle('Net', 'Echo', 'Local')^);
  ReplaceEx(S, '@type3', AreaStyle('N', 'E', 'L')^);
  ReplaceEx(S, '@name', GetAreaName(Area));
  ReplaceEx(S, '@loname', StLocase(GetAreaName(Area)));
  ReplaceEx(S, '@desc', GetAreaDesc(Area));
  ReplaceEx(S, '@format1', AreaFormat('Jam', 'Squish', '*.MSG', 'Passthrough')^);
  ReplaceEx(S, '@format2', AreaFormat('Jam', 'Squish', 'MSG', 'PT')^);
  ReplaceEx(S, '@format3', AreaFormat('J', 'S', 'M', 'P')^);
  ReplaceEx(S, '@format4', AreaFormat('!', '$', '', '')^);
  ReplaceEx(S, '@format5', AreaFormat('!', '$', '', 'P ')^);
  ReplaceEx(S, '@path', Format.Path);
  ReplaceEx(S, '@shortpath', jt.MakeShortName(Format.Path));
  ReplaceEx(S, '@group', GetAreaGroup(Area));
  ReplaceEx(S, '@aka1', AddressToStrEx(Aka));

  if Format.Style = asNetmail then
   ReplaceEx(S, '@aka2', '')
  else
   ReplaceEx(S, '@aka2', AddressToStrEx(Aka));

  WriteLn(Link, S);
 end;

function TUniformExporter.Name: String;
 begin
  Name:='Uniform';
 end;

end.