unit AnnAPI;

interface
uses
     Thunks,

     PlugAPI,
     PlugSIDE,

     jtMHLcmn,

     Objects;

const
 { // these messages handling by Announcer }

 AnnouncerRegisterAnnounceType          = $2000;
 AnnouncerGetRF                         = $2100;

 { // these messages sent to plugin }

 AnnouncerProcessFirst                  = $3000;
 AnnouncerProcess                       = $3001;
 AnnouncerProcessLast                   = $3002;

type
 PRegisterAnnounceTypeBlock = ^TRegisterAnnounceTypeBlock;
 TRegisterAnnounceTypeBlock = packed record
  Plugin: Pointer;
  Name: PString;
 end;

 PProcessAnnounceFirstBlock = ^TProcessAnnounceFirstBlock;
 TProcessAnnounceFirstBlock = packed record
  Name: PString;
  msg: Pointer;
  Count: Longint;
 end;

 PProcessAnnounceBlock = ^TProcessAnnounceBlock;
 TProcessAnnounceBlock = packed record
  Name: PString;
  msg: Pointer;
  ResourceName: PString;
  rf: Pointer;
  This, Count: Longint;
 end;

 PProcessAnnounceLastBlock = ^TProcessAnnounceLastBlock;
 TProcessAnnounceLastBlock = packed record
  Name: PString;
  msg: Pointer;
  Count: Longint;
 end;

function InitAnnouncerAPI: Boolean;

procedure RegisterAnnounceType(const Plugin: Pointer; const Name: String);

function AddAnnounceRecord(const Name: String; const Stream: PStream): Boolean;

implementation

const
 AnnouncerHandleCommand: TPluginHandleCommand = nil;

{ InitAnnouncerAPI }

function InitAnnouncerAPI: Boolean;
 var
  Plugin: Pointer;
 begin
  Plugin:=jt.plugs.Seek('Announcer');

  if Plugin = nil then
   InitAnnouncerAPI:=False
  else
   begin
    jt.plugs.GetPluginHandleCommand(Plugin, AnnouncerHandleCommand);

    InitAnnouncerAPI:=@AnnouncerHandleCommand <> nil;
   end;
 end;

{ RegisterAnnounceType }

procedure RegisterAnnounceType(const Plugin: Pointer; const Name: String);
 var
  Block: TRegisterAnnounceTypeBlock;
 begin
  if @AnnouncerHandleCommand <> nil then
   begin
    Block.Plugin:=Plugin;
    Block.Name:=@Name;

    AnnouncerHandleCommand(AnnouncerRegisterAnnounceType, Longint(@Block));
   end;
 end;

{ AddAnnounceRecord }

function AddAnnounceRecord(const Name: String; const Stream: PStream): Boolean;
 var
  rf: Pointer;
 begin
  if @AnnouncerHandleCommand <> nil then
   begin
    AnnouncerHandleCommand(AnnouncerGetRF, Longint(@rf));

    AddAnnounceRecord:=jt.rf.Add(rf, Name + '.' + GenerateMSGID, Stream, StreamLinker);
   end
  else
   AddAnnounceRecord:=True;
 end;

end.