unit afxCmn;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,

     afxAPI,
     ccAPI,

     Wizard;

const
 afxScanArea                    : Pointer       = nil; { Area }
 afxReplyToArea                 : Pointer       = nil; { Area }
 afxRespondTo                   : Pointer       = nil; { RegExp }
 afxHelpTemplate                : String        = '';
 afxKillRequests                : Boolean       = False;
 afxKillReplies                 : Boolean       = False;
 afxCatchNetmail                : Boolean       = False;

 afxName                        : String        = 'Areafix';

var
 Callbacks                      : array[TAreafixAction] of PCallbacks;

 ccafBeforeProcess              : PccHook;
 ccafProcessLine                : PccHook;
 ccafPostReply                  : PccHook; { msg, msgp }

type
 PAreasGroupTitle = ^TAreasGroupTitle;
 TAreasGroupTitle = object(TObject)
  Group: Char;
  Title: PString;

  constructor Init(const AGroup: Char; const ATitle: String);
  destructor Done; virtual;
 end;

 PAreasGroupTitles = ^TAreasGroupTitles;
 TAreasGroupTitles = object(TSortedCollection)
  function Compare(Key1, Key2: Pointer): xInteger; virtual;
  function KeyOf(Item: Pointer): Pointer; virtual;
 end;

const
 AreasGroupTitles       : PAreasGroupTitles     = nil;

 restGroup              : Pointer               = nil; { restriction }
 restDefaultDesc        : Pointer               = nil; { restriction }
 restNotOperable        : Pointer               = nil; { restriction }
 restHide               : Pointer               = nil; { restriction }
 restNoSubscribe        : Pointer               = nil; { restriction }
 restNoUnsubscribe      : Pointer               = nil; { restriction }
 restNoPAUSE            : Pointer               = nil; { restriction }
 restNoRESUME           : Pointer               = nil; { restriction }
 restNoLIST             : Pointer               = nil; { restriction }
 restNoFLIST            : Pointer               = nil; { restriction }
 restNoLINKED           : Pointer               = nil; { restriction }
 restNoUNLINKED         : Pointer               = nil; { restriction }
 restNoSETINP           : Pointer               = nil; { restriction }
 restNoSETOUTP          : Pointer               = nil; { restriction }
 restNoSETAFXP          : Pointer               = nil; { restriction }
 restNoSETMPS           : Pointer               = nil; { restriction }
 restNoSETMBS           : Pointer               = nil; { restriction }
 restNoRECIPIENT        : Pointer               = nil; { restriction }

procedure afxGroupValueParser(const Keyword, Linker, st: Pointer; Value: String); export;

function stAreafixReply(const Action: TStorageAction; const Data: Pointer): Pointer; export;

implementation
uses
     afxCore;

{ TAreasGroupTitle }

constructor TAreasGroupTitle.Init(const AGroup: Char; const ATitle: String);
 begin
  inherited Init;

  Group:=AGroup;
  Title:=NewStr(ATitle);
 end;

destructor TAreasGroupTitle.Done;
 begin
  DisposeStr(Title);

  inherited Done;
 end;

{ TAreasGroupTitles }

function TAreasGroupTitles.Compare(Key1, Key2: Pointer): xInteger;
 var
  K1: PChar absolute Key1;
  K2: PChar absolute Key2;
 begin
  if K1[0] < K2[0] then Compare:=-1 else
  if K1[0] > K2[0] then Compare:=1 else
   Compare:=0;
 end;

function TAreasGroupTitles.KeyOf(Item: Pointer): Pointer;
 begin
  KeyOf:=@PAreasGroupTitle(Item)^.Group;
 end;

{ afxGroupValueParser }

procedure afxGroupValueParser(const Keyword, Linker, st: Pointer; Value: String);
 begin
  if Length(Value) <> 1 then
   jt.linker.Error(Linker, 'afxGroup value must be single char');

  jt.st.Add(st, 'Group', Pointer(Value[1]), nil);
 end;

{ stAreafixReply }

function stAreafixReply(const Action: TStorageAction; const Data: Pointer): Pointer;
 var
  Parser: PAreafixParser;
 begin
  case Action of
   saDestroy: AreafixParser^.PostReply(Data);
   saClone: stAreafixReply:=nil;
   saInfo: stAreafixReply:=jt.NewStr('afxreplymsg');
  end;
 end;

end.