unit afxDisp;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,

     afxCmn,
     afxAPI,

     Wizard;

type
 PCommandHandler = ^TCommandHandler;
 TCommandHandler = object(TObject)
  Command: PString;
  Handler: TAreafixCommandHandler;

  constructor Init(const ACommand: String; const AHandler: TAreafixCommandHandler);
  destructor Done; virtual;
 end;

 PCommandHandlers = ^TCommandHandlers;
 TCommandHandlers = object(TStringCollection)
  procedure FreeItem(Item: Pointer); virtual;
  function KeyOf(Item: Pointer): Pointer; virtual;
 end;

const
 CommandHandlers                : PCommandHandlers      = nil;

implementation

{ TCommandHandler }

constructor TCommandHandler.Init(const ACommand: String; const AHandler: TAreafixCommandHandler);
 begin
  inherited Init;

  Command:=NewStr(ACommand);
  Handler:=AHandler;
 end;

destructor TCommandHandler.Done;
 begin
  DisposeStr(Command);

  inherited Done;
 end;

{ TCommandHandlers }

procedure TCommandHandlers.FreeItem(Item: Pointer);
 begin
  TCollection.FreeItem(Item);
 end;

function TCommandHandlers.KeyOf(Item: Pointer): Pointer;
 begin
  KeyOf:=PCommandHandler(Item)^.Command;
 end;

end.