unit afxRight;

interface
uses
     PlugAPI,
     PlugSIDE,

     jtMHLcmn,

     afxCmn,

     Wizard;

function IsOperable(const Area: Pointer): Boolean;
function IsShowable(const Link, Area: Pointer): Boolean;

function IsSubscribeable(const Link, Area: Pointer): Boolean;
function IsUnsubscribeable(const Link, Area: Pointer): Boolean;

function AllowPAUSE(const Link, Area: Pointer): Boolean;
function AllowRESUME(const Link, Area: Pointer): Boolean;
function AllowLIST(const Link: Pointer): Boolean;
function AllowFLIST(const Link: Pointer): Boolean;
function AllowLINKED(const Link: Pointer): Boolean;
function AllowUNLINKED(const Link: Pointer): Boolean;
function AllowRECIPIENT(const Address: PAddress): Boolean;

function GetAreaDescription(const Area: Pointer): String;

function GetAreafixName: String;

implementation

{ CheckArea }

function CheckArea(const Restriction, Area: Pointer): Boolean;
 begin
  CheckArea:=jt.rests.Check(Restriction, nil, jt.area.GetName(Area));
 end;

{ CheckLinkArea }

function CheckLinkArea(const Restriction, Link, Area: Pointer): Boolean;
 var
  Address: TAddress;
 begin
  jt.link.GetAddress(Link, Address);

  CheckLinkArea:=jt.rests.Check(Restriction, @Address, jt.area.GetName(Area));
 end;

{ CheckLink }

function CheckLink(const Restriction, Link: Pointer): Boolean;
 var
  Address: TAddress;
 begin
  jt.link.GetAddress(Link, Address);

  CheckLink:=jt.rests.Check(Restriction, @Address, nil);
 end;

{ IsOperable }

function IsOperable(const Area: Pointer): Boolean;
 var
  Format: TAreaFormat;
 begin
  jt.area.GetFormat(Area, Format);

  IsOperable:=(Format.Style = asEchomail) and not CheckArea(restNotOperable, Area);
 end;

{ IsShowable }

function IsShowable(const Link, Area: Pointer): Boolean;
 begin
  IsShowable:=not CheckLinkArea(restHide, Link, Area);
 end;

{ IsSubscribeable }

function IsSubscribeable(const Link, Area: Pointer): Boolean;
 begin
  IsSubscribeable:=not CheckLinkArea(restNoSubscribe, Link, Area);
 end;

{ IsUnsubscribeable }

function IsUnsubscribeable(const Link, Area: Pointer): Boolean;
 begin
  IsUnsubscribeable:=not CheckLinkArea(restNoUnsubscribe, Link, Area);
 end;

{ AllowPAUSE }

function AllowPAUSE(const Link, Area: Pointer): Boolean;
 begin
  AllowPAUSE:=not CheckLinkArea(restNoPAUSE, Link, Area);
 end;

{ AllowRESUME }

function AllowRESUME(const Link, Area: Pointer): Boolean;
 begin
  AllowRESUME:=not CheckLinkArea(restNoRESUME, Link, Area);
 end;

{ AllowLIST }

function AllowLIST(const Link: Pointer): Boolean;
 begin
  AllowLIST:=not CheckLink(restNoLIST, Link);
 end;

{ AllowFLIST }

function AllowFLIST(const Link: Pointer): Boolean;
 begin
  AllowFLIST:=not CheckLink(restNoFLIST, Link);
 end;

{ AllowLINKED }

function AllowLINKED(const Link: Pointer): Boolean;
 begin
  AllowLINKED:=not CheckLink(restNoLINKED, Link);
 end;

{ AllowUNLINKED }

function AllowUNLINKED(const Link: Pointer): Boolean;
 begin
  AllowUNLINKED:=not CheckLink(restNoUNLINKED, Link);
 end;

{ AllowRECIPIENT }

function AllowRECIPIENT(const Address: PAddress): Boolean;
 begin
  AllowRECIPIENT:=not jt.rests.Check(restNoRECIPIENT, Address, nil);
 end;

{ GetAreaDescription }

function GetAreaDescription(const Area: Pointer): String;
 var
  Description: String;
 begin
  GetPStringEx(jt.area.GetDesc(Area), Description);

  if Description = '' then
   jt.rests.GetValue(restDefaultDesc, nil, jt.area.GetName(Area), Description);

  GetAreaDescription:=Description;
 end;

{ GetAreafixName }

function GetAreafixName: String;
 begin
  GetAreafixName:=afxName;
 end;

end.