unit afxUtil;

interface
uses
     PlugAPI,
     PlugSIDE,

     jtMHLcmn,

     afxCmn,
     afxAPI,
     afxRight,

     Wizard;

procedure afxSubHandler(const Command: String; Value: String); export;
procedure afxUnsubHandler(const Command: String; Value: String); export;
procedure afxRecipient(const Command: String; Value: String); export;

implementation

{ afxSubHandler }

procedure afxSubHandler(const Command: String; Value: String);
 begin
  afxPerformSubscribe(Value);
 end;

{ afxUnsubHandler }

procedure afxUnsubHandler(const Command: String; Value: String);
 begin
  afxPerformUnsubscribe(Value);
 end;

{ afxRecipient }

procedure afxRecipient(const Command: String; Value: String);
 var
  Address: TAddress;
  Created: Boolean;
  Reply: Pointer;
 procedure CreateReply;
  begin
   Reply:=afxCreateReply('Recipients', Created);

   if Created then
    begin
     jt.msg.SetSubject(Reply, '%RECIPIENT error');

     afxFixEmptyReply(Reply);
    end;
  end;
 begin
  TrimEx(Value);

  ClearAddress(Address);

  if not StrToAddress(Value, Address) then
   begin
    CreateReply;

    jt.msg.Add(Reply, 'Unable to parse address "' + Value + '"');
   end
  else
   if AllowRECIPIENT(@Address) then
    afxAddRecipient(@Address)
   else
    begin
     CreateReply;

     jt.msg.Add(Reply, 'Sorry, but sending replies to ' + AddressToStrEx(Address) + ' is prohibited');
    end;
 end;

end.