unit bclAPI;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects;

const
 bclcOpen               = $2000;
 bclcQuery              = $2001;
 bclcEnumerate          = $2002;

type
 TBCLEnumerator = function(const Name, Desc: PString; const Param: Pointer): Boolean;

 PBCLOpenBlock = ^TBCLOpenBlock;
 TBCLOpenBlock = packed record
  Link, bcl: Pointer;
 end;

 PBCLQueryBlock = ^TBCLQueryBlock;
 TBCLQueryBlock = packed record
  bcl: Pointer;
  Name: PString;
  Desc: PString;
  Did: Boolean;
 end;

 PBCLEnumerateBlock = ^TBCLEnumerateBlock;
 TBCLEnumerateBlock = packed record
  bcl: Pointer;
  Enumerator: TBCLEnumerator;
  Param: Pointer;
 end;

function bclOpen(const Link: Pointer): Pointer;
function bclQuery(const bcl: Pointer; const Name: String; var Desc: String): Boolean;
procedure bclEnumerate(const bcl: Pointer; const Enumerator: TBCLEnumerator; const Param: Pointer);

implementation

const
 HandleCommand          : TPluginHandleCommand          = nil;

{ FixPlugin }

function FixPlugin: Boolean;
 var
  Plugin: Pointer;
 begin
  if @HandleCommand <> nil then
   FixPlugin:=True
  else
   begin
    Plugin:=jt.plugs.Seek('BCL');

    if Plugin <> nil then
     begin
      jt.plugs.GetPluginHandleCommand(Plugin, HandleCommand);

      FixPlugin:=@HandleCommand <> nil;
     end
    else
     FixPlugin:=False;
   end;
 end;

{ bclOpen }

function bclOpen(const Link: Pointer): Pointer;
 var
  Block: TBCLOpenBlock;
 begin
  if FixPlugin then
   begin
    Block.Link:=Link;

    HandleCommand(bclcOpen, Longint(@Block));

    bclOpen:=Block.bcl;
   end
  else
   bclOpen:=nil;
 end;

{ bclQuery }

function bclQuery(const bcl: Pointer; const Name: String; var Desc: String): Boolean;
 var
  Block: TBCLQueryBlock;
 begin
  if FixPlugin then
   begin
    Block.bcl:=bcl;
    Block.Name:=@Name;
    Block.Desc:=@Desc;

    HandleCommand(bclcQuery, Longint(@Block));

    bclQuery:=Block.Did;
   end
  else
   bclQuery:=False;
 end;

{ bclEnumerate }

procedure bclEnumerate(const bcl: Pointer; const Enumerator: TBCLEnumerator; const Param: Pointer);
 var
  Block: TBCLEnumerateBlock;
 begin
  if FixPlugin then
   begin
    Block.bcl:=bcl;
    Block.Enumerator:=Enumerator;
    Block.Param:=Param;

    HandleCommand(bclcEnumerate, Longint(@Block));
   end;
 end;

end.