unit bclAuto;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     bclAcc,
     bclCmn,

     jtMHLcmn,

     afxAPI,

     Wizard;

procedure SendAutoBCL;

implementation

{ SendAutoBCL }

procedure SendAutoBCL;
 var
  K, L, This, Days, AutoBCLLast: Longint;
  DT: TDateTime;
  Area, Link, st, msg, msgp: Pointer;
  FromAddress, ToAddress: TAddress;
  Writer: PBCLWriter;
  FName: String;
  Stream: PStream;
 begin
  jt.PushTitle;

  GetCurrentDateTime(DT);

  This:=GregorianToJulian(DT);

  for K:=0 to jt.link.Count - 1 do
   begin
    Link:=jt.link.At(K);

    st:=jt.link.st(Link);

    Days:=Longint(jt.st.Get(st, 'BCL.AutoBCL'));

    if Days = 0 then
     Continue;

    UnixDateTimeToDateTime(Longint(jt.st.Get(st, 'BCL.AutoBCLLast')), DT);

    if This - GregorianToJulian(DT) < Days then
     Continue;

    repeat
     FName:=jt.core.GetTempAttaches + GenerateMSGID + '.bcl';
    until not ExistFile(FName);

    Stream:=New(PBufStream, Init(FName, stCreate, 32768));

    if Stream^.Status <> stOk then
     begin
      jt.Report('Unable to create ' + FName + ', rc=' + Long2Str(Stream^.Status), True);

      Dispose(Stream, Done);

      Continue;
     end;

    msg:=jt.msg.Create;

    jt.st.Add(jt.msg.st(msg), 'Source', Pointer(tsLocalInbound), nil);

    jt.msg.SetFromName(msg, 'AutoBCL');
    jt.msg.SetToName(msg, 'Sysop');
    jt.msg.SetSubject(msg, FName);
    jt.msg.SetAttributes(msg, maPrivate or maKill or maAttach);
    jt.msg.SetArea(msg, jt.area.GetName(jt.area.SeekNetmail)^);

    jt.link.GetAddress(Link, ToAddress);

    jt.GetNetmailAka(ToAddress, FromAddress);

    msgp:=jt.msg.CreateParser(msg, True);

    jt.msg.p.SetFromAndToAddress(msgp, FromAddress, ToAddress, True);
    jt.msg.p.AddKludge(msgp, #1'FLAGS KFS');

    jt.msg.DestroyParser(msgp);

    jt.SetStatus('creating AutoBCL to ' + AddressToStrEx(ToAddress));
    jt.SetTitle(AddressToStrEx(ToAddress) + ' (creating AutoBCL)');

    jt.LogWrite('B', 'Creating AutoBCL to ' + AddressToStrEx(ToAddress) + ' (' + FName + ')');

    Writer:=New(PBCLWriter, Init(Stream, afxGetName, AddressToStrEx(FromAddress), bmList));

    for L:=0 to jt.area.Count - 1 do
     begin
      Area:=jt.area.At(L);

      if afxIsOperable(Area) and afxIsShowable(Link, Area) then
       Writer^.Add(bifMailarea, jt.area.GetName(Area)^, GetPString(jt.area.GetDesc(Area)), '');
     end;

    Dispose(Writer, Done);

    Dispose(Stream, Done);

    jt.tossscan.TossMessage(msg);

    GetCurrentDateTime(DT);

    DateTimeToUnixDateTime(DT, AutoBCLLast);

    jt.st.Add(st, 'BCL.AutoBCLLast', Pointer(AutoBCLLast), nil);

    jt.link.SetChanged(lcfChanged, 'bcl/autobcl');
   end;

  jt.ClearStatus;

  jt.PopTitle;
 end;

end.