unit ccDepend;

interface

type
 TDebugger = object
  Enabled: Boolean;
  Prefix: String[20];

  procedure Log(const Message: String);
 end;

procedure depReset;

procedure depError(const Message: String);
procedure depWarning(const Message: String);

function  depStackOverflow: Boolean;

implementation
uses
     PlugAPI,
     PlugSIDE;

const
 StackOverflowed: Boolean = False;

{ TDebugger }

procedure TDebugger.Log(const Message: String);
 begin
  if Enabled then
   jt.LogWrite('C', Prefix + ': ' + Message);
 end;

{ depReset }

procedure depReset;
 begin
  StackOverflowed:=False;
 end;

{ depError }

procedure depError(const Message: String);
 begin
  jt.linker.Error(jt.linker.Stub, Message);
 end;

{ depWarning }

procedure depWarning(const Message: String);
 begin
  jt.LogWrite('?', Message);
 end;

{ depStackOverflow }

function depStackOverflow: Boolean;
 begin
  if (SPtr < $1000) or StackOverflowed then
   begin
    if not StackOverflowed then
     begin
      depWarning('stack overflow');

      StackOverflowed:=True;
     end;

    depStackOverflow:=True;
   end
  else
   depStackOverflow:=False;
 end;

end.