{$IFNDEF VIRTUALPASCAL}
{$D-}
{$ENDIF}
unit ccJTAPI0;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     ccAPI,
     ccAction,
     ccCmn,
     ccCode,
     ccExpr,
     ccJTSupp,
     ccProto,
     ccRoot,
     ccSupp,
     ccToken,

     jtMHLcmn,

     Thunks,

     Wizard;

procedure AddJTAPIProtos(const Target: PActions);

implementation

{ coreGetMainAddress(var A: TAddress); }

type
 PcoreGetMainAddress = ^TcoreGetMainAddress;
 TcoreGetMainAddress = object(TAction)
  _A: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TcoreGetMainAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreGetMainAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _A:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _A^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TcoreGetMainAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __A: PAddress;
 begin
  _A^.Get(Data, __A);

  jt.core.GetMainAddress(__A^);

  Execute:=erOk;
 end;

destructor TcoreGetMainAddress.Done;
 begin
  Dispose(_A, Done);

  inherited Done;
 end;

{ coreGetMainSysop(var S: String); }

type
 PcoreGetMainSysop = ^TcoreGetMainSysop;
 TcoreGetMainSysop = object(TAction)
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TcoreGetMainSysop.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreGetMainSysop', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _S^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TcoreGetMainSysop.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __S: String;
 begin
  _S^.Get(Data, __S);

  jt.core.GetMainSysop(__S);

  _S^.Assign(Data, __S);

  Execute:=erOk;
 end;

destructor TcoreGetMainSysop.Done;
 begin
  Dispose(_S, Done);

  inherited Done;
 end;

{ coreIsOurAddress(var AAddress: TAddress): Boolean; }

type
 PcoreIsOurAddress = ^TcoreIsOurAddress;
 TcoreIsOurAddress = object(TBooleanExpression)
  _AAddress: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcoreIsOurAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreIsOurAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _AAddress^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcoreIsOurAddress.Get(const ExecuteData: PExecuteData; var Value);
 var
  __AAddress: PAddress;
 begin
  _AAddress^.Get(ExecuteData, __AAddress);

  Boolean(Value):=jt.core.IsOurAddress(__AAddress^);
 end;

destructor TcoreIsOurAddress.Done;
 begin
  Dispose(_AAddress, Done);

  inherited Done;
 end;

{ coreGetOrigin: String; }

type
 PcoreGetOrigin = ^TcoreGetOrigin;
 TcoreGetOrigin = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetOrigin.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetOrigin;
 end;

{ coreGetVersion: String; }

type
 PcoreGetVersion = ^TcoreGetVersion;
 TcoreGetVersion = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetVersion.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetVersion;
 end;

{ coreGetBuild: Longint; }

type
 PcoreGetBuild = ^TcoreGetBuild;
 TcoreGetBuild = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetBuild.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.GetBuild);
 end;

{ coreGetTitle: String; }

type
 PcoreGetTitle = ^TcoreGetTitle;
 TcoreGetTitle = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetTitle.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetTitle;
 end;

{ coreGetFullTitle: String; }

type
 PcoreGetFullTitle = ^TcoreGetFullTitle;
 TcoreGetFullTitle = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetFullTitle.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetFullTitle;
 end;

{ coreGetCopyright: String; }

type
 PcoreGetCopyright = ^TcoreGetCopyright;
 TcoreGetCopyright = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetCopyright.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetCopyright;
 end;

{ coreGetTID: String; }

type
 PcoreGetTID = ^TcoreGetTID;
 TcoreGetTID = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetTID.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetTID;
 end;

{ coreGetPID: String; }

type
 PcoreGetPID = ^TcoreGetPID;
 TcoreGetPID = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetPID.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetPID;
 end;

{ coreGetTearline: String; }

type
 PcoreGetTearline = ^TcoreGetTearline;
 TcoreGetTearline = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetTearline.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetTearline;
 end;

{ coreGetTempAttaches: String; }

type
 PcoreGetTempAttaches = ^TcoreGetTempAttaches;
 TcoreGetTempAttaches = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetTempAttaches.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.core.GetTempAttaches;
 end;

{ coreDestroyKernelObject(const AObject: Pointer); }

type
 PcoreDestroyKernelObject = ^TcoreDestroyKernelObject;
 TcoreDestroyKernelObject = object(TAction)
  _AObject: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TcoreDestroyKernelObject.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreDestroyKernelObject', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AObject:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TcoreDestroyKernelObject.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __AObject: Pointer;
 begin
  _AObject^.Get(Data, __AObject);

  jt.core.DestroyKernelObject(__AObject);

  Execute:=erOk;
 end;

destructor TcoreDestroyKernelObject.Done;
 begin
  Dispose(_AObject, Done);

  inherited Done;
 end;

{ coreUTC: Longint; }

type
 PcoreUTC = ^TcoreUTC;
 TcoreUTC = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreUTC.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.UTC);
 end;

{ coreGetInbound(const Index: Longint): PString; }

type
 PcoreGetInbound = ^TcoreGetInbound;
 TcoreGetInbound = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcoreGetInbound.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreGetInbound', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcoreGetInbound.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.core.GetInbound(__Index));
 end;

destructor TcoreGetInbound.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ coreGetBadInbound: PString; }

type
 PcoreGetBadInbound = ^TcoreGetBadInbound;
 TcoreGetBadInbound = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetBadInbound.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.GetBadInbound);
 end;

{ coreGetTempInbound: PString; }

type
 PcoreGetTempInbound = ^TcoreGetTempInbound;
 TcoreGetTempInbound = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetTempInbound.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.GetTempInbound);
 end;

{ coreGetBaseInbound: PString; }

type
 PcoreGetBaseInbound = ^TcoreGetBaseInbound;
 TcoreGetBaseInbound = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetBaseInbound.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.GetBaseInbound);
 end;

{ coreGetLocalInbound: PString; }

type
 PcoreGetLocalInbound = ^TcoreGetLocalInbound;
 TcoreGetLocalInbound = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TcoreGetLocalInbound.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.core.GetLocalInbound);
 end;

{ coreScreenHook(const Plugin: Pointer; const Add: Boolean); }

type
 PcoreScreenHook = ^TcoreScreenHook;
 TcoreScreenHook = object(TAction)
  _Plugin: PNumberExpression;
  _Add: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TcoreScreenHook.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreScreenHook', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Add:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TcoreScreenHook.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  __Add: Boolean;
 begin
  _Plugin^.Get(Data, __Plugin);
  _Add^.Get(Data, __Add);

  jt.core.ScreenHook(__Plugin, 
    __Add);

  Execute:=erOk;
 end;

destructor TcoreScreenHook.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_Add, Done);

  inherited Done;
 end;

{ coreAtFormat(const Index: Longint; var id: Longint; var FullName,
   ShortName: String): Boolean; }

type
 PcoreAtFormat = ^TcoreAtFormat;
 TcoreAtFormat = object(TBooleanExpression)
  _Index: PNumberExpression;
  _id: PNumberExpression;
  _FullName: PStringExpression;
  _ShortName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcoreAtFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreAtFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _id:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _id^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _FullName:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _FullName^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _ShortName:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _ShortName^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcoreAtFormat.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
  __id: Longint;
  __FullName: String;
  __ShortName: String;
 begin
  _Index^.Get(ExecuteData, __Index);
  _id^.Get(ExecuteData, __id);
  _FullName^.Get(ExecuteData, __FullName);
  _ShortName^.Get(ExecuteData, __ShortName);

  Boolean(Value):=jt.core.AtFormat(__Index, 
    __id, 
    __FullName, 
    __ShortName);

  _id^.Assign(ExecuteData, __id);
  _FullName^.Assign(ExecuteData, __FullName);
  _ShortName^.Assign(ExecuteData, __ShortName);
 end;

destructor TcoreAtFormat.Done;
 begin
  Dispose(_Index, Done);
  Dispose(_id, Done);
  Dispose(_FullName, Done);
  Dispose(_ShortName, Done);

  inherited Done;
 end;

{ coreSeekFormat(const id: Longint; var Index: Longint): Boolean; }

type
 PcoreSeekFormat = ^TcoreSeekFormat;
 TcoreSeekFormat = object(TBooleanExpression)
  _id: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcoreSeekFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('coreSeekFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _id:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Index^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcoreSeekFormat.Get(const ExecuteData: PExecuteData; var Value);
 var
  __id: Longint;
  __Index: Longint;
 begin
  _id^.Get(ExecuteData, __id);
  _Index^.Get(ExecuteData, __Index);

  Boolean(Value):=jt.core.SeekFormat(__id, 
    __Index);

  _Index^.Assign(ExecuteData, __Index);
 end;

destructor TcoreSeekFormat.Done;
 begin
  Dispose(_id, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ corembi(const id: Longint): Pointer; }

type
 Pcorembi = ^Tcorembi;
 Tcorembi = object(TNumberExpression)
  _id: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor Tcorembi.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('corembi', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _id:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure Tcorembi.Get(const ExecuteData: PExecuteData; var Value);
 var
  __id: Longint;
 begin
  _id^.Get(ExecuteData, __id);

  Longint(Value):=Longint(jt.core.mbi(__id));
 end;

destructor Tcorembi.Done;
 begin
  Dispose(_id, Done);

  inherited Done;
 end;

{ linkervCreate: Pointer; }

type
 PlinkervCreate = ^TlinkervCreate;
 TlinkervCreate = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlinkervCreate.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.linker.v.Create);
 end;

{ linkervDestroy(const Linker: Pointer); }

type
 PlinkervDestroy = ^TlinkervDestroy;
 TlinkervDestroy = object(TAction)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkervDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkervDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkervDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(Data, __Linker);

  jt.linker.v.Destroy(__Linker);

  Execute:=erOk;
 end;

destructor TlinkervDestroy.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkervResetError(const Linker: Pointer); }

type
 PlinkervResetError = ^TlinkervResetError;
 TlinkervResetError = object(TAction)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkervResetError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkervResetError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkervResetError.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(Data, __Linker);

  jt.linker.v.ResetError(__Linker);

  Execute:=erOk;
 end;

destructor TlinkervResetError.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkervGetError(const Linker: Pointer): String; }

type
 PlinkervGetError = ^TlinkervGetError;
 TlinkervGetError = object(TStringExpression)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkervGetError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkervGetError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkervGetError.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(ExecuteData, __Linker);

  String(Value):=jt.linker.v.GetError(__Linker);
 end;

destructor TlinkervGetError.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkervWasError(const Linker: Pointer): Boolean; }

type
 PlinkervWasError = ^TlinkervWasError;
 TlinkervWasError = object(TBooleanExpression)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkervWasError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkervWasError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkervWasError.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(ExecuteData, __Linker);

  Boolean(Value):=jt.linker.v.WasError(__Linker);
 end;

destructor TlinkervWasError.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkerParseString(const Linker: Pointer; const S: String): String; }

type
 PlinkerParseString = ^TlinkerParseString;
 TlinkerParseString = object(TStringExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseString.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  String(Value):=jt.linker.ParseString(__Linker, 
    __S);
 end;

destructor TlinkerParseString.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseStringToken(const Linker: Pointer; var S: String):
   String; }

type
 PlinkerParseStringToken = ^TlinkerParseStringToken;
 TlinkerParseStringToken = object(TStringExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseStringToken.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseStringToken', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _S^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseStringToken.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  String(Value):=jt.linker.ParseStringToken(__Linker, 
    __S);

  _S^.Assign(ExecuteData, __S);
 end;

destructor TlinkerParseStringToken.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseBoolean(const Linker: Pointer; const S: String): Boolean; }

type
 PlinkerParseBoolean = ^TlinkerParseBoolean;
 TlinkerParseBoolean = object(TBooleanExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseBoolean.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseBoolean', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseBoolean.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  Boolean(Value):=jt.linker.ParseBoolean(__Linker, 
    __S);
 end;

destructor TlinkerParseBoolean.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseAreaStyle(const Linker: Pointer; const S: String; const
   AreaFormat: PAreaFormat); }

type
 PlinkerParseAreaStyle = ^TlinkerParseAreaStyle;
 TlinkerParseAreaStyle = object(TAction)
  _Linker: PNumberExpression;
  _S: PStringExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseAreaStyle.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseAreaStyle', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerParseAreaStyle.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __S: String;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(Data, __Linker);
  _S^.Get(Data, __S);
  _AreaFormat^.Get(Data, __AreaFormat);

  jt.linker.ParseAreaStyle(__Linker, 
    __S, 
    __AreaFormat);

  Execute:=erOk;
 end;

destructor TlinkerParseAreaStyle.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerParseAreaFormat(const Linker: Pointer; const S: String;
   const AreaFormat: PAreaFormat); }

type
 PlinkerParseAreaFormat = ^TlinkerParseAreaFormat;
 TlinkerParseAreaFormat = object(TAction)
  _Linker: PNumberExpression;
  _S: PStringExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerParseAreaFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __S: String;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(Data, __Linker);
  _S^.Get(Data, __S);
  _AreaFormat^.Get(Data, __AreaFormat);

  jt.linker.ParseAreaFormat(__Linker, 
    __S, 
    __AreaFormat);

  Execute:=erOk;
 end;

destructor TlinkerParseAreaFormat.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerParseAreaPath(const Linker: Pointer; const S: String; const
   AreaFormat: PAreaFormat); }

type
 PlinkerParseAreaPath = ^TlinkerParseAreaPath;
 TlinkerParseAreaPath = object(TAction)
  _Linker: PNumberExpression;
  _S: PStringExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseAreaPath.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseAreaPath', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerParseAreaPath.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __S: String;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(Data, __Linker);
  _S^.Get(Data, __S);
  _AreaFormat^.Get(Data, __AreaFormat);

  jt.linker.ParseAreaPath(__Linker, 
    __S, 
    __AreaFormat);

  Execute:=erOk;
 end;

destructor TlinkerParseAreaPath.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerParseSize(const Linker: Pointer; const S: String): Longint; }

type
 PlinkerParseSize = ^TlinkerParseSize;
 TlinkerParseSize = object(TNumberExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  Longint(Value):=Longint(jt.linker.ParseSize(__Linker, 
    __S));
 end;

destructor TlinkerParseSize.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseAreaFlags(const Linker: Pointer; const S: String):
   Longint; }

type
 PlinkerParseAreaFlags = ^TlinkerParseAreaFlags;
 TlinkerParseAreaFlags = object(TNumberExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseAreaFlags.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseAreaFlags', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseAreaFlags.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  Longint(Value):=Longint(jt.linker.ParseAreaFlags(__Linker, 
    __S));
 end;

destructor TlinkerParseAreaFlags.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseNumber(const Linker: Pointer; const S: String): Longint; }

type
 PlinkerParseNumber = ^TlinkerParseNumber;
 TlinkerParseNumber = object(TNumberExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseNumber.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseNumber', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseNumber.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  Longint(Value):=Longint(jt.linker.ParseNumber(__Linker, 
    __S));
 end;

destructor TlinkerParseNumber.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerParseWord(const Linker: Pointer; var Value: String): String; }

type
 PlinkerParseWord = ^TlinkerParseWord;
 TlinkerParseWord = object(TStringExpression)
  _Linker: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseWord.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseWord', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Value^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerParseWord.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __Value: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _Value^.Get(ExecuteData, __Value);

  String(Value):=jt.linker.ParseWord(__Linker, 
    __Value);

  _Value^.Assign(ExecuteData, __Value);
 end;

destructor TlinkerParseWord.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ linkerCreateAreaForward(const AreaName: String; const Area: PPointer;
   const FName: String; const Line: Longint); }

type
 PlinkerCreateAreaForward = ^TlinkerCreateAreaForward;
 TlinkerCreateAreaForward = object(TAction)
  _AreaName: PStringExpression;
  _Area: PNumberExpression;
  _FName: PStringExpression;
  _Line: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerCreateAreaForward.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerCreateAreaForward', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AreaName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerCreateAreaForward.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __AreaName: String;
  __Area: PPointer;
  __FName: String;
  __Line: Longint;
 begin
  _AreaName^.Get(Data, __AreaName);
  _Area^.Get(Data, __Area);
  _FName^.Get(Data, __FName);
  _Line^.Get(Data, __Line);

  jt.linker.CreateAreaForward(__AreaName, 
    __Area, 
    __FName, 
    __Line);

  Execute:=erOk;
 end;

destructor TlinkerCreateAreaForward.Done;
 begin
  Dispose(_AreaName, Done);
  Dispose(_Area, Done);
  Dispose(_FName, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ linkerCreateLinkForward(const Address: TAddress; const Link: PPointer;
   const FName: String; const Line: Longint); }

type
 PlinkerCreateLinkForward = ^TlinkerCreateLinkForward;
 TlinkerCreateLinkForward = object(TAction)
  _Address: PNumberExpression;
  _Link: PNumberExpression;
  _FName: PStringExpression;
  _Line: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerCreateLinkForward.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerCreateLinkForward', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerCreateLinkForward.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Address: PAddress;
  __Link: PPointer;
  __FName: String;
  __Line: Longint;
 begin
  _Address^.Get(Data, __Address);
  _Link^.Get(Data, __Link);
  _FName^.Get(Data, __FName);
  _Line^.Get(Data, __Line);

  jt.linker.CreateLinkForward(__Address^, 
    __Link, 
    __FName, 
    __Line);

  Execute:=erOk;
 end;

destructor TlinkerCreateLinkForward.Done;
 begin
  Dispose(_Address, Done);
  Dispose(_Link, Done);
  Dispose(_FName, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ linkerCreateLinkAreaForward(const Address: TAddress; const AreaName:
   String; const LinkArea: PPointer; const FName: String; const
   Line: Longint); }

type
 PlinkerCreateLinkAreaForward = ^TlinkerCreateLinkAreaForward;
 TlinkerCreateLinkAreaForward = object(TAction)
  _Address: PNumberExpression;
  _AreaName: PStringExpression;
  _LinkArea: PNumberExpression;
  _FName: PStringExpression;
  _Line: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerCreateLinkAreaForward.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerCreateLinkAreaForward', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AreaName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerCreateLinkAreaForward.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Address: PAddress;
  __AreaName: String;
  __LinkArea: PPointer;
  __FName: String;
  __Line: Longint;
 begin
  _Address^.Get(Data, __Address);
  _AreaName^.Get(Data, __AreaName);
  _LinkArea^.Get(Data, __LinkArea);
  _FName^.Get(Data, __FName);
  _Line^.Get(Data, __Line);

  jt.linker.CreateLinkAreaForward(__Address^, 
    __AreaName, 
    __LinkArea, 
    __FName, 
    __Line);

  Execute:=erOk;
 end;

destructor TlinkerCreateLinkAreaForward.Done;
 begin
  Dispose(_Address, Done);
  Dispose(_AreaName, Done);
  Dispose(_LinkArea, Done);
  Dispose(_FName, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ linkerError(const Linker: Pointer; const S: String); }

type
 PlinkerError = ^TlinkerError;
 TlinkerError = object(TAction)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerError.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(Data, __Linker);
  _S^.Get(Data, __S);

  jt.linker.Error(__Linker, 
    __S);

  Execute:=erOk;
 end;

destructor TlinkerError.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerFName(const Linker: Pointer): String; }

type
 PlinkerFName = ^TlinkerFName;
 TlinkerFName = object(TStringExpression)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerFName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerFName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerFName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(ExecuteData, __Linker);

  String(Value):=jt.linker.FName(__Linker);
 end;

destructor TlinkerFName.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkerLine(const Linker: Pointer): Longint; }

type
 PlinkerLine = ^TlinkerLine;
 TlinkerLine = object(TNumberExpression)
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerLine.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerLine', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerLine.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
 begin
  _Linker^.Get(ExecuteData, __Linker);

  Longint(Value):=Longint(jt.linker.Line(__Linker));
 end;

destructor TlinkerLine.Done;
 begin
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ linkerExportLine(const Linker: Pointer; const S: String); }

type
 PlinkerExportLine = ^TlinkerExportLine;
 TlinkerExportLine = object(TAction)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerExportLine.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerExportLine', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerExportLine.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(Data, __Linker);
  _S^.Get(Data, __S);

  jt.linker.ExportLine(__Linker, 
    __S);

  Execute:=erOk;
 end;

destructor TlinkerExportLine.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerUnparseString(const Linker: Pointer; const S: String): String; }

type
 PlinkerUnparseString = ^TlinkerUnparseString;
 TlinkerUnparseString = object(TStringExpression)
  _Linker: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseString.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __S: String;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _S^.Get(ExecuteData, __S);

  String(Value):=jt.linker.UnparseString(__Linker, 
    __S);
 end;

destructor TlinkerUnparseString.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkerUnparseBoolean(const Linker: Pointer; const B: Boolean):
   String; }

type
 PlinkerUnparseBoolean = ^TlinkerUnparseBoolean;
 TlinkerUnparseBoolean = object(TStringExpression)
  _Linker: PNumberExpression;
  _B: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseBoolean.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseBoolean', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _B:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseBoolean.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __B: Boolean;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _B^.Get(ExecuteData, __B);

  String(Value):=jt.linker.UnparseBoolean(__Linker, 
    __B);
 end;

destructor TlinkerUnparseBoolean.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_B, Done);

  inherited Done;
 end;

{ linkerUnparseAreaStyle(const Linker: Pointer; const AreaFormat:
   PAreaFormat): String; }

type
 PlinkerUnparseAreaStyle = ^TlinkerUnparseAreaStyle;
 TlinkerUnparseAreaStyle = object(TStringExpression)
  _Linker: PNumberExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseAreaStyle.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseAreaStyle', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseAreaStyle.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _AreaFormat^.Get(ExecuteData, __AreaFormat);

  String(Value):=jt.linker.UnparseAreaStyle(__Linker, 
    __AreaFormat);
 end;

destructor TlinkerUnparseAreaStyle.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerUnparseAreaFormat(const Linker: Pointer; const AreaFormat:
   PAreaFormat): String; }

type
 PlinkerUnparseAreaFormat = ^TlinkerUnparseAreaFormat;
 TlinkerUnparseAreaFormat = object(TStringExpression)
  _Linker: PNumberExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseAreaFormat.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _AreaFormat^.Get(ExecuteData, __AreaFormat);

  String(Value):=jt.linker.UnparseAreaFormat(__Linker, 
    __AreaFormat);
 end;

destructor TlinkerUnparseAreaFormat.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerUnparseAreaPath(const Linker: Pointer; const AreaFormat:
   PAreaFormat): String; }

type
 PlinkerUnparseAreaPath = ^TlinkerUnparseAreaPath;
 TlinkerUnparseAreaPath = object(TStringExpression)
  _Linker: PNumberExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseAreaPath.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseAreaPath', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseAreaPath.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __AreaFormat: PAreaFormat;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _AreaFormat^.Get(ExecuteData, __AreaFormat);

  String(Value):=jt.linker.UnparseAreaPath(__Linker, 
    __AreaFormat);
 end;

destructor TlinkerUnparseAreaPath.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ linkerUnparseSize(const Linker: Pointer; const Size: Longint):
   String; }

type
 PlinkerUnparseSize = ^TlinkerUnparseSize;
 TlinkerUnparseSize = object(TStringExpression)
  _Linker: PNumberExpression;
  _Size: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Size:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __Size: Longint;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _Size^.Get(ExecuteData, __Size);

  String(Value):=jt.linker.UnparseSize(__Linker, 
    __Size);
 end;

destructor TlinkerUnparseSize.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_Size, Done);

  inherited Done;
 end;

{ linkerUnparseAreaFlags(const Linker: Pointer; const Flags: Longint):
   String; }

type
 PlinkerUnparseAreaFlags = ^TlinkerUnparseAreaFlags;
 TlinkerUnparseAreaFlags = object(TStringExpression)
  _Linker: PNumberExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseAreaFlags.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseAreaFlags', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseAreaFlags.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __Flags: Longint;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _Flags^.Get(ExecuteData, __Flags);

  String(Value):=jt.linker.UnparseAreaFlags(__Linker, 
    __Flags);
 end;

destructor TlinkerUnparseAreaFlags.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ linkerUnparseNumber(const Linker: Pointer; const Number: Longint):
   String; }

type
 PlinkerUnparseNumber = ^TlinkerUnparseNumber;
 TlinkerUnparseNumber = object(TStringExpression)
  _Linker: PNumberExpression;
  _Number: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseNumber.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseNumber', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Number:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseNumber.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __Number: Longint;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _Number^.Get(ExecuteData, __Number);

  String(Value):=jt.linker.UnparseNumber(__Linker, 
    __Number);
 end;

destructor TlinkerUnparseNumber.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_Number, Done);

  inherited Done;
 end;

{ linkerRegisterAreaSectionCallback(const Plugin: Pointer); }

type
 PlinkerRegisterAreaSectionCallback = ^TlinkerRegisterAreaSectionCallback;
 TlinkerRegisterAreaSectionCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerRegisterAreaSectionCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerRegisterAreaSectionCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerRegisterAreaSectionCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.linker.RegisterAreaSectionCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkerRegisterAreaSectionCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkerRegisterLinkSectionCallback(const Plugin: Pointer); }

type
 PlinkerRegisterLinkSectionCallback = ^TlinkerRegisterLinkSectionCallback;
 TlinkerRegisterLinkSectionCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerRegisterLinkSectionCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerRegisterLinkSectionCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerRegisterLinkSectionCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.linker.RegisterLinkSectionCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkerRegisterLinkSectionCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkerParseDateTime(const Linker: Pointer; const Value: String;
   var DT: TDateTime); }

type
 PlinkerParseDateTime = ^TlinkerParseDateTime;
 TlinkerParseDateTime = object(TAction)
  _Linker: PNumberExpression;
  _Value: PStringExpression;
  _DT: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkerParseDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerParseDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _DT:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DT^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkerParseDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Linker: Pointer;
  __Value: String;
  __DT: PDateTime;
 begin
  _Linker^.Get(Data, __Linker);
  _Value^.Get(Data, __Value);
  _DT^.Get(Data, __DT);

  jt.linker.ParseDateTime(__Linker, 
    __Value, 
    __DT^);

  Execute:=erOk;
 end;

destructor TlinkerParseDateTime.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_Value, Done);
  Dispose(_DT, Done);

  inherited Done;
 end;

{ linkerUnparseDateTime(const Linker: Pointer; var DT: TDateTime):
   String; }

type
 PlinkerUnparseDateTime = ^TlinkerUnparseDateTime;
 TlinkerUnparseDateTime = object(TStringExpression)
  _Linker: PNumberExpression;
  _DT: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkerUnparseDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkerUnparseDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DT:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DT^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkerUnparseDateTime.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Linker: Pointer;
  __DT: PDateTime;
 begin
  _Linker^.Get(ExecuteData, __Linker);
  _DT^.Get(ExecuteData, __DT);

  String(Value):=jt.linker.UnparseDateTime(__Linker, 
    __DT^);
 end;

destructor TlinkerUnparseDateTime.Done;
 begin
  Dispose(_Linker, Done);
  Dispose(_DT, Done);

  inherited Done;
 end;

{ linkerStub: Pointer; }

type
 PlinkerStub = ^TlinkerStub;
 TlinkerStub = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlinkerStub.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.linker.Stub);
 end;

{ linkerStubSoft: Pointer; }

type
 PlinkerStubSoft = ^TlinkerStubSoft;
 TlinkerStubSoft = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlinkerStubSoft.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.linker.StubSoft);
 end;

{ linkareaAt(const Link: Pointer; const Index: Longint): Pointer; }

type
 PlinkareaAt = ^TlinkareaAt;
 TlinkareaAt = object(TNumberExpression)
  _Link: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
  __Index: Longint;
 begin
  _Link^.Get(ExecuteData, __Link);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.link.area.At(__Link, 
    __Index));
 end;

destructor TlinkareaAt.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ linkareaCount(const Link: Pointer): Longint; }

type
 PlinkareaCount = ^TlinkareaCount;
 TlinkareaCount = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.area.Count(__Link));
 end;

destructor TlinkareaCount.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkareaGetArea(const LinkArea: Pointer): Pointer; }

type
 PlinkareaGetArea = ^TlinkareaGetArea;
 TlinkareaGetArea = object(TNumberExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaGetArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaGetArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaGetArea.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Longint(Value):=Longint(jt.link.area.GetArea(__LinkArea));
 end;

destructor TlinkareaGetArea.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaIsReadable(const LinkArea: Pointer): Boolean; }

type
 PlinkareaIsReadable = ^TlinkareaIsReadable;
 TlinkareaIsReadable = object(TBooleanExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaIsReadable.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaIsReadable', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaIsReadable.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Boolean(Value):=jt.link.area.IsReadable(__LinkArea);
 end;

destructor TlinkareaIsReadable.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaIsWriteable(const LinkArea: Pointer): Boolean; }

type
 PlinkareaIsWriteable = ^TlinkareaIsWriteable;
 TlinkareaIsWriteable = object(TBooleanExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaIsWriteable.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaIsWriteable', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaIsWriteable.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Boolean(Value):=jt.link.area.IsWriteable(__LinkArea);
 end;

destructor TlinkareaIsWriteable.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaIsPassive(const LinkArea: Pointer): Boolean; }

type
 PlinkareaIsPassive = ^TlinkareaIsPassive;
 TlinkareaIsPassive = object(TBooleanExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaIsPassive.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaIsPassive', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaIsPassive.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Boolean(Value):=jt.link.area.IsPassive(__LinkArea);
 end;

destructor TlinkareaIsPassive.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaIsSubscribed(const LinkArea: Pointer): Boolean; }

type
 PlinkareaIsSubscribed = ^TlinkareaIsSubscribed;
 TlinkareaIsSubscribed = object(TBooleanExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaIsSubscribed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaIsSubscribed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaIsSubscribed.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Boolean(Value):=jt.link.area.IsSubscribed(__LinkArea);
 end;

destructor TlinkareaIsSubscribed.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaSetReadable(const LinkArea: Pointer; const Enable: Boolean); }

type
 PlinkareaSetReadable = ^TlinkareaSetReadable;
 TlinkareaSetReadable = object(TAction)
  _LinkArea: PNumberExpression;
  _Enable: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaSetReadable.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaSetReadable', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Enable:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaSetReadable.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __LinkArea: Pointer;
  __Enable: Boolean;
 begin
  _LinkArea^.Get(Data, __LinkArea);
  _Enable^.Get(Data, __Enable);

  jt.link.area.SetReadable(__LinkArea, 
    __Enable);

  Execute:=erOk;
 end;

destructor TlinkareaSetReadable.Done;
 begin
  Dispose(_LinkArea, Done);
  Dispose(_Enable, Done);

  inherited Done;
 end;

{ linkareaSetWriteable(const LinkArea: Pointer; const Enable: Boolean); }

type
 PlinkareaSetWriteable = ^TlinkareaSetWriteable;
 TlinkareaSetWriteable = object(TAction)
  _LinkArea: PNumberExpression;
  _Enable: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaSetWriteable.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaSetWriteable', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Enable:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaSetWriteable.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __LinkArea: Pointer;
  __Enable: Boolean;
 begin
  _LinkArea^.Get(Data, __LinkArea);
  _Enable^.Get(Data, __Enable);

  jt.link.area.SetWriteable(__LinkArea, 
    __Enable);

  Execute:=erOk;
 end;

destructor TlinkareaSetWriteable.Done;
 begin
  Dispose(_LinkArea, Done);
  Dispose(_Enable, Done);

  inherited Done;
 end;

{ linkareaSetPassive(const LinkArea: Pointer; const Enable: Boolean); }

type
 PlinkareaSetPassive = ^TlinkareaSetPassive;
 TlinkareaSetPassive = object(TAction)
  _LinkArea: PNumberExpression;
  _Enable: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaSetPassive.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaSetPassive', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Enable:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaSetPassive.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __LinkArea: Pointer;
  __Enable: Boolean;
 begin
  _LinkArea^.Get(Data, __LinkArea);
  _Enable^.Get(Data, __Enable);

  jt.link.area.SetPassive(__LinkArea, 
    __Enable);

  Execute:=erOk;
 end;

destructor TlinkareaSetPassive.Done;
 begin
  Dispose(_LinkArea, Done);
  Dispose(_Enable, Done);

  inherited Done;
 end;

{ linkareaSetSubscribed(const LinkArea: Pointer; const Enable: Boolean); }

type
 PlinkareaSetSubscribed = ^TlinkareaSetSubscribed;
 TlinkareaSetSubscribed = object(TAction)
  _LinkArea: PNumberExpression;
  _Enable: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaSetSubscribed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaSetSubscribed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Enable:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaSetSubscribed.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __LinkArea: Pointer;
  __Enable: Boolean;
 begin
  _LinkArea^.Get(Data, __LinkArea);
  _Enable^.Get(Data, __Enable);

  jt.link.area.SetSubscribed(__LinkArea, 
    __Enable);

  Execute:=erOk;
 end;

destructor TlinkareaSetSubscribed.Done;
 begin
  Dispose(_LinkArea, Done);
  Dispose(_Enable, Done);

  inherited Done;
 end;

{ linkareaReserved; }

type
 PlinkareaReserved = ^TlinkareaReserved;
 TlinkareaReserved = object(TAction)
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
 end;

function TlinkareaReserved.Execute(const Data: PExecuteData): TExecuteResult;
 begin
  jt.link.area.Reserved;

  Execute:=erOk;
 end;

{ linkareaGetOwner(const LinkArea: Pointer): Pointer; }

type
 PlinkareaGetOwner = ^TlinkareaGetOwner;
 TlinkareaGetOwner = object(TNumberExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaGetOwner.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaGetOwner', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaGetOwner.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Longint(Value):=Longint(jt.link.area.GetOwner(__LinkArea));
 end;

destructor TlinkareaGetOwner.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaGetACS(const LinkArea: Pointer): String; }

type
 PlinkareaGetACS = ^TlinkareaGetACS;
 TlinkareaGetACS = object(TStringExpression)
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaGetACS.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaGetACS', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkareaGetACS.Get(const ExecuteData: PExecuteData; var Value);
 var
  __LinkArea: Pointer;
 begin
  _LinkArea^.Get(ExecuteData, __LinkArea);

  String(Value):=jt.link.area.GetACS(__LinkArea);
 end;

destructor TlinkareaGetACS.Done;
 begin
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkareaRegisterIsReadableCallback(const Plugin: Pointer); }

type
 PlinkareaRegisterIsReadableCallback = ^TlinkareaRegisterIsReadableCallback;
 TlinkareaRegisterIsReadableCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaRegisterIsReadableCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaRegisterIsReadableCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaRegisterIsReadableCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.link.area.RegisterIsReadableCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkareaRegisterIsReadableCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkareaRegisterIsWriteableCallback(const Plugin: Pointer); }

type
 PlinkareaRegisterIsWriteableCallback = ^TlinkareaRegisterIsWriteableCallback;
 TlinkareaRegisterIsWriteableCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaRegisterIsWriteableCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaRegisterIsWriteableCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaRegisterIsWriteableCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.link.area.RegisterIsWriteableCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkareaRegisterIsWriteableCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkareaRegisterIsPassiveCallback(const Plugin: Pointer); }

type
 PlinkareaRegisterIsPassiveCallback = ^TlinkareaRegisterIsPassiveCallback;
 TlinkareaRegisterIsPassiveCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaRegisterIsPassiveCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaRegisterIsPassiveCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaRegisterIsPassiveCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.link.area.RegisterIsPassiveCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkareaRegisterIsPassiveCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkareaRegisterIsSubscribedCallback(const Plugin: Pointer); }

type
 PlinkareaRegisterIsSubscribedCallback = ^TlinkareaRegisterIsSubscribedCallback;
 TlinkareaRegisterIsSubscribedCallback = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkareaRegisterIsSubscribedCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkareaRegisterIsSubscribedCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkareaRegisterIsSubscribedCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.link.area.RegisterIsSubscribedCallback(__Plugin);

  Execute:=erOk;
 end;

destructor TlinkareaRegisterIsSubscribedCallback.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ linkSeek(var Address: TAddress): Pointer; }

type
 PlinkSeek = ^TlinkSeek;
 TlinkSeek = object(TNumberExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  Longint(Value):=Longint(jt.link.Seek(__Address^));
 end;

destructor TlinkSeek.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ linkAt(const Index: Longint): Pointer; }

type
 PlinkAt = ^TlinkAt;
 TlinkAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.link.At(__Index));
 end;

destructor TlinkAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ linkCount: Longint; }

type
 PlinkCount = ^TlinkCount;
 TlinkCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlinkCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.link.Count);
 end;

{ linkSetChanged(const Flags: Longint; const Reason: String); }

type
 PlinkSetChanged = ^TlinkSetChanged;
 TlinkSetChanged = object(TAction)
  _Flags: PNumberExpression;
  _Reason: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetChanged.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetChanged', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Reason:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetChanged.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Flags: Longint;
  __Reason: String;
 begin
  _Flags^.Get(Data, __Flags);
  _Reason^.Get(Data, __Reason);

  jt.link.SetChanged(__Flags, 
    __Reason);

  Execute:=erOk;
 end;

destructor TlinkSetChanged.Done;
 begin
  Dispose(_Flags, Done);
  Dispose(_Reason, Done);

  inherited Done;
 end;

{ linkGetAddress(const Link: Pointer; var Address: TAddress); }

type
 PlinkGetAddress = ^TlinkGetAddress;
 TlinkGetAddress = object(TAction)
  _Link: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkGetAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Address: PAddress;
 begin
  _Link^.Get(Data, __Link);
  _Address^.Get(Data, __Address);

  jt.link.GetAddress(__Link, 
    __Address^);

  Execute:=erOk;
 end;

destructor TlinkGetAddress.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ linkGetAka(const Link: Pointer; var Address: TAddress); }

type
 PlinkGetAka = ^TlinkGetAka;
 TlinkGetAka = object(TAction)
  _Link: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetAka.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetAka', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkGetAka.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Address: PAddress;
 begin
  _Link^.Get(Data, __Link);
  _Address^.Get(Data, __Address);

  jt.link.GetAka(__Link, 
    __Address^);

  Execute:=erOk;
 end;

destructor TlinkGetAka.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ linkGetInPassword(const Link: Pointer; var S: String); }

type
 PlinkGetInPassword = ^TlinkGetInPassword;
 TlinkGetInPassword = object(TAction)
  _Link: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetInPassword.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetInPassword', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _S^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkGetInPassword.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __S: String;
 begin
  _Link^.Get(Data, __Link);
  _S^.Get(Data, __S);

  jt.link.GetInPassword(__Link, 
    __S);

  _S^.Assign(Data, __S);

  Execute:=erOk;
 end;

destructor TlinkGetInPassword.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkGetOutPassword(const Link: Pointer; var S: String); }

type
 PlinkGetOutPassword = ^TlinkGetOutPassword;
 TlinkGetOutPassword = object(TAction)
  _Link: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetOutPassword.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetOutPassword', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _S^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkGetOutPassword.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __S: String;
 begin
  _Link^.Get(Data, __Link);
  _S^.Get(Data, __S);

  jt.link.GetOutPassword(__Link, 
    __S);

  _S^.Assign(Data, __S);

  Execute:=erOk;
 end;

destructor TlinkGetOutPassword.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkGetArchiver(const Link: Pointer): Pointer; }

type
 PlinkGetArchiver = ^TlinkGetArchiver;
 TlinkGetArchiver = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetArchiver.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetArchiver', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkGetArchiver.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.GetArchiver(__Link));
 end;

destructor TlinkGetArchiver.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkSetInPassword(const Link: Pointer; const S: String); }

type
 PlinkSetInPassword = ^TlinkSetInPassword;
 TlinkSetInPassword = object(TAction)
  _Link: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetInPassword.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetInPassword', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetInPassword.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __S: String;
 begin
  _Link^.Get(Data, __Link);
  _S^.Get(Data, __S);

  jt.link.SetInPassword(__Link, 
    __S);

  Execute:=erOk;
 end;

destructor TlinkSetInPassword.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkSetOutPassword(const Link: Pointer; const S: String); }

type
 PlinkSetOutPassword = ^TlinkSetOutPassword;
 TlinkSetOutPassword = object(TAction)
  _Link: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetOutPassword.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetOutPassword', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetOutPassword.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __S: String;
 begin
  _Link^.Get(Data, __Link);
  _S^.Get(Data, __S);

  jt.link.SetOutPassword(__Link, 
    __S);

  Execute:=erOk;
 end;

destructor TlinkSetOutPassword.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ linkSetArchiver(const Link, Archiver: Pointer); }

type
 PlinkSetArchiver = ^TlinkSetArchiver;
 TlinkSetArchiver = object(TAction)
  _Link: PNumberExpression;
  _Archiver: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetArchiver.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetArchiver', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Archiver:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetArchiver.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Archiver: Pointer;
 begin
  _Link^.Get(Data, __Link);
  _Archiver^.Get(Data, __Archiver);

  jt.link.SetArchiver(__Link, 
    __Archiver);

  Execute:=erOk;
 end;

destructor TlinkSetArchiver.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Archiver, Done);

  inherited Done;
 end;

{ linkSeekArea(const Link, Area: Pointer): Pointer; }

type
 PlinkSeekArea = ^TlinkSeekArea;
 TlinkSeekArea = object(TNumberExpression)
  _Link: PNumberExpression;
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkSeekArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSeekArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkSeekArea.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
  __Area: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.link.SeekArea(__Link, 
    __Area));
 end;

destructor TlinkSeekArea.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Area, Done);

  inherited Done;
 end;

{ linkCreateLinkArea(const Link, Area: Pointer): Pointer; }

type
 PlinkCreateLinkArea = ^TlinkCreateLinkArea;
 TlinkCreateLinkArea = object(TNumberExpression)
  _Link: PNumberExpression;
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkCreateLinkArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkCreateLinkArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkCreateLinkArea.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
  __Area: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.link.CreateLinkArea(__Link, 
    __Area));
 end;

destructor TlinkCreateLinkArea.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Area, Done);

  inherited Done;
 end;

{ linkSt(const Link: Pointer): Pointer; }

type
 PlinkSt = ^TlinkSt;
 TlinkSt = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.St(__Link));
 end;

destructor TlinkSt.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkGetDomainInfo(const Link: Pointer; var Domain, DomainOutbound:
   String; var MainZone: Longint); }

type
 PlinkGetDomainInfo = ^TlinkGetDomainInfo;
 TlinkGetDomainInfo = object(TAction)
  _Link: PNumberExpression;
  _Domain: PStringExpression;
  _DomainOutbound: PStringExpression;
  _MainZone: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetDomainInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetDomainInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Domain:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Domain^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _DomainOutbound:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _DomainOutbound^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _MainZone:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _MainZone^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkGetDomainInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Domain: String;
  __DomainOutbound: String;
  __MainZone: Longint;
 begin
  _Link^.Get(Data, __Link);
  _Domain^.Get(Data, __Domain);
  _DomainOutbound^.Get(Data, __DomainOutbound);
  _MainZone^.Get(Data, __MainZone);

  jt.link.GetDomainInfo(__Link, 
    __Domain, 
    __DomainOutbound, 
    __MainZone);

  _Domain^.Assign(Data, __Domain);
  _DomainOutbound^.Assign(Data, __DomainOutbound);
  _MainZone^.Assign(Data, __MainZone);

  Execute:=erOk;
 end;

destructor TlinkGetDomainInfo.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Domain, Done);
  Dispose(_DomainOutbound, Done);
  Dispose(_MainZone, Done);

  inherited Done;
 end;

{ linkGetMaxBundleSize(const Link: Pointer): Longint; }

type
 PlinkGetMaxBundleSize = ^TlinkGetMaxBundleSize;
 TlinkGetMaxBundleSize = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetMaxBundleSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetMaxBundleSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkGetMaxBundleSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.GetMaxBundleSize(__Link));
 end;

destructor TlinkGetMaxBundleSize.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkGetMaxPacketSize(const Link: Pointer): Longint; }

type
 PlinkGetMaxPacketSize = ^TlinkGetMaxPacketSize;
 TlinkGetMaxPacketSize = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkGetMaxPacketSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkGetMaxPacketSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkGetMaxPacketSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.GetMaxPacketSize(__Link));
 end;

destructor TlinkGetMaxPacketSize.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkSetMaxBundleSize(const Link: Pointer; const Value: Longint); }

type
 PlinkSetMaxBundleSize = ^TlinkSetMaxBundleSize;
 TlinkSetMaxBundleSize = object(TAction)
  _Link: PNumberExpression;
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetMaxBundleSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetMaxBundleSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetMaxBundleSize.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Value: Longint;
 begin
  _Link^.Get(Data, __Link);
  _Value^.Get(Data, __Value);

  jt.link.SetMaxBundleSize(__Link, 
    __Value);

  Execute:=erOk;
 end;

destructor TlinkSetMaxBundleSize.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ linkSetMaxPacketSize(const Link: Pointer; const Value: Longint); }

type
 PlinkSetMaxPacketSize = ^TlinkSetMaxPacketSize;
 TlinkSetMaxPacketSize = object(TAction)
  _Link: PNumberExpression;
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkSetMaxPacketSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkSetMaxPacketSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkSetMaxPacketSize.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Value: Longint;
 begin
  _Link^.Get(Data, __Link);
  _Value^.Get(Data, __Value);

  jt.link.SetMaxPacketSize(__Link, 
    __Value);

  Execute:=erOk;
 end;

destructor TlinkSetMaxPacketSize.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ linkOML(const Link: Pointer): Pointer; }

type
 PlinkOML = ^TlinkOML;
 TlinkOML = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkOML.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkOML', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkOML.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.OML(__Link));
 end;

destructor TlinkOML.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ linkDestroyLinkArea(const Link, LinkArea: Pointer); }

type
 PlinkDestroyLinkArea = ^TlinkDestroyLinkArea;
 TlinkDestroyLinkArea = object(TAction)
  _Link: PNumberExpression;
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlinkDestroyLinkArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkDestroyLinkArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlinkDestroyLinkArea.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __LinkArea: Pointer;
 begin
  _Link^.Get(Data, __Link);
  _LinkArea^.Get(Data, __LinkArea);

  jt.link.DestroyLinkArea(__Link, 
    __LinkArea);

  Execute:=erOk;
 end;

destructor TlinkDestroyLinkArea.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

{ linkCloneLinkArea(const Link, LinkArea: Pointer): Pointer; }

type
 PlinkCloneLinkArea = ^TlinkCloneLinkArea;
 TlinkCloneLinkArea = object(TNumberExpression)
  _Link: PNumberExpression;
  _LinkArea: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkCloneLinkArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkCloneLinkArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _LinkArea:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkCloneLinkArea.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
  __LinkArea: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);
  _LinkArea^.Get(ExecuteData, __LinkArea);

  Longint(Value):=Longint(jt.link.CloneLinkArea(__Link, 
    __LinkArea));
 end;

destructor TlinkCloneLinkArea.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_LinkArea, Done);

  inherited Done;
 end;

function CreatorCOREGETMAINADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETMAINADDRESS:=New(PcoreGetMainAddress, Init(Tokenizer, Actions));
 end;

function CreatorCOREGETMAINSYSOP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETMAINSYSOP:=New(PcoreGetMainSysop, Init(Tokenizer, Actions));
 end;

function CreatorCOREISOURADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREISOURADDRESS:=New(PcoreIsOurAddress, Init(Tokenizer, Actions));
 end;

function CreatorCOREGETORIGIN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETORIGIN:=New(PcoreGetOrigin, Init('coreGetOrigin', Actions));
 end;

function CreatorCOREGETVERSION(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETVERSION:=New(PcoreGetVersion, Init('coreGetVersion', Actions));
 end;

function CreatorCOREGETBUILD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETBUILD:=New(PcoreGetBuild, Init('coreGetBuild', Actions));
 end;

function CreatorCOREGETTITLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETTITLE:=New(PcoreGetTitle, Init('coreGetTitle', Actions));
 end;

function CreatorCOREGETFULLTITLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETFULLTITLE:=New(PcoreGetFullTitle, Init('coreGetFullTitle', Actions));
 end;

function CreatorCOREGETCOPYRIGHT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETCOPYRIGHT:=New(PcoreGetCopyright, Init('coreGetCopyright', Actions));
 end;

function CreatorCOREGETTID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETTID:=New(PcoreGetTID, Init('coreGetTID', Actions));
 end;

function CreatorCOREGETPID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETPID:=New(PcoreGetPID, Init('coreGetPID', Actions));
 end;

function CreatorCOREGETTEARLINE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETTEARLINE:=New(PcoreGetTearline, Init('coreGetTearline', Actions));
 end;

function CreatorCOREGETTEMPATTACHES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETTEMPATTACHES:=New(PcoreGetTempAttaches, Init('coreGetTempAttaches', Actions));
 end;

function CreatorCOREDESTROYKERNELOBJECT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREDESTROYKERNELOBJECT:=New(PcoreDestroyKernelObject, Init(Tokenizer, Actions));
 end;

function CreatorCOREUTC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREUTC:=New(PcoreUTC, Init('coreUTC', Actions));
 end;

function CreatorCOREGETINBOUND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETINBOUND:=New(PcoreGetInbound, Init(Tokenizer, Actions));
 end;

function CreatorCOREGETBADINBOUND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETBADINBOUND:=New(PcoreGetBadInbound, Init('coreGetBadInbound', Actions));
 end;

function CreatorCOREGETTEMPINBOUND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETTEMPINBOUND:=New(PcoreGetTempInbound, Init('coreGetTempInbound', Actions));
 end;

function CreatorCOREGETBASEINBOUND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETBASEINBOUND:=New(PcoreGetBaseInbound, Init('coreGetBaseInbound', Actions));
 end;

function CreatorCOREGETLOCALINBOUND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREGETLOCALINBOUND:=New(PcoreGetLocalInbound, Init('coreGetLocalInbound', Actions));
 end;

function CreatorCORESCREENHOOK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCORESCREENHOOK:=New(PcoreScreenHook, Init(Tokenizer, Actions));
 end;

function CreatorCOREATFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREATFORMAT:=New(PcoreAtFormat, Init(Tokenizer, Actions));
 end;

function CreatorCORESEEKFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCORESEEKFORMAT:=New(PcoreSeekFormat, Init(Tokenizer, Actions));
 end;

function CreatorCOREMBI(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOREMBI:=New(Pcorembi, Init(Tokenizer, Actions));
 end;

function CreatorLINKERVCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERVCREATE:=New(PlinkervCreate, Init('linkervCreate', Actions));
 end;

function CreatorLINKERVDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERVDESTROY:=New(PlinkervDestroy, Init(Tokenizer, Actions));
 end;

function CreatorLINKERVRESETERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERVRESETERROR:=New(PlinkervResetError, Init(Tokenizer, Actions));
 end;

function CreatorLINKERVGETERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERVGETERROR:=New(PlinkervGetError, Init(Tokenizer, Actions));
 end;

function CreatorLINKERVWASERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERVWASERROR:=New(PlinkervWasError, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSESTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSESTRING:=New(PlinkerParseString, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSESTRINGTOKEN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSESTRINGTOKEN:=New(PlinkerParseStringToken, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEBOOLEAN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEBOOLEAN:=New(PlinkerParseBoolean, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEAREASTYLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEAREASTYLE:=New(PlinkerParseAreaStyle, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEAREAFORMAT:=New(PlinkerParseAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEAREAPATH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEAREAPATH:=New(PlinkerParseAreaPath, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSESIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSESIZE:=New(PlinkerParseSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEAREAFLAGS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEAREAFLAGS:=New(PlinkerParseAreaFlags, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSENUMBER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSENUMBER:=New(PlinkerParseNumber, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEWORD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEWORD:=New(PlinkerParseWord, Init(Tokenizer, Actions));
 end;

function CreatorLINKERCREATEAREAFORWARD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERCREATEAREAFORWARD:=New(PlinkerCreateAreaForward, Init(Tokenizer, Actions));
 end;

function CreatorLINKERCREATELINKFORWARD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERCREATELINKFORWARD:=New(PlinkerCreateLinkForward, Init(Tokenizer, Actions));
 end;

function CreatorLINKERCREATELINKAREAFORWARD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERCREATELINKAREAFORWARD:=New(PlinkerCreateLinkAreaForward, Init(Tokenizer, Actions));
 end;

function CreatorLINKERERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERERROR:=New(PlinkerError, Init(Tokenizer, Actions));
 end;

function CreatorLINKERFNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERFNAME:=New(PlinkerFName, Init(Tokenizer, Actions));
 end;

function CreatorLINKERLINE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERLINE:=New(PlinkerLine, Init(Tokenizer, Actions));
 end;

function CreatorLINKEREXPORTLINE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKEREXPORTLINE:=New(PlinkerExportLine, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSESTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSESTRING:=New(PlinkerUnparseString, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEBOOLEAN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEBOOLEAN:=New(PlinkerUnparseBoolean, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEAREASTYLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEAREASTYLE:=New(PlinkerUnparseAreaStyle, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEAREAFORMAT:=New(PlinkerUnparseAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEAREAPATH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEAREAPATH:=New(PlinkerUnparseAreaPath, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSESIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSESIZE:=New(PlinkerUnparseSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEAREAFLAGS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEAREAFLAGS:=New(PlinkerUnparseAreaFlags, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSENUMBER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSENUMBER:=New(PlinkerUnparseNumber, Init(Tokenizer, Actions));
 end;

function CreatorLINKERREGISTERAREASECTIONCALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERREGISTERAREASECTIONCALLBACK:=New(PlinkerRegisterAreaSectionCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKERREGISTERLINKSECTIONCALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERREGISTERLINKSECTIONCALLBACK:=New(PlinkerRegisterLinkSectionCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKERPARSEDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERPARSEDATETIME:=New(PlinkerParseDateTime, Init(Tokenizer, Actions));
 end;

function CreatorLINKERUNPARSEDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERUNPARSEDATETIME:=New(PlinkerUnparseDateTime, Init(Tokenizer, Actions));
 end;

function CreatorLINKERSTUB(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERSTUB:=New(PlinkerStub, Init('linkerStub', Actions));
 end;

function CreatorLINKERSTUBSOFT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKERSTUBSOFT:=New(PlinkerStubSoft, Init('linkerStubSoft', Actions));
 end;

function CreatorLINKAREAAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAAT:=New(PlinkareaAt, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREACOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREACOUNT:=New(PlinkareaCount, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAGETAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAGETAREA:=New(PlinkareaGetArea, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAISREADABLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAISREADABLE:=New(PlinkareaIsReadable, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAISWRITEABLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAISWRITEABLE:=New(PlinkareaIsWriteable, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAISPASSIVE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAISPASSIVE:=New(PlinkareaIsPassive, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAISSUBSCRIBED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAISSUBSCRIBED:=New(PlinkareaIsSubscribed, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREASETREADABLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREASETREADABLE:=New(PlinkareaSetReadable, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREASETWRITEABLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREASETWRITEABLE:=New(PlinkareaSetWriteable, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREASETPASSIVE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREASETPASSIVE:=New(PlinkareaSetPassive, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREASETSUBSCRIBED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREASETSUBSCRIBED:=New(PlinkareaSetSubscribed, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREARESERVED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREARESERVED:=New(PlinkareaReserved, Init('linkareaReserved', Actions));
 end;

function CreatorLINKAREAGETOWNER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAGETOWNER:=New(PlinkareaGetOwner, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAGETACS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAGETACS:=New(PlinkareaGetACS, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAREGISTERISREADABLECALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAREGISTERISREADABLECALLBACK:=New(PlinkareaRegisterIsReadableCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAREGISTERISWRITEABLECALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAREGISTERISWRITEABLECALLBACK:=New(PlinkareaRegisterIsWriteableCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAREGISTERISPASSIVECALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAREGISTERISPASSIVECALLBACK:=New(PlinkareaRegisterIsPassiveCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKAREAREGISTERISSUBSCRIBEDCALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAREAREGISTERISSUBSCRIBEDCALLBACK:=New(PlinkareaRegisterIsSubscribedCallback, Init(Tokenizer, Actions));
 end;

function CreatorLINKSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSEEK:=New(PlinkSeek, Init(Tokenizer, Actions));
 end;

function CreatorLINKAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKAT:=New(PlinkAt, Init(Tokenizer, Actions));
 end;

function CreatorLINKCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKCOUNT:=New(PlinkCount, Init('linkCount', Actions));
 end;

function CreatorLINKSETCHANGED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETCHANGED:=New(PlinkSetChanged, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETADDRESS:=New(PlinkGetAddress, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETAKA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETAKA:=New(PlinkGetAka, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETINPASSWORD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETINPASSWORD:=New(PlinkGetInPassword, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETOUTPASSWORD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETOUTPASSWORD:=New(PlinkGetOutPassword, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETARCHIVER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETARCHIVER:=New(PlinkGetArchiver, Init(Tokenizer, Actions));
 end;

function CreatorLINKSETINPASSWORD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETINPASSWORD:=New(PlinkSetInPassword, Init(Tokenizer, Actions));
 end;

function CreatorLINKSETOUTPASSWORD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETOUTPASSWORD:=New(PlinkSetOutPassword, Init(Tokenizer, Actions));
 end;

function CreatorLINKSETARCHIVER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETARCHIVER:=New(PlinkSetArchiver, Init(Tokenizer, Actions));
 end;

function CreatorLINKSEEKAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSEEKAREA:=New(PlinkSeekArea, Init(Tokenizer, Actions));
 end;

function CreatorLINKCREATELINKAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKCREATELINKAREA:=New(PlinkCreateLinkArea, Init(Tokenizer, Actions));
 end;

function CreatorLINKST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKST:=New(PlinkSt, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETDOMAININFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETDOMAININFO:=New(PlinkGetDomainInfo, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETMAXBUNDLESIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETMAXBUNDLESIZE:=New(PlinkGetMaxBundleSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKGETMAXPACKETSIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKGETMAXPACKETSIZE:=New(PlinkGetMaxPacketSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKSETMAXBUNDLESIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETMAXBUNDLESIZE:=New(PlinkSetMaxBundleSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKSETMAXPACKETSIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKSETMAXPACKETSIZE:=New(PlinkSetMaxPacketSize, Init(Tokenizer, Actions));
 end;

function CreatorLINKOML(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKOML:=New(PlinkOML, Init(Tokenizer, Actions));
 end;

function CreatorLINKDESTROYLINKAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKDESTROYLINKAREA:=New(PlinkDestroyLinkArea, Init(Tokenizer, Actions));
 end;

function CreatorLINKCLONELINKAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKCLONELINKAREA:=New(PlinkCloneLinkArea, Init(Tokenizer, Actions));
 end;

{ AddJTAPIProtos }

procedure AddJTAPIProtos(const Target: PActions);
 begin
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('COREGETMAINADDRESS',
    CreatorCOREGETMAINADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('COREGETMAINSYSOP', CreatorCOREGETMAINSYSOP)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('COREISOURADDRESS',
    CreatorCOREISOURADDRESS)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETORIGIN',
    CreatorCOREGETORIGIN)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETVERSION',
    CreatorCOREGETVERSION)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETBUILD', CreatorCOREGETBUILD)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETTITLE', CreatorCOREGETTITLE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETFULLTITLE',
    CreatorCOREGETFULLTITLE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETCOPYRIGHT',
    CreatorCOREGETCOPYRIGHT)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETTID', CreatorCOREGETTID)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETPID', CreatorCOREGETPID)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETTEARLINE',
    CreatorCOREGETTEARLINE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COREGETTEMPATTACHES',
    CreatorCOREGETTEMPATTACHES)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('COREDESTROYKERNELOBJECT',
    CreatorCOREDESTROYKERNELOBJECT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREUTC', CreatorCOREUTC)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETINBOUND',
    CreatorCOREGETINBOUND)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETBADINBOUND',
    CreatorCOREGETBADINBOUND)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETTEMPINBOUND',
    CreatorCOREGETTEMPINBOUND)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETBASEINBOUND',
    CreatorCOREGETBASEINBOUND)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREGETLOCALINBOUND',
    CreatorCOREGETLOCALINBOUND)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('CORESCREENHOOK', CreatorCORESCREENHOOK)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('COREATFORMAT', CreatorCOREATFORMAT)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('CORESEEKFORMAT',
    CreatorCORESEEKFORMAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COREMBI', CreatorCOREMBI)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERVCREATE',
    CreatorLINKERVCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERVDESTROY', CreatorLINKERVDESTROY)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERVRESETERROR', CreatorLINKERVRESETERROR)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERVGETERROR',
    CreatorLINKERVGETERROR)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKERVWASERROR',
    CreatorLINKERVWASERROR)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERPARSESTRING',
    CreatorLINKERPARSESTRING)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERPARSESTRINGTOKEN',
    CreatorLINKERPARSESTRINGTOKEN)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKERPARSEBOOLEAN',
    CreatorLINKERPARSEBOOLEAN)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERPARSEAREASTYLE',
    CreatorLINKERPARSEAREASTYLE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERPARSEAREAFORMAT',
    CreatorLINKERPARSEAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERPARSEAREAPATH',
    CreatorLINKERPARSEAREAPATH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERPARSESIZE',
    CreatorLINKERPARSESIZE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERPARSEAREAFLAGS',
    CreatorLINKERPARSEAREAFLAGS)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERPARSENUMBER',
    CreatorLINKERPARSENUMBER)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERPARSEWORD',
    CreatorLINKERPARSEWORD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERCREATEAREAFORWARD',
    CreatorLINKERCREATEAREAFORWARD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERCREATELINKFORWARD',
    CreatorLINKERCREATELINKFORWARD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERCREATELINKAREAFORWARD',
    CreatorLINKERCREATELINKAREAFORWARD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERERROR', CreatorLINKERERROR)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERFNAME', CreatorLINKERFNAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERLINE', CreatorLINKERLINE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKEREXPORTLINE', CreatorLINKEREXPORTLINE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSESTRING',
    CreatorLINKERUNPARSESTRING)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEBOOLEAN',
    CreatorLINKERUNPARSEBOOLEAN)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEAREASTYLE',
    CreatorLINKERUNPARSEAREASTYLE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEAREAFORMAT',
    CreatorLINKERUNPARSEAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEAREAPATH',
    CreatorLINKERUNPARSEAREAPATH)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSESIZE',
    CreatorLINKERUNPARSESIZE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEAREAFLAGS',
    CreatorLINKERUNPARSEAREAFLAGS)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSENUMBER',
    CreatorLINKERUNPARSENUMBER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERREGISTERAREASECTIONCALLBACK',
    CreatorLINKERREGISTERAREASECTIONCALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERREGISTERLINKSECTIONCALLBACK',
    CreatorLINKERREGISTERLINKSECTIONCALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKERPARSEDATETIME',
    CreatorLINKERPARSEDATETIME)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKERUNPARSEDATETIME',
    CreatorLINKERUNPARSEDATETIME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERSTUB', CreatorLINKERSTUB)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKERSTUBSOFT',
    CreatorLINKERSTUBSOFT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKAREAAT', CreatorLINKAREAAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKAREACOUNT',
    CreatorLINKAREACOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKAREAGETAREA',
    CreatorLINKAREAGETAREA)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKAREAISREADABLE',
    CreatorLINKAREAISREADABLE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKAREAISWRITEABLE',
    CreatorLINKAREAISWRITEABLE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKAREAISPASSIVE',
    CreatorLINKAREAISPASSIVE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LINKAREAISSUBSCRIBED',
    CreatorLINKAREAISSUBSCRIBED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREASETREADABLE',
    CreatorLINKAREASETREADABLE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREASETWRITEABLE',
    CreatorLINKAREASETWRITEABLE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREASETPASSIVE',
    CreatorLINKAREASETPASSIVE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREASETSUBSCRIBED',
    CreatorLINKAREASETSUBSCRIBED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREARESERVED', CreatorLINKAREARESERVED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKAREAGETOWNER',
    CreatorLINKAREAGETOWNER)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LINKAREAGETACS',
    CreatorLINKAREAGETACS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREAREGISTERISREADABLECALLBACK',
    CreatorLINKAREAREGISTERISREADABLECALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREAREGISTERISWRITEABLECALLBACK',
    CreatorLINKAREAREGISTERISWRITEABLECALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREAREGISTERISPASSIVECALLBACK',
    CreatorLINKAREAREGISTERISPASSIVECALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKAREAREGISTERISSUBSCRIBEDCALLBACK',
    CreatorLINKAREAREGISTERISSUBSCRIBEDCALLBACK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKSEEK', CreatorLINKSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKAT', CreatorLINKAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKCOUNT', CreatorLINKCOUNT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETCHANGED', CreatorLINKSETCHANGED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKGETADDRESS', CreatorLINKGETADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKGETAKA', CreatorLINKGETAKA)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKGETINPASSWORD', CreatorLINKGETINPASSWORD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKGETOUTPASSWORD',
    CreatorLINKGETOUTPASSWORD)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKGETARCHIVER',
    CreatorLINKGETARCHIVER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETINPASSWORD', CreatorLINKSETINPASSWORD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETOUTPASSWORD',
    CreatorLINKSETOUTPASSWORD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETARCHIVER', CreatorLINKSETARCHIVER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKSEEKAREA', CreatorLINKSEEKAREA)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKCREATELINKAREA',
    CreatorLINKCREATELINKAREA)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKST', CreatorLINKST)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKGETDOMAININFO', CreatorLINKGETDOMAININFO)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKGETMAXBUNDLESIZE',
    CreatorLINKGETMAXBUNDLESIZE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKGETMAXPACKETSIZE',
    CreatorLINKGETMAXPACKETSIZE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETMAXBUNDLESIZE',
    CreatorLINKSETMAXBUNDLESIZE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKSETMAXPACKETSIZE',
    CreatorLINKSETMAXPACKETSIZE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKOML', CreatorLINKOML)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LINKDESTROYLINKAREA',
    CreatorLINKDESTROYLINKAREA)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKCLONELINKAREA',
    CreatorLINKCLONELINKAREA)));
 end;

end.
