{$IFNDEF VIRTUALPASCAL}
{$D-}
{$ENDIF}
unit ccJTAPI1;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     ccAPI,
     ccAction,
     ccCmn,
     ccCode,
     ccExpr,
     ccJTSupp,
     ccProto,
     ccRoot,
     ccSupp,
     ccToken,

     jtMHLcmn,

     Thunks,

     Wizard;

procedure AddJTAPIProtos(const Target: PActions);

implementation

{ linkIndexOf(const Link: Pointer): Longint; }

type
 PlinkIndexOf = ^TlinkIndexOf;
 TlinkIndexOf = object(TNumberExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlinkIndexOf.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('linkIndexOf', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlinkIndexOf.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  Longint(Value):=Longint(jt.link.IndexOf(__Link));
 end;

destructor TlinkIndexOf.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ areakilledAt(const Index: Longint): Pointer; }

type
 PareakilledAt = ^TareakilledAt;
 TareakilledAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareakilledAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areakilledAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareakilledAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.area.killed.At(__Index));
 end;

destructor TareakilledAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ areakilledCount: Longint; }

type
 PareakilledCount = ^TareakilledCount;
 TareakilledCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TareakilledCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.area.killed.Count);
 end;

{ areakilledSeek(const Name: String): Pointer; }

type
 PareakilledSeek = ^TareakilledSeek;
 TareakilledSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareakilledSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areakilledSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareakilledSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.area.killed.Seek(__Name));
 end;

destructor TareakilledSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ areakilledCreate(const Name: String): Pointer; }

type
 PareakilledCreate = ^TareakilledCreate;
 TareakilledCreate = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareakilledCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areakilledCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareakilledCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.area.killed.Create(__Name));
 end;

destructor TareakilledCreate.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ areakilledDestroy(const Area: Pointer); }

type
 PareakilledDestroy = ^TareakilledDestroy;
 TareakilledDestroy = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareakilledDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areakilledDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareakilledDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.killed.Destroy(__Area);

  Execute:=erOk;
 end;

destructor TareakilledDestroy.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaSeek(const Name: String): Pointer; }

type
 PareaSeek = ^TareaSeek;
 TareaSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.area.Seek(__Name));
 end;

destructor TareaSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ areaSeekNetmail: Pointer; }

type
 PareaSeekNetmail = ^TareaSeekNetmail;
 TareaSeekNetmail = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TareaSeekNetmail.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.area.SeekNetmail);
 end;

{ areaSeekBadmail: Pointer; }

type
 PareaSeekBadmail = ^TareaSeekBadmail;
 TareaSeekBadmail = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TareaSeekBadmail.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.area.SeekBadmail);
 end;

{ areaCreate(const Name: String; const Format: PAreaFormat): Pointer; }

type
 PareaCreate = ^TareaCreate;
 TareaCreate = object(TNumberExpression)
  _Name: PStringExpression;
  _Format: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
  __Format: PAreaFormat;
 begin
  _Name^.Get(ExecuteData, __Name);
  _Format^.Get(ExecuteData, __Format);

  Longint(Value):=Longint(jt.area.Create(__Name, 
    __Format));
 end;

destructor TareaCreate.Done;
 begin
  Dispose(_Name, Done);
  Dispose(_Format, Done);

  inherited Done;
 end;

{ areaDestroy(const Area: Pointer); }

type
 PareaDestroy = ^TareaDestroy;
 TareaDestroy = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.Destroy(__Area);

  Execute:=erOk;
 end;

destructor TareaDestroy.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaAt(const Index: Longint): Pointer; }

type
 PareaAt = ^TareaAt;
 TareaAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.area.At(__Index));
 end;

destructor TareaAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ areaCount: Longint; }

type
 PareaCount = ^TareaCount;
 TareaCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TareaCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.area.Count);
 end;

{ areaSetChanged(const Flags: Longint; const Reason: String); }

type
 PareaSetChanged = ^TareaSetChanged;
 TareaSetChanged = object(TAction)
  _Flags: PNumberExpression;
  _Reason: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaSetChanged.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSetChanged', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Reason:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaSetChanged.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Flags: Longint;
  __Reason: String;
 begin
  _Flags^.Get(Data, __Flags);
  _Reason^.Get(Data, __Reason);

  jt.area.SetChanged(__Flags, 
    __Reason);

  Execute:=erOk;
 end;

destructor TareaSetChanged.Done;
 begin
  Dispose(_Flags, Done);
  Dispose(_Reason, Done);

  inherited Done;
 end;

{ areaGetName(const Area: Pointer): PString; }

type
 PareaGetName = ^TareaGetName;
 TareaGetName = object(TNumberExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaGetName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaGetName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaGetName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.area.GetName(__Area));
 end;

destructor TareaGetName.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaSetName(const Area: Pointer; const Name: String); }

type
 PareaSetName = ^TareaSetName;
 TareaSetName = object(TAction)
  _Area: PNumberExpression;
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaSetName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSetName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaSetName.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Name: String;
 begin
  _Area^.Get(Data, __Area);
  _Name^.Get(Data, __Name);

  jt.area.SetName(__Area, 
    __Name);

  Execute:=erOk;
 end;

destructor TareaSetName.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ areaGetDesc(const Area: Pointer): PString; }

type
 PareaGetDesc = ^TareaGetDesc;
 TareaGetDesc = object(TNumberExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaGetDesc.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaGetDesc', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaGetDesc.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.area.GetDesc(__Area));
 end;

destructor TareaGetDesc.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaSetDesc(const Area: Pointer; const Desc: String); }

type
 PareaSetDesc = ^TareaSetDesc;
 TareaSetDesc = object(TAction)
  _Area: PNumberExpression;
  _Desc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaSetDesc.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSetDesc', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Desc:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaSetDesc.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Desc: String;
 begin
  _Area^.Get(Data, __Area);
  _Desc^.Get(Data, __Desc);

  jt.area.SetDesc(__Area, 
    __Desc);

  Execute:=erOk;
 end;

destructor TareaSetDesc.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Desc, Done);

  inherited Done;
 end;

{ areaGetFormat(const Area: Pointer; var Format: TAreaFormat); }

type
 PareaGetFormat = ^TareaGetFormat;
 TareaGetFormat = object(TAction)
  _Area: PNumberExpression;
  _Format: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaGetFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaGetFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Format^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaGetFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Format: PAreaFormat;
 begin
  _Area^.Get(Data, __Area);
  _Format^.Get(Data, __Format);

  jt.area.GetFormat(__Area, 
    __Format^);

  Execute:=erOk;
 end;

destructor TareaGetFormat.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Format, Done);

  inherited Done;
 end;

{ areaSetFormat(const Area: Pointer; var Format: TAreaFormat); }

type
 PareaSetFormat = ^TareaSetFormat;
 TareaSetFormat = object(TAction)
  _Area: PNumberExpression;
  _Format: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaSetFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSetFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Format^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaSetFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Format: PAreaFormat;
 begin
  _Area^.Get(Data, __Area);
  _Format^.Get(Data, __Format);

  jt.area.SetFormat(__Area, 
    __Format^);

  Execute:=erOk;
 end;

destructor TareaSetFormat.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Format, Done);

  inherited Done;
 end;

{ areaGetUplink(const Area: Pointer; var Uplink: TAddress); }

type
 PareaGetUplink = ^TareaGetUplink;
 TareaGetUplink = object(TAction)
  _Area: PNumberExpression;
  _Uplink: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaGetUplink.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaGetUplink', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Uplink:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Uplink^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaGetUplink.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Uplink: PAddress;
 begin
  _Area^.Get(Data, __Area);
  _Uplink^.Get(Data, __Uplink);

  jt.area.GetUplink(__Area, 
    __Uplink^);

  Execute:=erOk;
 end;

destructor TareaGetUplink.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Uplink, Done);

  inherited Done;
 end;

{ areaSetUplink(const Area: Pointer; const Uplink: TAddress); }

type
 PareaSetUplink = ^TareaSetUplink;
 TareaSetUplink = object(TAction)
  _Area: PNumberExpression;
  _Uplink: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaSetUplink.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSetUplink', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Uplink:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaSetUplink.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Uplink: PAddress;
 begin
  _Area^.Get(Data, __Area);
  _Uplink^.Get(Data, __Uplink);

  jt.area.SetUplink(__Area, 
    __Uplink^);

  Execute:=erOk;
 end;

destructor TareaSetUplink.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Uplink, Done);

  inherited Done;
 end;

{ areaSt(const Area: Pointer): Pointer; }

type
 PareaSt = ^TareaSt;
 TareaSt = object(TNumberExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.area.St(__Area));
 end;

destructor TareaSt.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaGetAka(const Area: Pointer; var Aka: TAddress); }

type
 PareaGetAka = ^TareaGetAka;
 TareaGetAka = object(TAction)
  _Area: PNumberExpression;
  _Aka: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaGetAka.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaGetAka', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Aka:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Aka^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaGetAka.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __Aka: PAddress;
 begin
  _Area^.Get(Data, __Area);
  _Aka^.Get(Data, __Aka);

  jt.area.GetAka(__Area, 
    __Aka^);

  Execute:=erOk;
 end;

destructor TareaGetAka.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_Aka, Done);

  inherited Done;
 end;

{ areaLock(const Area: Pointer; var mb: Pointer; var rc: String):
   Boolean; }

type
 PareaLock = ^TareaLock;
 TareaLock = object(TBooleanExpression)
  _Area: PNumberExpression;
  _mb: PNumberExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaLock.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaLock', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _mb^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaLock.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
  __mb: Pointer;
  __rc: String;
 begin
  _Area^.Get(ExecuteData, __Area);
  _mb^.Get(ExecuteData, __mb);
  _rc^.Get(ExecuteData, __rc);

  Boolean(Value):=jt.area.Lock(__Area, 
    __mb, 
    __rc);

  _mb^.Assign(ExecuteData, __mb);
  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TareaLock.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_mb, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ areaUnlock(const Area: Pointer; var mb: Pointer); }

type
 PareaUnlock = ^TareaUnlock;
 TareaUnlock = object(TAction)
  _Area: PNumberExpression;
  _mb: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaUnlock.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaUnlock', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _mb^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaUnlock.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
  __mb: Pointer;
 begin
  _Area^.Get(Data, __Area);
  _mb^.Get(Data, __mb);

  jt.area.Unlock(__Area, 
    __mb);

  _mb^.Assign(Data, __mb);

  Execute:=erOk;
 end;

destructor TareaUnlock.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_mb, Done);

  inherited Done;
 end;

{ areaKill(const Area: Pointer; var rc: String): Boolean; }

type
 PareaKill = ^TareaKill;
 TareaKill = object(TBooleanExpression)
  _Area: PNumberExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaKill.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaKill', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaKill.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
  __rc: String;
 begin
  _Area^.Get(ExecuteData, __Area);
  _rc^.Get(ExecuteData, __rc);

  Boolean(Value):=jt.area.Kill(__Area, 
    __rc);

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TareaKill.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ areaPack(const Area: Pointer; var BeforePack, AfterPack: Longint;
   const Callback: TPackAreaCallback; const Param: Pointer):
   Boolean; }

type
 PareaPack = ^TareaPack;
 TareaPack = object(TBooleanExpression)
  _Area: PNumberExpression;
  _BeforePack: PNumberExpression;
  _AfterPack: PNumberExpression;
  _Callback: PNumberExpression;
  _Param: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaPack.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaPack', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _BeforePack:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _BeforePack^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _AfterPack:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _AfterPack^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Callback:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Param:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaPack.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
  __BeforePack: Longint;
  __AfterPack: Longint;
  ___Callback: TPackAreaCallback;
  __Callback: Longint absolute ___Callback;
  __Param: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);
  _BeforePack^.Get(ExecuteData, __BeforePack);
  _AfterPack^.Get(ExecuteData, __AfterPack);
  _Callback^.Get(ExecuteData, __Callback);
  _Param^.Get(ExecuteData, __Param);

  Boolean(Value):=jt.area.Pack(__Area, 
    __BeforePack, 
    __AfterPack, 
    ___Callback, 
    __Param);

  _BeforePack^.Assign(ExecuteData, __BeforePack);
  _AfterPack^.Assign(ExecuteData, __AfterPack);
 end;

destructor TareaPack.Done;
 begin
  Dispose(_Area, Done);
  Dispose(_BeforePack, Done);
  Dispose(_AfterPack, Done);
  Dispose(_Callback, Done);
  Dispose(_Param, Done);

  inherited Done;
 end;

{ areaRegisterNotifyAreaCreated(const Plugin: Pointer); }

type
 PareaRegisterNotifyAreaCreated = ^TareaRegisterNotifyAreaCreated;
 TareaRegisterNotifyAreaCreated = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaRegisterNotifyAreaCreated.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaRegisterNotifyAreaCreated', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaRegisterNotifyAreaCreated.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.area.RegisterNotifyAreaCreated(__Plugin);

  Execute:=erOk;
 end;

destructor TareaRegisterNotifyAreaCreated.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ areaRegisterNotifyAreaChanged(const Plugin: Pointer); }

type
 PareaRegisterNotifyAreaChanged = ^TareaRegisterNotifyAreaChanged;
 TareaRegisterNotifyAreaChanged = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaRegisterNotifyAreaChanged.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaRegisterNotifyAreaChanged', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaRegisterNotifyAreaChanged.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.area.RegisterNotifyAreaChanged(__Plugin);

  Execute:=erOk;
 end;

destructor TareaRegisterNotifyAreaChanged.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ areaRegisterNotifyAreaDestroyed(const Plugin: Pointer); }

type
 PareaRegisterNotifyAreaDestroyed = ^TareaRegisterNotifyAreaDestroyed;
 TareaRegisterNotifyAreaDestroyed = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaRegisterNotifyAreaDestroyed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaRegisterNotifyAreaDestroyed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaRegisterNotifyAreaDestroyed.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.area.RegisterNotifyAreaDestroyed(__Plugin);

  Execute:=erOk;
 end;

destructor TareaRegisterNotifyAreaDestroyed.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ areaNotifyAreaCreated(const Area: Pointer); }

type
 PareaNotifyAreaCreated = ^TareaNotifyAreaCreated;
 TareaNotifyAreaCreated = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaNotifyAreaCreated.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaNotifyAreaCreated', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaNotifyAreaCreated.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.NotifyAreaCreated(__Area);

  Execute:=erOk;
 end;

destructor TareaNotifyAreaCreated.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaNotifyAreaChanged(const Area: Pointer); }

type
 PareaNotifyAreaChanged = ^TareaNotifyAreaChanged;
 TareaNotifyAreaChanged = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaNotifyAreaChanged.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaNotifyAreaChanged', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaNotifyAreaChanged.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.NotifyAreaChanged(__Area);

  Execute:=erOk;
 end;

destructor TareaNotifyAreaChanged.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaNotifyAreaDestroyed(const Area: Pointer); }

type
 PareaNotifyAreaDestroyed = ^TareaNotifyAreaDestroyed;
 TareaNotifyAreaDestroyed = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaNotifyAreaDestroyed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaNotifyAreaDestroyed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaNotifyAreaDestroyed.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.NotifyAreaDestroyed(__Area);

  Execute:=erOk;
 end;

destructor TareaNotifyAreaDestroyed.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaIndexOf(const Area: Pointer): Longint; }

type
 PareaIndexOf = ^TareaIndexOf;
 TareaIndexOf = object(TNumberExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaIndexOf.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaIndexOf', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaIndexOf.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.area.IndexOf(__Area));
 end;

destructor TareaIndexOf.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaKillBase(const Format: TAreaFormat; var rc: String): Boolean; }

type
 PareaKillBase = ^TareaKillBase;
 TareaKillBase = object(TBooleanExpression)
  _Format: PNumberExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaKillBase.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaKillBase', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaKillBase.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Format: PAreaFormat;
  __rc: String;
 begin
  _Format^.Get(ExecuteData, __Format);
  _rc^.Get(ExecuteData, __rc);

  Boolean(Value):=jt.area.KillBase(__Format^, 
    __rc);

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TareaKillBase.Done;
 begin
  Dispose(_Format, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ areaIsBaseExists(const Format: TAreaFormat): Boolean; }

type
 PareaIsBaseExists = ^TareaIsBaseExists;
 TareaIsBaseExists = object(TBooleanExpression)
  _Format: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaIsBaseExists.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaIsBaseExists', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaIsBaseExists.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Format: PAreaFormat;
 begin
  _Format^.Get(ExecuteData, __Format);

  Boolean(Value):=jt.area.IsBaseExists(__Format^);
 end;

destructor TareaIsBaseExists.Done;
 begin
  Dispose(_Format, Done);

  inherited Done;
 end;

{ areaMinimizeHandles; }

type
 PareaMinimizeHandles = ^TareaMinimizeHandles;
 TareaMinimizeHandles = object(TAction)
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
 end;

function TareaMinimizeHandles.Execute(const Data: PExecuteData): TExecuteResult;
 begin
  jt.area.MinimizeHandles;

  Execute:=erOk;
 end;

{ areaUsed(const Area: Pointer); }

type
 PareaUsed = ^TareaUsed;
 TareaUsed = object(TAction)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaUsed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaUsed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaUsed.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Area: Pointer;
 begin
  _Area^.Get(Data, __Area);

  jt.area.Used(__Area);

  Execute:=erOk;
 end;

destructor TareaUsed.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaNetmail(const Area: Pointer): Boolean; }

type
 PareaNetmail = ^TareaNetmail;
 TareaNetmail = object(TBooleanExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaNetmail.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaNetmail', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaNetmail.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Boolean(Value):=jt.area.Netmail(__Area);
 end;

destructor TareaNetmail.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaPassthrough(const Area: Pointer): Boolean; }

type
 PareaPassthrough = ^TareaPassthrough;
 TareaPassthrough = object(TBooleanExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TareaPassthrough.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaPassthrough', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TareaPassthrough.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Boolean(Value):=jt.area.Passthrough(__Area);
 end;

destructor TareaPassthrough.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areambi(const Area: Pointer): Pointer; }

type
 Pareambi = ^Tareambi;
 Tareambi = object(TNumberExpression)
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor Tareambi.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areambi', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure Tareambi.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Area: Pointer;
 begin
  _Area^.Get(ExecuteData, __Area);

  Longint(Value):=Longint(jt.area.mbi(__Area));
 end;

destructor Tareambi.Done;
 begin
  Dispose(_Area, Done);

  inherited Done;
 end;

{ areaPackEx(const mbi: Pointer; const Path: String; var Block); }

type
 PareaPackEx = ^TareaPackEx;
 TareaPackEx = object(TAction)
  _mbi: PNumberExpression;
  _Path: PStringExpression;
  _Block: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TareaPackEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('areaPackEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mbi:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Path:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Block:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TareaPackEx.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __mbi: Pointer;
  __Path: String;
  __Block: Pointer;
 begin
  _mbi^.Get(Data, __mbi);
  _Path^.Get(Data, __Path);
  _Block^.Get(Data, __Block);

  jt.area.PackEx(__mbi, 
    __Path, 
    __Block^);

  Execute:=erOk;
 end;

destructor TareaPackEx.Done;
 begin
  Dispose(_mbi, Done);
  Dispose(_Path, Done);
  Dispose(_Block, Done);

  inherited Done;
 end;

{ restsAdd(Name: String; const Flags: Longint): Pointer; }

type
 PrestsAdd = ^TrestsAdd;
 TrestsAdd = object(TNumberExpression)
  _Name: PStringExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrestsAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrestsAdd.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
  __Flags: Longint;
 begin
  _Name^.Get(ExecuteData, __Name);
  _Flags^.Get(ExecuteData, __Flags);

  Longint(Value):=Longint(jt.rests.Add(__Name, 
    __Flags));
 end;

destructor TrestsAdd.Done;
 begin
  Dispose(_Name, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ restsAddValueParser(Name: String; const Flags: Longint; const
   ValueParser: TRestrictionValueParser): Pointer; }

type
 PrestsAddValueParser = ^TrestsAddValueParser;
 TrestsAddValueParser = object(TNumberExpression)
  _Name: PStringExpression;
  _Flags: PNumberExpression;
  _ValueParser: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrestsAddValueParser.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsAddValueParser', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _ValueParser:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrestsAddValueParser.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
  __Flags: Longint;
  ___ValueParser: TRestrictionValueParser;
  __ValueParser: Longint absolute ___ValueParser;
 begin
  _Name^.Get(ExecuteData, __Name);
  _Flags^.Get(ExecuteData, __Flags);
  _ValueParser^.Get(ExecuteData, __ValueParser);

  Longint(Value):=Longint(jt.rests.AddValueParser(__Name, 
    __Flags, 
    ___ValueParser));
 end;

destructor TrestsAddValueParser.Done;
 begin
  Dispose(_Name, Done);
  Dispose(_Flags, Done);
  Dispose(_ValueParser, Done);

  inherited Done;
 end;

{ restsCheck(const Restriction: Pointer; const Link: PAddress; const
   Area: PString): Boolean; }

type
 PrestsCheck = ^TrestsCheck;
 TrestsCheck = object(TBooleanExpression)
  _Restriction: PNumberExpression;
  _Link: PNumberExpression;
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrestsCheck.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsCheck', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Restriction:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrestsCheck.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Restriction: Pointer;
  __Link: PAddress;
  __Area: PString;
 begin
  _Restriction^.Get(ExecuteData, __Restriction);
  _Link^.Get(ExecuteData, __Link);
  _Area^.Get(ExecuteData, __Area);

  Boolean(Value):=jt.rests.Check(__Restriction, 
    __Link, 
    __Area);
 end;

destructor TrestsCheck.Done;
 begin
  Dispose(_Restriction, Done);
  Dispose(_Link, Done);
  Dispose(_Area, Done);

  inherited Done;
 end;

{ restsGetValue(const Restriction: Pointer; const Link: PAddress;
   const Area: PString; var Target: String); }

type
 PrestsGetValue = ^TrestsGetValue;
 TrestsGetValue = object(TAction)
  _Restriction: PNumberExpression;
  _Link: PNumberExpression;
  _Area: PNumberExpression;
  _Target: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TrestsGetValue.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsGetValue', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Restriction:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Target:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Target^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TrestsGetValue.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Restriction: Pointer;
  __Link: PAddress;
  __Area: PString;
  __Target: String;
 begin
  _Restriction^.Get(Data, __Restriction);
  _Link^.Get(Data, __Link);
  _Area^.Get(Data, __Area);
  _Target^.Get(Data, __Target);

  jt.rests.GetValue(__Restriction, 
    __Link, 
    __Area, 
    __Target);

  _Target^.Assign(Data, __Target);

  Execute:=erOk;
 end;

destructor TrestsGetValue.Done;
 begin
  Dispose(_Restriction, Done);
  Dispose(_Link, Done);
  Dispose(_Area, Done);
  Dispose(_Target, Done);

  inherited Done;
 end;

{ restsCallback(const Restriction: Pointer; const Link: PAddress;
   const Area: PString; const Callback: TRestrictionCallback;
   const Param: Pointer); }

type
 PrestsCallback = ^TrestsCallback;
 TrestsCallback = object(TAction)
  _Restriction: PNumberExpression;
  _Link: PNumberExpression;
  _Area: PNumberExpression;
  _Callback: PNumberExpression;
  _Param: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TrestsCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Restriction:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Callback:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Param:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TrestsCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Restriction: Pointer;
  __Link: PAddress;
  __Area: PString;
  ___Callback: TRestrictionCallback;
  __Callback: Longint absolute ___Callback;
  __Param: Pointer;
 begin
  _Restriction^.Get(Data, __Restriction);
  _Link^.Get(Data, __Link);
  _Area^.Get(Data, __Area);
  _Callback^.Get(Data, __Callback);
  _Param^.Get(Data, __Param);

  jt.rests.Callback(__Restriction, 
    __Link, 
    __Area, 
    ___Callback, 
    __Param);

  Execute:=erOk;
 end;

destructor TrestsCallback.Done;
 begin
  Dispose(_Restriction, Done);
  Dispose(_Link, Done);
  Dispose(_Area, Done);
  Dispose(_Callback, Done);
  Dispose(_Param, Done);

  inherited Done;
 end;

{ restsGetst(const Restriction: Pointer; const Link: PAddress; const
   Area: PString; var st: Pointer); }

type
 PrestsGetst = ^TrestsGetst;
 TrestsGetst = object(TAction)
  _Restriction: PNumberExpression;
  _Link: PNumberExpression;
  _Area: PNumberExpression;
  _st: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TrestsGetst.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsGetst', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Restriction:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _st^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TrestsGetst.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Restriction: Pointer;
  __Link: PAddress;
  __Area: PString;
  __st: Pointer;
 begin
  _Restriction^.Get(Data, __Restriction);
  _Link^.Get(Data, __Link);
  _Area^.Get(Data, __Area);
  _st^.Get(Data, __st);

  jt.rests.Getst(__Restriction, 
    __Link, 
    __Area, 
    __st);

  _st^.Assign(Data, __st);

  Execute:=erOk;
 end;

destructor TrestsGetst.Done;
 begin
  Dispose(_Restriction, Done);
  Dispose(_Link, Done);
  Dispose(_Area, Done);
  Dispose(_st, Done);

  inherited Done;
 end;

{ restsGetUsed(const Restriction: Pointer): Longint; }

type
 PrestsGetUsed = ^TrestsGetUsed;
 TrestsGetUsed = object(TNumberExpression)
  _Restriction: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrestsGetUsed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('restsGetUsed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Restriction:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrestsGetUsed.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Restriction: Pointer;
 begin
  _Restriction^.Get(ExecuteData, __Restriction);

  Longint(Value):=Longint(jt.rests.GetUsed(__Restriction));
 end;

destructor TrestsGetUsed.Done;
 begin
  Dispose(_Restriction, Done);

  inherited Done;
 end;

{ arcSeek(const Name: String): Pointer; }

type
 ParcSeek = ^TarcSeek;
 TarcSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.arc.Seek(__Name));
 end;

destructor TarcSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ arcIdentify(const FName: String): Pointer; }

type
 ParcIdentify = ^TarcIdentify;
 TarcIdentify = object(TNumberExpression)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcIdentify.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcIdentify', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcIdentify.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
 begin
  _FName^.Get(ExecuteData, __FName);

  Longint(Value):=Longint(jt.arc.Identify(__FName));
 end;

destructor TarcIdentify.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ arcCount: Longint; }

type
 ParcCount = ^TarcCount;
 TarcCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TarcCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.arc.Count);
 end;

{ arcAt(const Index: Longint): Pointer; }

type
 ParcAt = ^TarcAt;
 TarcAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.arc.At(__Index));
 end;

destructor TarcAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ arcGetName(const Archiver: Pointer): String; }

type
 ParcGetName = ^TarcGetName;
 TarcGetName = object(TStringExpression)
  _Archiver: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcGetName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcGetName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Archiver:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcGetName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Archiver: Pointer;
 begin
  _Archiver^.Get(ExecuteData, __Archiver);

  String(Value):=jt.arc.GetName(__Archiver);
 end;

destructor TarcGetName.Done;
 begin
  Dispose(_Archiver, Done);

  inherited Done;
 end;

{ arcGetAdd(const Archiver: Pointer): String; }

type
 ParcGetAdd = ^TarcGetAdd;
 TarcGetAdd = object(TStringExpression)
  _Archiver: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcGetAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcGetAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Archiver:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcGetAdd.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Archiver: Pointer;
 begin
  _Archiver^.Get(ExecuteData, __Archiver);

  String(Value):=jt.arc.GetAdd(__Archiver);
 end;

destructor TarcGetAdd.Done;
 begin
  Dispose(_Archiver, Done);

  inherited Done;
 end;

{ arcGetExtract(const Archiver: Pointer): String; }

type
 ParcGetExtract = ^TarcGetExtract;
 TarcGetExtract = object(TStringExpression)
  _Archiver: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TarcGetExtract.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('arcGetExtract', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Archiver:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TarcGetExtract.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Archiver: Pointer;
 begin
  _Archiver^.Get(ExecuteData, __Archiver);

  String(Value):=jt.arc.GetExtract(__Archiver);
 end;

destructor TarcGetExtract.Done;
 begin
  Dispose(_Archiver, Done);

  inherited Done;
 end;

{ arcQuiet: Boolean; }

type
 ParcQuiet = ^TarcQuiet;
 TarcQuiet = object(TBooleanExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TarcQuiet.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Boolean(Value):=jt.arc.Quiet;
 end;

{ listexCreate(const AFlags: Longint): Pointer; }

type
 PlistexCreate = ^TlistexCreate;
 TlistexCreate = object(TNumberExpression)
  _AFlags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AFlags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __AFlags: Longint;
 begin
  _AFlags^.Get(ExecuteData, __AFlags);

  Longint(Value):=Longint(jt.list.ex.Create(__AFlags));
 end;

destructor TlistexCreate.Done;
 begin
  Dispose(_AFlags, Done);

  inherited Done;
 end;

{ listexClone(const Source: Pointer): Pointer; }

type
 PlistexClone = ^TlistexClone;
 TlistexClone = object(TNumberExpression)
  _Source: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexClone.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexClone', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Source:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexClone.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Source: Pointer;
 begin
  _Source^.Get(ExecuteData, __Source);

  Longint(Value):=Longint(jt.list.ex.Clone(__Source));
 end;

destructor TlistexClone.Done;
 begin
  Dispose(_Source, Done);

  inherited Done;
 end;

{ listexDestroy(const ListEx: Pointer); }

type
 PlistexDestroy = ^TlistexDestroy;
 TlistexDestroy = object(TAction)
  _ListEx: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlistexDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlistexDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __ListEx: Pointer;
 begin
  _ListEx^.Get(Data, __ListEx);

  jt.list.ex.Destroy(__ListEx);

  Execute:=erOk;
 end;

destructor TlistexDestroy.Done;
 begin
  Dispose(_ListEx, Done);

  inherited Done;
 end;

{ listexAt(const ListEx: Pointer; const Index: Longint): PString; }

type
 PlistexAt = ^TlistexAt;
 TlistexAt = object(TNumberExpression)
  _ListEx: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Index: Longint;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.list.ex.At(__ListEx, 
    __Index));
 end;

destructor TlistexAt.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ listexCount(const ListEx: Pointer): Longint; }

type
 PlistexCount = ^TlistexCount;
 TlistexCount = object(TNumberExpression)
  _ListEx: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);

  Longint(Value):=Longint(jt.list.ex.Count(__ListEx));
 end;

destructor TlistexCount.Done;
 begin
  Dispose(_ListEx, Done);

  inherited Done;
 end;

{ listexAdd(const ListEx: Pointer; const Mask: String): Boolean; }

type
 PlistexAdd = ^TlistexAdd;
 TlistexAdd = object(TBooleanExpression)
  _ListEx: PNumberExpression;
  _Mask: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Mask:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexAdd.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Mask: String;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Mask^.Get(ExecuteData, __Mask);

  Boolean(Value):=jt.list.ex.Add(__ListEx, 
    __Mask);
 end;

destructor TlistexAdd.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Mask, Done);

  inherited Done;
 end;

{ listexAddRegExp(const ListEx: Pointer; const Mask: String; const
   RegExp: Pointer): Boolean; }

type
 PlistexAddRegExp = ^TlistexAddRegExp;
 TlistexAddRegExp = object(TBooleanExpression)
  _ListEx: PNumberExpression;
  _Mask: PStringExpression;
  _RegExp: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexAddRegExp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexAddRegExp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Mask:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _RegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexAddRegExp.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Mask: String;
  __RegExp: Pointer;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Mask^.Get(ExecuteData, __Mask);
  _RegExp^.Get(ExecuteData, __RegExp);

  Boolean(Value):=jt.list.ex.AddRegExp(__ListEx, 
    __Mask, 
    __RegExp);
 end;

destructor TlistexAddRegExp.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Mask, Done);
  Dispose(_RegExp, Done);

  inherited Done;
 end;

{ listexAddWildcard(const ListEx: Pointer; const Wildcard: String):
   Boolean; }

type
 PlistexAddWildcard = ^TlistexAddWildcard;
 TlistexAddWildcard = object(TBooleanExpression)
  _ListEx: PNumberExpression;
  _Wildcard: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexAddWildcard.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexAddWildcard', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Wildcard:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexAddWildcard.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Wildcard: String;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Wildcard^.Get(ExecuteData, __Wildcard);

  Boolean(Value):=jt.list.ex.AddWildcard(__ListEx, 
    __Wildcard);
 end;

destructor TlistexAddWildcard.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Wildcard, Done);

  inherited Done;
 end;

{ listexOptimize(const ListEx: Pointer); }

type
 PlistexOptimize = ^TlistexOptimize;
 TlistexOptimize = object(TAction)
  _ListEx: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlistexOptimize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexOptimize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlistexOptimize.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __ListEx: Pointer;
 begin
  _ListEx^.Get(Data, __ListEx);

  jt.list.ex.Optimize(__ListEx);

  Execute:=erOk;
 end;

destructor TlistexOptimize.Done;
 begin
  Dispose(_ListEx, Done);

  inherited Done;
 end;

{ listexGetError(const ListEx: Pointer): String; }

type
 PlistexGetError = ^TlistexGetError;
 TlistexGetError = object(TStringExpression)
  _ListEx: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexGetError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexGetError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexGetError.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);

  String(Value):=jt.list.ex.GetError(__ListEx);
 end;

destructor TlistexGetError.Done;
 begin
  Dispose(_ListEx, Done);

  inherited Done;
 end;

{ listexCheck(const ListEx: Pointer; const Value: String): Boolean; }

type
 PlistexCheck = ^TlistexCheck;
 TlistexCheck = object(TBooleanExpression)
  _ListEx: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexCheck.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexCheck', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexCheck.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Value: String;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Value^.Get(ExecuteData, __Value);

  Boolean(Value):=jt.list.ex.Check(__ListEx, 
    __Value);
 end;

destructor TlistexCheck.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ listexCheckPChar(const ListEx: Pointer; const Value: PChar): Boolean; }

type
 PlistexCheckPChar = ^TlistexCheckPChar;
 TlistexCheckPChar = object(TBooleanExpression)
  _ListEx: PNumberExpression;
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistexCheckPChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listexCheckPChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ListEx:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistexCheckPChar.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ListEx: Pointer;
  __Value: PChar;
 begin
  _ListEx^.Get(ExecuteData, __ListEx);
  _Value^.Get(ExecuteData, __Value);

  Boolean(Value):=jt.list.ex.CheckPChar(__ListEx, 
    __Value);
 end;

destructor TlistexCheckPChar.Done;
 begin
  Dispose(_ListEx, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ listExportList: Pointer; }

type
 PlistExportList = ^TlistExportList;
 TlistExportList = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlistExportList.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.list.ExportList);
 end;

{ listImportList: Pointer; }

type
 PlistImportList = ^TlistImportList;
 TlistImportList = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TlistImportList.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.list.ImportList);
 end;

{ listAdd(const List: Pointer; const S: String); }

type
 PlistAdd = ^TlistAdd;
 TlistAdd = object(TAction)
  _List: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlistAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _List:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlistAdd.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __List: Pointer;
  __S: String;
 begin
  _List^.Get(Data, __List);
  _S^.Get(Data, __S);

  jt.list.Add(__List, 
    __S);

  Execute:=erOk;
 end;

destructor TlistAdd.Done;
 begin
  Dispose(_List, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ listRemove(const List: Pointer; const S: String); }

type
 PlistRemove = ^TlistRemove;
 TlistRemove = object(TAction)
  _List: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlistRemove.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listRemove', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _List:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlistRemove.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __List: Pointer;
  __S: String;
 begin
  _List^.Get(Data, __List);
  _S^.Get(Data, __S);

  jt.list.Remove(__List, 
    __S);

  Execute:=erOk;
 end;

destructor TlistRemove.Done;
 begin
  Dispose(_List, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ listCount(const List: Pointer): Longint; }

type
 PlistCount = ^TlistCount;
 TlistCount = object(TNumberExpression)
  _List: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _List:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __List: Pointer;
 begin
  _List^.Get(ExecuteData, __List);

  Longint(Value):=Longint(jt.list.Count(__List));
 end;

destructor TlistCount.Done;
 begin
  Dispose(_List, Done);

  inherited Done;
 end;

{ listAt(const List: Pointer; const Index: Longint): String; }

type
 PlistAt = ^TlistAt;
 TlistAt = object(TStringExpression)
  _List: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TlistAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _List:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TlistAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __List: Pointer;
  __Index: Longint;
 begin
  _List^.Get(ExecuteData, __List);
  _Index^.Get(ExecuteData, __Index);

  String(Value):=jt.list.At(__List, 
    __Index);
 end;

destructor TlistAt.Done;
 begin
  Dispose(_List, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ listFlush(const List: Pointer); }

type
 PlistFlush = ^TlistFlush;
 TlistFlush = object(TAction)
  _List: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TlistFlush.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('listFlush', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _List:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TlistFlush.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __List: Pointer;
 begin
  _List^.Get(Data, __List);

  jt.list.Flush(__List);

  Execute:=erOk;
 end;

destructor TlistFlush.Done;
 begin
  Dispose(_List, Done);

  inherited Done;
 end;

{ plugsSeek(const Name: String): Pointer; }

type
 PplugsSeek = ^TplugsSeek;
 TplugsSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TplugsSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TplugsSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.plugs.Seek(__Name));
 end;

destructor TplugsSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ plugsCount: Longint; }

type
 PplugsCount = ^TplugsCount;
 TplugsCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TplugsCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.plugs.Count);
 end;

{ plugsAt(const Index: Longint): Pointer; }

type
 PplugsAt = ^TplugsAt;
 TplugsAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TplugsAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TplugsAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.plugs.At(__Index));
 end;

destructor TplugsAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ plugsGetInformation(const Plugin: Pointer; var Information: TPluginInformation); }

type
 PplugsGetInformation = ^TplugsGetInformation;
 TplugsGetInformation = object(TAction)
  _Plugin: PNumberExpression;
  _Information: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetInformation.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetInformation', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Information:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Information^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetInformation.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  __Information: PPluginInformation;
 begin
  _Plugin^.Get(Data, __Plugin);
  _Information^.Get(Data, __Information);

  jt.plugs.GetInformation(__Plugin, 
    __Information^);

  Execute:=erOk;
 end;

destructor TplugsGetInformation.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_Information, Done);

  inherited Done;
 end;

{ plugsGetPluginFName(const Plugin: Pointer; var FName: String); }

type
 PplugsGetPluginFName = ^TplugsGetPluginFName;
 TplugsGetPluginFName = object(TAction)
  _Plugin: PNumberExpression;
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginFName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginFName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _FName^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginFName.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  __FName: String;
 begin
  _Plugin^.Get(Data, __Plugin);
  _FName^.Get(Data, __FName);

  jt.plugs.GetPluginFName(__Plugin, 
    __FName);

  _FName^.Assign(Data, __FName);

  Execute:=erOk;
 end;

destructor TplugsGetPluginFName.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_FName, Done);

  inherited Done;
 end;

{ plugsGetPluginHandleCmdlineSwitch(const Plugin: Pointer; var EntryPoint:
   TPluginHandleCmdlineSwitch); }

type
 PplugsGetPluginHandleCmdlineSwitch = ^TplugsGetPluginHandleCmdlineSwitch;
 TplugsGetPluginHandleCmdlineSwitch = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginHandleCmdlineSwitch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginHandleCmdlineSwitch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginHandleCmdlineSwitch.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginHandleCmdlineSwitch;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginHandleCmdlineSwitch(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginHandleCmdlineSwitch.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginHandleCommand(const Plugin: Pointer; var EntryPoint:
   TPluginHandleCommand); }

type
 PplugsGetPluginHandleCommand = ^TplugsGetPluginHandleCommand;
 TplugsGetPluginHandleCommand = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginHandleCommand.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginHandleCommand', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginHandleCommand.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginHandleCommand;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginHandleCommand(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginHandleCommand.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginHandleConfigSwitch(const Plugin: Pointer; var EntryPoint:
   TPluginHandleConfigSwitch); }

type
 PplugsGetPluginHandleConfigSwitch = ^TplugsGetPluginHandleConfigSwitch;
 TplugsGetPluginHandleConfigSwitch = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginHandleConfigSwitch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginHandleConfigSwitch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginHandleConfigSwitch.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginHandleConfigSwitch;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginHandleConfigSwitch(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginHandleConfigSwitch.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginShowHelp(const Plugin: Pointer; var EntryPoint:
   TPluginShowHelp); }

type
 PplugsGetPluginShowHelp = ^TplugsGetPluginShowHelp;
 TplugsGetPluginShowHelp = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginShowHelp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginShowHelp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginShowHelp.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginShowHelp;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginShowHelp(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginShowHelp.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginHandleAreaSwitch(const Plugin: Pointer; var EntryPoint:
   TPluginHandleAreaSwitch); }

type
 PplugsGetPluginHandleAreaSwitch = ^TplugsGetPluginHandleAreaSwitch;
 TplugsGetPluginHandleAreaSwitch = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginHandleAreaSwitch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginHandleAreaSwitch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginHandleAreaSwitch.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginHandleAreaSwitch;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginHandleAreaSwitch(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginHandleAreaSwitch.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginHandleLinkSwitch(const Plugin: Pointer; var EntryPoint:
   TPluginHandleLinkSwitch); }

type
 PplugsGetPluginHandleLinkSwitch = ^TplugsGetPluginHandleLinkSwitch;
 TplugsGetPluginHandleLinkSwitch = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginHandleLinkSwitch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginHandleLinkSwitch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginHandleLinkSwitch.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginHandleLinkSwitch;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginHandleLinkSwitch(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginHandleLinkSwitch.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginExportAreaSwitches(const Plugin: Pointer; var EntryPoint:
   TPluginExportAreaSwitches); }

type
 PplugsGetPluginExportAreaSwitches = ^TplugsGetPluginExportAreaSwitches;
 TplugsGetPluginExportAreaSwitches = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginExportAreaSwitches.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginExportAreaSwitches', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginExportAreaSwitches.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginExportAreaSwitches;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginExportAreaSwitches(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginExportAreaSwitches.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsGetPluginExportLinkSwitches(const Plugin: Pointer; var EntryPoint:
   TPluginExportLinkSwitches); }

type
 PplugsGetPluginExportLinkSwitches = ^TplugsGetPluginExportLinkSwitches;
 TplugsGetPluginExportLinkSwitches = object(TAction)
  _Plugin: PNumberExpression;
  _EntryPoint: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginExportLinkSwitches.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginExportLinkSwitches', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _EntryPoint:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _EntryPoint^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TplugsGetPluginExportLinkSwitches.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
  ___EntryPoint: TPluginExportLinkSwitches;
  __EntryPoint: Longint absolute ___EntryPoint;
 begin
  _Plugin^.Get(Data, __Plugin);
  _EntryPoint^.Get(Data, __EntryPoint);

  jt.plugs.GetPluginExportLinkSwitches(__Plugin, 
    ___EntryPoint);

  _EntryPoint^.Assign(Data, __EntryPoint);

  Execute:=erOk;
 end;

destructor TplugsGetPluginExportLinkSwitches.Done;
 begin
  Dispose(_Plugin, Done);
  Dispose(_EntryPoint, Done);

  inherited Done;
 end;

{ plugsSt(const Plugin: Pointer): Pointer; }

type
 PplugsSt = ^TplugsSt;
 TplugsSt = object(TNumberExpression)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TplugsSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TplugsSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(ExecuteData, __Plugin);

  Longint(Value):=Longint(jt.plugs.St(__Plugin));
 end;

destructor TplugsSt.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ plugsGetPluginName(const Plugin: Pointer): PString; }

type
 PplugsGetPluginName = ^TplugsGetPluginName;
 TplugsGetPluginName = object(TNumberExpression)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TplugsGetPluginName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('plugsGetPluginName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TplugsGetPluginName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(ExecuteData, __Plugin);

  Longint(Value):=Longint(jt.plugs.GetPluginName(__Plugin));
 end;

destructor TplugsGetPluginName.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ msgpCreate(const Stream: Pointer; const Netmail: Boolean): Pointer; }

type
 PmsgpCreate = ^TmsgpCreate;
 TmsgpCreate = object(TNumberExpression)
  _Stream: PNumberExpression;
  _Netmail: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Stream:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Netmail:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Stream: Pointer;
  __Netmail: Boolean;
 begin
  _Stream^.Get(ExecuteData, __Stream);
  _Netmail^.Get(ExecuteData, __Netmail);

  Longint(Value):=Longint(jt.msg.p.Create(__Stream, 
    __Netmail));
 end;

destructor TmsgpCreate.Done;
 begin
  Dispose(_Stream, Done);
  Dispose(_Netmail, Done);

  inherited Done;
 end;

{ msgpDestroy(const p: Pointer); }

type
 PmsgpDestroy = ^TmsgpDestroy;
 TmsgpDestroy = object(TAction)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
 begin
  _p^.Get(Data, __p);

  jt.msg.p.Destroy(__p);

  Execute:=erOk;
 end;

destructor TmsgpDestroy.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpGetStringPChar(const p: Pointer; const Line: PChar; const
   MaxLen: xInteger); }

type
 PmsgpGetStringPChar = ^TmsgpGetStringPChar;
 TmsgpGetStringPChar = object(TAction)
  _p: PNumberExpression;
  _Line: PNumberExpression;
  _MaxLen: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetStringPChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetStringPChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _MaxLen:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpGetStringPChar.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Line: PChar;
  __MaxLen: Longint;
 begin
  _p^.Get(Data, __p);
  _Line^.Get(Data, __Line);
  _MaxLen^.Get(Data, __MaxLen);

  jt.msg.p.GetStringPChar(__p, 
    __Line, 
    xInteger(__MaxLen));

  Execute:=erOk;
 end;

destructor TmsgpGetStringPChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Line, Done);
  Dispose(_MaxLen, Done);

  inherited Done;
 end;

{ msgpGetStringPCharEx(const p: Pointer): PChar; }

type
 PmsgpGetStringPCharEx = ^TmsgpGetStringPCharEx;
 TmsgpGetStringPCharEx = object(TNumberExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetStringPCharEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetStringPCharEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetStringPCharEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Longint(Value):=Longint(jt.msg.p.GetStringPCharEx(__p));
 end;

destructor TmsgpGetStringPCharEx.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpGetString(const p: Pointer; var Line: String); }

type
 PmsgpGetString = ^TmsgpGetString;
 TmsgpGetString = object(TAction)
  _p: PNumberExpression;
  _Line: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Line^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpGetString.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Line: String;
 begin
  _p^.Get(Data, __p);
  _Line^.Get(Data, __Line);

  jt.msg.p.GetString(__p, 
    __Line);

  _Line^.Assign(Data, __Line);

  Execute:=erOk;
 end;

destructor TmsgpGetString.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ msgpPutStringPChar(const p: Pointer; const Line: PChar); }

type
 PmsgpPutStringPChar = ^TmsgpPutStringPChar;
 TmsgpPutStringPChar = object(TAction)
  _p: PNumberExpression;
  _Line: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpPutStringPChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpPutStringPChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpPutStringPChar.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Line: PChar;
 begin
  _p^.Get(Data, __p);
  _Line^.Get(Data, __Line);

  jt.msg.p.PutStringPChar(__p, 
    __Line);

  Execute:=erOk;
 end;

destructor TmsgpPutStringPChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ msgpPutString(const p: Pointer; const Line: String); }

type
 PmsgpPutString = ^TmsgpPutString;
 TmsgpPutString = object(TAction)
  _p: PNumberExpression;
  _Line: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpPutString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpPutString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Line:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpPutString.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Line: String;
 begin
  _p^.Get(Data, __p);
  _Line^.Get(Data, __Line);

  jt.msg.p.PutString(__p, 
    __Line);

  Execute:=erOk;
 end;

destructor TmsgpPutString.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Line, Done);

  inherited Done;
 end;

{ msgpGetTextPos(const p: Pointer): Longint; }

type
 PmsgpGetTextPos = ^TmsgpGetTextPos;
 TmsgpGetTextPos = object(TNumberExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetTextPos.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetTextPos', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetTextPos.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Longint(Value):=Longint(jt.msg.p.GetTextPos(__p));
 end;

destructor TmsgpGetTextPos.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpGetTextSize(const p: Pointer): Longint; }

type
 PmsgpGetTextSize = ^TmsgpGetTextSize;
 TmsgpGetTextSize = object(TNumberExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetTextSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetTextSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetTextSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Longint(Value):=Longint(jt.msg.p.GetTextSize(__p));
 end;

destructor TmsgpGetTextSize.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

function CreatorLINKINDEXOF(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLINKINDEXOF:=New(PlinkIndexOf, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILLEDAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLEDAT:=New(PareakilledAt, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILLEDCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLEDCOUNT:=New(PareakilledCount, Init('areakilledCount', Actions));
 end;

function CreatorAREAKILLEDSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLEDSEEK:=New(PareakilledSeek, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILLEDCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLEDCREATE:=New(PareakilledCreate, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILLEDDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLEDDESTROY:=New(PareakilledDestroy, Init(Tokenizer, Actions));
 end;

function CreatorAREASEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASEEK:=New(PareaSeek, Init(Tokenizer, Actions));
 end;

function CreatorAREASEEKNETMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASEEKNETMAIL:=New(PareaSeekNetmail, Init('areaSeekNetmail', Actions));
 end;

function CreatorAREASEEKBADMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASEEKBADMAIL:=New(PareaSeekBadmail, Init('areaSeekBadmail', Actions));
 end;

function CreatorAREACREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREACREATE:=New(PareaCreate, Init(Tokenizer, Actions));
 end;

function CreatorAREADESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREADESTROY:=New(PareaDestroy, Init(Tokenizer, Actions));
 end;

function CreatorAREAAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAAT:=New(PareaAt, Init(Tokenizer, Actions));
 end;

function CreatorAREACOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREACOUNT:=New(PareaCount, Init('areaCount', Actions));
 end;

function CreatorAREASETCHANGED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASETCHANGED:=New(PareaSetChanged, Init(Tokenizer, Actions));
 end;

function CreatorAREAGETNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAGETNAME:=New(PareaGetName, Init(Tokenizer, Actions));
 end;

function CreatorAREASETNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASETNAME:=New(PareaSetName, Init(Tokenizer, Actions));
 end;

function CreatorAREAGETDESC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAGETDESC:=New(PareaGetDesc, Init(Tokenizer, Actions));
 end;

function CreatorAREASETDESC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASETDESC:=New(PareaSetDesc, Init(Tokenizer, Actions));
 end;

function CreatorAREAGETFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAGETFORMAT:=New(PareaGetFormat, Init(Tokenizer, Actions));
 end;

function CreatorAREASETFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASETFORMAT:=New(PareaSetFormat, Init(Tokenizer, Actions));
 end;

function CreatorAREAGETUPLINK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAGETUPLINK:=New(PareaGetUplink, Init(Tokenizer, Actions));
 end;

function CreatorAREASETUPLINK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREASETUPLINK:=New(PareaSetUplink, Init(Tokenizer, Actions));
 end;

function CreatorAREAST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAST:=New(PareaSt, Init(Tokenizer, Actions));
 end;

function CreatorAREAGETAKA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAGETAKA:=New(PareaGetAka, Init(Tokenizer, Actions));
 end;

function CreatorAREALOCK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREALOCK:=New(PareaLock, Init(Tokenizer, Actions));
 end;

function CreatorAREAUNLOCK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAUNLOCK:=New(PareaUnlock, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILL:=New(PareaKill, Init(Tokenizer, Actions));
 end;

function CreatorAREAPACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAPACK:=New(PareaPack, Init(Tokenizer, Actions));
 end;

function CreatorAREAREGISTERNOTIFYAREACREATED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAREGISTERNOTIFYAREACREATED:=New(PareaRegisterNotifyAreaCreated, Init(Tokenizer, Actions));
 end;

function CreatorAREAREGISTERNOTIFYAREACHANGED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAREGISTERNOTIFYAREACHANGED:=New(PareaRegisterNotifyAreaChanged, Init(Tokenizer, Actions));
 end;

function CreatorAREAREGISTERNOTIFYAREADESTROYED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAREGISTERNOTIFYAREADESTROYED:=New(PareaRegisterNotifyAreaDestroyed, Init(Tokenizer, Actions));
 end;

function CreatorAREANOTIFYAREACREATED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREANOTIFYAREACREATED:=New(PareaNotifyAreaCreated, Init(Tokenizer, Actions));
 end;

function CreatorAREANOTIFYAREACHANGED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREANOTIFYAREACHANGED:=New(PareaNotifyAreaChanged, Init(Tokenizer, Actions));
 end;

function CreatorAREANOTIFYAREADESTROYED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREANOTIFYAREADESTROYED:=New(PareaNotifyAreaDestroyed, Init(Tokenizer, Actions));
 end;

function CreatorAREAINDEXOF(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAINDEXOF:=New(PareaIndexOf, Init(Tokenizer, Actions));
 end;

function CreatorAREAKILLBASE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAKILLBASE:=New(PareaKillBase, Init(Tokenizer, Actions));
 end;

function CreatorAREAISBASEEXISTS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAISBASEEXISTS:=New(PareaIsBaseExists, Init(Tokenizer, Actions));
 end;

function CreatorAREAMINIMIZEHANDLES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAMINIMIZEHANDLES:=New(PareaMinimizeHandles, Init('areaMinimizeHandles', Actions));
 end;

function CreatorAREAUSED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAUSED:=New(PareaUsed, Init(Tokenizer, Actions));
 end;

function CreatorAREANETMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREANETMAIL:=New(PareaNetmail, Init(Tokenizer, Actions));
 end;

function CreatorAREAPASSTHROUGH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAPASSTHROUGH:=New(PareaPassthrough, Init(Tokenizer, Actions));
 end;

function CreatorAREAMBI(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAMBI:=New(Pareambi, Init(Tokenizer, Actions));
 end;

function CreatorAREAPACKEX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAPACKEX:=New(PareaPackEx, Init(Tokenizer, Actions));
 end;

function CreatorRESTSADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSADD:=New(PrestsAdd, Init(Tokenizer, Actions));
 end;

function CreatorRESTSADDVALUEPARSER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSADDVALUEPARSER:=New(PrestsAddValueParser, Init(Tokenizer, Actions));
 end;

function CreatorRESTSCHECK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSCHECK:=New(PrestsCheck, Init(Tokenizer, Actions));
 end;

function CreatorRESTSGETVALUE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSGETVALUE:=New(PrestsGetValue, Init(Tokenizer, Actions));
 end;

function CreatorRESTSCALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSCALLBACK:=New(PrestsCallback, Init(Tokenizer, Actions));
 end;

function CreatorRESTSGETST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSGETST:=New(PrestsGetst, Init(Tokenizer, Actions));
 end;

function CreatorRESTSGETUSED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRESTSGETUSED:=New(PrestsGetUsed, Init(Tokenizer, Actions));
 end;

function CreatorARCSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCSEEK:=New(ParcSeek, Init(Tokenizer, Actions));
 end;

function CreatorARCIDENTIFY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCIDENTIFY:=New(ParcIdentify, Init(Tokenizer, Actions));
 end;

function CreatorARCCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCCOUNT:=New(ParcCount, Init('arcCount', Actions));
 end;

function CreatorARCAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCAT:=New(ParcAt, Init(Tokenizer, Actions));
 end;

function CreatorARCGETNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCGETNAME:=New(ParcGetName, Init(Tokenizer, Actions));
 end;

function CreatorARCGETADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCGETADD:=New(ParcGetAdd, Init(Tokenizer, Actions));
 end;

function CreatorARCGETEXTRACT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCGETEXTRACT:=New(ParcGetExtract, Init(Tokenizer, Actions));
 end;

function CreatorARCQUIET(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorARCQUIET:=New(ParcQuiet, Init('arcQuiet', Actions));
 end;

function CreatorLISTEXCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXCREATE:=New(PlistexCreate, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXCLONE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXCLONE:=New(PlistexClone, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXDESTROY:=New(PlistexDestroy, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXAT:=New(PlistexAt, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXCOUNT:=New(PlistexCount, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXADD:=New(PlistexAdd, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXADDREGEXP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXADDREGEXP:=New(PlistexAddRegExp, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXADDWILDCARD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXADDWILDCARD:=New(PlistexAddWildcard, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXOPTIMIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXOPTIMIZE:=New(PlistexOptimize, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXGETERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXGETERROR:=New(PlistexGetError, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXCHECK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXCHECK:=New(PlistexCheck, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXCHECKPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXCHECKPCHAR:=New(PlistexCheckPChar, Init(Tokenizer, Actions));
 end;

function CreatorLISTEXPORTLIST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTEXPORTLIST:=New(PlistExportList, Init('listExportList', Actions));
 end;

function CreatorLISTIMPORTLIST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTIMPORTLIST:=New(PlistImportList, Init('listImportList', Actions));
 end;

function CreatorLISTADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTADD:=New(PlistAdd, Init(Tokenizer, Actions));
 end;

function CreatorLISTREMOVE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTREMOVE:=New(PlistRemove, Init(Tokenizer, Actions));
 end;

function CreatorLISTCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTCOUNT:=New(PlistCount, Init(Tokenizer, Actions));
 end;

function CreatorLISTAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTAT:=New(PlistAt, Init(Tokenizer, Actions));
 end;

function CreatorLISTFLUSH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorLISTFLUSH:=New(PlistFlush, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSSEEK:=New(PplugsSeek, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSCOUNT:=New(PplugsCount, Init('plugsCount', Actions));
 end;

function CreatorPLUGSAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSAT:=New(PplugsAt, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETINFORMATION(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETINFORMATION:=New(PplugsGetInformation, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINFNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINFNAME:=New(PplugsGetPluginFName, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINHANDLECMDLINESWITCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINHANDLECMDLINESWITCH:=New(PplugsGetPluginHandleCmdlineSwitch, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINHANDLECOMMAND(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINHANDLECOMMAND:=New(PplugsGetPluginHandleCommand, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINHANDLECONFIGSWITCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINHANDLECONFIGSWITCH:=New(PplugsGetPluginHandleConfigSwitch, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINSHOWHELP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINSHOWHELP:=New(PplugsGetPluginShowHelp, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINHANDLEAREASWITCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINHANDLEAREASWITCH:=New(PplugsGetPluginHandleAreaSwitch, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINHANDLELINKSWITCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINHANDLELINKSWITCH:=New(PplugsGetPluginHandleLinkSwitch, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINEXPORTAREASWITCHES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINEXPORTAREASWITCHES:=New(PplugsGetPluginExportAreaSwitches, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINEXPORTLINKSWITCHES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINEXPORTLINKSWITCHES:=New(PplugsGetPluginExportLinkSwitches, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSST:=New(PplugsSt, Init(Tokenizer, Actions));
 end;

function CreatorPLUGSGETPLUGINNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPLUGSGETPLUGINNAME:=New(PplugsGetPluginName, Init(Tokenizer, Actions));
 end;

function CreatorMSGPCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPCREATE:=New(PmsgpCreate, Init(Tokenizer, Actions));
 end;

function CreatorMSGPDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPDESTROY:=New(PmsgpDestroy, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETSTRINGPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETSTRINGPCHAR:=New(PmsgpGetStringPChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETSTRINGPCHAREX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETSTRINGPCHAREX:=New(PmsgpGetStringPCharEx, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETSTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETSTRING:=New(PmsgpGetString, Init(Tokenizer, Actions));
 end;

function CreatorMSGPPUTSTRINGPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPPUTSTRINGPCHAR:=New(PmsgpPutStringPChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPPUTSTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPPUTSTRING:=New(PmsgpPutString, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETTEXTPOS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETTEXTPOS:=New(PmsgpGetTextPos, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETTEXTSIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETTEXTSIZE:=New(PmsgpGetTextSize, Init(Tokenizer, Actions));
 end;

{ AddJTAPIProtos }

procedure AddJTAPIProtos(const Target: PActions);
 begin
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LINKINDEXOF', CreatorLINKINDEXOF)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAKILLEDAT', CreatorAREAKILLEDAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAKILLEDCOUNT',
    CreatorAREAKILLEDCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAKILLEDSEEK',
    CreatorAREAKILLEDSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAKILLEDCREATE',
    CreatorAREAKILLEDCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAKILLEDDESTROY', CreatorAREAKILLEDDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREASEEK', CreatorAREASEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREASEEKNETMAIL',
    CreatorAREASEEKNETMAIL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREASEEKBADMAIL',
    CreatorAREASEEKBADMAIL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREACREATE', CreatorAREACREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREADESTROY', CreatorAREADESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAAT', CreatorAREAAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREACOUNT', CreatorAREACOUNT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREASETCHANGED', CreatorAREASETCHANGED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAGETNAME', CreatorAREAGETNAME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREASETNAME', CreatorAREASETNAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAGETDESC', CreatorAREAGETDESC)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREASETDESC', CreatorAREASETDESC)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAGETFORMAT', CreatorAREAGETFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREASETFORMAT', CreatorAREASETFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAGETUPLINK', CreatorAREAGETUPLINK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREASETUPLINK', CreatorAREASETUPLINK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAST', CreatorAREAST)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAGETAKA', CreatorAREAGETAKA)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREALOCK', CreatorAREALOCK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAUNLOCK', CreatorAREAUNLOCK)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAKILL', CreatorAREAKILL)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAPACK', CreatorAREAPACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAREGISTERNOTIFYAREACREATED',
    CreatorAREAREGISTERNOTIFYAREACREATED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAREGISTERNOTIFYAREACHANGED',
    CreatorAREAREGISTERNOTIFYAREACHANGED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAREGISTERNOTIFYAREADESTROYED',
    CreatorAREAREGISTERNOTIFYAREADESTROYED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREANOTIFYAREACREATED',
    CreatorAREANOTIFYAREACREATED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREANOTIFYAREACHANGED',
    CreatorAREANOTIFYAREACHANGED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREANOTIFYAREADESTROYED',
    CreatorAREANOTIFYAREADESTROYED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAINDEXOF', CreatorAREAINDEXOF)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAKILLBASE', CreatorAREAKILLBASE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAISBASEEXISTS',
    CreatorAREAISBASEEXISTS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAMINIMIZEHANDLES',
    CreatorAREAMINIMIZEHANDLES)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAUSED', CreatorAREAUSED)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREANETMAIL', CreatorAREANETMAIL)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAPASSTHROUGH',
    CreatorAREAPASSTHROUGH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('AREAMBI', CreatorAREAMBI)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('AREAPACKEX', CreatorAREAPACKEX)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RESTSADD', CreatorRESTSADD)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RESTSADDVALUEPARSER',
    CreatorRESTSADDVALUEPARSER)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('RESTSCHECK', CreatorRESTSCHECK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('RESTSGETVALUE', CreatorRESTSGETVALUE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('RESTSCALLBACK', CreatorRESTSCALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('RESTSGETST', CreatorRESTSGETST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RESTSGETUSED', CreatorRESTSGETUSED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('ARCSEEK', CreatorARCSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('ARCIDENTIFY', CreatorARCIDENTIFY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('ARCCOUNT', CreatorARCCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('ARCAT', CreatorARCAT)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ARCGETNAME', CreatorARCGETNAME)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ARCGETADD', CreatorARCGETADD)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ARCGETEXTRACT',
    CreatorARCGETEXTRACT)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ARCQUIET', CreatorARCQUIET)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTEXCREATE', CreatorLISTEXCREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTEXCLONE', CreatorLISTEXCLONE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LISTEXDESTROY', CreatorLISTEXDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTEXAT', CreatorLISTEXAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTEXCOUNT', CreatorLISTEXCOUNT)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LISTEXADD', CreatorLISTEXADD)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LISTEXADDREGEXP',
    CreatorLISTEXADDREGEXP)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LISTEXADDWILDCARD',
    CreatorLISTEXADDWILDCARD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LISTEXOPTIMIZE', CreatorLISTEXOPTIMIZE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LISTEXGETERROR',
    CreatorLISTEXGETERROR)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LISTEXCHECK', CreatorLISTEXCHECK)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('LISTEXCHECKPCHAR',
    CreatorLISTEXCHECKPCHAR)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTEXPORTLIST',
    CreatorLISTEXPORTLIST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTIMPORTLIST',
    CreatorLISTIMPORTLIST)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LISTADD', CreatorLISTADD)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LISTREMOVE', CreatorLISTREMOVE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('LISTCOUNT', CreatorLISTCOUNT)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('LISTAT', CreatorLISTAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('LISTFLUSH', CreatorLISTFLUSH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PLUGSSEEK', CreatorPLUGSSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PLUGSCOUNT', CreatorPLUGSCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PLUGSAT', CreatorPLUGSAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETINFORMATION',
    CreatorPLUGSGETINFORMATION)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINFNAME',
    CreatorPLUGSGETPLUGINFNAME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINHANDLECMDLINESWITCH',
    CreatorPLUGSGETPLUGINHANDLECMDLINESWITCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINHANDLECOMMAND',
    CreatorPLUGSGETPLUGINHANDLECOMMAND)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINHANDLECONFIGSWITCH',
    CreatorPLUGSGETPLUGINHANDLECONFIGSWITCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINSHOWHELP',
    CreatorPLUGSGETPLUGINSHOWHELP)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINHANDLEAREASWITCH',
    CreatorPLUGSGETPLUGINHANDLEAREASWITCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINHANDLELINKSWITCH',
    CreatorPLUGSGETPLUGINHANDLELINKSWITCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINEXPORTAREASWITCHES',
    CreatorPLUGSGETPLUGINEXPORTAREASWITCHES)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PLUGSGETPLUGINEXPORTLINKSWITCHES',
    CreatorPLUGSGETPLUGINEXPORTLINKSWITCHES)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PLUGSST', CreatorPLUGSST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PLUGSGETPLUGINNAME',
    CreatorPLUGSGETPLUGINNAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPCREATE', CreatorMSGPCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPDESTROY', CreatorMSGPDESTROY)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPGETSTRINGPCHAR',
    CreatorMSGPGETSTRINGPCHAR)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPGETSTRINGPCHAREX',
    CreatorMSGPGETSTRINGPCHAREX)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPGETSTRING', CreatorMSGPGETSTRING)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPPUTSTRINGPCHAR',
    CreatorMSGPPUTSTRINGPCHAR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPPUTSTRING', CreatorMSGPPUTSTRING)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPGETTEXTPOS',
    CreatorMSGPGETTEXTPOS)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPGETTEXTSIZE',
    CreatorMSGPGETTEXTSIZE)));
 end;

end.
