{$IFNDEF VIRTUALPASCAL}
{$D-}
{$ENDIF}
unit ccJTAPI2;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     ccAPI,
     ccAction,
     ccCmn,
     ccCode,
     ccExpr,
     ccJTSupp,
     ccProto,
     ccRoot,
     ccSupp,
     ccToken,

     jtMHLcmn,

     Thunks,

     Wizard;

procedure AddJTAPIProtos(const Target: PActions);

implementation

{ msgpSetTextPos(const p: Pointer; const NewPos: Longint); }

type
 PmsgpSetTextPos = ^TmsgpSetTextPos;
 TmsgpSetTextPos = object(TAction)
  _p: PNumberExpression;
  _NewPos: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetTextPos.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetTextPos', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _NewPos:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetTextPos.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __NewPos: Longint;
 begin
  _p^.Get(Data, __p);
  _NewPos^.Get(Data, __NewPos);

  jt.msg.p.SetTextPos(__p, 
    __NewPos);

  Execute:=erOk;
 end;

destructor TmsgpSetTextPos.Done;
 begin
  Dispose(_p, Done);
  Dispose(_NewPos, Done);

  inherited Done;
 end;

{ msgpEndOfMessage(const p: Pointer): Boolean; }

type
 PmsgpEndOfMessage = ^TmsgpEndOfMessage;
 TmsgpEndOfMessage = object(TBooleanExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpEndOfMessage.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpEndOfMessage', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpEndOfMessage.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Boolean(Value):=jt.msg.p.EndOfMessage(__p);
 end;

destructor TmsgpEndOfMessage.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpTruncateText(const p: Pointer); }

type
 PmsgpTruncateText = ^TmsgpTruncateText;
 TmsgpTruncateText = object(TAction)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpTruncateText.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpTruncateText', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpTruncateText.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
 begin
  _p^.Get(Data, __p);

  jt.msg.p.TruncateText(__p);

  Execute:=erOk;
 end;

destructor TmsgpTruncateText.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpGetFromAddress(const p: Pointer; var Address: TAddress); }

type
 PmsgpGetFromAddress = ^TmsgpGetFromAddress;
 TmsgpGetFromAddress = object(TAction)
  _p: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetFromAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetFromAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpGetFromAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _Address^.Get(Data, __Address);

  jt.msg.p.GetFromAddress(__p, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpGetFromAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpGetToAddress(const p: Pointer; var Address: TAddress); }

type
 PmsgpGetToAddress = ^TmsgpGetToAddress;
 TmsgpGetToAddress = object(TAction)
  _p: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpGetToAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _Address^.Get(Data, __Address);

  jt.msg.p.GetToAddress(__p, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpGetToAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpGetFromAndToAddress(const p: Pointer; var FromAddress, ToAddress:
   TAddress); }

type
 PmsgpGetFromAndToAddress = ^TmsgpGetFromAndToAddress;
 TmsgpGetFromAndToAddress = object(TAction)
  _p: PNumberExpression;
  _FromAddress: PNumberExpression;
  _ToAddress: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetFromAndToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetFromAndToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FromAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _FromAddress^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _ToAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _ToAddress^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpGetFromAndToAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __FromAddress: PAddress;
  __ToAddress: PAddress;
 begin
  _p^.Get(Data, __p);
  _FromAddress^.Get(Data, __FromAddress);
  _ToAddress^.Get(Data, __ToAddress);

  jt.msg.p.GetFromAndToAddress(__p, 
    __FromAddress^, 
    __ToAddress^);

  Execute:=erOk;
 end;

destructor TmsgpGetFromAndToAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_FromAddress, Done);
  Dispose(_ToAddress, Done);

  inherited Done;
 end;

{ msgpSetFromAddress(const p: Pointer; var Address: TAddress; const
   FreshMSGID: Boolean); }

type
 PmsgpSetFromAddress = ^TmsgpSetFromAddress;
 TmsgpSetFromAddress = object(TAction)
  _p: PNumberExpression;
  _Address: PNumberExpression;
  _FreshMSGID: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetFromAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetFromAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _FreshMSGID:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetFromAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Address: PAddress;
  __FreshMSGID: Boolean;
 begin
  _p^.Get(Data, __p);
  _Address^.Get(Data, __Address);
  _FreshMSGID^.Get(Data, __FreshMSGID);

  jt.msg.p.SetFromAddress(__p, 
    __Address^, 
    __FreshMSGID);

  Execute:=erOk;
 end;

destructor TmsgpSetFromAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Address, Done);
  Dispose(_FreshMSGID, Done);

  inherited Done;
 end;

{ msgpSetToAddress(const p: Pointer; var Address: TAddress); }

type
 PmsgpSetToAddress = ^TmsgpSetToAddress;
 TmsgpSetToAddress = object(TAction)
  _p: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetToAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _Address^.Get(Data, __Address);

  jt.msg.p.SetToAddress(__p, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpSetToAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpSetFromAndToAddress(const p: Pointer; var FromAddress, ToAddress:
   TAddress; const FreshMSGID: Boolean); }

type
 PmsgpSetFromAndToAddress = ^TmsgpSetFromAndToAddress;
 TmsgpSetFromAndToAddress = object(TAction)
  _p: PNumberExpression;
  _FromAddress: PNumberExpression;
  _ToAddress: PNumberExpression;
  _FreshMSGID: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetFromAndToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetFromAndToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FromAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _FromAddress^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _ToAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _ToAddress^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _FreshMSGID:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetFromAndToAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __FromAddress: PAddress;
  __ToAddress: PAddress;
  __FreshMSGID: Boolean;
 begin
  _p^.Get(Data, __p);
  _FromAddress^.Get(Data, __FromAddress);
  _ToAddress^.Get(Data, __ToAddress);
  _FreshMSGID^.Get(Data, __FreshMSGID);

  jt.msg.p.SetFromAndToAddress(__p, 
    __FromAddress^, 
    __ToAddress^, 
    __FreshMSGID);

  Execute:=erOk;
 end;

destructor TmsgpSetFromAndToAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_FromAddress, Done);
  Dispose(_ToAddress, Done);
  Dispose(_FreshMSGID, Done);

  inherited Done;
 end;

{ msgpCheckFromAddress(const p: Pointer; const S: String; var Address:
   TAddress); }

type
 PmsgpCheckFromAddress = ^TmsgpCheckFromAddress;
 TmsgpCheckFromAddress = object(TAction)
  _p: PNumberExpression;
  _S: PStringExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpCheckFromAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpCheckFromAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpCheckFromAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __S: String;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _S^.Get(Data, __S);
  _Address^.Get(Data, __Address);

  jt.msg.p.CheckFromAddress(__p, 
    __S, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpCheckFromAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_S, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpCheckToAddress(const p: Pointer; const S: String; var Address:
   TAddress); }

type
 PmsgpCheckToAddress = ^TmsgpCheckToAddress;
 TmsgpCheckToAddress = object(TAction)
  _p: PNumberExpression;
  _S: PStringExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpCheckToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpCheckToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpCheckToAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __S: String;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _S^.Get(Data, __S);
  _Address^.Get(Data, __Address);

  jt.msg.p.CheckToAddress(__p, 
    __S, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpCheckToAddress.Done;
 begin
  Dispose(_p, Done);
  Dispose(_S, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpGetKludgePChar(const p: Pointer; const Name, Destination:
   PChar; const MaxLen: Word): Boolean; }

type
 PmsgpGetKludgePChar = ^TmsgpGetKludgePChar;
 TmsgpGetKludgePChar = object(TBooleanExpression)
  _p: PNumberExpression;
  _Name: PNumberExpression;
  _Destination: PNumberExpression;
  _MaxLen: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetKludgePChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetKludgePChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Destination:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _MaxLen:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetKludgePChar.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
  __Name: PChar;
  __Destination: PChar;
  __MaxLen: Longint;
 begin
  _p^.Get(ExecuteData, __p);
  _Name^.Get(ExecuteData, __Name);
  _Destination^.Get(ExecuteData, __Destination);
  _MaxLen^.Get(ExecuteData, __MaxLen);

  Boolean(Value):=jt.msg.p.GetKludgePChar(__p, 
    __Name, 
    __Destination, 
    Word(__MaxLen));
 end;

destructor TmsgpGetKludgePChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);
  Dispose(_Destination, Done);
  Dispose(_MaxLen, Done);

  inherited Done;
 end;

{ msgpGetKludge(const p: Pointer; const Name: String; var Destination:
   String): Boolean; }

type
 PmsgpGetKludge = ^TmsgpGetKludge;
 TmsgpGetKludge = object(TBooleanExpression)
  _p: PNumberExpression;
  _Name: PStringExpression;
  _Destination: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetKludge.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetKludge', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Destination:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Destination^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetKludge.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
  __Name: String;
  __Destination: String;
 begin
  _p^.Get(ExecuteData, __p);
  _Name^.Get(ExecuteData, __Name);
  _Destination^.Get(ExecuteData, __Destination);

  Boolean(Value):=jt.msg.p.GetKludge(__p, 
    __Name, 
    __Destination);

  _Destination^.Assign(ExecuteData, __Destination);
 end;

destructor TmsgpGetKludge.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);
  Dispose(_Destination, Done);

  inherited Done;
 end;

{ msgpSetKludgePChar(const p: Pointer; const Name, Value: PChar); }

type
 PmsgpSetKludgePChar = ^TmsgpSetKludgePChar;
 TmsgpSetKludgePChar = object(TAction)
  _p: PNumberExpression;
  _Name: PNumberExpression;
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetKludgePChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetKludgePChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetKludgePChar.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Name: PChar;
  __Value: PChar;
 begin
  _p^.Get(Data, __p);
  _Name^.Get(Data, __Name);
  _Value^.Get(Data, __Value);

  jt.msg.p.SetKludgePChar(__p, 
    __Name, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgpSetKludgePChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgpSetKludge(const p: Pointer; const Name, Value: String); }

type
 PmsgpSetKludge = ^TmsgpSetKludge;
 TmsgpSetKludge = object(TAction)
  _p: PNumberExpression;
  _Name: PStringExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpSetKludge.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpSetKludge', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpSetKludge.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Name: String;
  __Value: String;
 begin
  _p^.Get(Data, __p);
  _Name^.Get(Data, __Name);
  _Value^.Get(Data, __Value);

  jt.msg.p.SetKludge(__p, 
    __Name, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgpSetKludge.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgpDeleteKludgePChar(const p: Pointer; const Name: PChar); }

type
 PmsgpDeleteKludgePChar = ^TmsgpDeleteKludgePChar;
 TmsgpDeleteKludgePChar = object(TAction)
  _p: PNumberExpression;
  _Name: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpDeleteKludgePChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpDeleteKludgePChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpDeleteKludgePChar.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Name: PChar;
 begin
  _p^.Get(Data, __p);
  _Name^.Get(Data, __Name);

  jt.msg.p.DeleteKludgePChar(__p, 
    __Name);

  Execute:=erOk;
 end;

destructor TmsgpDeleteKludgePChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ msgpDeleteKludge(const p: Pointer; const Name: String); }

type
 PmsgpDeleteKludge = ^TmsgpDeleteKludge;
 TmsgpDeleteKludge = object(TAction)
  _p: PNumberExpression;
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpDeleteKludge.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpDeleteKludge', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpDeleteKludge.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Name: String;
 begin
  _p^.Get(Data, __p);
  _Name^.Get(Data, __Name);

  jt.msg.p.DeleteKludge(__p, 
    __Name);

  Execute:=erOk;
 end;

destructor TmsgpDeleteKludge.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ msgpAddKludgePChar(const p: Pointer; const Value: PChar); }

type
 PmsgpAddKludgePChar = ^TmsgpAddKludgePChar;
 TmsgpAddKludgePChar = object(TAction)
  _p: PNumberExpression;
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpAddKludgePChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpAddKludgePChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpAddKludgePChar.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Value: PChar;
 begin
  _p^.Get(Data, __p);
  _Value^.Get(Data, __Value);

  jt.msg.p.AddKludgePChar(__p, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgpAddKludgePChar.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgpAddKludge(const p: Pointer; const Value: String); }

type
 PmsgpAddKludge = ^TmsgpAddKludge;
 TmsgpAddKludge = object(TAction)
  _p: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpAddKludge.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpAddKludge', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpAddKludge.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Value: String;
 begin
  _p^.Get(Data, __p);
  _Value^.Get(Data, __Value);

  jt.msg.p.AddKludge(__p, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgpAddKludge.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgpAfterLastKludge(const p: Pointer): Longint; }

type
 PmsgpAfterLastKludge = ^TmsgpAfterLastKludge;
 TmsgpAfterLastKludge = object(TNumberExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpAfterLastKludge.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpAfterLastKludge', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpAfterLastKludge.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Longint(Value):=Longint(jt.msg.p.AfterLastKludge(__p));
 end;

destructor TmsgpAfterLastKludge.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpReadText(const p: Pointer; var Buffer; const Size: Longint); }

type
 PmsgpReadText = ^TmsgpReadText;
 TmsgpReadText = object(TAction)
  _p: PNumberExpression;
  _Buffer: PNumberExpression;
  _Size: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpReadText.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpReadText', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Buffer:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Size:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpReadText.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Buffer: Pointer;
  __Size: Longint;
 begin
  _p^.Get(Data, __p);
  _Buffer^.Get(Data, __Buffer);
  _Size^.Get(Data, __Size);

  jt.msg.p.ReadText(__p, 
    __Buffer^, 
    __Size);

  Execute:=erOk;
 end;

destructor TmsgpReadText.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Buffer, Done);
  Dispose(_Size, Done);

  inherited Done;
 end;

{ msgpWriteText(const p: Pointer; var Buffer; const Size: Longint); }

type
 PmsgpWriteText = ^TmsgpWriteText;
 TmsgpWriteText = object(TAction)
  _p: PNumberExpression;
  _Buffer: PNumberExpression;
  _Size: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpWriteText.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpWriteText', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Buffer:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Size:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpWriteText.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Buffer: Pointer;
  __Size: Longint;
 begin
  _p^.Get(Data, __p);
  _Buffer^.Get(Data, __Buffer);
  _Size^.Get(Data, __Size);

  jt.msg.p.WriteText(__p, 
    __Buffer^, 
    __Size);

  Execute:=erOk;
 end;

destructor TmsgpWriteText.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Buffer, Done);
  Dispose(_Size, Done);

  inherited Done;
 end;

{ msgpPutTearline(const p: Pointer); }

type
 PmsgpPutTearline = ^TmsgpPutTearline;
 TmsgpPutTearline = object(TAction)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpPutTearline.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpPutTearline', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpPutTearline.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
 begin
  _p^.Get(Data, __p);

  jt.msg.p.PutTearline(__p);

  Execute:=erOk;
 end;

destructor TmsgpPutTearline.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpPutOrigin(const p: Pointer; const Address: TAddress); }

type
 PmsgpPutOrigin = ^TmsgpPutOrigin;
 TmsgpPutOrigin = object(TAction)
  _p: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgpPutOrigin.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpPutOrigin', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgpPutOrigin.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
  __Address: PAddress;
 begin
  _p^.Get(Data, __p);
  _Address^.Get(Data, __Address);

  jt.msg.p.PutOrigin(__p, 
    __Address^);

  Execute:=erOk;
 end;

destructor TmsgpPutOrigin.Done;
 begin
  Dispose(_p, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ msgpGetPChar(const p: Pointer): PChar; }

type
 PmsgpGetPChar = ^TmsgpGetPChar;
 TmsgpGetPChar = object(TNumberExpression)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpGetPChar.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpGetPChar', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpGetPChar.Get(const ExecuteData: PExecuteData; var Value);
 var
  __p: Pointer;
 begin
  _p^.Get(ExecuteData, __p);

  Longint(Value):=Longint(jt.msg.p.GetPChar(__p));
 end;

destructor TmsgpGetPChar.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgpCreateEx(const Stream: Pointer; const Netmail: Boolean; const
   StreamLinker: PStreamLinker; const DestroyStream: Boolean):
   Pointer; }

type
 PmsgpCreateEx = ^TmsgpCreateEx;
 TmsgpCreateEx = object(TNumberExpression)
  _Stream: PNumberExpression;
  _Netmail: PBooleanExpression;
  _StreamLinker: PNumberExpression;
  _DestroyStream: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgpCreateEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgpCreateEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Stream:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Netmail:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _StreamLinker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DestroyStream:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgpCreateEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Stream: Pointer;
  __Netmail: Boolean;
  __StreamLinker: PStreamLinker;
  __DestroyStream: Boolean;
 begin
  _Stream^.Get(ExecuteData, __Stream);
  _Netmail^.Get(ExecuteData, __Netmail);
  _StreamLinker^.Get(ExecuteData, __StreamLinker);
  _DestroyStream^.Get(ExecuteData, __DestroyStream);

  Longint(Value):=Longint(jt.msg.p.CreateEx(__Stream, 
    __Netmail, 
    __StreamLinker, 
    __DestroyStream));
 end;

destructor TmsgpCreateEx.Done;
 begin
  Dispose(_Stream, Done);
  Dispose(_Netmail, Done);
  Dispose(_StreamLinker, Done);
  Dispose(_DestroyStream, Done);

  inherited Done;
 end;

{ msgtiseenbyCreate: Pointer; }

type
 PmsgtiseenbyCreate = ^TmsgtiseenbyCreate;
 TmsgtiseenbyCreate = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TmsgtiseenbyCreate.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.msg.ti.seenby.Create);
 end;

{ msgtiseenbyClone(const seenby: Pointer): Pointer; }

type
 PmsgtiseenbyClone = ^TmsgtiseenbyClone;
 TmsgtiseenbyClone = object(TNumberExpression)
  _seenby: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyClone.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyClone', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiseenbyClone.Get(const ExecuteData: PExecuteData; var Value);
 var
  __seenby: Pointer;
 begin
  _seenby^.Get(ExecuteData, __seenby);

  Longint(Value):=Longint(jt.msg.ti.seenby.Clone(__seenby));
 end;

destructor TmsgtiseenbyClone.Done;
 begin
  Dispose(_seenby, Done);

  inherited Done;
 end;

{ msgtiseenbyDestroy(const seenby: Pointer); }

type
 PmsgtiseenbyDestroy = ^TmsgtiseenbyDestroy;
 TmsgtiseenbyDestroy = object(TAction)
  _seenby: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiseenbyDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __seenby: Pointer;
 begin
  _seenby^.Get(Data, __seenby);

  jt.msg.ti.seenby.Destroy(__seenby);

  Execute:=erOk;
 end;

destructor TmsgtiseenbyDestroy.Done;
 begin
  Dispose(_seenby, Done);

  inherited Done;
 end;

{ msgtiseenbyAt(const seenby: Pointer; const Index: Longint): PTechInfo; }

type
 PmsgtiseenbyAt = ^TmsgtiseenbyAt;
 TmsgtiseenbyAt = object(TNumberExpression)
  _seenby: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiseenbyAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __seenby: Pointer;
  __Index: Longint;
 begin
  _seenby^.Get(ExecuteData, __seenby);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.msg.ti.seenby.At(__seenby, 
    __Index));
 end;

destructor TmsgtiseenbyAt.Done;
 begin
  Dispose(_seenby, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtiseenbyCount(const seenby: Pointer): Longint; }

type
 PmsgtiseenbyCount = ^TmsgtiseenbyCount;
 TmsgtiseenbyCount = object(TNumberExpression)
  _seenby: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiseenbyCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __seenby: Pointer;
 begin
  _seenby^.Get(ExecuteData, __seenby);

  Longint(Value):=Longint(jt.msg.ti.seenby.Count(__seenby));
 end;

destructor TmsgtiseenbyCount.Done;
 begin
  Dispose(_seenby, Done);

  inherited Done;
 end;

{ msgtiseenbySearch(const seenby: Pointer; const TechInfo: TTechInfo;
   var Index: xInteger): PTechInfo; }

type
 PmsgtiseenbySearch = ^TmsgtiseenbySearch;
 TmsgtiseenbySearch = object(TNumberExpression)
  _seenby: PNumberExpression;
  _TechInfo: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbySearch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbySearch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Index^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiseenbySearch.Get(const ExecuteData: PExecuteData; var Value);
 var
  __seenby: Pointer;
  __TechInfo: PTechInfo;
  __Index: Longint;
 begin
  _seenby^.Get(ExecuteData, __seenby);
  _TechInfo^.Get(ExecuteData, __TechInfo);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.msg.ti.seenby.Search(__seenby, 
    __TechInfo^, 
    xInteger(__Index)));

  _Index^.Assign(ExecuteData, __Index);
 end;

destructor TmsgtiseenbySearch.Done;
 begin
  Dispose(_seenby, Done);
  Dispose(_TechInfo, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtiseenbyInsert(const seenby: Pointer; const TechInfo: PTechInfo); }

type
 PmsgtiseenbyInsert = ^TmsgtiseenbyInsert;
 TmsgtiseenbyInsert = object(TAction)
  _seenby: PNumberExpression;
  _TechInfo: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyInsert.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyInsert', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiseenbyInsert.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __seenby: Pointer;
  __TechInfo: PTechInfo;
 begin
  _seenby^.Get(Data, __seenby);
  _TechInfo^.Get(Data, __TechInfo);

  jt.msg.ti.seenby.Insert(__seenby, 
    __TechInfo);

  Execute:=erOk;
 end;

destructor TmsgtiseenbyInsert.Done;
 begin
  Dispose(_seenby, Done);
  Dispose(_TechInfo, Done);

  inherited Done;
 end;

{ msgtiseenbyFree(const seenby: Pointer; const Index: Longint); }

type
 PmsgtiseenbyFree = ^TmsgtiseenbyFree;
 TmsgtiseenbyFree = object(TAction)
  _seenby: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyFree.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyFree', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiseenbyFree.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __seenby: Pointer;
  __Index: Longint;
 begin
  _seenby^.Get(Data, __seenby);
  _Index^.Get(Data, __Index);

  jt.msg.ti.seenby.Free(__seenby, 
    __Index);

  Execute:=erOk;
 end;

destructor TmsgtiseenbyFree.Done;
 begin
  Dispose(_seenby, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtiseenbyFreeAll(const seenby: Pointer); }

type
 PmsgtiseenbyFreeAll = ^TmsgtiseenbyFreeAll;
 TmsgtiseenbyFreeAll = object(TAction)
  _seenby: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiseenbyFreeAll.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiseenbyFreeAll', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _seenby:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiseenbyFreeAll.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __seenby: Pointer;
 begin
  _seenby^.Get(Data, __seenby);

  jt.msg.ti.seenby.FreeAll(__seenby);

  Execute:=erOk;
 end;

destructor TmsgtiseenbyFreeAll.Done;
 begin
  Dispose(_seenby, Done);

  inherited Done;
 end;

{ msgtipathCreate: Pointer; }

type
 PmsgtipathCreate = ^TmsgtipathCreate;
 TmsgtipathCreate = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TmsgtipathCreate.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.msg.ti.path.Create);
 end;

{ msgtipathClone(const path: Pointer): Pointer; }

type
 PmsgtipathClone = ^TmsgtipathClone;
 TmsgtipathClone = object(TNumberExpression)
  _path: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathClone.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathClone', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtipathClone.Get(const ExecuteData: PExecuteData; var Value);
 var
  __path: Pointer;
 begin
  _path^.Get(ExecuteData, __path);

  Longint(Value):=Longint(jt.msg.ti.path.Clone(__path));
 end;

destructor TmsgtipathClone.Done;
 begin
  Dispose(_path, Done);

  inherited Done;
 end;

{ msgtipathDestroy(const path: Pointer); }

type
 PmsgtipathDestroy = ^TmsgtipathDestroy;
 TmsgtipathDestroy = object(TAction)
  _path: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtipathDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __path: Pointer;
 begin
  _path^.Get(Data, __path);

  jt.msg.ti.path.Destroy(__path);

  Execute:=erOk;
 end;

destructor TmsgtipathDestroy.Done;
 begin
  Dispose(_path, Done);

  inherited Done;
 end;

{ msgtipathAt(const path: Pointer; const Index: Longint): PTechInfo; }

type
 PmsgtipathAt = ^TmsgtipathAt;
 TmsgtipathAt = object(TNumberExpression)
  _path: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtipathAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __path: Pointer;
  __Index: Longint;
 begin
  _path^.Get(ExecuteData, __path);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.msg.ti.path.At(__path, 
    __Index));
 end;

destructor TmsgtipathAt.Done;
 begin
  Dispose(_path, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtipathCount(const path: Pointer): Longint; }

type
 PmsgtipathCount = ^TmsgtipathCount;
 TmsgtipathCount = object(TNumberExpression)
  _path: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtipathCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __path: Pointer;
 begin
  _path^.Get(ExecuteData, __path);

  Longint(Value):=Longint(jt.msg.ti.path.Count(__path));
 end;

destructor TmsgtipathCount.Done;
 begin
  Dispose(_path, Done);

  inherited Done;
 end;

{ msgtipathSearch(const path: Pointer; const TechInfo: TTechInfo;
   var Index: xInteger): PTechInfo; }

type
 PmsgtipathSearch = ^TmsgtipathSearch;
 TmsgtipathSearch = object(TNumberExpression)
  _path: PNumberExpression;
  _TechInfo: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathSearch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathSearch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Index^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtipathSearch.Get(const ExecuteData: PExecuteData; var Value);
 var
  __path: Pointer;
  __TechInfo: PTechInfo;
  __Index: Longint;
 begin
  _path^.Get(ExecuteData, __path);
  _TechInfo^.Get(ExecuteData, __TechInfo);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.msg.ti.path.Search(__path, 
    __TechInfo^, 
    xInteger(__Index)));

  _Index^.Assign(ExecuteData, __Index);
 end;

destructor TmsgtipathSearch.Done;
 begin
  Dispose(_path, Done);
  Dispose(_TechInfo, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtipathInsert(const path: Pointer; const Index: Longint; const
   TechInfo: PTechInfo); }

type
 PmsgtipathInsert = ^TmsgtipathInsert;
 TmsgtipathInsert = object(TAction)
  _path: PNumberExpression;
  _Index: PNumberExpression;
  _TechInfo: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathInsert.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathInsert', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtipathInsert.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __path: Pointer;
  __Index: Longint;
  __TechInfo: PTechInfo;
 begin
  _path^.Get(Data, __path);
  _Index^.Get(Data, __Index);
  _TechInfo^.Get(Data, __TechInfo);

  jt.msg.ti.path.Insert(__path, 
    __Index, 
    __TechInfo);

  Execute:=erOk;
 end;

destructor TmsgtipathInsert.Done;
 begin
  Dispose(_path, Done);
  Dispose(_Index, Done);
  Dispose(_TechInfo, Done);

  inherited Done;
 end;

{ msgtipathDelete(const path: Pointer; const Index: Longint); }

type
 PmsgtipathDelete = ^TmsgtipathDelete;
 TmsgtipathDelete = object(TAction)
  _path: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathDelete.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathDelete', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtipathDelete.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __path: Pointer;
  __Index: Longint;
 begin
  _path^.Get(Data, __path);
  _Index^.Get(Data, __Index);

  jt.msg.ti.path.Delete(__path, 
    __Index);

  Execute:=erOk;
 end;

destructor TmsgtipathDelete.Done;
 begin
  Dispose(_path, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtipathFree(const path: Pointer; const Index: Longint); }

type
 PmsgtipathFree = ^TmsgtipathFree;
 TmsgtipathFree = object(TAction)
  _path: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathFree.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathFree', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtipathFree.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __path: Pointer;
  __Index: Longint;
 begin
  _path^.Get(Data, __path);
  _Index^.Get(Data, __Index);

  jt.msg.ti.path.Free(__path, 
    __Index);

  Execute:=erOk;
 end;

destructor TmsgtipathFree.Done;
 begin
  Dispose(_path, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ msgtipathFreeAll(const path: Pointer); }

type
 PmsgtipathFreeAll = ^TmsgtipathFreeAll;
 TmsgtipathFreeAll = object(TAction)
  _path: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtipathFreeAll.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtipathFreeAll', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _path:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtipathFreeAll.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __path: Pointer;
 begin
  _path^.Get(Data, __path);

  jt.msg.ti.path.FreeAll(__path);

  Execute:=erOk;
 end;

destructor TmsgtipathFreeAll.Done;
 begin
  Dispose(_path, Done);

  inherited Done;
 end;

{ msgtiCreate(const ATechInfo: TTechInfo): PTechInfo; }

type
 PmsgtiCreate = ^TmsgtiCreate;
 TmsgtiCreate = object(TNumberExpression)
  _ATechInfo: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ATechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ATechInfo: PTechInfo;
 begin
  _ATechInfo^.Get(ExecuteData, __ATechInfo);

  Longint(Value):=Longint(jt.msg.ti.Create(__ATechInfo^));
 end;

destructor TmsgtiCreate.Done;
 begin
  Dispose(_ATechInfo, Done);

  inherited Done;
 end;

{ msgtiCreateEx(const Net, Node: System.Integer): PTechInfo; }

type
 PmsgtiCreateEx = ^TmsgtiCreateEx;
 TmsgtiCreateEx = object(TNumberExpression)
  _Net: PNumberExpression;
  _Node: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiCreateEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiCreateEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Net:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Node:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiCreateEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Net: Longint;
  __Node: Longint;
 begin
  _Net^.Get(ExecuteData, __Net);
  _Node^.Get(ExecuteData, __Node);

  Longint(Value):=Longint(jt.msg.ti.CreateEx(__Net, 
    __Node));
 end;

destructor TmsgtiCreateEx.Done;
 begin
  Dispose(_Net, Done);
  Dispose(_Node, Done);

  inherited Done;
 end;

{ msgtiParse(S: String; var rc: String): PTechInfo; }

type
 PmsgtiParse = ^TmsgtiParse;
 TmsgtiParse = object(TNumberExpression)
  _S: PStringExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiParse.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiParse', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgtiParse.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: String;
  __rc: String;
 begin
  _S^.Get(ExecuteData, __S);
  _rc^.Get(ExecuteData, __rc);

  Longint(Value):=Longint(jt.msg.ti.Parse(__S, 
    __rc));

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TmsgtiParse.Done;
 begin
  Dispose(_S, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ msgtiDestroy(const TechInfo: PTechInfo); }

type
 PmsgtiDestroy = ^TmsgtiDestroy;
 TmsgtiDestroy = object(TAction)
  _TechInfo: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __TechInfo: PTechInfo;
 begin
  _TechInfo^.Get(Data, __TechInfo);

  jt.msg.ti.Destroy(__TechInfo);

  Execute:=erOk;
 end;

destructor TmsgtiDestroy.Done;
 begin
  Dispose(_TechInfo, Done);

  inherited Done;
 end;

{ msgtiPickupTechInfo(const msg: Pointer); }

type
 PmsgtiPickupTechInfo = ^TmsgtiPickupTechInfo;
 TmsgtiPickupTechInfo = object(TAction)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiPickupTechInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiPickupTechInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiPickupTechInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
 begin
  _msg^.Get(Data, __msg);

  jt.msg.ti.PickupTechInfo(__msg);

  Execute:=erOk;
 end;

destructor TmsgtiPickupTechInfo.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgtiDropTechInfo(const msg: Pointer); }

type
 PmsgtiDropTechInfo = ^TmsgtiDropTechInfo;
 TmsgtiDropTechInfo = object(TAction)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiDropTechInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiDropTechInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiDropTechInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
 begin
  _msg^.Get(Data, __msg);

  jt.msg.ti.DropTechInfo(__msg);

  Execute:=erOk;
 end;

destructor TmsgtiDropTechInfo.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgtiDoTechInfo(const Link, Area, msg: Pointer; const FromAddress:
   PAddress); }

type
 PmsgtiDoTechInfo = ^TmsgtiDoTechInfo;
 TmsgtiDoTechInfo = object(TAction)
  _Link: PNumberExpression;
  _Area: PNumberExpression;
  _msg: PNumberExpression;
  _FromAddress: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgtiDoTechInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgtiDoTechInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FromAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgtiDoTechInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Link: Pointer;
  __Area: Pointer;
  __msg: Pointer;
  __FromAddress: PAddress;
 begin
  _Link^.Get(Data, __Link);
  _Area^.Get(Data, __Area);
  _msg^.Get(Data, __msg);
  _FromAddress^.Get(Data, __FromAddress);

  jt.msg.ti.DoTechInfo(__Link, 
    __Area, 
    __msg, 
    __FromAddress);

  Execute:=erOk;
 end;

destructor TmsgtiDoTechInfo.Done;
 begin
  Dispose(_Link, Done);
  Dispose(_Area, Done);
  Dispose(_msg, Done);
  Dispose(_FromAddress, Done);

  inherited Done;
 end;

{ msgGetFromName(const msg: Pointer): PString; }

type
 PmsgGetFromName = ^TmsgGetFromName;
 TmsgGetFromName = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetFromName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetFromName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetFromName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetFromName(__msg));
 end;

destructor TmsgGetFromName.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetToName(const msg: Pointer): PString; }

type
 PmsgGetToName = ^TmsgGetToName;
 TmsgGetToName = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetToName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetToName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetToName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetToName(__msg));
 end;

destructor TmsgGetToName.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetSubject(const msg: Pointer): PString; }

type
 PmsgGetSubject = ^TmsgGetSubject;
 TmsgGetSubject = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetSubject.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetSubject', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetSubject.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetSubject(__msg));
 end;

destructor TmsgGetSubject.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetArea(const msg: Pointer): PString; }

type
 PmsgGetArea = ^TmsgGetArea;
 TmsgGetArea = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetArea.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetArea(__msg));
 end;

destructor TmsgGetArea.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetAttributes(const msg: Pointer): Longint; }

type
 PmsgGetAttributes = ^TmsgGetAttributes;
 TmsgGetAttributes = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetAttributes.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetAttributes', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetAttributes.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetAttributes(__msg));
 end;

destructor TmsgGetAttributes.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetText(const msg: Pointer): Pointer; }

type
 PmsgGetText = ^TmsgGetText;
 TmsgGetText = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetText.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetText', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetText.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetText(__msg));
 end;

destructor TmsgGetText.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgGetWritten(const msg: Pointer; var Written: TDateTime); }

type
 PmsgGetWritten = ^TmsgGetWritten;
 TmsgGetWritten = object(TAction)
  _msg: PNumberExpression;
  _Written: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetWritten.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetWritten', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Written:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Written^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgGetWritten.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Written: PDateTime;
 begin
  _msg^.Get(Data, __msg);
  _Written^.Get(Data, __Written);

  jt.msg.GetWritten(__msg, 
    __Written^);

  Execute:=erOk;
 end;

destructor TmsgGetWritten.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Written, Done);

  inherited Done;
 end;

{ msgGetArrived(const msg: Pointer; var Arrived: TDateTime); }

type
 PmsgGetArrived = ^TmsgGetArrived;
 TmsgGetArrived = object(TAction)
  _msg: PNumberExpression;
  _Arrived: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetArrived.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetArrived', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Arrived:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Arrived^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgGetArrived.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Arrived: PDateTime;
 begin
  _msg^.Get(Data, __msg);
  _Arrived^.Get(Data, __Arrived);

  jt.msg.GetArrived(__msg, 
    __Arrived^);

  Execute:=erOk;
 end;

destructor TmsgGetArrived.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Arrived, Done);

  inherited Done;
 end;

{ msgSetFromName(const msg: Pointer; const Value: String); }

type
 PmsgSetFromName = ^TmsgSetFromName;
 TmsgSetFromName = object(TAction)
  _msg: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetFromName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetFromName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetFromName.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Value: String;
 begin
  _msg^.Get(Data, __msg);
  _Value^.Get(Data, __Value);

  jt.msg.SetFromName(__msg, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgSetFromName.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgSetToName(const msg: Pointer; const Value: String); }

type
 PmsgSetToName = ^TmsgSetToName;
 TmsgSetToName = object(TAction)
  _msg: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetToName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetToName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetToName.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Value: String;
 begin
  _msg^.Get(Data, __msg);
  _Value^.Get(Data, __Value);

  jt.msg.SetToName(__msg, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgSetToName.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgSetSubject(const msg: Pointer; const Value: String); }

type
 PmsgSetSubject = ^TmsgSetSubject;
 TmsgSetSubject = object(TAction)
  _msg: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetSubject.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetSubject', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetSubject.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Value: String;
 begin
  _msg^.Get(Data, __msg);
  _Value^.Get(Data, __Value);

  jt.msg.SetSubject(__msg, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgSetSubject.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgSetArea(const msg: Pointer; const Value: String); }

type
 PmsgSetArea = ^TmsgSetArea;
 TmsgSetArea = object(TAction)
  _msg: PNumberExpression;
  _Value: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetArea.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetArea', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Value:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetArea.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Value: String;
 begin
  _msg^.Get(Data, __msg);
  _Value^.Get(Data, __Value);

  jt.msg.SetArea(__msg, 
    __Value);

  Execute:=erOk;
 end;

destructor TmsgSetArea.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Value, Done);

  inherited Done;
 end;

{ msgSetAttributes(const msg: Pointer; const Attributes: Longint); }

type
 PmsgSetAttributes = ^TmsgSetAttributes;
 TmsgSetAttributes = object(TAction)
  _msg: PNumberExpression;
  _Attributes: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetAttributes.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetAttributes', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Attributes:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetAttributes.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Attributes: Longint;
 begin
  _msg^.Get(Data, __msg);
  _Attributes^.Get(Data, __Attributes);

  jt.msg.SetAttributes(__msg, 
    __Attributes);

  Execute:=erOk;
 end;

destructor TmsgSetAttributes.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Attributes, Done);

  inherited Done;
 end;

{ msgSetWritten(const msg: Pointer; const Written: TDateTime); }

type
 PmsgSetWritten = ^TmsgSetWritten;
 TmsgSetWritten = object(TAction)
  _msg: PNumberExpression;
  _Written: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetWritten.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetWritten', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Written:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetWritten.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Written: PDateTime;
 begin
  _msg^.Get(Data, __msg);
  _Written^.Get(Data, __Written);

  jt.msg.SetWritten(__msg, 
    __Written^);

  Execute:=erOk;
 end;

destructor TmsgSetWritten.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Written, Done);

  inherited Done;
 end;

{ msgSetArrived(const msg: Pointer; const Arrived: TDateTime); }

type
 PmsgSetArrived = ^TmsgSetArrived;
 TmsgSetArrived = object(TAction)
  _msg: PNumberExpression;
  _Arrived: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetArrived.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetArrived', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Arrived:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetArrived.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __Arrived: PDateTime;
 begin
  _msg^.Get(Data, __msg);
  _Arrived^.Get(Data, __Arrived);

  jt.msg.SetArrived(__msg, 
    __Arrived^);

  Execute:=erOk;
 end;

destructor TmsgSetArrived.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Arrived, Done);

  inherited Done;
 end;

{ msgGetGlobal(const msg: Pointer): Longint; }

type
 PmsgGetGlobal = ^TmsgGetGlobal;
 TmsgGetGlobal = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgGetGlobal.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgGetGlobal', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgGetGlobal.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.GetGlobal(__msg));
 end;

destructor TmsgGetGlobal.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgSt(const msg: Pointer): Pointer; }

type
 PmsgSt = ^TmsgSt;
 TmsgSt = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.St(__msg));
 end;

destructor TmsgSt.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgCreate: Pointer; }

type
 PmsgCreate = ^TmsgCreate;
 TmsgCreate = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TmsgCreate.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.msg.Create);
 end;

{ msgClone(const Amsg: Pointer; const Flags: Longint): Pointer; }

type
 PmsgClone = ^TmsgClone;
 TmsgClone = object(TNumberExpression)
  _Amsg: PNumberExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgClone.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgClone', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Amsg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgClone.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Amsg: Pointer;
  __Flags: Longint;
 begin
  _Amsg^.Get(ExecuteData, __Amsg);
  _Flags^.Get(ExecuteData, __Flags);

  Longint(Value):=Longint(jt.msg.Clone(__Amsg, 
    __Flags));
 end;

destructor TmsgClone.Done;
 begin
  Dispose(_Amsg, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ msgDestroy(const msg: Pointer); }

type
 PmsgDestroy = ^TmsgDestroy;
 TmsgDestroy = object(TAction)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
 begin
  _msg^.Get(Data, __msg);

  jt.msg.Destroy(__msg);

  Execute:=erOk;
 end;

destructor TmsgDestroy.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgCreateParser(const msg: Pointer; const Netmail: Boolean): Pointer; }

type
 PmsgCreateParser = ^TmsgCreateParser;
 TmsgCreateParser = object(TNumberExpression)
  _msg: PNumberExpression;
  _Netmail: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgCreateParser.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgCreateParser', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Netmail:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgCreateParser.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
  __Netmail: Boolean;
 begin
  _msg^.Get(ExecuteData, __msg);
  _Netmail^.Get(ExecuteData, __Netmail);

  Longint(Value):=Longint(jt.msg.CreateParser(__msg, 
    __Netmail));
 end;

destructor TmsgCreateParser.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_Netmail, Done);

  inherited Done;
 end;

{ msgDestroyParser(const p: Pointer); }

type
 PmsgDestroyParser = ^TmsgDestroyParser;
 TmsgDestroyParser = object(TAction)
  _p: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgDestroyParser.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgDestroyParser', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _p:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgDestroyParser.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __p: Pointer;
 begin
  _p^.Get(Data, __p);

  jt.msg.DestroyParser(__p);

  Execute:=erOk;
 end;

destructor TmsgDestroyParser.Done;
 begin
  Dispose(_p, Done);

  inherited Done;
 end;

{ msgAdd(const msg: Pointer; const S: String); }

type
 PmsgAdd = ^TmsgAdd;
 TmsgAdd = object(TAction)
  _msg: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgAdd.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __S: String;
 begin
  _msg^.Get(Data, __msg);
  _S^.Get(Data, __S);

  jt.msg.Add(__msg, 
    __S);

  Execute:=erOk;
 end;

destructor TmsgAdd.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ msgSize(const msg: Pointer): Longint; }

type
 PmsgSize = ^TmsgSize;
 TmsgSize = object(TNumberExpression)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmsgSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmsgSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __msg: Pointer;
 begin
  _msg^.Get(ExecuteData, __msg);

  Longint(Value):=Longint(jt.msg.Size(__msg));
 end;

destructor TmsgSize.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ msgAddHeader(const msg: Pointer; const S: String); }

type
 PmsgAddHeader = ^TmsgAddHeader;
 TmsgAddHeader = object(TAction)
  _msg: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgAddHeader.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgAddHeader', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgAddHeader.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __S: String;
 begin
  _msg^.Get(Data, __msg);
  _S^.Get(Data, __S);

  jt.msg.AddHeader(__msg, 
    __S);

  Execute:=erOk;
 end;

destructor TmsgAddHeader.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ msgAddAfterKludges(const msg: Pointer; const S: String); }

type
 PmsgAddAfterKludges = ^TmsgAddAfterKludges;
 TmsgAddAfterKludges = object(TAction)
  _msg: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgAddAfterKludges.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgAddAfterKludges', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgAddAfterKludges.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __S: String;
 begin
  _msg^.Get(Data, __msg);
  _S^.Get(Data, __S);

  jt.msg.AddAfterKludges(__msg, 
    __S);

  Execute:=erOk;
 end;

destructor TmsgAddAfterKludges.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ msgSetGlobal(const msg: Pointer; const AGlobal: Longint); }

type
 PmsgSetGlobal = ^TmsgSetGlobal;
 TmsgSetGlobal = object(TAction)
  _msg: PNumberExpression;
  _AGlobal: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmsgSetGlobal.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('msgSetGlobal', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AGlobal:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmsgSetGlobal.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
  __AGlobal: Longint;
 begin
  _msg^.Get(Data, __msg);
  _AGlobal^.Get(Data, __AGlobal);

  jt.msg.SetGlobal(__msg, 
    __AGlobal);

  Execute:=erOk;
 end;

destructor TmsgSetGlobal.Done;
 begin
  Dispose(_msg, Done);
  Dispose(_AGlobal, Done);

  inherited Done;
 end;

{ omlCreate(const id: String; var rc: String): Pointer; }

type
 PomlCreate = ^TomlCreate;
 TomlCreate = object(TNumberExpression)
  _id: PStringExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _id:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __id: String;
  __rc: String;
 begin
  _id^.Get(ExecuteData, __id);
  _rc^.Get(ExecuteData, __rc);

  Longint(Value):=Longint(jt.om.l.Create(__id, 
    __rc));

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TomlCreate.Done;
 begin
  Dispose(_id, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ omlDestroy(const oml: Pointer); }

type
 PomlDestroy = ^TomlDestroy;
 TomlDestroy = object(TAction)
  _oml: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TomlDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TomlDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __oml: Pointer;
 begin
  _oml^.Get(Data, __oml);

  jt.om.l.Destroy(__oml);

  Execute:=erOk;
 end;

destructor TomlDestroy.Done;
 begin
  Dispose(_oml, Done);

  inherited Done;
 end;

{ omlOM(const oml: Pointer): Pointer; }

type
 PomlOM = ^TomlOM;
 TomlOM = object(TNumberExpression)
  _oml: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlOM.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlOM', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlOM.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
 begin
  _oml^.Get(ExecuteData, __oml);

  Longint(Value):=Longint(jt.om.l.OM(__oml));
 end;

destructor TomlOM.Done;
 begin
  Dispose(_oml, Done);

  inherited Done;
 end;

{ omlID(const oml: Pointer): String; }

type
 PomlID = ^TomlID;
 TomlID = object(TStringExpression)
  _oml: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlID.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlID', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlID.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
 begin
  _oml^.Get(ExecuteData, __oml);

  String(Value):=jt.om.l.ID(__oml);
 end;

destructor TomlID.Done;
 begin
  Dispose(_oml, Done);

  inherited Done;
 end;

{ omlSt(const oml: Pointer): Pointer; }

type
 PomlSt = ^TomlSt;
 TomlSt = object(TNumberExpression)
  _oml: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
 begin
  _oml^.Get(ExecuteData, __oml);

  Longint(Value):=Longint(jt.om.l.St(__oml));
 end;

destructor TomlSt.Done;
 begin
  Dispose(_oml, Done);

  inherited Done;
 end;

{ omlCreateSession(const oml: Pointer; const FromAddress, ToAddress:
   TAddress; const Password: String): Pointer; }

type
 PomlCreateSession = ^TomlCreateSession;
 TomlCreateSession = object(TNumberExpression)
  _oml: PNumberExpression;
  _FromAddress: PNumberExpression;
  _ToAddress: PNumberExpression;
  _Password: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlCreateSession.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlCreateSession', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FromAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _ToAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Password:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlCreateSession.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
  __FromAddress: PAddress;
  __ToAddress: PAddress;
  __Password: String;
 begin
  _oml^.Get(ExecuteData, __oml);
  _FromAddress^.Get(ExecuteData, __FromAddress);
  _ToAddress^.Get(ExecuteData, __ToAddress);
  _Password^.Get(ExecuteData, __Password);

  Longint(Value):=Longint(jt.om.l.CreateSession(__oml, 
    __FromAddress^, 
    __ToAddress^, 
    __Password));
 end;

destructor TomlCreateSession.Done;
 begin
  Dispose(_oml, Done);
  Dispose(_FromAddress, Done);
  Dispose(_ToAddress, Done);
  Dispose(_Password, Done);

  inherited Done;
 end;

{ omlHash(const oml: Pointer): System.Integer; }

type
 PomlHash = ^TomlHash;
 TomlHash = object(TNumberExpression)
  _oml: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlHash.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlHash', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlHash.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
 begin
  _oml^.Get(ExecuteData, __oml);

  Longint(Value):=Longint(jt.om.l.Hash(__oml));
 end;

destructor TomlHash.Done;
 begin
  Dispose(_oml, Done);

  inherited Done;
 end;

{ omlSeekByHash(const Hash: System.Integer): Pointer; }

type
 PomlSeekByHash = ^TomlSeekByHash;
 TomlSeekByHash = object(TNumberExpression)
  _Hash: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomlSeekByHash.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omlSeekByHash', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Hash:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomlSeekByHash.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Hash: Longint;
 begin
  _Hash^.Get(ExecuteData, __Hash);

  Longint(Value):=Longint(jt.om.l.SeekByHash(__Hash));
 end;

destructor TomlSeekByHash.Done;
 begin
  Dispose(_Hash, Done);

  inherited Done;
 end;

{ omsCreate(const oml: Pointer; const FromAddress, ToAddress: TAddress;
   const Password: String): Pointer; }

type
 PomsCreate = ^TomsCreate;
 TomsCreate = object(TNumberExpression)
  _oml: PNumberExpression;
  _FromAddress: PNumberExpression;
  _ToAddress: PNumberExpression;
  _Password: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomsCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omsCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oml:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _FromAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _ToAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Password:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomsCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oml: Pointer;
  __FromAddress: PAddress;
  __ToAddress: PAddress;
  __Password: String;
 begin
  _oml^.Get(ExecuteData, __oml);
  _FromAddress^.Get(ExecuteData, __FromAddress);
  _ToAddress^.Get(ExecuteData, __ToAddress);
  _Password^.Get(ExecuteData, __Password);

  Longint(Value):=Longint(jt.om.s.Create(__oml, 
    __FromAddress^, 
    __ToAddress^, 
    __Password));
 end;

destructor TomsCreate.Done;
 begin
  Dispose(_oml, Done);
  Dispose(_FromAddress, Done);
  Dispose(_ToAddress, Done);
  Dispose(_Password, Done);

  inherited Done;
 end;

{ omsDestroy(const oms: Pointer); }

type
 PomsDestroy = ^TomsDestroy;
 TomsDestroy = object(TAction)
  _oms: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TomsDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omsDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oms:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TomsDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __oms: Pointer;
 begin
  _oms^.Get(Data, __oms);

  jt.om.s.Destroy(__oms);

  Execute:=erOk;
 end;

destructor TomsDestroy.Done;
 begin
  Dispose(_oms, Done);

  inherited Done;
 end;

{ omsGetBusy(const oms: Pointer): Boolean; }

type
 PomsGetBusy = ^TomsGetBusy;
 TomsGetBusy = object(TBooleanExpression)
  _oms: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomsGetBusy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omsGetBusy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oms:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomsGetBusy.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oms: Pointer;
 begin
  _oms^.Get(ExecuteData, __oms);

  Boolean(Value):=jt.om.s.GetBusy(__oms);
 end;

destructor TomsGetBusy.Done;
 begin
  Dispose(_oms, Done);

  inherited Done;
 end;

{ omsSetBusy(const oms: Pointer; const Busy: Boolean): Boolean; }

type
 PomsSetBusy = ^TomsSetBusy;
 TomsSetBusy = object(TBooleanExpression)
  _oms: PNumberExpression;
  _Busy: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomsSetBusy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omsSetBusy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oms:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Busy:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomsSetBusy.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oms: Pointer;
  __Busy: Boolean;
 begin
  _oms^.Get(ExecuteData, __oms);
  _Busy^.Get(ExecuteData, __Busy);

  Boolean(Value):=jt.om.s.SetBusy(__oms, 
    __Busy);
 end;

destructor TomsSetBusy.Done;
 begin
  Dispose(_oms, Done);
  Dispose(_Busy, Done);

  inherited Done;
 end;

{ omsExportMessage(const oms: Pointer; const msg: Pointer): Boolean; }

type
 PomsExportMessage = ^TomsExportMessage;
 TomsExportMessage = object(TBooleanExpression)
  _oms: PNumberExpression;
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomsExportMessage.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omsExportMessage', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _oms:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomsExportMessage.Get(const ExecuteData: PExecuteData; var Value);
 var
  __oms: Pointer;
  __msg: Pointer;
 begin
  _oms^.Get(ExecuteData, __oms);
  _msg^.Get(ExecuteData, __msg);

  Boolean(Value):=jt.om.s.ExportMessage(__oms, 
    __msg);
 end;

destructor TomsExportMessage.Done;
 begin
  Dispose(_oms, Done);
  Dispose(_msg, Done);

  inherited Done;
 end;

{ omRegister(const Name: String; const Plugin: Pointer): Pointer; }

type
 PomRegister = ^TomRegister;
 TomRegister = object(TNumberExpression)
  _Name: PStringExpression;
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomRegister.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omRegister', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomRegister.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
  __Plugin: Pointer;
 begin
  _Name^.Get(ExecuteData, __Name);
  _Plugin^.Get(ExecuteData, __Plugin);

  Longint(Value):=Longint(jt.om.Register(__Name, 
    __Plugin));
 end;

destructor TomRegister.Done;
 begin
  Dispose(_Name, Done);
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ omGetName(const om: Pointer): String; }

type
 PomGetName = ^TomGetName;
 TomGetName = object(TStringExpression)
  _om: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomGetName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omGetName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _om:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomGetName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __om: Pointer;
 begin
  _om^.Get(ExecuteData, __om);

  String(Value):=jt.om.GetName(__om);
 end;

destructor TomGetName.Done;
 begin
  Dispose(_om, Done);

  inherited Done;
 end;

{ omSt(const om: Pointer): Pointer; }

type
 PomSt = ^TomSt;
 TomSt = object(TNumberExpression)
  _om: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomSt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omSt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _om:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomSt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __om: Pointer;
 begin
  _om^.Get(ExecuteData, __om);

  Longint(Value):=Longint(jt.om.St(__om));
 end;

destructor TomSt.Done;
 begin
  Dispose(_om, Done);

  inherited Done;
 end;

{ omCount: Longint; }

type
 PomCount = ^TomCount;
 TomCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TomCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.om.Count);
 end;

{ omAt(const Index: Longint): Pointer; }

type
 PomAt = ^TomAt;
 TomAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.om.At(__Index));
 end;

destructor TomAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ omGetPlugin(const om: Pointer): Pointer; }

type
 PomGetPlugin = ^TomGetPlugin;
 TomGetPlugin = object(TNumberExpression)
  _om: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TomGetPlugin.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('omGetPlugin', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _om:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TomGetPlugin.Get(const ExecuteData: PExecuteData; var Value);
 var
  __om: Pointer;
 begin
  _om^.Get(ExecuteData, __om);

  Longint(Value):=Longint(jt.om.GetPlugin(__om));
 end;

destructor TomGetPlugin.Done;
 begin
  Dispose(_om, Done);

  inherited Done;
 end;

{ stCreate: Pointer; }

type
 PstCreate = ^TstCreate;
 TstCreate = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TstCreate.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.st.Create);
 end;

{ stDestroy(const st: Pointer); }

type
 PstDestroy = ^TstDestroy;
 TstDestroy = object(TAction)
  _st: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TstDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TstDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __st: Pointer;
 begin
  _st^.Get(Data, __st);

  jt.st.Destroy(__st);

  Execute:=erOk;
 end;

destructor TstDestroy.Done;
 begin
  Dispose(_st, Done);

  inherited Done;
 end;

{ stAdd(const st: Pointer; const Name: String; const Data: Pointer;
   const Service: TStorageService); }

type
 PstAdd = ^TstAdd;
 TstAdd = object(TAction)
  _st: PNumberExpression;
  _Name: PStringExpression;
  _Data: PNumberExpression;
  _Service: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TstAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Service:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TstAdd.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __st: Pointer;
  __Name: String;
  __Data: Pointer;
  ___Service: TStorageService;
  __Service: Longint absolute ___Service;
 begin
  _st^.Get(Data, __st);
  _Name^.Get(Data, __Name);
  _Data^.Get(Data, __Data);
  _Service^.Get(Data, __Service);

  jt.st.Add(__st, 
    __Name, 
    __Data, 
    ___Service);

  Execute:=erOk;
 end;

destructor TstAdd.Done;
 begin
  Dispose(_st, Done);
  Dispose(_Name, Done);
  Dispose(_Data, Done);
  Dispose(_Service, Done);

  inherited Done;
 end;

function CreatorMSGPSETTEXTPOS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETTEXTPOS:=New(PmsgpSetTextPos, Init(Tokenizer, Actions));
 end;

function CreatorMSGPENDOFMESSAGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPENDOFMESSAGE:=New(PmsgpEndOfMessage, Init(Tokenizer, Actions));
 end;

function CreatorMSGPTRUNCATETEXT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPTRUNCATETEXT:=New(PmsgpTruncateText, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETFROMADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETFROMADDRESS:=New(PmsgpGetFromAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETTOADDRESS:=New(PmsgpGetToAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETFROMANDTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETFROMANDTOADDRESS:=New(PmsgpGetFromAndToAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPSETFROMADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETFROMADDRESS:=New(PmsgpSetFromAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPSETTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETTOADDRESS:=New(PmsgpSetToAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPSETFROMANDTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETFROMANDTOADDRESS:=New(PmsgpSetFromAndToAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPCHECKFROMADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPCHECKFROMADDRESS:=New(PmsgpCheckFromAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPCHECKTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPCHECKTOADDRESS:=New(PmsgpCheckToAddress, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETKLUDGEPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETKLUDGEPCHAR:=New(PmsgpGetKludgePChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETKLUDGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETKLUDGE:=New(PmsgpGetKludge, Init(Tokenizer, Actions));
 end;

function CreatorMSGPSETKLUDGEPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETKLUDGEPCHAR:=New(PmsgpSetKludgePChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPSETKLUDGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPSETKLUDGE:=New(PmsgpSetKludge, Init(Tokenizer, Actions));
 end;

function CreatorMSGPDELETEKLUDGEPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPDELETEKLUDGEPCHAR:=New(PmsgpDeleteKludgePChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPDELETEKLUDGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPDELETEKLUDGE:=New(PmsgpDeleteKludge, Init(Tokenizer, Actions));
 end;

function CreatorMSGPADDKLUDGEPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPADDKLUDGEPCHAR:=New(PmsgpAddKludgePChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPADDKLUDGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPADDKLUDGE:=New(PmsgpAddKludge, Init(Tokenizer, Actions));
 end;

function CreatorMSGPAFTERLASTKLUDGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPAFTERLASTKLUDGE:=New(PmsgpAfterLastKludge, Init(Tokenizer, Actions));
 end;

function CreatorMSGPREADTEXT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPREADTEXT:=New(PmsgpReadText, Init(Tokenizer, Actions));
 end;

function CreatorMSGPWRITETEXT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPWRITETEXT:=New(PmsgpWriteText, Init(Tokenizer, Actions));
 end;

function CreatorMSGPPUTTEARLINE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPPUTTEARLINE:=New(PmsgpPutTearline, Init(Tokenizer, Actions));
 end;

function CreatorMSGPPUTORIGIN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPPUTORIGIN:=New(PmsgpPutOrigin, Init(Tokenizer, Actions));
 end;

function CreatorMSGPGETPCHAR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPGETPCHAR:=New(PmsgpGetPChar, Init(Tokenizer, Actions));
 end;

function CreatorMSGPCREATEEX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGPCREATEEX:=New(PmsgpCreateEx, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYCREATE:=New(PmsgtiseenbyCreate, Init('msgtiseenbyCreate', Actions));
 end;

function CreatorMSGTISEENBYCLONE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYCLONE:=New(PmsgtiseenbyClone, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYDESTROY:=New(PmsgtiseenbyDestroy, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYAT:=New(PmsgtiseenbyAt, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYCOUNT:=New(PmsgtiseenbyCount, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYSEARCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYSEARCH:=New(PmsgtiseenbySearch, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYINSERT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYINSERT:=New(PmsgtiseenbyInsert, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYFREE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYFREE:=New(PmsgtiseenbyFree, Init(Tokenizer, Actions));
 end;

function CreatorMSGTISEENBYFREEALL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTISEENBYFREEALL:=New(PmsgtiseenbyFreeAll, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHCREATE:=New(PmsgtipathCreate, Init('msgtipathCreate', Actions));
 end;

function CreatorMSGTIPATHCLONE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHCLONE:=New(PmsgtipathClone, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHDESTROY:=New(PmsgtipathDestroy, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHAT:=New(PmsgtipathAt, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHCOUNT:=New(PmsgtipathCount, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHSEARCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHSEARCH:=New(PmsgtipathSearch, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHINSERT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHINSERT:=New(PmsgtipathInsert, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHDELETE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHDELETE:=New(PmsgtipathDelete, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHFREE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHFREE:=New(PmsgtipathFree, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPATHFREEALL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPATHFREEALL:=New(PmsgtipathFreeAll, Init(Tokenizer, Actions));
 end;

function CreatorMSGTICREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTICREATE:=New(PmsgtiCreate, Init(Tokenizer, Actions));
 end;

function CreatorMSGTICREATEEX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTICREATEEX:=New(PmsgtiCreateEx, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPARSE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPARSE:=New(PmsgtiParse, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIDESTROY:=New(PmsgtiDestroy, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIPICKUPTECHINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIPICKUPTECHINFO:=New(PmsgtiPickupTechInfo, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIDROPTECHINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIDROPTECHINFO:=New(PmsgtiDropTechInfo, Init(Tokenizer, Actions));
 end;

function CreatorMSGTIDOTECHINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGTIDOTECHINFO:=New(PmsgtiDoTechInfo, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETFROMNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETFROMNAME:=New(PmsgGetFromName, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETTONAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETTONAME:=New(PmsgGetToName, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETSUBJECT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETSUBJECT:=New(PmsgGetSubject, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETAREA:=New(PmsgGetArea, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETATTRIBUTES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETATTRIBUTES:=New(PmsgGetAttributes, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETTEXT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETTEXT:=New(PmsgGetText, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETWRITTEN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETWRITTEN:=New(PmsgGetWritten, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETARRIVED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETARRIVED:=New(PmsgGetArrived, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETFROMNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETFROMNAME:=New(PmsgSetFromName, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETTONAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETTONAME:=New(PmsgSetToName, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETSUBJECT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETSUBJECT:=New(PmsgSetSubject, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETAREA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETAREA:=New(PmsgSetArea, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETATTRIBUTES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETATTRIBUTES:=New(PmsgSetAttributes, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETWRITTEN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETWRITTEN:=New(PmsgSetWritten, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETARRIVED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETARRIVED:=New(PmsgSetArrived, Init(Tokenizer, Actions));
 end;

function CreatorMSGGETGLOBAL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGGETGLOBAL:=New(PmsgGetGlobal, Init(Tokenizer, Actions));
 end;

function CreatorMSGST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGST:=New(PmsgSt, Init(Tokenizer, Actions));
 end;

function CreatorMSGCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGCREATE:=New(PmsgCreate, Init('msgCreate', Actions));
 end;

function CreatorMSGCLONE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGCLONE:=New(PmsgClone, Init(Tokenizer, Actions));
 end;

function CreatorMSGDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGDESTROY:=New(PmsgDestroy, Init(Tokenizer, Actions));
 end;

function CreatorMSGCREATEPARSER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGCREATEPARSER:=New(PmsgCreateParser, Init(Tokenizer, Actions));
 end;

function CreatorMSGDESTROYPARSER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGDESTROYPARSER:=New(PmsgDestroyParser, Init(Tokenizer, Actions));
 end;

function CreatorMSGADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGADD:=New(PmsgAdd, Init(Tokenizer, Actions));
 end;

function CreatorMSGSIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSIZE:=New(PmsgSize, Init(Tokenizer, Actions));
 end;

function CreatorMSGADDHEADER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGADDHEADER:=New(PmsgAddHeader, Init(Tokenizer, Actions));
 end;

function CreatorMSGADDAFTERKLUDGES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGADDAFTERKLUDGES:=New(PmsgAddAfterKludges, Init(Tokenizer, Actions));
 end;

function CreatorMSGSETGLOBAL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGSETGLOBAL:=New(PmsgSetGlobal, Init(Tokenizer, Actions));
 end;

function CreatorOMLCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLCREATE:=New(PomlCreate, Init(Tokenizer, Actions));
 end;

function CreatorOMLDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLDESTROY:=New(PomlDestroy, Init(Tokenizer, Actions));
 end;

function CreatorOMLOM(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLOM:=New(PomlOM, Init(Tokenizer, Actions));
 end;

function CreatorOMLID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLID:=New(PomlID, Init(Tokenizer, Actions));
 end;

function CreatorOMLST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLST:=New(PomlSt, Init(Tokenizer, Actions));
 end;

function CreatorOMLCREATESESSION(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLCREATESESSION:=New(PomlCreateSession, Init(Tokenizer, Actions));
 end;

function CreatorOMLHASH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLHASH:=New(PomlHash, Init(Tokenizer, Actions));
 end;

function CreatorOMLSEEKBYHASH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMLSEEKBYHASH:=New(PomlSeekByHash, Init(Tokenizer, Actions));
 end;

function CreatorOMSCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMSCREATE:=New(PomsCreate, Init(Tokenizer, Actions));
 end;

function CreatorOMSDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMSDESTROY:=New(PomsDestroy, Init(Tokenizer, Actions));
 end;

function CreatorOMSGETBUSY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMSGETBUSY:=New(PomsGetBusy, Init(Tokenizer, Actions));
 end;

function CreatorOMSSETBUSY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMSSETBUSY:=New(PomsSetBusy, Init(Tokenizer, Actions));
 end;

function CreatorOMSEXPORTMESSAGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMSEXPORTMESSAGE:=New(PomsExportMessage, Init(Tokenizer, Actions));
 end;

function CreatorOMREGISTER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMREGISTER:=New(PomRegister, Init(Tokenizer, Actions));
 end;

function CreatorOMGETNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMGETNAME:=New(PomGetName, Init(Tokenizer, Actions));
 end;

function CreatorOMST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMST:=New(PomSt, Init(Tokenizer, Actions));
 end;

function CreatorOMCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMCOUNT:=New(PomCount, Init('omCount', Actions));
 end;

function CreatorOMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMAT:=New(PomAt, Init(Tokenizer, Actions));
 end;

function CreatorOMGETPLUGIN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorOMGETPLUGIN:=New(PomGetPlugin, Init(Tokenizer, Actions));
 end;

function CreatorSTCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTCREATE:=New(PstCreate, Init('stCreate', Actions));
 end;

function CreatorSTDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTDESTROY:=New(PstDestroy, Init(Tokenizer, Actions));
 end;

function CreatorSTADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTADD:=New(PstAdd, Init(Tokenizer, Actions));
 end;

{ AddJTAPIProtos }

procedure AddJTAPIProtos(const Target: PActions);
 begin
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETTEXTPOS', CreatorMSGPSETTEXTPOS)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MSGPENDOFMESSAGE',
    CreatorMSGPENDOFMESSAGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPTRUNCATETEXT', CreatorMSGPTRUNCATETEXT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPGETFROMADDRESS',
    CreatorMSGPGETFROMADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPGETTOADDRESS', CreatorMSGPGETTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPGETFROMANDTOADDRESS',
    CreatorMSGPGETFROMANDTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETFROMADDRESS',
    CreatorMSGPSETFROMADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETTOADDRESS', CreatorMSGPSETTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETFROMANDTOADDRESS',
    CreatorMSGPSETFROMANDTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPCHECKFROMADDRESS',
    CreatorMSGPCHECKFROMADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPCHECKTOADDRESS',
    CreatorMSGPCHECKTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MSGPGETKLUDGEPCHAR',
    CreatorMSGPGETKLUDGEPCHAR)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MSGPGETKLUDGE',
    CreatorMSGPGETKLUDGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETKLUDGEPCHAR',
    CreatorMSGPSETKLUDGEPCHAR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPSETKLUDGE', CreatorMSGPSETKLUDGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPDELETEKLUDGEPCHAR',
    CreatorMSGPDELETEKLUDGEPCHAR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPDELETEKLUDGE', CreatorMSGPDELETEKLUDGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPADDKLUDGEPCHAR',
    CreatorMSGPADDKLUDGEPCHAR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPADDKLUDGE', CreatorMSGPADDKLUDGE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPAFTERLASTKLUDGE',
    CreatorMSGPAFTERLASTKLUDGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPREADTEXT', CreatorMSGPREADTEXT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPWRITETEXT', CreatorMSGPWRITETEXT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPPUTTEARLINE', CreatorMSGPPUTTEARLINE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGPPUTORIGIN', CreatorMSGPPUTORIGIN)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPGETPCHAR', CreatorMSGPGETPCHAR)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGPCREATEEX', CreatorMSGPCREATEEX)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTISEENBYCREATE',
    CreatorMSGTISEENBYCREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTISEENBYCLONE',
    CreatorMSGTISEENBYCLONE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTISEENBYDESTROY',
    CreatorMSGTISEENBYDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTISEENBYAT',
    CreatorMSGTISEENBYAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTISEENBYCOUNT',
    CreatorMSGTISEENBYCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTISEENBYSEARCH',
    CreatorMSGTISEENBYSEARCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTISEENBYINSERT', CreatorMSGTISEENBYINSERT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTISEENBYFREE', CreatorMSGTISEENBYFREE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTISEENBYFREEALL',
    CreatorMSGTISEENBYFREEALL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPATHCREATE',
    CreatorMSGTIPATHCREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPATHCLONE',
    CreatorMSGTIPATHCLONE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPATHDESTROY', CreatorMSGTIPATHDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPATHAT', CreatorMSGTIPATHAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPATHCOUNT',
    CreatorMSGTIPATHCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPATHSEARCH',
    CreatorMSGTIPATHSEARCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPATHINSERT', CreatorMSGTIPATHINSERT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPATHDELETE', CreatorMSGTIPATHDELETE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPATHFREE', CreatorMSGTIPATHFREE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPATHFREEALL', CreatorMSGTIPATHFREEALL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTICREATE', CreatorMSGTICREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTICREATEEX',
    CreatorMSGTICREATEEX)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGTIPARSE', CreatorMSGTIPARSE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIDESTROY', CreatorMSGTIDESTROY)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIPICKUPTECHINFO',
    CreatorMSGTIPICKUPTECHINFO)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIDROPTECHINFO', CreatorMSGTIDROPTECHINFO)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGTIDOTECHINFO', CreatorMSGTIDOTECHINFO)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETFROMNAME',
    CreatorMSGGETFROMNAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETTONAME', CreatorMSGGETTONAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETSUBJECT',
    CreatorMSGGETSUBJECT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETAREA', CreatorMSGGETAREA)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETATTRIBUTES',
    CreatorMSGGETATTRIBUTES)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETTEXT', CreatorMSGGETTEXT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGGETWRITTEN', CreatorMSGGETWRITTEN)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGGETARRIVED', CreatorMSGGETARRIVED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETFROMNAME', CreatorMSGSETFROMNAME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETTONAME', CreatorMSGSETTONAME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETSUBJECT', CreatorMSGSETSUBJECT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETAREA', CreatorMSGSETAREA)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETATTRIBUTES', CreatorMSGSETATTRIBUTES)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETWRITTEN', CreatorMSGSETWRITTEN)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETARRIVED', CreatorMSGSETARRIVED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGGETGLOBAL', CreatorMSGGETGLOBAL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGST', CreatorMSGST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGCREATE', CreatorMSGCREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGCLONE', CreatorMSGCLONE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGDESTROY', CreatorMSGDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGCREATEPARSER',
    CreatorMSGCREATEPARSER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGDESTROYPARSER', CreatorMSGDESTROYPARSER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGADD', CreatorMSGADD)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MSGSIZE', CreatorMSGSIZE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGADDHEADER', CreatorMSGADDHEADER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGADDAFTERKLUDGES',
    CreatorMSGADDAFTERKLUDGES)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGSETGLOBAL', CreatorMSGSETGLOBAL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLCREATE', CreatorOMLCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('OMLDESTROY', CreatorOMLDESTROY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLOM', CreatorOMLOM)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('OMLID', CreatorOMLID)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLST', CreatorOMLST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLCREATESESSION',
    CreatorOMLCREATESESSION)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLHASH', CreatorOMLHASH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMLSEEKBYHASH',
    CreatorOMLSEEKBYHASH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMSCREATE', CreatorOMSCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('OMSDESTROY', CreatorOMSDESTROY)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('OMSGETBUSY', CreatorOMSGETBUSY)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('OMSSETBUSY', CreatorOMSSETBUSY)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('OMSEXPORTMESSAGE',
    CreatorOMSEXPORTMESSAGE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMREGISTER', CreatorOMREGISTER)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('OMGETNAME', CreatorOMGETNAME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMST', CreatorOMST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMCOUNT', CreatorOMCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMAT', CreatorOMAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('OMGETPLUGIN', CreatorOMGETPLUGIN)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('STCREATE', CreatorSTCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('STDESTROY', CreatorSTDESTROY)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('STADD', CreatorSTADD)));
 end;

end.
