{$IFNDEF VIRTUALPASCAL}
{$D-}
{$ENDIF}
unit ccJTAPI3;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     ccAPI,
     ccAction,
     ccCmn,
     ccCode,
     ccExpr,
     ccJTSupp,
     ccProto,
     ccRoot,
     ccSupp,
     ccToken,

     jtMHLcmn,

     Thunks,

     Wizard;

procedure AddJTAPIProtos(const Target: PActions);

implementation

{ stRemove(const st: Pointer; const Name: String); }

type
 PstRemove = ^TstRemove;
 TstRemove = object(TAction)
  _st: PNumberExpression;
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TstRemove.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stRemove', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TstRemove.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __st: Pointer;
  __Name: String;
 begin
  _st^.Get(Data, __st);
  _Name^.Get(Data, __Name);

  jt.st.Remove(__st, 
    __Name);

  Execute:=erOk;
 end;

destructor TstRemove.Done;
 begin
  Dispose(_st, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ stGet(const st: Pointer; const Name: String): Pointer; }

type
 PstGet = ^TstGet;
 TstGet = object(TNumberExpression)
  _st: PNumberExpression;
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TstGet.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stGet', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TstGet.Get(const ExecuteData: PExecuteData; var Value);
 var
  __st: Pointer;
  __Name: String;
 begin
  _st^.Get(ExecuteData, __st);
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.st.Get(__st, 
    __Name));
 end;

destructor TstGet.Done;
 begin
  Dispose(_st, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ stClone(const st: Pointer): Pointer; }

type
 PstClone = ^TstClone;
 TstClone = object(TNumberExpression)
  _st: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TstClone.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stClone', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TstClone.Get(const ExecuteData: PExecuteData; var Value);
 var
  __st: Pointer;
 begin
  _st^.Get(ExecuteData, __st);

  Longint(Value):=Longint(jt.st.Clone(__st));
 end;

destructor TstClone.Done;
 begin
  Dispose(_st, Done);

  inherited Done;
 end;

{ stAddCallback(const st: Pointer; const Name: String; const Plugin:
   Pointer); }

type
 PstAddCallback = ^TstAddCallback;
 TstAddCallback = object(TAction)
  _st: PNumberExpression;
  _Name: PStringExpression;
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TstAddCallback.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stAddCallback', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TstAddCallback.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __st: Pointer;
  __Name: String;
  __Plugin: Pointer;
 begin
  _st^.Get(Data, __st);
  _Name^.Get(Data, __Name);
  _Plugin^.Get(Data, __Plugin);

  jt.st.AddCallback(__st, 
    __Name, 
    __Plugin);

  Execute:=erOk;
 end;

destructor TstAddCallback.Done;
 begin
  Dispose(_st, Done);
  Dispose(_Name, Done);
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ stInc(const st: Pointer; const Name: String; const IncDelta: Longint); }

type
 PstInc = ^TstInc;
 TstInc = object(TAction)
  _st: PNumberExpression;
  _Name: PStringExpression;
  _IncDelta: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TstInc.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('stInc', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _st:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _IncDelta:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TstInc.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __st: Pointer;
  __Name: String;
  __IncDelta: Longint;
 begin
  _st^.Get(Data, __st);
  _Name^.Get(Data, __Name);
  _IncDelta^.Get(Data, __IncDelta);

  jt.st.Inc(__st, 
    __Name, 
    __IncDelta);

  Execute:=erOk;
 end;

destructor TstInc.Done;
 begin
  Dispose(_st, Done);
  Dispose(_Name, Done);
  Dispose(_IncDelta, Done);

  inherited Done;
 end;

{ stglobalst: Pointer; }

type
 Pstglobalst = ^Tstglobalst;
 Tstglobalst = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure Tstglobalst.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.st.globalst);
 end;

{ svcStString(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStString = ^TsvcStString;
 TsvcStString = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStString.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StString(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStString.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStAddress(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStAddress = ^TsvcStAddress;
 TsvcStAddress = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStAddress.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StAddress(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStAddress.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStListEx(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStListEx = ^TsvcStListEx;
 TsvcStListEx = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStListEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStListEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStListEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StListEx(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStListEx.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStAreaFormat(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStAreaFormat = ^TsvcStAreaFormat;
 TsvcStAreaFormat = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStAreaFormat.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StAreaFormat(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStAreaFormat.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStPath(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStPath = ^TsvcStPath;
 TsvcStPath = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStPath.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStPath', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStPath.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StPath(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStPath.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStSeenby(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStSeenby = ^TsvcStSeenby;
 TsvcStSeenby = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStSeenby.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStSeenby', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStSeenby.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StSeenby(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStSeenby.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStCallbacks(const Action: TStorageAction; const Data: Pointer):
   Pointer; }

type
 PsvcStCallbacks = ^TsvcStCallbacks;
 TsvcStCallbacks = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStCallbacks.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStCallbacks', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStCallbacks.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StCallbacks(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStCallbacks.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ svcStOMS(const Action: TStorageAction; const Data: Pointer): Pointer; }

type
 PsvcStOMS = ^TsvcStOMS;
 TsvcStOMS = object(TNumberExpression)
  _Action: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsvcStOMS.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('svcStOMS', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Action:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsvcStOMS.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Action: Longint;
  __Data: Pointer;
 begin
  _Action^.Get(ExecuteData, __Action);
  _Data^.Get(ExecuteData, __Data);

  Longint(Value):=Longint(jt.svc.StOMS(TStorageAction(__Action), 
    __Data));
 end;

destructor TsvcStOMS.Done;
 begin
  Dispose(_Action, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ srvRegisterHandler(const Plugin: Pointer); }

type
 PsrvRegisterHandler = ^TsrvRegisterHandler;
 TsrvRegisterHandler = object(TAction)
  _Plugin: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TsrvRegisterHandler.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('srvRegisterHandler', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Plugin:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TsrvRegisterHandler.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Plugin: Pointer;
 begin
  _Plugin^.Get(Data, __Plugin);

  jt.srv.RegisterHandler(__Plugin);

  Execute:=erOk;
 end;

destructor TsrvRegisterHandler.Done;
 begin
  Dispose(_Plugin, Done);

  inherited Done;
 end;

{ srvExecute(const Service: String; const Param: Longint); }

type
 PsrvExecute = ^TsrvExecute;
 TsrvExecute = object(TAction)
  _Service: PStringExpression;
  _Param: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TsrvExecute.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('srvExecute', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Service:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Param:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TsrvExecute.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Service: String;
  __Param: Longint;
 begin
  _Service^.Get(Data, __Service);
  _Param^.Get(Data, __Param);

  jt.srv.Execute(__Service, 
    __Param);

  Execute:=erOk;
 end;

destructor TsrvExecute.Done;
 begin
  Dispose(_Service, Done);
  Dispose(_Param, Done);

  inherited Done;
 end;

{ srvExecuteEx(const Service: String; const Param: Longint; var
   AResult: Longint; var Error: Boolean; var RC: String): Boolean; }

type
 PsrvExecuteEx = ^TsrvExecuteEx;
 TsrvExecuteEx = object(TBooleanExpression)
  _Service: PStringExpression;
  _Param: PNumberExpression;
  _AResult: PNumberExpression;
  _Error: PBooleanExpression;
  _RC: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TsrvExecuteEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('srvExecuteEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Service:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Param:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AResult:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _AResult^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Error:=Actions^.ParseBooleanExpression(Tokenizer, True);

  if not _Error^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etBoolean);

  Tokenizer^.Next([tmComma]);

  _RC:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _RC^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TsrvExecuteEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Service: String;
  __Param: Longint;
  __AResult: Longint;
  __Error: Boolean;
  __RC: String;
 begin
  _Service^.Get(ExecuteData, __Service);
  _Param^.Get(ExecuteData, __Param);
  _AResult^.Get(ExecuteData, __AResult);
  _Error^.Get(ExecuteData, __Error);
  _RC^.Get(ExecuteData, __RC);

  Boolean(Value):=jt.srv.ExecuteEx(__Service, 
    __Param, 
    __AResult, 
    __Error, 
    __RC);

  _AResult^.Assign(ExecuteData, __AResult);
  _Error^.Assign(ExecuteData, __Error);
  _RC^.Assign(ExecuteData, __RC);
 end;

destructor TsrvExecuteEx.Done;
 begin
  Dispose(_Service, Done);
  Dispose(_Param, Done);
  Dispose(_AResult, Done);
  Dispose(_Error, Done);
  Dispose(_RC, Done);

  inherited Done;
 end;

{ cbcCount(const cbcs: Pointer): Longint; }

type
 PcbcCount = ^TcbcCount;
 TcbcCount = object(TNumberExpression)
  _cbcs: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcbcCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('cbcCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _cbcs:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcbcCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __cbcs: Pointer;
 begin
  _cbcs^.Get(ExecuteData, __cbcs);

  Longint(Value):=Longint(jt.cbc.Count(__cbcs));
 end;

destructor TcbcCount.Done;
 begin
  Dispose(_cbcs, Done);

  inherited Done;
 end;

{ cbcAt(const cbcs: Pointer; const Index: Longint): Pointer; }

type
 PcbcAt = ^TcbcAt;
 TcbcAt = object(TNumberExpression)
  _cbcs: PNumberExpression;
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TcbcAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('cbcAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _cbcs:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TcbcAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __cbcs: Pointer;
  __Index: Longint;
 begin
  _cbcs^.Get(ExecuteData, __cbcs);
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.cbc.At(__cbcs, 
    __Index));
 end;

destructor TcbcAt.Done;
 begin
  Dispose(_cbcs, Done);
  Dispose(_Index, Done);

  inherited Done;
 end;

{ rfCreate(const FName: String; const Flags: Longint): Pointer; }

type
 PrfCreate = ^TrfCreate;
 TrfCreate = object(TNumberExpression)
  _FName: PStringExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
  __Flags: Longint;
 begin
  _FName^.Get(ExecuteData, __FName);
  _Flags^.Get(ExecuteData, __Flags);

  Longint(Value):=Longint(jt.rf.Create(__FName, 
    __Flags));
 end;

destructor TrfCreate.Done;
 begin
  Dispose(_FName, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ rfDestroy(const rf: Pointer); }

type
 PrfDestroy = ^TrfDestroy;
 TrfDestroy = object(TAction)
  _rf: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TrfDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TrfDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __rf: Pointer;
 begin
  _rf^.Get(Data, __rf);

  jt.rf.Destroy(__rf);

  Execute:=erOk;
 end;

destructor TrfDestroy.Done;
 begin
  Dispose(_rf, Done);

  inherited Done;
 end;

{ rfAdd(const rf: Pointer; const Name: String; const Stream: Pointer;
   const Linker: PStreamLinker): Boolean; }

type
 PrfAdd = ^TrfAdd;
 TrfAdd = object(TBooleanExpression)
  _rf: PNumberExpression;
  _Name: PStringExpression;
  _Stream: PNumberExpression;
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Stream:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfAdd.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
  __Name: String;
  __Stream: Pointer;
  __Linker: PStreamLinker;
 begin
  _rf^.Get(ExecuteData, __rf);
  _Name^.Get(ExecuteData, __Name);
  _Stream^.Get(ExecuteData, __Stream);
  _Linker^.Get(ExecuteData, __Linker);

  Boolean(Value):=jt.rf.Add(__rf, 
    __Name, 
    __Stream, 
    __Linker);
 end;

destructor TrfAdd.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_Name, Done);
  Dispose(_Stream, Done);
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ rfRemove(const rf: Pointer; const Name: String): Boolean; }

type
 PrfRemove = ^TrfRemove;
 TrfRemove = object(TBooleanExpression)
  _rf: PNumberExpression;
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfRemove.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfRemove', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfRemove.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
  __Name: String;
 begin
  _rf^.Get(ExecuteData, __rf);
  _Name^.Get(ExecuteData, __Name);

  Boolean(Value):=jt.rf.Remove(__rf, 
    __Name);
 end;

destructor TrfRemove.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_Name, Done);

  inherited Done;
 end;

{ rfGet(const rf: Pointer; const Name: String; const Stream: Pointer;
   const Linker: PStreamLinker): Boolean; }

type
 PrfGet = ^TrfGet;
 TrfGet = object(TBooleanExpression)
  _rf: PNumberExpression;
  _Name: PStringExpression;
  _Stream: PNumberExpression;
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfGet.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfGet', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Stream:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfGet.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
  __Name: String;
  __Stream: Pointer;
  __Linker: PStreamLinker;
 begin
  _rf^.Get(ExecuteData, __rf);
  _Name^.Get(ExecuteData, __Name);
  _Stream^.Get(ExecuteData, __Stream);
  _Linker^.Get(ExecuteData, __Linker);

  Boolean(Value):=jt.rf.Get(__rf, 
    __Name, 
    __Stream, 
    __Linker);
 end;

destructor TrfGet.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_Name, Done);
  Dispose(_Stream, Done);
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ rfGetSizes(const rf: Pointer; var JunkSize, DataSize, TotalSize:
   Longint); }

type
 PrfGetSizes = ^TrfGetSizes;
 TrfGetSizes = object(TAction)
  _rf: PNumberExpression;
  _JunkSize: PNumberExpression;
  _DataSize: PNumberExpression;
  _TotalSize: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TrfGetSizes.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfGetSizes', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _JunkSize:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _JunkSize^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _DataSize:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DataSize^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _TotalSize:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _TotalSize^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TrfGetSizes.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __rf: Pointer;
  __JunkSize: Longint;
  __DataSize: Longint;
  __TotalSize: Longint;
 begin
  _rf^.Get(Data, __rf);
  _JunkSize^.Get(Data, __JunkSize);
  _DataSize^.Get(Data, __DataSize);
  _TotalSize^.Get(Data, __TotalSize);

  jt.rf.GetSizes(__rf, 
    __JunkSize, 
    __DataSize, 
    __TotalSize);

  _JunkSize^.Assign(Data, __JunkSize);
  _DataSize^.Assign(Data, __DataSize);
  _TotalSize^.Assign(Data, __TotalSize);

  Execute:=erOk;
 end;

destructor TrfGetSizes.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_JunkSize, Done);
  Dispose(_DataSize, Done);
  Dispose(_TotalSize, Done);

  inherited Done;
 end;

{ rfPack(const rf: Pointer; const TempStream: Pointer; const Linker:
   PStreamLinker): Boolean; }

type
 PrfPack = ^TrfPack;
 TrfPack = object(TBooleanExpression)
  _rf: PNumberExpression;
  _TempStream: PNumberExpression;
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfPack.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfPack', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TempStream:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfPack.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
  __TempStream: Pointer;
  __Linker: PStreamLinker;
 begin
  _rf^.Get(ExecuteData, __rf);
  _TempStream^.Get(ExecuteData, __TempStream);
  _Linker^.Get(ExecuteData, __Linker);

  Boolean(Value):=jt.rf.Pack(__rf, 
    __TempStream, 
    __Linker);
 end;

destructor TrfPack.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_TempStream, Done);
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ rfcommon: Pointer; }

type
 Prfcommon = ^Trfcommon;
 Trfcommon = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure Trfcommon.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.rf.common);
 end;

{ rfCount(const rf: Pointer): Longint; }

type
 PrfCount = ^TrfCount;
 TrfCount = object(TNumberExpression)
  _rf: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
 begin
  _rf^.Get(ExecuteData, __rf);

  Longint(Value):=Longint(jt.rf.Count(__rf));
 end;

destructor TrfCount.Done;
 begin
  Dispose(_rf, Done);

  inherited Done;
 end;

{ rfAt(const rf: Pointer; const Index: Longint; var Junk: Boolean;
   var Size: Longint): PString; }

type
 PrfAt = ^TrfAt;
 TrfAt = object(TNumberExpression)
  _rf: PNumberExpression;
  _Index: PNumberExpression;
  _Junk: PBooleanExpression;
  _Size: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrfAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rfAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _rf:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Junk:=Actions^.ParseBooleanExpression(Tokenizer, True);

  if not _Junk^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etBoolean);

  Tokenizer^.Next([tmComma]);

  _Size:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Size^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrfAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __rf: Pointer;
  __Index: Longint;
  __Junk: Boolean;
  __Size: Longint;
 begin
  _rf^.Get(ExecuteData, __rf);
  _Index^.Get(ExecuteData, __Index);
  _Junk^.Get(ExecuteData, __Junk);
  _Size^.Get(ExecuteData, __Size);

  Longint(Value):=Longint(jt.rf.At(__rf, 
    __Index, 
    __Junk, 
    __Size));

  _Junk^.Assign(ExecuteData, __Junk);
  _Size^.Assign(ExecuteData, __Size);
 end;

destructor TrfAt.Done;
 begin
  Dispose(_rf, Done);
  Dispose(_Index, Done);
  Dispose(_Junk, Done);
  Dispose(_Size, Done);

  inherited Done;
 end;

{ reCreate(const AMask: PChar): Pointer; }

type
 PreCreate = ^TreCreate;
 TreCreate = object(TNumberExpression)
  _AMask: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreCreate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reCreate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AMask:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreCreate.Get(const ExecuteData: PExecuteData; var Value);
 var
  __AMask: PChar;
 begin
  _AMask^.Get(ExecuteData, __AMask);

  Longint(Value):=Longint(jt.re.Create(__AMask));
 end;

destructor TreCreate.Done;
 begin
  Dispose(_AMask, Done);

  inherited Done;
 end;

{ reCreateStr(const AMask: String): Pointer; }

type
 PreCreateStr = ^TreCreateStr;
 TreCreateStr = object(TNumberExpression)
  _AMask: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreCreateStr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reCreateStr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AMask:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreCreateStr.Get(const ExecuteData: PExecuteData; var Value);
 var
  __AMask: String;
 begin
  _AMask^.Get(ExecuteData, __AMask);

  Longint(Value):=Longint(jt.re.CreateStr(__AMask));
 end;

destructor TreCreateStr.Done;
 begin
  Dispose(_AMask, Done);

  inherited Done;
 end;

{ reDestroy(const ARegExp: Pointer); }

type
 PreDestroy = ^TreDestroy;
 TreDestroy = object(TAction)
  _ARegExp: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TreDestroy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reDestroy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ARegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TreDestroy.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __ARegExp: Pointer;
 begin
  _ARegExp^.Get(Data, __ARegExp);

  jt.re.Destroy(__ARegExp);

  Execute:=erOk;
 end;

destructor TreDestroy.Done;
 begin
  Dispose(_ARegExp, Done);

  inherited Done;
 end;

{ reIsValid(const ARegExp: Pointer): Boolean; }

type
 PreIsValid = ^TreIsValid;
 TreIsValid = object(TBooleanExpression)
  _ARegExp: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreIsValid.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reIsValid', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ARegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreIsValid.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ARegExp: Pointer;
 begin
  _ARegExp^.Get(ExecuteData, __ARegExp);

  Boolean(Value):=jt.re.IsValid(__ARegExp);
 end;

destructor TreIsValid.Done;
 begin
  Dispose(_ARegExp, Done);

  inherited Done;
 end;

{ reMatch(const ARegExp: Pointer; const Addr: PChar; CaseSensitive:
   Boolean): Boolean; }

type
 PreMatch = ^TreMatch;
 TreMatch = object(TBooleanExpression)
  _ARegExp: PNumberExpression;
  _Addr: PNumberExpression;
  _CaseSensitive: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreMatch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reMatch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ARegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Addr:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _CaseSensitive:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreMatch.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ARegExp: Pointer;
  __Addr: PChar;
  __CaseSensitive: Boolean;
 begin
  _ARegExp^.Get(ExecuteData, __ARegExp);
  _Addr^.Get(ExecuteData, __Addr);
  _CaseSensitive^.Get(ExecuteData, __CaseSensitive);

  Boolean(Value):=jt.re.Match(__ARegExp, 
    __Addr, 
    __CaseSensitive);
 end;

destructor TreMatch.Done;
 begin
  Dispose(_ARegExp, Done);
  Dispose(_Addr, Done);
  Dispose(_CaseSensitive, Done);

  inherited Done;
 end;

{ reMatchStr(const ARegExp: Pointer; const Addr: String; CaseSensitive:
   Boolean): Boolean; }

type
 PreMatchStr = ^TreMatchStr;
 TreMatchStr = object(TBooleanExpression)
  _ARegExp: PNumberExpression;
  _Addr: PStringExpression;
  _CaseSensitive: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreMatchStr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reMatchStr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ARegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Addr:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _CaseSensitive:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreMatchStr.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ARegExp: Pointer;
  __Addr: String;
  __CaseSensitive: Boolean;
 begin
  _ARegExp^.Get(ExecuteData, __ARegExp);
  _Addr^.Get(ExecuteData, __Addr);
  _CaseSensitive^.Get(ExecuteData, __CaseSensitive);

  Boolean(Value):=jt.re.MatchStr(__ARegExp, 
    __Addr, 
    __CaseSensitive);
 end;

destructor TreMatchStr.Done;
 begin
  Dispose(_ARegExp, Done);
  Dispose(_Addr, Done);
  Dispose(_CaseSensitive, Done);

  inherited Done;
 end;

{ reGetErrorMsg(const ARegExp: Pointer): String; }

type
 PreGetErrorMsg = ^TreGetErrorMsg;
 TreGetErrorMsg = object(TStringExpression)
  _ARegExp: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TreGetErrorMsg.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('reGetErrorMsg', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ARegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TreGetErrorMsg.Get(const ExecuteData: PExecuteData; var Value);
 var
  __ARegExp: Pointer;
 begin
  _ARegExp^.Get(ExecuteData, __ARegExp);

  String(Value):=jt.re.GetErrorMsg(__ARegExp);
 end;

destructor TreGetErrorMsg.Done;
 begin
  Dispose(_ARegExp, Done);

  inherited Done;
 end;

{ rePreprocessWildcard(const Wildcard: String): String; }

type
 PrePreprocessWildcard = ^TrePreprocessWildcard;
 TrePreprocessWildcard = object(TStringExpression)
  _Wildcard: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TrePreprocessWildcard.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('rePreprocessWildcard', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Wildcard:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TrePreprocessWildcard.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Wildcard: String;
 begin
  _Wildcard^.Get(ExecuteData, __Wildcard);

  String(Value):=jt.re.PreprocessWildcard(__Wildcard);
 end;

destructor TrePreprocessWildcard.Done;
 begin
  Dispose(_Wildcard, Done);

  inherited Done;
 end;

{ reGetTitle: String; }

type
 PreGetTitle = ^TreGetTitle;
 TreGetTitle = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TreGetTitle.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.re.GetTitle;
 end;

{ reGetVersion: String; }

type
 PreGetVersion = ^TreGetVersion;
 TreGetVersion = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TreGetVersion.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.re.GetVersion;
 end;

{ reGetCopyright: String; }

type
 PreGetCopyright = ^TreGetCopyright;
 TreGetCopyright = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TreGetCopyright.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.re.GetCopyright;
 end;

{ reTitle: String; }

type
 PreTitle = ^TreTitle;
 TreTitle = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TreTitle.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jt.re.Title;
 end;

{ mbNetmail(const mb: Pointer): Boolean; }

type
 PmbNetmail = ^TmbNetmail;
 TmbNetmail = object(TBooleanExpression)
  _mb: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbNetmail.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbNetmail', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbNetmail.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
 begin
  _mb^.Get(ExecuteData, __mb);

  Boolean(Value):=jt.mb.Netmail(__mb);
 end;

destructor TmbNetmail.Done;
 begin
  Dispose(_mb, Done);

  inherited Done;
 end;

{ mbAdd(const mb: Pointer; const msg: Pointer; var rc: String; const
   Flags: Longint): Boolean; }

type
 PmbAdd = ^TmbAdd;
 TmbAdd = object(TBooleanExpression)
  _mb: PNumberExpression;
  _msg: PNumberExpression;
  _rc: PStringExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbAdd.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbAdd', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbAdd.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __msg: Pointer;
  __rc: String;
  __Flags: Longint;
 begin
  _mb^.Get(ExecuteData, __mb);
  _msg^.Get(ExecuteData, __msg);
  _rc^.Get(ExecuteData, __rc);
  _Flags^.Get(ExecuteData, __Flags);

  Boolean(Value):=jt.mb.Add(__mb, 
    __msg, 
    __rc, 
    __Flags);

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TmbAdd.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_msg, Done);
  Dispose(_rc, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ mbCount(const mb: Pointer): Longint; }

type
 PmbCount = ^TmbCount;
 TmbCount = object(TNumberExpression)
  _mb: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbCount.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbCount', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbCount.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
 begin
  _mb^.Get(ExecuteData, __mb);

  Longint(Value):=Longint(jt.mb.Count(__mb));
 end;

destructor TmbCount.Done;
 begin
  Dispose(_mb, Done);

  inherited Done;
 end;

{ mbLoad(const mb: Pointer; const No: Longint; var msg: Pointer;
   var rc: String; const Flags: Longint): Boolean; }

type
 PmbLoad = ^TmbLoad;
 TmbLoad = object(TBooleanExpression)
  _mb: PNumberExpression;
  _No: PNumberExpression;
  _msg: PNumberExpression;
  _rc: PStringExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbLoad.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbLoad', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _No:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _msg^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbLoad.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __No: Longint;
  __msg: Pointer;
  __rc: String;
  __Flags: Longint;
 begin
  _mb^.Get(ExecuteData, __mb);
  _No^.Get(ExecuteData, __No);
  _msg^.Get(ExecuteData, __msg);
  _rc^.Get(ExecuteData, __rc);
  _Flags^.Get(ExecuteData, __Flags);

  Boolean(Value):=jt.mb.Load(__mb, 
    __No, 
    __msg, 
    __rc, 
    __Flags);

  _msg^.Assign(ExecuteData, __msg);
  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TmbLoad.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_No, Done);
  Dispose(_msg, Done);
  Dispose(_rc, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ mbStore(const mb: Pointer; const No: Longint; const msg: Pointer;
   var rc: String; const Flags: Longint): Boolean; }

type
 PmbStore = ^TmbStore;
 TmbStore = object(TBooleanExpression)
  _mb: PNumberExpression;
  _No: PNumberExpression;
  _msg: PNumberExpression;
  _rc: PStringExpression;
  _Flags: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbStore.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbStore', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _No:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbStore.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __No: Longint;
  __msg: Pointer;
  __rc: String;
  __Flags: Longint;
 begin
  _mb^.Get(ExecuteData, __mb);
  _No^.Get(ExecuteData, __No);
  _msg^.Get(ExecuteData, __msg);
  _rc^.Get(ExecuteData, __rc);
  _Flags^.Get(ExecuteData, __Flags);

  Boolean(Value):=jt.mb.Store(__mb, 
    __No, 
    __msg, 
    __rc, 
    __Flags);

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TmbStore.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_No, Done);
  Dispose(_msg, Done);
  Dispose(_rc, Done);
  Dispose(_Flags, Done);

  inherited Done;
 end;

{ mbKill(const mb: Pointer; const No: Longint; var rc: String):
   Boolean; }

type
 PmbKill = ^TmbKill;
 TmbKill = object(TBooleanExpression)
  _mb: PNumberExpression;
  _No: PNumberExpression;
  _rc: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbKill.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbKill', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _No:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _rc:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _rc^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbKill.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __No: Longint;
  __rc: String;
 begin
  _mb^.Get(ExecuteData, __mb);
  _No^.Get(ExecuteData, __No);
  _rc^.Get(ExecuteData, __rc);

  Boolean(Value):=jt.mb.Kill(__mb, 
    __No, 
    __rc);

  _rc^.Assign(ExecuteData, __rc);
 end;

destructor TmbKill.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_No, Done);
  Dispose(_rc, Done);

  inherited Done;
 end;

{ mbNoToGlobal(const mb: Pointer; const No: Longint): Longint; }

type
 PmbNoToGlobal = ^TmbNoToGlobal;
 TmbNoToGlobal = object(TNumberExpression)
  _mb: PNumberExpression;
  _No: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbNoToGlobal.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbNoToGlobal', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _No:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbNoToGlobal.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __No: Longint;
 begin
  _mb^.Get(ExecuteData, __mb);
  _No^.Get(ExecuteData, __No);

  Longint(Value):=Longint(jt.mb.NoToGlobal(__mb, 
    __No));
 end;

destructor TmbNoToGlobal.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_No, Done);

  inherited Done;
 end;

{ mbGlobalToNo(const mb: Pointer; const Global: Longint): Longint; }

type
 PmbGlobalToNo = ^TmbGlobalToNo;
 TmbGlobalToNo = object(TNumberExpression)
  _mb: PNumberExpression;
  _Global: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbGlobalToNo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbGlobalToNo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Global:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbGlobalToNo.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __Global: Longint;
 begin
  _mb^.Get(ExecuteData, __mb);
  _Global^.Get(ExecuteData, __Global);

  Longint(Value):=Longint(jt.mb.GlobalToNo(__mb, 
    __Global));
 end;

destructor TmbGlobalToNo.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_Global, Done);

  inherited Done;
 end;

{ mbLock(const mb: Pointer): Boolean; }

type
 PmbLock = ^TmbLock;
 TmbLock = object(TBooleanExpression)
  _mb: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbLock.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbLock', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbLock.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
 begin
  _mb^.Get(ExecuteData, __mb);

  Boolean(Value):=jt.mb.Lock(__mb);
 end;

destructor TmbLock.Done;
 begin
  Dispose(_mb, Done);

  inherited Done;
 end;

{ mbUnlock(const mb: Pointer); }

type
 PmbUnlock = ^TmbUnlock;
 TmbUnlock = object(TAction)
  _mb: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmbUnlock.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbUnlock', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmbUnlock.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __mb: Pointer;
 begin
  _mb^.Get(Data, __mb);

  jt.mb.Unlock(__mb);

  Execute:=erOk;
 end;

destructor TmbUnlock.Done;
 begin
  Dispose(_mb, Done);

  inherited Done;
 end;

{ mbLoadLinkInfo(const mb: Pointer; var Block); }

type
 PmbLoadLinkInfo = ^TmbLoadLinkInfo;
 TmbLoadLinkInfo = object(TAction)
  _mb: PNumberExpression;
  _Block: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmbLoadLinkInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbLoadLinkInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Block:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmbLoadLinkInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __mb: Pointer;
  __Block: Pointer;
 begin
  _mb^.Get(Data, __mb);
  _Block^.Get(Data, __Block);

  jt.mb.LoadLinkInfo(__mb, 
    __Block^);

  Execute:=erOk;
 end;

destructor TmbLoadLinkInfo.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_Block, Done);

  inherited Done;
 end;

{ mbStoreLinkInfo(const mb: Pointer; var Block); }

type
 PmbStoreLinkInfo = ^TmbStoreLinkInfo;
 TmbStoreLinkInfo = object(TAction)
  _mb: PNumberExpression;
  _Block: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TmbStoreLinkInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbStoreLinkInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Block:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TmbStoreLinkInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __mb: Pointer;
  __Block: Pointer;
 begin
  _mb^.Get(Data, __mb);
  _Block^.Get(Data, __Block);

  jt.mb.StoreLinkInfo(__mb, 
    __Block^);

  Execute:=erOk;
 end;

destructor TmbStoreLinkInfo.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_Block, Done);

  inherited Done;
 end;

{ mbExtendedOpened(const mb: Pointer; const Operation: Longint;
   var Data): Boolean; }

type
 PmbExtendedOpened = ^TmbExtendedOpened;
 TmbExtendedOpened = object(TBooleanExpression)
  _mb: PNumberExpression;
  _Operation: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbExtendedOpened.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbExtendedOpened', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mb:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Operation:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbExtendedOpened.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mb: Pointer;
  __Operation: Longint;
  __Data: Pointer;
 begin
  _mb^.Get(ExecuteData, __mb);
  _Operation^.Get(ExecuteData, __Operation);
  _Data^.Get(ExecuteData, __Data);

  Boolean(Value):=jt.mb.ExtendedOpened(__mb, 
    __Operation, 
    __Data^);
 end;

destructor TmbExtendedOpened.Done;
 begin
  Dispose(_mb, Done);
  Dispose(_Operation, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ mbExtended(const mbi: Pointer; const Operation: Longint; var Data):
   Boolean; }

type
 PmbExtended = ^TmbExtended;
 TmbExtended = object(TBooleanExpression)
  _mbi: PNumberExpression;
  _Operation: PNumberExpression;
  _Data: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TmbExtended.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('mbExtended', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _mbi:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Operation:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Data:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TmbExtended.Get(const ExecuteData: PExecuteData; var Value);
 var
  __mbi: Pointer;
  __Operation: Longint;
  __Data: Pointer;
 begin
  _mbi^.Get(ExecuteData, __mbi);
  _Operation^.Get(ExecuteData, __Operation);
  _Data^.Get(ExecuteData, __Data);

  Boolean(Value):=jt.mb.Extended(__mbi, 
    __Operation, 
    __Data^);
 end;

destructor TmbExtended.Done;
 begin
  Dispose(_mbi, Done);
  Dispose(_Operation, Done);
  Dispose(_Data, Done);

  inherited Done;
 end;

{ fmtrRegister(const FormatReader: PFormatReader); }

type
 PfmtrRegister = ^TfmtrRegister;
 TfmtrRegister = object(TAction)
  _FormatReader: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TfmtrRegister.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtrRegister', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FormatReader:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TfmtrRegister.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FormatReader: PFormatReader;
 begin
  _FormatReader^.Get(Data, __FormatReader);

  jt.fmt.r.Register(__FormatReader);

  Execute:=erOk;
 end;

destructor TfmtrRegister.Done;
 begin
  Dispose(_FormatReader, Done);

  inherited Done;
 end;

{ fmtrSeek(const Name: String): PFormatReader; }

type
 PfmtrSeek = ^TfmtrSeek;
 TfmtrSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtrSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtrSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtrSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.fmt.r.Seek(__Name));
 end;

destructor TfmtrSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ fmtrIdent(const FName: String): PFormatReader; }

type
 PfmtrIdent = ^TfmtrIdent;
 TfmtrIdent = object(TNumberExpression)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtrIdent.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtrIdent', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtrIdent.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
 begin
  _FName^.Get(ExecuteData, __FName);

  Longint(Value):=Longint(jt.fmt.r.Ident(__FName));
 end;

destructor TfmtrIdent.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ fmtrCount: Longint; }

type
 PfmtrCount = ^TfmtrCount;
 TfmtrCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtrCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.r.Count);
 end;

{ fmtrAt(const Index: Longint): PFormatReader; }

type
 PfmtrAt = ^TfmtrAt;
 TfmtrAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtrAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtrAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtrAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.fmt.r.At(__Index));
 end;

destructor TfmtrAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ fmtwRegister(const FormatWriter: PFormatWriter); }

type
 PfmtwRegister = ^TfmtwRegister;
 TfmtwRegister = object(TAction)
  _FormatWriter: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TfmtwRegister.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtwRegister', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FormatWriter:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TfmtwRegister.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FormatWriter: PFormatWriter;
 begin
  _FormatWriter^.Get(Data, __FormatWriter);

  jt.fmt.w.Register(__FormatWriter);

  Execute:=erOk;
 end;

destructor TfmtwRegister.Done;
 begin
  Dispose(_FormatWriter, Done);

  inherited Done;
 end;

{ fmtwSeek(const Name: String): PFormatWriter; }

type
 PfmtwSeek = ^TfmtwSeek;
 TfmtwSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtwSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtwSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtwSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.fmt.w.Seek(__Name));
 end;

destructor TfmtwSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ fmtwCount: Longint; }

type
 PfmtwCount = ^TfmtwCount;
 TfmtwCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtwCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.w.Count);
 end;

{ fmtwAt(const Index: Longint): PFormatWriter; }

type
 PfmtwAt = ^TfmtwAt;
 TfmtwAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtwAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtwAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtwAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.fmt.w.At(__Index));
 end;

destructor TfmtwAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ fmtppRegister(const FormatPreprocessor: PFormatPreprocessor); }

type
 PfmtppRegister = ^TfmtppRegister;
 TfmtppRegister = object(TAction)
  _FormatPreprocessor: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TfmtppRegister.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtppRegister', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FormatPreprocessor:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TfmtppRegister.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FormatPreprocessor: PFormatPreprocessor;
 begin
  _FormatPreprocessor^.Get(Data, __FormatPreprocessor);

  jt.fmt.pp.Register(__FormatPreprocessor);

  Execute:=erOk;
 end;

destructor TfmtppRegister.Done;
 begin
  Dispose(_FormatPreprocessor, Done);

  inherited Done;
 end;

{ fmtppSeek(const Name: String): PFormatPreprocessor; }

type
 PfmtppSeek = ^TfmtppSeek;
 TfmtppSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtppSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtppSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtppSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.fmt.pp.Seek(__Name));
 end;

destructor TfmtppSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ fmtppCount: Longint; }

type
 PfmtppCount = ^TfmtppCount;
 TfmtppCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtppCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.pp.Count);
 end;

{ fmtppAt(const Index: Longint): PFormatPreprocessor; }

type
 PfmtppAt = ^TfmtppAt;
 TfmtppAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtppAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtppAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtppAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.fmt.pp.At(__Index));
 end;

destructor TfmtppAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ fmtopRegister(const FormatOutprocessor: PFormatOutprocessor); }

type
 PfmtopRegister = ^TfmtopRegister;
 TfmtopRegister = object(TAction)
  _FormatOutprocessor: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TfmtopRegister.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtopRegister', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FormatOutprocessor:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TfmtopRegister.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FormatOutprocessor: PFormatOutprocessor;
 begin
  _FormatOutprocessor^.Get(Data, __FormatOutprocessor);

  jt.fmt.op.Register(__FormatOutprocessor);

  Execute:=erOk;
 end;

destructor TfmtopRegister.Done;
 begin
  Dispose(_FormatOutprocessor, Done);

  inherited Done;
 end;

{ fmtopSeek(const Name: String): PFormatOutprocessor; }

type
 PfmtopSeek = ^TfmtopSeek;
 TfmtopSeek = object(TNumberExpression)
  _Name: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtopSeek.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtopSeek', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Name:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtopSeek.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Name: String;
 begin
  _Name^.Get(ExecuteData, __Name);

  Longint(Value):=Longint(jt.fmt.op.Seek(__Name));
 end;

destructor TfmtopSeek.Done;
 begin
  Dispose(_Name, Done);

  inherited Done;
 end;

{ fmtopCount: Longint; }

type
 PfmtopCount = ^TfmtopCount;
 TfmtopCount = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtopCount.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.op.Count);
 end;

{ fmtopAt(const Index: Longint): PFormatOutprocessor; }

type
 PfmtopAt = ^TfmtopAt;
 TfmtopAt = object(TNumberExpression)
  _Index: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TfmtopAt.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('fmtopAt', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TfmtopAt.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Index: Longint;
 begin
  _Index^.Get(ExecuteData, __Index);

  Longint(Value):=Longint(jt.fmt.op.At(__Index));
 end;

destructor TfmtopAt.Done;
 begin
  Dispose(_Index, Done);

  inherited Done;
 end;

{ fmtDefaultFormatWriter: PFormatWriter; }

type
 PfmtDefaultFormatWriter = ^TfmtDefaultFormatWriter;
 TfmtDefaultFormatWriter = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtDefaultFormatWriter.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.DefaultFormatWriter);
 end;

{ fmtDefaultFormatOutprocessor: PFormatOutprocessor; }

type
 PfmtDefaultFormatOutprocessor = ^TfmtDefaultFormatOutprocessor;
 TfmtDefaultFormatOutprocessor = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TfmtDefaultFormatOutprocessor.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.fmt.DefaultFormatOutprocessor);
 end;

{ tossscanSetTossMessage(const ATossMessage: TTossMessage); }

type
 PtossscanSetTossMessage = ^TtossscanSetTossMessage;
 TtossscanSetTossMessage = object(TAction)
  _ATossMessage: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanSetTossMessage.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanSetTossMessage', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ATossMessage:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanSetTossMessage.Execute(const Data: PExecuteData): TExecuteResult;
 var
  ___ATossMessage: TTossMessage;
  __ATossMessage: Longint absolute ___ATossMessage;
 begin
  _ATossMessage^.Get(Data, __ATossMessage);

  jt.tossscan.SetTossMessage(___ATossMessage);

  Execute:=erOk;
 end;

destructor TtossscanSetTossMessage.Done;
 begin
  Dispose(_ATossMessage, Done);

  inherited Done;
 end;

{ tossscanTossMessage(msg: Pointer); }

type
 PtossscanTossMessage = ^TtossscanTossMessage;
 TtossscanTossMessage = object(TAction)
  _msg: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanTossMessage.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanTossMessage', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _msg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanTossMessage.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __msg: Pointer;
 begin
  _msg^.Get(Data, __msg);

  jt.tossscan.TossMessage(__msg);

  Execute:=erOk;
 end;

destructor TtossscanTossMessage.Done;
 begin
  Dispose(_msg, Done);

  inherited Done;
 end;

{ tossscanSetTossMessageToLinks(const ATossMessageToLinks: TTossMessageToLinks); }

type
 PtossscanSetTossMessageToLinks = ^TtossscanSetTossMessageToLinks;
 TtossscanSetTossMessageToLinks = object(TAction)
  _ATossMessageToLinks: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanSetTossMessageToLinks.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanSetTossMessageToLinks', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ATossMessageToLinks:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanSetTossMessageToLinks.Execute(const Data: PExecuteData): TExecuteResult;
 var
  ___ATossMessageToLinks: TTossMessageToLinks;
  __ATossMessageToLinks: Longint absolute ___ATossMessageToLinks;
 begin
  _ATossMessageToLinks^.Get(Data, __ATossMessageToLinks);

  jt.tossscan.SetTossMessageToLinks(___ATossMessageToLinks);

  Execute:=erOk;
 end;

destructor TtossscanSetTossMessageToLinks.Done;
 begin
  Dispose(_ATossMessageToLinks, Done);

  inherited Done;
 end;

{ tossscanTossMessageToLinks(const Amsg, Area, ALink: Pointer); }

type
 PtossscanTossMessageToLinks = ^TtossscanTossMessageToLinks;
 TtossscanTossMessageToLinks = object(TAction)
  _Amsg: PNumberExpression;
  _Area: PNumberExpression;
  _ALink: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanTossMessageToLinks.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanTossMessageToLinks', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Amsg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _ALink:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanTossMessageToLinks.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Amsg: Pointer;
  __Area: Pointer;
  __ALink: Pointer;
 begin
  _Amsg^.Get(Data, __Amsg);
  _Area^.Get(Data, __Area);
  _ALink^.Get(Data, __ALink);

  jt.tossscan.TossMessageToLinks(__Amsg, 
    __Area, 
    __ALink);

  Execute:=erOk;
 end;

destructor TtossscanTossMessageToLinks.Done;
 begin
  Dispose(_Amsg, Done);
  Dispose(_Area, Done);
  Dispose(_ALink, Done);

  inherited Done;
 end;

{ tossscanSetTossToBadmail(const ATossToBadmail: TTossToBadmail); }

type
 PtossscanSetTossToBadmail = ^TtossscanSetTossToBadmail;
 TtossscanSetTossToBadmail = object(TAction)
  _ATossToBadmail: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanSetTossToBadmail.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanSetTossToBadmail', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _ATossToBadmail:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanSetTossToBadmail.Execute(const Data: PExecuteData): TExecuteResult;
 var
  ___ATossToBadmail: TTossToBadmail;
  __ATossToBadmail: Longint absolute ___ATossToBadmail;
 begin
  _ATossToBadmail^.Get(Data, __ATossToBadmail);

  jt.tossscan.SetTossToBadmail(___ATossToBadmail);

  Execute:=erOk;
 end;

destructor TtossscanSetTossToBadmail.Done;
 begin
  Dispose(_ATossToBadmail, Done);

  inherited Done;
 end;

{ tossscanTossToBadmail(const Amsg: Pointer; const Reason: String); }

type
 PtossscanTossToBadmail = ^TtossscanTossToBadmail;
 TtossscanTossToBadmail = object(TAction)
  _Amsg: PNumberExpression;
  _Reason: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TtossscanTossToBadmail.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('tossscanTossToBadmail', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Amsg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Reason:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TtossscanTossToBadmail.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Amsg: Pointer;
  __Reason: String;
 begin
  _Amsg^.Get(Data, __Amsg);
  _Reason^.Get(Data, __Reason);

  jt.tossscan.TossToBadmail(__Amsg, 
    __Reason);

  Execute:=erOk;
 end;

destructor TtossscanTossToBadmail.Done;
 begin
  Dispose(_Amsg, Done);
  Dispose(_Reason, Done);

  inherited Done;
 end;

{ PrintStr(const S: String); }

type
 PPrintStr = ^TPrintStr;
 TPrintStr = object(TAction)
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPrintStr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PrintStr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPrintStr.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __S: String;
 begin
  _S^.Get(Data, __S);

  jt.PrintStr(__S);

  Execute:=erOk;
 end;

destructor TPrintStr.Done;
 begin
  Dispose(_S, Done);

  inherited Done;
 end;

{ ComparePasswords(const Password1, Password2: String; const Link:
   Pointer): Boolean; }

type
 PComparePasswords = ^TComparePasswords;
 TComparePasswords = object(TBooleanExpression)
  _Password1: PStringExpression;
  _Password2: PStringExpression;
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TComparePasswords.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('ComparePasswords', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Password1:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Password2:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TComparePasswords.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Password1: String;
  __Password2: String;
  __Link: Pointer;
 begin
  _Password1^.Get(ExecuteData, __Password1);
  _Password2^.Get(ExecuteData, __Password2);
  _Link^.Get(ExecuteData, __Link);

  Boolean(Value):=jt.ComparePasswords(__Password1, 
    __Password2, 
    __Link);
 end;

destructor TComparePasswords.Done;
 begin
  Dispose(_Password1, Done);
  Dispose(_Password2, Done);
  Dispose(_Link, Done);

  inherited Done;
 end;

{ GetNetmailAka(var Source, Address: TAddress); }

type
 PGetNetmailAka = ^TGetNetmailAka;
 TGetNetmailAka = object(TAction)
  _Source: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TGetNetmailAka.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetNetmailAka', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Source:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Source^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TGetNetmailAka.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Source: PAddress;
  __Address: PAddress;
 begin
  _Source^.Get(Data, __Source);
  _Address^.Get(Data, __Address);

  jt.GetNetmailAka(__Source^, 
    __Address^);

  Execute:=erOk;
 end;

destructor TGetNetmailAka.Done;
 begin
  Dispose(_Source, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ GetDomainInfo(const Address: TAddress; var Domain, DomainOutbound:
   String; var MainZone: Longint): Boolean; }

type
 PGetDomainInfo = ^TGetDomainInfo;
 TGetDomainInfo = object(TBooleanExpression)
  _Address: PNumberExpression;
  _Domain: PStringExpression;
  _DomainOutbound: PStringExpression;
  _MainZone: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetDomainInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetDomainInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Domain:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Domain^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _DomainOutbound:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _DomainOutbound^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _MainZone:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _MainZone^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetDomainInfo.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
  __Domain: String;
  __DomainOutbound: String;
  __MainZone: Longint;
 begin
  _Address^.Get(ExecuteData, __Address);
  _Domain^.Get(ExecuteData, __Domain);
  _DomainOutbound^.Get(ExecuteData, __DomainOutbound);
  _MainZone^.Get(ExecuteData, __MainZone);

  Boolean(Value):=jt.GetDomainInfo(__Address^, 
    __Domain, 
    __DomainOutbound, 
    __MainZone);

  _Domain^.Assign(ExecuteData, __Domain);
  _DomainOutbound^.Assign(ExecuteData, __DomainOutbound);
  _MainZone^.Assign(ExecuteData, __MainZone);
 end;

destructor TGetDomainInfo.Done;
 begin
  Dispose(_Address, Done);
  Dispose(_Domain, Done);
  Dispose(_DomainOutbound, Done);
  Dispose(_MainZone, Done);

  inherited Done;
 end;

{ NewAreaFormat: PAreaFormat; }

type
 PNewAreaFormat = ^TNewAreaFormat;
 TNewAreaFormat = object(TNumberExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TNewAreaFormat.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Longint(Value):=Longint(jt.NewAreaFormat);
 end;

{ DestroyAreaFormat(const Format: PAreaFormat); }

type
 PDestroyAreaFormat = ^TDestroyAreaFormat;
 TDestroyAreaFormat = object(TAction)
  _Format: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDestroyAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DestroyAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDestroyAreaFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Format: PAreaFormat;
 begin
  _Format^.Get(Data, __Format);

  jt.DestroyAreaFormat(__Format);

  Execute:=erOk;
 end;

destructor TDestroyAreaFormat.Done;
 begin
  Dispose(_Format, Done);

  inherited Done;
 end;

{ NewAddress(const AAddress: TAddress): PAddress; }

type
 PNewAddress = ^TNewAddress;
 TNewAddress = object(TNumberExpression)
  _AAddress: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TNewAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('NewAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AAddress:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TNewAddress.Get(const ExecuteData: PExecuteData; var Value);
 var
  __AAddress: PAddress;
 begin
  _AAddress^.Get(ExecuteData, __AAddress);

  Longint(Value):=Longint(jt.NewAddress(__AAddress^));
 end;

destructor TNewAddress.Done;
 begin
  Dispose(_AAddress, Done);

  inherited Done;
 end;

{ DestroyAddress(const Address: PAddress); }

type
 PDestroyAddress = ^TDestroyAddress;
 TDestroyAddress = object(TAction)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDestroyAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DestroyAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDestroyAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Address: PAddress;
 begin
  _Address^.Get(Data, __Address);

  jt.DestroyAddress(__Address);

  Execute:=erOk;
 end;

destructor TDestroyAddress.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ ParseAddressMask(Source: String; var Address: TAddress): Boolean; }

type
 PParseAddressMask = ^TParseAddressMask;
 TParseAddressMask = object(TBooleanExpression)
  _Source: PStringExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TParseAddressMask.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('ParseAddressMask', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Source:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TParseAddressMask.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Source: String;
  __Address: PAddress;
 begin
  _Source^.Get(ExecuteData, __Source);
  _Address^.Get(ExecuteData, __Address);

  Boolean(Value):=jt.ParseAddressMask(__Source, 
    __Address^);
 end;

destructor TParseAddressMask.Done;
 begin
  Dispose(_Source, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ UnparseAddressMask(const Address: TAddress): String; }

type
 PUnparseAddressMask = ^TUnparseAddressMask;
 TUnparseAddressMask = object(TStringExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TUnparseAddressMask.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnparseAddressMask', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TUnparseAddressMask.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  String(Value):=jt.UnparseAddressMask(__Address^);
 end;

destructor TUnparseAddressMask.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ CompileAddressMask(const AMask: String; var Mask: TAddress; const
   Linker: Pointer); }

type
 PCompileAddressMask = ^TCompileAddressMask;
 TCompileAddressMask = object(TAction)
  _AMask: PStringExpression;
  _Mask: PNumberExpression;
  _Linker: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TCompileAddressMask.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('CompileAddressMask', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AMask:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Mask:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Mask^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TCompileAddressMask.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __AMask: String;
  __Mask: PAddress;
  __Linker: Pointer;
 begin
  _AMask^.Get(Data, __AMask);
  _Mask^.Get(Data, __Mask);
  _Linker^.Get(Data, __Linker);

  jt.CompileAddressMask(__AMask, 
    __Mask^, 
    __Linker);

  Execute:=erOk;
 end;

destructor TCompileAddressMask.Done;
 begin
  Dispose(_AMask, Done);
  Dispose(_Mask, Done);
  Dispose(_Linker, Done);

  inherited Done;
 end;

{ CompareAddressMask(const Mask, Address: TAddress): Boolean; }

type
 PCompareAddressMask = ^TCompareAddressMask;
 TCompareAddressMask = object(TBooleanExpression)
  _Mask: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TCompareAddressMask.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('CompareAddressMask', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Mask:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TCompareAddressMask.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Mask: PAddress;
  __Address: PAddress;
 begin
  _Mask^.Get(ExecuteData, __Mask);
  _Address^.Get(ExecuteData, __Address);

  Boolean(Value):=jt.CompareAddressMask(__Mask^, 
    __Address^);
 end;

destructor TCompareAddressMask.Done;
 begin
  Dispose(_Mask, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ CompileRegExp(const AMask: String; var RegExp: Pointer; const
   Linker: Pointer; const Macros: Boolean); }

type
 PCompileRegExp = ^TCompileRegExp;
 TCompileRegExp = object(TAction)
  _AMask: PStringExpression;
  _RegExp: PNumberExpression;
  _Linker: PNumberExpression;
  _Macros: PBooleanExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TCompileRegExp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('CompileRegExp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AMask:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _RegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _RegExp^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Linker:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Macros:=Actions^.ParseBooleanExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TCompileRegExp.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __AMask: String;
  __RegExp: Pointer;
  __Linker: Pointer;
  __Macros: Boolean;
 begin
  _AMask^.Get(Data, __AMask);
  _RegExp^.Get(Data, __RegExp);
  _Linker^.Get(Data, __Linker);
  _Macros^.Get(Data, __Macros);

  jt.CompileRegExp(__AMask, 
    __RegExp, 
    __Linker, 
    __Macros);

  _RegExp^.Assign(Data, __RegExp);

  Execute:=erOk;
 end;

destructor TCompileRegExp.Done;
 begin
  Dispose(_AMask, Done);
  Dispose(_RegExp, Done);
  Dispose(_Linker, Done);
  Dispose(_Macros, Done);

  inherited Done;
 end;

{ DestroyRegExp(const RegExp: Pointer); }

type
 PDestroyRegExp = ^TDestroyRegExp;
 TDestroyRegExp = object(TAction)
  _RegExp: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDestroyRegExp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DestroyRegExp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _RegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDestroyRegExp.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __RegExp: Pointer;
 begin
  _RegExp^.Get(Data, __RegExp);

  jt.DestroyRegExp(__RegExp);

  Execute:=erOk;
 end;

destructor TDestroyRegExp.Done;
 begin
  Dispose(_RegExp, Done);

  inherited Done;
 end;

{ AddressMatchRegExp(const RegExp: Pointer; const Address: PAddress):
   Boolean; }

type
 PAddressMatchRegExp = ^TAddressMatchRegExp;
 TAddressMatchRegExp = object(TBooleanExpression)
  _RegExp: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressMatchRegExp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressMatchRegExp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _RegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressMatchRegExp.Get(const ExecuteData: PExecuteData; var Value);
 var
  __RegExp: Pointer;
  __Address: PAddress;
 begin
  _RegExp^.Get(ExecuteData, __RegExp);
  _Address^.Get(ExecuteData, __Address);

  Boolean(Value):=jt.AddressMatchRegExp(__RegExp, 
    __Address);
 end;

destructor TAddressMatchRegExp.Done;
 begin
  Dispose(_RegExp, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ AreaMatchRegExp(const RegExp: Pointer; const Area: PString): Boolean; }

type
 PAreaMatchRegExp = ^TAreaMatchRegExp;
 TAreaMatchRegExp = object(TBooleanExpression)
  _RegExp: PNumberExpression;
  _Area: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAreaMatchRegExp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AreaMatchRegExp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _RegExp:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Area:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAreaMatchRegExp.Get(const ExecuteData: PExecuteData; var Value);
 var
  __RegExp: Pointer;
  __Area: PString;
 begin
  _RegExp^.Get(ExecuteData, __RegExp);
  _Area^.Get(ExecuteData, __Area);

  Boolean(Value):=jt.AreaMatchRegExp(__RegExp, 
    __Area);
 end;

destructor TAreaMatchRegExp.Done;
 begin
  Dispose(_RegExp, Done);
  Dispose(_Area, Done);

  inherited Done;
 end;

{ Percent(const Current, Maximum: Longint): String; }

type
 PPercent = ^TPercent;
 TPercent = object(TStringExpression)
  _Current: PNumberExpression;
  _Maximum: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TPercent.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Percent', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Current:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Maximum:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TPercent.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Current: Longint;
  __Maximum: Longint;
 begin
  _Current^.Get(ExecuteData, __Current);
  _Maximum^.Get(ExecuteData, __Maximum);

  String(Value):=jt.Percent(__Current, 
    __Maximum);
 end;

destructor TPercent.Done;
 begin
  Dispose(_Current, Done);
  Dispose(_Maximum, Done);

  inherited Done;
 end;

{ CreateUniqueFileName(var FName: String; const Directory: String;
   const Extension: String); }

type
 PCreateUniqueFileName = ^TCreateUniqueFileName;
 TCreateUniqueFileName = object(TAction)
  _FName: PStringExpression;
  _Directory: PStringExpression;
  _Extension: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TCreateUniqueFileName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('CreateUniqueFileName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _FName^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _Directory:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Extension:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TCreateUniqueFileName.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FName: String;
  __Directory: String;
  __Extension: String;
 begin
  _FName^.Get(Data, __FName);
  _Directory^.Get(Data, __Directory);
  _Extension^.Get(Data, __Extension);

  jt.CreateUniqueFileName(__FName, 
    __Directory, 
    __Extension);

  _FName^.Assign(Data, __FName);

  Execute:=erOk;
 end;

destructor TCreateUniqueFileName.Done;
 begin
  Dispose(_FName, Done);
  Dispose(_Directory, Done);
  Dispose(_Extension, Done);

  inherited Done;
 end;

{ Cancelled: Boolean; }

type
 PCancelled = ^TCancelled;
 TCancelled = object(TBooleanExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TCancelled.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Boolean(Value):=jt.Cancelled;
 end;

{ Error: Boolean; }

type
 PError = ^TError;
 TError = object(TBooleanExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TError.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Boolean(Value):=jt.Error;
 end;

{ SetError(const S: String); }

type
 PSetError = ^TSetError;
 TSetError = object(TAction)
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TSetError.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('SetError', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TSetError.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __S: String;
 begin
  _S^.Get(Data, __S);

  jt.SetError(__S);

  Execute:=erOk;
 end;

destructor TSetError.Done;
 begin
  Dispose(_S, Done);

  inherited Done;
 end;

function CreatorSTREMOVE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTREMOVE:=New(PstRemove, Init(Tokenizer, Actions));
 end;

function CreatorSTGET(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTGET:=New(PstGet, Init(Tokenizer, Actions));
 end;

function CreatorSTCLONE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTCLONE:=New(PstClone, Init(Tokenizer, Actions));
 end;

function CreatorSTADDCALLBACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTADDCALLBACK:=New(PstAddCallback, Init(Tokenizer, Actions));
 end;

function CreatorSTINC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTINC:=New(PstInc, Init(Tokenizer, Actions));
 end;

function CreatorSTGLOBALST(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTGLOBALST:=New(Pstglobalst, Init('stglobalst', Actions));
 end;

function CreatorSVCSTSTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTSTRING:=New(PsvcStString, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTADDRESS:=New(PsvcStAddress, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTLISTEX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTLISTEX:=New(PsvcStListEx, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTAREAFORMAT:=New(PsvcStAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTPATH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTPATH:=New(PsvcStPath, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTSEENBY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTSEENBY:=New(PsvcStSeenby, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTCALLBACKS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTCALLBACKS:=New(PsvcStCallbacks, Init(Tokenizer, Actions));
 end;

function CreatorSVCSTOMS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSVCSTOMS:=New(PsvcStOMS, Init(Tokenizer, Actions));
 end;

function CreatorSRVREGISTERHANDLER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSRVREGISTERHANDLER:=New(PsrvRegisterHandler, Init(Tokenizer, Actions));
 end;

function CreatorSRVEXECUTE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSRVEXECUTE:=New(PsrvExecute, Init(Tokenizer, Actions));
 end;

function CreatorSRVEXECUTEEX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSRVEXECUTEEX:=New(PsrvExecuteEx, Init(Tokenizer, Actions));
 end;

function CreatorCBCCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCBCCOUNT:=New(PcbcCount, Init(Tokenizer, Actions));
 end;

function CreatorCBCAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCBCAT:=New(PcbcAt, Init(Tokenizer, Actions));
 end;

function CreatorRFCREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFCREATE:=New(PrfCreate, Init(Tokenizer, Actions));
 end;

function CreatorRFDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFDESTROY:=New(PrfDestroy, Init(Tokenizer, Actions));
 end;

function CreatorRFADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFADD:=New(PrfAdd, Init(Tokenizer, Actions));
 end;

function CreatorRFREMOVE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFREMOVE:=New(PrfRemove, Init(Tokenizer, Actions));
 end;

function CreatorRFGET(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFGET:=New(PrfGet, Init(Tokenizer, Actions));
 end;

function CreatorRFGETSIZES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFGETSIZES:=New(PrfGetSizes, Init(Tokenizer, Actions));
 end;

function CreatorRFPACK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFPACK:=New(PrfPack, Init(Tokenizer, Actions));
 end;

function CreatorRFCOMMON(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFCOMMON:=New(Prfcommon, Init('rfcommon', Actions));
 end;

function CreatorRFCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFCOUNT:=New(PrfCount, Init(Tokenizer, Actions));
 end;

function CreatorRFAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRFAT:=New(PrfAt, Init(Tokenizer, Actions));
 end;

function CreatorRECREATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRECREATE:=New(PreCreate, Init(Tokenizer, Actions));
 end;

function CreatorRECREATESTR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRECREATESTR:=New(PreCreateStr, Init(Tokenizer, Actions));
 end;

function CreatorREDESTROY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREDESTROY:=New(PreDestroy, Init(Tokenizer, Actions));
 end;

function CreatorREISVALID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREISVALID:=New(PreIsValid, Init(Tokenizer, Actions));
 end;

function CreatorREMATCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREMATCH:=New(PreMatch, Init(Tokenizer, Actions));
 end;

function CreatorREMATCHSTR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREMATCHSTR:=New(PreMatchStr, Init(Tokenizer, Actions));
 end;

function CreatorREGETERRORMSG(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREGETERRORMSG:=New(PreGetErrorMsg, Init(Tokenizer, Actions));
 end;

function CreatorREPREPROCESSWILDCARD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREPREPROCESSWILDCARD:=New(PrePreprocessWildcard, Init(Tokenizer, Actions));
 end;

function CreatorREGETTITLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREGETTITLE:=New(PreGetTitle, Init('reGetTitle', Actions));
 end;

function CreatorREGETVERSION(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREGETVERSION:=New(PreGetVersion, Init('reGetVersion', Actions));
 end;

function CreatorREGETCOPYRIGHT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorREGETCOPYRIGHT:=New(PreGetCopyright, Init('reGetCopyright', Actions));
 end;

function CreatorRETITLE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorRETITLE:=New(PreTitle, Init('reTitle', Actions));
 end;

function CreatorMBNETMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBNETMAIL:=New(PmbNetmail, Init(Tokenizer, Actions));
 end;

function CreatorMBADD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBADD:=New(PmbAdd, Init(Tokenizer, Actions));
 end;

function CreatorMBCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBCOUNT:=New(PmbCount, Init(Tokenizer, Actions));
 end;

function CreatorMBLOAD(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBLOAD:=New(PmbLoad, Init(Tokenizer, Actions));
 end;

function CreatorMBSTORE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBSTORE:=New(PmbStore, Init(Tokenizer, Actions));
 end;

function CreatorMBKILL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBKILL:=New(PmbKill, Init(Tokenizer, Actions));
 end;

function CreatorMBNOTOGLOBAL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBNOTOGLOBAL:=New(PmbNoToGlobal, Init(Tokenizer, Actions));
 end;

function CreatorMBGLOBALTONO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBGLOBALTONO:=New(PmbGlobalToNo, Init(Tokenizer, Actions));
 end;

function CreatorMBLOCK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBLOCK:=New(PmbLock, Init(Tokenizer, Actions));
 end;

function CreatorMBUNLOCK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBUNLOCK:=New(PmbUnlock, Init(Tokenizer, Actions));
 end;

function CreatorMBLOADLINKINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBLOADLINKINFO:=New(PmbLoadLinkInfo, Init(Tokenizer, Actions));
 end;

function CreatorMBSTORELINKINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBSTORELINKINFO:=New(PmbStoreLinkInfo, Init(Tokenizer, Actions));
 end;

function CreatorMBEXTENDEDOPENED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBEXTENDEDOPENED:=New(PmbExtendedOpened, Init(Tokenizer, Actions));
 end;

function CreatorMBEXTENDED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMBEXTENDED:=New(PmbExtended, Init(Tokenizer, Actions));
 end;

function CreatorFMTRREGISTER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTRREGISTER:=New(PfmtrRegister, Init(Tokenizer, Actions));
 end;

function CreatorFMTRSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTRSEEK:=New(PfmtrSeek, Init(Tokenizer, Actions));
 end;

function CreatorFMTRIDENT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTRIDENT:=New(PfmtrIdent, Init(Tokenizer, Actions));
 end;

function CreatorFMTRCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTRCOUNT:=New(PfmtrCount, Init('fmtrCount', Actions));
 end;

function CreatorFMTRAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTRAT:=New(PfmtrAt, Init(Tokenizer, Actions));
 end;

function CreatorFMTWREGISTER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTWREGISTER:=New(PfmtwRegister, Init(Tokenizer, Actions));
 end;

function CreatorFMTWSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTWSEEK:=New(PfmtwSeek, Init(Tokenizer, Actions));
 end;

function CreatorFMTWCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTWCOUNT:=New(PfmtwCount, Init('fmtwCount', Actions));
 end;

function CreatorFMTWAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTWAT:=New(PfmtwAt, Init(Tokenizer, Actions));
 end;

function CreatorFMTPPREGISTER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTPPREGISTER:=New(PfmtppRegister, Init(Tokenizer, Actions));
 end;

function CreatorFMTPPSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTPPSEEK:=New(PfmtppSeek, Init(Tokenizer, Actions));
 end;

function CreatorFMTPPCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTPPCOUNT:=New(PfmtppCount, Init('fmtppCount', Actions));
 end;

function CreatorFMTPPAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTPPAT:=New(PfmtppAt, Init(Tokenizer, Actions));
 end;

function CreatorFMTOPREGISTER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTOPREGISTER:=New(PfmtopRegister, Init(Tokenizer, Actions));
 end;

function CreatorFMTOPSEEK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTOPSEEK:=New(PfmtopSeek, Init(Tokenizer, Actions));
 end;

function CreatorFMTOPCOUNT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTOPCOUNT:=New(PfmtopCount, Init('fmtopCount', Actions));
 end;

function CreatorFMTOPAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTOPAT:=New(PfmtopAt, Init(Tokenizer, Actions));
 end;

function CreatorFMTDEFAULTFORMATWRITER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTDEFAULTFORMATWRITER:=New(PfmtDefaultFormatWriter, Init('fmtDefaultFormatWriter', Actions));
 end;

function CreatorFMTDEFAULTFORMATOUTPROCESSOR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorFMTDEFAULTFORMATOUTPROCESSOR:=New(PfmtDefaultFormatOutprocessor, Init('fmtDefaultFormatOutprocessor', Actions));
 end;

function CreatorTOSSSCANSETTOSSMESSAGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANSETTOSSMESSAGE:=New(PtossscanSetTossMessage, Init(Tokenizer, Actions));
 end;

function CreatorTOSSSCANTOSSMESSAGE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANTOSSMESSAGE:=New(PtossscanTossMessage, Init(Tokenizer, Actions));
 end;

function CreatorTOSSSCANSETTOSSMESSAGETOLINKS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANSETTOSSMESSAGETOLINKS:=New(PtossscanSetTossMessageToLinks, Init(Tokenizer, Actions));
 end;

function CreatorTOSSSCANTOSSMESSAGETOLINKS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANTOSSMESSAGETOLINKS:=New(PtossscanTossMessageToLinks, Init(Tokenizer, Actions));
 end;

function CreatorTOSSSCANSETTOSSTOBADMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANSETTOSSTOBADMAIL:=New(PtossscanSetTossToBadmail, Init(Tokenizer, Actions));
 end;

function CreatorTOSSSCANTOSSTOBADMAIL(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOSSSCANTOSSTOBADMAIL:=New(PtossscanTossToBadmail, Init(Tokenizer, Actions));
 end;

function CreatorPRINTSTR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPRINTSTR:=New(PPrintStr, Init(Tokenizer, Actions));
 end;

function CreatorCOMPAREPASSWORDS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOMPAREPASSWORDS:=New(PComparePasswords, Init(Tokenizer, Actions));
 end;

function CreatorGETNETMAILAKA(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETNETMAILAKA:=New(PGetNetmailAka, Init(Tokenizer, Actions));
 end;

function CreatorGETDOMAININFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETDOMAININFO:=New(PGetDomainInfo, Init(Tokenizer, Actions));
 end;

function CreatorNEWAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorNEWAREAFORMAT:=New(PNewAreaFormat, Init('NewAreaFormat', Actions));
 end;

function CreatorDESTROYAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDESTROYAREAFORMAT:=New(PDestroyAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorNEWADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorNEWADDRESS:=New(PNewAddress, Init(Tokenizer, Actions));
 end;

function CreatorDESTROYADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDESTROYADDRESS:=New(PDestroyAddress, Init(Tokenizer, Actions));
 end;

function CreatorPARSEADDRESSMASK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPARSEADDRESSMASK:=New(PParseAddressMask, Init(Tokenizer, Actions));
 end;

function CreatorUNPARSEADDRESSMASK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPARSEADDRESSMASK:=New(PUnparseAddressMask, Init(Tokenizer, Actions));
 end;

function CreatorCOMPILEADDRESSMASK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOMPILEADDRESSMASK:=New(PCompileAddressMask, Init(Tokenizer, Actions));
 end;

function CreatorCOMPAREADDRESSMASK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOMPAREADDRESSMASK:=New(PCompareAddressMask, Init(Tokenizer, Actions));
 end;

function CreatorCOMPILEREGEXP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOMPILEREGEXP:=New(PCompileRegExp, Init(Tokenizer, Actions));
 end;

function CreatorDESTROYREGEXP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDESTROYREGEXP:=New(PDestroyRegExp, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSMATCHREGEXP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSMATCHREGEXP:=New(PAddressMatchRegExp, Init(Tokenizer, Actions));
 end;

function CreatorAREAMATCHREGEXP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorAREAMATCHREGEXP:=New(PAreaMatchRegExp, Init(Tokenizer, Actions));
 end;

function CreatorPERCENT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPERCENT:=New(PPercent, Init(Tokenizer, Actions));
 end;

function CreatorCREATEUNIQUEFILENAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCREATEUNIQUEFILENAME:=New(PCreateUniqueFileName, Init(Tokenizer, Actions));
 end;

function CreatorCANCELLED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCANCELLED:=New(PCancelled, Init('Cancelled', Actions));
 end;

function CreatorERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorERROR:=New(PError, Init('Error', Actions));
 end;

function CreatorSETERROR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSETERROR:=New(PSetError, Init(Tokenizer, Actions));
 end;

{ AddJTAPIProtos }

procedure AddJTAPIProtos(const Target: PActions);
 begin
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('STREMOVE', CreatorSTREMOVE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('STGET', CreatorSTGET)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('STCLONE', CreatorSTCLONE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('STADDCALLBACK', CreatorSTADDCALLBACK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('STINC', CreatorSTINC)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('STGLOBALST', CreatorSTGLOBALST)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTSTRING', CreatorSVCSTSTRING)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTADDRESS', CreatorSVCSTADDRESS)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTLISTEX', CreatorSVCSTLISTEX)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTAREAFORMAT',
    CreatorSVCSTAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTPATH', CreatorSVCSTPATH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTSEENBY', CreatorSVCSTSEENBY)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTCALLBACKS',
    CreatorSVCSTCALLBACKS)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('SVCSTOMS', CreatorSVCSTOMS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('SRVREGISTERHANDLER',
    CreatorSRVREGISTERHANDLER)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('SRVEXECUTE', CreatorSRVEXECUTE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('SRVEXECUTEEX', CreatorSRVEXECUTEEX)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('CBCCOUNT', CreatorCBCCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('CBCAT', CreatorCBCAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RFCREATE', CreatorRFCREATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('RFDESTROY', CreatorRFDESTROY)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('RFADD', CreatorRFADD)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('RFREMOVE', CreatorRFREMOVE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('RFGET', CreatorRFGET)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('RFGETSIZES', CreatorRFGETSIZES)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('RFPACK', CreatorRFPACK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RFCOMMON', CreatorRFCOMMON)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RFCOUNT', CreatorRFCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RFAT', CreatorRFAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RECREATE', CreatorRECREATE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('RECREATESTR', CreatorRECREATESTR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('REDESTROY', CreatorREDESTROY)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('REISVALID', CreatorREISVALID)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('REMATCH', CreatorREMATCH)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('REMATCHSTR', CreatorREMATCHSTR)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('REGETERRORMSG',
    CreatorREGETERRORMSG)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('REPREPROCESSWILDCARD',
    CreatorREPREPROCESSWILDCARD)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('REGETTITLE', CreatorREGETTITLE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('REGETVERSION', CreatorREGETVERSION)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('REGETCOPYRIGHT',
    CreatorREGETCOPYRIGHT)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('RETITLE', CreatorRETITLE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBNETMAIL', CreatorMBNETMAIL)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBADD', CreatorMBADD)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MBCOUNT', CreatorMBCOUNT)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBLOAD', CreatorMBLOAD)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBSTORE', CreatorMBSTORE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBKILL', CreatorMBKILL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MBNOTOGLOBAL', CreatorMBNOTOGLOBAL)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('MBGLOBALTONO', CreatorMBGLOBALTONO)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBLOCK', CreatorMBLOCK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MBUNLOCK', CreatorMBUNLOCK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MBLOADLINKINFO', CreatorMBLOADLINKINFO)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MBSTORELINKINFO', CreatorMBSTORELINKINFO)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBEXTENDEDOPENED',
    CreatorMBEXTENDEDOPENED)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('MBEXTENDED', CreatorMBEXTENDED)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('FMTRREGISTER', CreatorFMTRREGISTER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTRSEEK', CreatorFMTRSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTRIDENT', CreatorFMTRIDENT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTRCOUNT', CreatorFMTRCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTRAT', CreatorFMTRAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('FMTWREGISTER', CreatorFMTWREGISTER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTWSEEK', CreatorFMTWSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTWCOUNT', CreatorFMTWCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTWAT', CreatorFMTWAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('FMTPPREGISTER', CreatorFMTPPREGISTER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTPPSEEK', CreatorFMTPPSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTPPCOUNT', CreatorFMTPPCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTPPAT', CreatorFMTPPAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('FMTOPREGISTER', CreatorFMTOPREGISTER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTOPSEEK', CreatorFMTOPSEEK)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTOPCOUNT', CreatorFMTOPCOUNT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTOPAT', CreatorFMTOPAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTDEFAULTFORMATWRITER',
    CreatorFMTDEFAULTFORMATWRITER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('FMTDEFAULTFORMATOUTPROCESSOR',
    CreatorFMTDEFAULTFORMATOUTPROCESSOR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANSETTOSSMESSAGE',
    CreatorTOSSSCANSETTOSSMESSAGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANTOSSMESSAGE',
    CreatorTOSSSCANTOSSMESSAGE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANSETTOSSMESSAGETOLINKS',
    CreatorTOSSSCANSETTOSSMESSAGETOLINKS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANTOSSMESSAGETOLINKS',
    CreatorTOSSSCANTOSSMESSAGETOLINKS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANSETTOSSTOBADMAIL',
    CreatorTOSSSCANSETTOSSTOBADMAIL)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOSSSCANTOSSTOBADMAIL',
    CreatorTOSSSCANTOSSTOBADMAIL)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PRINTSTR', CreatorPRINTSTR)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('COMPAREPASSWORDS',
    CreatorCOMPAREPASSWORDS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('GETNETMAILAKA', CreatorGETNETMAILAKA)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('GETDOMAININFO',
    CreatorGETDOMAININFO)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('NEWAREAFORMAT',
    CreatorNEWAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DESTROYAREAFORMAT', CreatorDESTROYAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('NEWADDRESS', CreatorNEWADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DESTROYADDRESS', CreatorDESTROYADDRESS)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('PARSEADDRESSMASK',
    CreatorPARSEADDRESSMASK)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('UNPARSEADDRESSMASK',
    CreatorUNPARSEADDRESSMASK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('COMPILEADDRESSMASK',
    CreatorCOMPILEADDRESSMASK)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('COMPAREADDRESSMASK',
    CreatorCOMPAREADDRESSMASK)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('COMPILEREGEXP', CreatorCOMPILEREGEXP)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DESTROYREGEXP', CreatorDESTROYREGEXP)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ADDRESSMATCHREGEXP',
    CreatorADDRESSMATCHREGEXP)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('AREAMATCHREGEXP',
    CreatorAREAMATCHREGEXP)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('PERCENT', CreatorPERCENT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('CREATEUNIQUEFILENAME',
    CreatorCREATEUNIQUEFILENAME)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('CANCELLED', CreatorCANCELLED)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ERROR', CreatorERROR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('SETERROR', CreatorSETERROR)));
 end;

end.
