{$IFNDEF VIRTUALPASCAL}
{$D-}
{$ENDIF}
unit ccJTAPI5;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Strings,

     ccAPI,
     ccAction,
     ccCmn,
     ccCode,
     ccExpr,
     ccJTSupp,
     ccProto,
     ccRoot,
     ccSupp,
     ccToken,

     jtMHLcmn,

     Thunks,

     Wizard;

procedure AddJTAPIProtos(const Target: PActions);

implementation

{ GetFileSize(const S: String): Longint; }

type
 PGetFileSize = ^TGetFileSize;
 TGetFileSize = object(TNumberExpression)
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetFileSize.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetFileSize', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetFileSize.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: String;
 begin
  _S^.Get(ExecuteData, __S);

  Longint(Value):=Longint(Wizard.GetFileSize(__S));
 end;

destructor TGetFileSize.Done;
 begin
  Dispose(_S, Done);

  inherited Done;
 end;

{ GetStamp(const FName: String): Longint; }

type
 PGetStamp = ^TGetStamp;
 TGetStamp = object(TNumberExpression)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetStamp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetStamp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetStamp.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
 begin
  _FName^.Get(ExecuteData, __FName);

  Longint(Value):=Longint(Wizard.GetStamp(__FName));
 end;

destructor TGetStamp.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ SetAttr(const FName: String; K: Longint); }

type
 PSetAttr = ^TSetAttr;
 TSetAttr = object(TAction)
  _FName: PStringExpression;
  _K: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TSetAttr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('SetAttr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _K:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TSetAttr.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FName: String;
  __K: Longint;
 begin
  _FName^.Get(Data, __FName);
  _K^.Get(Data, __K);

  Wizard.SetAttr(__FName, 
    __K);

  Execute:=erOk;
 end;

destructor TSetAttr.Done;
 begin
  Dispose(_FName, Done);
  Dispose(_K, Done);

  inherited Done;
 end;

{ SetStamp(const FName: String; K: Longint); }

type
 PSetStamp = ^TSetStamp;
 TSetStamp = object(TAction)
  _FName: PStringExpression;
  _K: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TSetStamp.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('SetStamp', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _K:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TSetStamp.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FName: String;
  __K: Longint;
 begin
  _FName^.Get(Data, __FName);
  _K^.Get(Data, __K);

  Wizard.SetStamp(__FName, 
    __K);

  Execute:=erOk;
 end;

destructor TSetStamp.Done;
 begin
  Dispose(_FName, Done);
  Dispose(_K, Done);

  inherited Done;
 end;

{ StackOverflow: Boolean; }

type
 PStackOverflow = ^TStackOverflow;
 TStackOverflow = object(TBooleanExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TStackOverflow.Get(const ExecuteData: PExecuteData; var Value);
 begin
  Boolean(Value):=Wizard.StackOverflow;
 end;

{ _s(const Value: Longint): String; }

type
 P_s = ^T_s;
 T_s = object(TStringExpression)
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor T_s.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('_s', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure T_s.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Value: Longint;
 begin
  _Value^.Get(ExecuteData, __Value);

  String(Value):=Wizard._s(__Value);
 end;

destructor T_s.Done;
 begin
  Dispose(_Value, Done);

  inherited Done;
 end;

{ _nz(const Value: Longint; const S: String): String; }

type
 P_nz = ^T_nz;
 T_nz = object(TStringExpression)
  _Value: PNumberExpression;
  _S: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor T_nz.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('_nz', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure T_nz.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Value: Longint;
  __S: String;
 begin
  _Value^.Get(ExecuteData, __Value);
  _S^.Get(ExecuteData, __S);

  String(Value):=Wizard._nz(__Value, 
    __S);
 end;

destructor T_nz.Done;
 begin
  Dispose(_Value, Done);
  Dispose(_S, Done);

  inherited Done;
 end;

{ NumberWidth(const Value: Longint): Byte; }

type
 PNumberWidth = ^TNumberWidth;
 TNumberWidth = object(TNumberExpression)
  _Value: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TNumberWidth.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('NumberWidth', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Value:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TNumberWidth.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Value: Longint;
 begin
  _Value^.Get(ExecuteData, __Value);

  Longint(Value):=Longint(Wizard.NumberWidth(__Value));
 end;

destructor TNumberWidth.Done;
 begin
  Dispose(_Value, Done);

  inherited Done;
 end;

{ CompareLongint(const L1, L2: Longint): xInteger; }

type
 PCompareLongint = ^TCompareLongint;
 TCompareLongint = object(TNumberExpression)
  _L1: PNumberExpression;
  _L2: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TCompareLongint.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('CompareLongint', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _L1:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _L2:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TCompareLongint.Get(const ExecuteData: PExecuteData; var Value);
 var
  __L1: Longint;
  __L2: Longint;
 begin
  _L1^.Get(ExecuteData, __L1);
  _L2^.Get(ExecuteData, __L2);

  Longint(Value):=Longint(Wizard.CompareLongint(__L1, 
    __L2));
 end;

destructor TCompareLongint.Done;
 begin
  Dispose(_L1, Done);
  Dispose(_L2, Done);

  inherited Done;
 end;

{ UnpackTechInfo(const TechInfo: TTechInfo; var Net, Node: Longint); }

type
 PUnpackTechInfo = ^TUnpackTechInfo;
 TUnpackTechInfo = object(TAction)
  _TechInfo: PNumberExpression;
  _Net: PNumberExpression;
  _Node: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackTechInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackTechInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Net:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Net^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Node:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Node^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackTechInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __TechInfo: PTechInfo;
  __Net: Longint;
  __Node: Longint;
 begin
  _TechInfo^.Get(Data, __TechInfo);
  _Net^.Get(Data, __Net);
  _Node^.Get(Data, __Node);

  ccsupp.UnpackTechInfo(__TechInfo^, 
    __Net, 
    __Node);

  _Net^.Assign(Data, __Net);
  _Node^.Assign(Data, __Node);

  Execute:=erOk;
 end;

destructor TUnpackTechInfo.Done;
 begin
  Dispose(_TechInfo, Done);
  Dispose(_Net, Done);
  Dispose(_Node, Done);

  inherited Done;
 end;

{ PackTechInfo(const Net, Node: Longint; var TechInfo: TTechInfo); }

type
 PPackTechInfo = ^TPackTechInfo;
 TPackTechInfo = object(TAction)
  _Net: PNumberExpression;
  _Node: PNumberExpression;
  _TechInfo: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackTechInfo.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackTechInfo', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Net:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Node:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _TechInfo:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _TechInfo^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackTechInfo.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Net: Longint;
  __Node: Longint;
  __TechInfo: PTechInfo;
 begin
  _Net^.Get(Data, __Net);
  _Node^.Get(Data, __Node);
  _TechInfo^.Get(Data, __TechInfo);

  ccsupp.PackTechInfo(__Net, 
    __Node, 
    __TechInfo^);

  Execute:=erOk;
 end;

destructor TPackTechInfo.Done;
 begin
  Dispose(_Net, Done);
  Dispose(_Node, Done);
  Dispose(_TechInfo, Done);

  inherited Done;
 end;

{ UnpackAreaFormat(const AreaFormat: TAreaFormat; var Style, Format:
   Longint; var Path: String); }

type
 PUnpackAreaFormat = ^TUnpackAreaFormat;
 TUnpackAreaFormat = object(TAction)
  _AreaFormat: PNumberExpression;
  _Style: PNumberExpression;
  _Format: PNumberExpression;
  _Path: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Style:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Style^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Format^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Path:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _Path^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackAreaFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __AreaFormat: PAreaFormat;
  __Style: Longint;
  __Format: Longint;
  __Path: String;
 begin
  _AreaFormat^.Get(Data, __AreaFormat);
  _Style^.Get(Data, __Style);
  _Format^.Get(Data, __Format);
  _Path^.Get(Data, __Path);

  ccsupp.UnpackAreaFormat(__AreaFormat^, 
    __Style, 
    __Format, 
    __Path);

  _Style^.Assign(Data, __Style);
  _Format^.Assign(Data, __Format);
  _Path^.Assign(Data, __Path);

  Execute:=erOk;
 end;

destructor TUnpackAreaFormat.Done;
 begin
  Dispose(_AreaFormat, Done);
  Dispose(_Style, Done);
  Dispose(_Format, Done);
  Dispose(_Path, Done);

  inherited Done;
 end;

{ PackAreaFormat(const Style, Format: Longint; const Path: String;
   var AreaFormat: TAreaFormat); }

type
 PPackAreaFormat = ^TPackAreaFormat;
 TPackAreaFormat = object(TAction)
  _Style: PNumberExpression;
  _Format: PNumberExpression;
  _Path: PStringExpression;
  _AreaFormat: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackAreaFormat.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackAreaFormat', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Style:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Format:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Path:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _AreaFormat:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _AreaFormat^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackAreaFormat.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Style: Longint;
  __Format: Longint;
  __Path: String;
  __AreaFormat: PAreaFormat;
 begin
  _Style^.Get(Data, __Style);
  _Format^.Get(Data, __Format);
  _Path^.Get(Data, __Path);
  _AreaFormat^.Get(Data, __AreaFormat);

  ccsupp.PackAreaFormat(__Style, 
    __Format, 
    __Path, 
    __AreaFormat^);

  Execute:=erOk;
 end;

destructor TPackAreaFormat.Done;
 begin
  Dispose(_Style, Done);
  Dispose(_Format, Done);
  Dispose(_Path, Done);
  Dispose(_AreaFormat, Done);

  inherited Done;
 end;

{ UnpackAddress(const Address: TAddress; var Zone, Net, Node, Point:
   Longint); }

type
 PUnpackAddress = ^TUnpackAddress;
 TUnpackAddress = object(TAction)
  _Address: PNumberExpression;
  _Zone: PNumberExpression;
  _Net: PNumberExpression;
  _Node: PNumberExpression;
  _Point: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Zone:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Zone^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Net:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Net^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Node:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Node^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Point:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Point^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Address: PAddress;
  __Zone: Longint;
  __Net: Longint;
  __Node: Longint;
  __Point: Longint;
 begin
  _Address^.Get(Data, __Address);
  _Zone^.Get(Data, __Zone);
  _Net^.Get(Data, __Net);
  _Node^.Get(Data, __Node);
  _Point^.Get(Data, __Point);

  ccsupp.UnpackAddress(__Address^, 
    __Zone, 
    __Net, 
    __Node, 
    __Point);

  _Zone^.Assign(Data, __Zone);
  _Net^.Assign(Data, __Net);
  _Node^.Assign(Data, __Node);
  _Point^.Assign(Data, __Point);

  Execute:=erOk;
 end;

destructor TUnpackAddress.Done;
 begin
  Dispose(_Address, Done);
  Dispose(_Zone, Done);
  Dispose(_Net, Done);
  Dispose(_Node, Done);
  Dispose(_Point, Done);

  inherited Done;
 end;

{ PackAddress(const Zone, Net, Node, Point: Longint; var Address:
   TAddress); }

type
 PPackAddress = ^TPackAddress;
 TPackAddress = object(TAction)
  _Zone: PNumberExpression;
  _Net: PNumberExpression;
  _Node: PNumberExpression;
  _Point: PNumberExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Zone:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Net:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Node:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Point:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Zone: Longint;
  __Net: Longint;
  __Node: Longint;
  __Point: Longint;
  __Address: PAddress;
 begin
  _Zone^.Get(Data, __Zone);
  _Net^.Get(Data, __Net);
  _Node^.Get(Data, __Node);
  _Point^.Get(Data, __Point);
  _Address^.Get(Data, __Address);

  ccsupp.PackAddress(__Zone, 
    __Net, 
    __Node, 
    __Point, 
    __Address^);

  Execute:=erOk;
 end;

destructor TPackAddress.Done;
 begin
  Dispose(_Zone, Done);
  Dispose(_Net, Done);
  Dispose(_Node, Done);
  Dispose(_Point, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ UnpackTime(const DateTime: TDateTime; var Hour, Min, Sec: Longint); }

type
 PUnpackTime = ^TUnpackTime;
 TUnpackTime = object(TAction)
  _DateTime: PNumberExpression;
  _Hour: PNumberExpression;
  _Min: PNumberExpression;
  _Sec: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Hour:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Hour^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Min:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Min^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Sec:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Sec^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
  __Hour: Longint;
  __Min: Longint;
  __Sec: Longint;
 begin
  _DateTime^.Get(Data, __DateTime);
  _Hour^.Get(Data, __Hour);
  _Min^.Get(Data, __Min);
  _Sec^.Get(Data, __Sec);

  ccsupp.UnpackTime(__DateTime^, 
    __Hour, 
    __Min, 
    __Sec);

  _Hour^.Assign(Data, __Hour);
  _Min^.Assign(Data, __Min);
  _Sec^.Assign(Data, __Sec);

  Execute:=erOk;
 end;

destructor TUnpackTime.Done;
 begin
  Dispose(_DateTime, Done);
  Dispose(_Hour, Done);
  Dispose(_Min, Done);
  Dispose(_Sec, Done);

  inherited Done;
 end;

{ UnpackDate(const DateTime: TDateTime; var Year, Month, Day: Longint); }

type
 PUnpackDate = ^TUnpackDate;
 TUnpackDate = object(TAction)
  _DateTime: PNumberExpression;
  _Year: PNumberExpression;
  _Month: PNumberExpression;
  _Day: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackDate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackDate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Year:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Year^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Month^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Day:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Day^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackDate.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
  __Year: Longint;
  __Month: Longint;
  __Day: Longint;
 begin
  _DateTime^.Get(Data, __DateTime);
  _Year^.Get(Data, __Year);
  _Month^.Get(Data, __Month);
  _Day^.Get(Data, __Day);

  ccsupp.UnpackDate(__DateTime^, 
    __Year, 
    __Month, 
    __Day);

  _Year^.Assign(Data, __Year);
  _Month^.Assign(Data, __Month);
  _Day^.Assign(Data, __Day);

  Execute:=erOk;
 end;

destructor TUnpackDate.Done;
 begin
  Dispose(_DateTime, Done);
  Dispose(_Year, Done);
  Dispose(_Month, Done);
  Dispose(_Day, Done);

  inherited Done;
 end;

{ UnpackDateTime(const DateTime: TDateTime; var Hour, Min, Sec,
   Year, Month, Day: Longint); }

type
 PUnpackDateTime = ^TUnpackDateTime;
 TUnpackDateTime = object(TAction)
  _DateTime: PNumberExpression;
  _Hour: PNumberExpression;
  _Min: PNumberExpression;
  _Sec: PNumberExpression;
  _Year: PNumberExpression;
  _Month: PNumberExpression;
  _Day: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnpackDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnpackDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Hour:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Hour^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Min:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Min^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Sec:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Sec^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Year:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Year^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Month^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Day:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Day^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnpackDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
  __Hour: Longint;
  __Min: Longint;
  __Sec: Longint;
  __Year: Longint;
  __Month: Longint;
  __Day: Longint;
 begin
  _DateTime^.Get(Data, __DateTime);
  _Hour^.Get(Data, __Hour);
  _Min^.Get(Data, __Min);
  _Sec^.Get(Data, __Sec);
  _Year^.Get(Data, __Year);
  _Month^.Get(Data, __Month);
  _Day^.Get(Data, __Day);

  ccsupp.UnpackDateTime(__DateTime^, 
    __Hour, 
    __Min, 
    __Sec, 
    __Year, 
    __Month, 
    __Day);

  _Hour^.Assign(Data, __Hour);
  _Min^.Assign(Data, __Min);
  _Sec^.Assign(Data, __Sec);
  _Year^.Assign(Data, __Year);
  _Month^.Assign(Data, __Month);
  _Day^.Assign(Data, __Day);

  Execute:=erOk;
 end;

destructor TUnpackDateTime.Done;
 begin
  Dispose(_DateTime, Done);
  Dispose(_Hour, Done);
  Dispose(_Min, Done);
  Dispose(_Sec, Done);
  Dispose(_Year, Done);
  Dispose(_Month, Done);
  Dispose(_Day, Done);

  inherited Done;
 end;

{ PackTime(const Hour, Min, Sec: Longint; var DateTime: TDateTime); }

type
 PPackTime = ^TPackTime;
 TPackTime = object(TAction)
  _Hour: PNumberExpression;
  _Min: PNumberExpression;
  _Sec: PNumberExpression;
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Hour:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Min:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Sec:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Hour: Longint;
  __Min: Longint;
  __Sec: Longint;
  __DateTime: PDateTime;
 begin
  _Hour^.Get(Data, __Hour);
  _Min^.Get(Data, __Min);
  _Sec^.Get(Data, __Sec);
  _DateTime^.Get(Data, __DateTime);

  ccsupp.PackTime(__Hour, 
    __Min, 
    __Sec, 
    __DateTime^);

  Execute:=erOk;
 end;

destructor TPackTime.Done;
 begin
  Dispose(_Hour, Done);
  Dispose(_Min, Done);
  Dispose(_Sec, Done);
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ PackDate(const Year, Month, Day: Longint; var DateTime: TDateTime); }

type
 PPackDate = ^TPackDate;
 TPackDate = object(TAction)
  _Year: PNumberExpression;
  _Month: PNumberExpression;
  _Day: PNumberExpression;
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackDate.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackDate', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Year:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Day:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackDate.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Year: Longint;
  __Month: Longint;
  __Day: Longint;
  __DateTime: PDateTime;
 begin
  _Year^.Get(Data, __Year);
  _Month^.Get(Data, __Month);
  _Day^.Get(Data, __Day);
  _DateTime^.Get(Data, __DateTime);

  ccsupp.PackDate(__Year, 
    __Month, 
    __Day, 
    __DateTime^);

  Execute:=erOk;
 end;

destructor TPackDate.Done;
 begin
  Dispose(_Year, Done);
  Dispose(_Month, Done);
  Dispose(_Day, Done);
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ PackDateTime(const Hour, Min, Sec, Year, Month, Day: Longint;
   var DateTime: TDateTime); }

type
 PPackDateTime = ^TPackDateTime;
 TPackDateTime = object(TAction)
  _Hour: PNumberExpression;
  _Min: PNumberExpression;
  _Sec: PNumberExpression;
  _Year: PNumberExpression;
  _Month: PNumberExpression;
  _Day: PNumberExpression;
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPackDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PackDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Hour:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Min:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Sec:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Year:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Day:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPackDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Hour: Longint;
  __Min: Longint;
  __Sec: Longint;
  __Year: Longint;
  __Month: Longint;
  __Day: Longint;
  __DateTime: PDateTime;
 begin
  _Hour^.Get(Data, __Hour);
  _Min^.Get(Data, __Min);
  _Sec^.Get(Data, __Sec);
  _Year^.Get(Data, __Year);
  _Month^.Get(Data, __Month);
  _Day^.Get(Data, __Day);
  _DateTime^.Get(Data, __DateTime);

  ccsupp.PackDateTime(__Hour, 
    __Min, 
    __Sec, 
    __Year, 
    __Month, 
    __Day, 
    __DateTime^);

  Execute:=erOk;
 end;

destructor TPackDateTime.Done;
 begin
  Dispose(_Hour, Done);
  Dispose(_Min, Done);
  Dispose(_Sec, Done);
  Dispose(_Year, Done);
  Dispose(_Month, Done);
  Dispose(_Day, Done);
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ Touch(const FName: String); }

type
 PTouch = ^TTouch;
 TTouch = object(TAction)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TTouch.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Touch', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TTouch.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FName: String;
 begin
  _FName^.Get(Data, __FName);

  ccsupp.Touch(__FName);

  Execute:=erOk;
 end;

destructor TTouch.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ TouchOnce(const FName: String); }

type
 PTouchOnce = ^TTouchOnce;
 TTouchOnce = object(TAction)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TTouchOnce.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('TouchOnce', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TTouchOnce.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __FName: String;
 begin
  _FName^.Get(Data, __FName);

  ccsupp.TouchOnce(__FName);

  Execute:=erOk;
 end;

destructor TTouchOnce.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ Pstos(const S: PString): String; }

type
 PPstos = ^TPstos;
 TPstos = object(TStringExpression)
  _S: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TPstos.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Pstos', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TPstos.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: PString;
 begin
  _S^.Get(ExecuteData, __S);

  String(Value):=ccsupp.Pstos(__S);
 end;

destructor TPstos.Done;
 begin
  Dispose(_S, Done);

  inherited Done;
 end;

{ Chr(const N: Longint): String; }

type
 PChr = ^TChr;
 TChr = object(TStringExpression)
  _N: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TChr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Chr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _N:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TChr.Get(const ExecuteData: PExecuteData; var Value);
 var
  __N: Longint;
 begin
  _N^.Get(ExecuteData, __N);

  String(Value):=ccsupp.Chr(__N);
 end;

destructor TChr.Done;
 begin
  Dispose(_N, Done);

  inherited Done;
 end;

{ Pos(const SubStr, Str: String): Longint; }

type
 PPos = ^TPos;
 TPos = object(TNumberExpression)
  _SubStr: PStringExpression;
  _Str: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TPos.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Pos', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _SubStr:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Str:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TPos.Get(const ExecuteData: PExecuteData; var Value);
 var
  __SubStr: String;
  __Str: String;
 begin
  _SubStr^.Get(ExecuteData, __SubStr);
  _Str^.Get(ExecuteData, __Str);

  Longint(Value):=Longint(ccsupp.Pos(__SubStr, 
    __Str));
 end;

destructor TPos.Done;
 begin
  Dispose(_SubStr, Done);
  Dispose(_Str, Done);

  inherited Done;
 end;

{ Copy(const S: String; const Index, Count: Longint): String; }

type
 PCopy = ^TCopy;
 TCopy = object(TStringExpression)
  _S: PStringExpression;
  _Index: PNumberExpression;
  _Count: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TCopy.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Copy', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Count:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TCopy.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: String;
  __Index: Longint;
  __Count: Longint;
 begin
  _S^.Get(ExecuteData, __S);
  _Index^.Get(ExecuteData, __Index);
  _Count^.Get(ExecuteData, __Count);

  String(Value):=ccsupp.Copy(__S, 
    __Index, 
    __Count);
 end;

destructor TCopy.Done;
 begin
  Dispose(_S, Done);
  Dispose(_Index, Done);
  Dispose(_Count, Done);

  inherited Done;
 end;

{ Delete(var S: String; const Index, Count: Longint); }

type
 PDelete = ^TDelete;
 TDelete = object(TAction)
  _S: PStringExpression;
  _Index: PNumberExpression;
  _Count: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDelete.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Delete', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  if not _S^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etString);

  Tokenizer^.Next([tmComma]);

  _Index:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Count:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDelete.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __S: String;
  __Index: Longint;
  __Count: Longint;
 begin
  _S^.Get(Data, __S);
  _Index^.Get(Data, __Index);
  _Count^.Get(Data, __Count);

  ccsupp.Delete(__S, 
    __Index, 
    __Count);

  _S^.Assign(Data, __S);

  Execute:=erOk;
 end;

destructor TDelete.Done;
 begin
  Dispose(_S, Done);
  Dispose(_Index, Done);
  Dispose(_Count, Done);

  inherited Done;
 end;

{ Inc(var N: Longint); }

type
 PInc = ^TInc;
 TInc = object(TAction)
  _N: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TInc.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Inc', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _N:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _N^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TInc.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __N: Longint;
 begin
  _N^.Get(Data, __N);

  ccsupp.Inc(__N);

  _N^.Assign(Data, __N);

  Execute:=erOk;
 end;

destructor TInc.Done;
 begin
  Dispose(_N, Done);

  inherited Done;
 end;

{ Dec(var N: Longint); }

type
 PDec = ^TDec;
 TDec = object(TAction)
  _N: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDec.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Dec', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _N:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _N^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDec.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __N: Longint;
 begin
  _N^.Get(Data, __N);

  ccsupp.Dec(__N);

  _N^.Assign(Data, __N);

  Execute:=erOk;
 end;

destructor TDec.Done;
 begin
  Dispose(_N, Done);

  inherited Done;
 end;

{ Carbon(const smsg: Pointer; const AreaName: String); }

type
 PCarbon = ^TCarbon;
 TCarbon = object(TAction)
  _smsg: PNumberExpression;
  _AreaName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TCarbon.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Carbon', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _smsg:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _AreaName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TCarbon.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __smsg: Pointer;
  __AreaName: String;
 begin
  _smsg^.Get(Data, __smsg);
  _AreaName^.Get(Data, __AreaName);

  ccsupp.Carbon(__smsg, 
    __AreaName);

  Execute:=erOk;
 end;

destructor TCarbon.Done;
 begin
  Dispose(_smsg, Done);
  Dispose(_AreaName, Done);

  inherited Done;
 end;

{ Speed(A, B: Longint): String; }

type
 PSpeed = ^TSpeed;
 TSpeed = object(TStringExpression)
  _A: PNumberExpression;
  _B: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TSpeed.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('Speed', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _A:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _B:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TSpeed.Get(const ExecuteData: PExecuteData; var Value);
 var
  __A: Longint;
  __B: Longint;
 begin
  _A^.Get(ExecuteData, __A);
  _B^.Get(ExecuteData, __B);

  String(Value):=ccsupp.Speed(__A, 
    __B);
 end;

destructor TSpeed.Done;
 begin
  Dispose(_A, Done);
  Dispose(_B, Done);

  inherited Done;
 end;

{ IdentifyReader(const FName: String): PFormatReader; }

type
 PIdentifyReader = ^TIdentifyReader;
 TIdentifyReader = object(TNumberExpression)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TIdentifyReader.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('IdentifyReader', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TIdentifyReader.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
 begin
  _FName^.Get(ExecuteData, __FName);

  Longint(Value):=Longint(PlugUTIL.IdentifyReader(__FName));
 end;

destructor TIdentifyReader.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ IdentifyReaderNoExtCare(const FName: String): PFormatReader; }

type
 PIdentifyReaderNoExtCare = ^TIdentifyReaderNoExtCare;
 TIdentifyReaderNoExtCare = object(TNumberExpression)
  _FName: PStringExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TIdentifyReaderNoExtCare.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('IdentifyReaderNoExtCare', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _FName:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TIdentifyReaderNoExtCare.Get(const ExecuteData: PExecuteData; var Value);
 var
  __FName: String;
 begin
  _FName^.Get(ExecuteData, __FName);

  Longint(Value):=Longint(PlugUTIL.IdentifyReaderNoExtCare(__FName));
 end;

destructor TIdentifyReaderNoExtCare.Done;
 begin
  Dispose(_FName, Done);

  inherited Done;
 end;

{ AddressOfLink(const Link: Pointer): String; }

type
 PAddressOfLink = ^TAddressOfLink;
 TAddressOfLink = object(TStringExpression)
  _Link: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressOfLink.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressOfLink', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Link:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressOfLink.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Link: Pointer;
 begin
  _Link^.Get(ExecuteData, __Link);

  String(Value):=PlugUTIL.AddressOfLink(__Link);
 end;

destructor TAddressOfLink.Done;
 begin
  Dispose(_Link, Done);

  inherited Done;
 end;

{ GetTossSourceName(const Source: Longint): String; }

type
 PGetTossSourceName = ^TGetTossSourceName;
 TGetTossSourceName = object(TStringExpression)
  _Source: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetTossSourceName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetTossSourceName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Source:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetTossSourceName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Source: Longint;
 begin
  _Source^.Get(ExecuteData, __Source);

  String(Value):=PlugSIDE.GetTossSourceName(__Source);
 end;

destructor TGetTossSourceName.Done;
 begin
  Dispose(_Source, Done);

  inherited Done;
 end;

{ GetCommandWhenName(const When: TCommandWhen): String; }

type
 PGetCommandWhenName = ^TGetCommandWhenName;
 TGetCommandWhenName = object(TStringExpression)
  _When: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetCommandWhenName.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetCommandWhenName', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _When:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetCommandWhenName.Get(const ExecuteData: PExecuteData; var Value);
 var
  __When: record case Byte of 1: (When: TCommandWhen); 2: (Junk: Longint) end;
 begin
  _When^.Get(ExecuteData, __When);

  String(Value):=PlugSIDE.GetCommandWhenName(__When.When);
 end;

destructor TGetCommandWhenName.Done;
 begin
  Dispose(_When, Done);

  inherited Done;
 end;

{ AddressToStr(const Address: TAddress): String; }

type
 PAddressToStr = ^TAddressToStr;
 TAddressToStr = object(TStringExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressToStr.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressToStr', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressToStr.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  String(Value):=jtMHLcmn.AddressToStr(__Address^);
 end;

destructor TAddressToStr.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ AddressToStrPointless(const Address: TAddress): String; }

type
 PAddressToStrPointless = ^TAddressToStrPointless;
 TAddressToStrPointless = object(TStringExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressToStrPointless.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressToStrPointless', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressToStrPointless.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  String(Value):=jtMHLcmn.AddressToStrPointless(__Address^);
 end;

destructor TAddressToStrPointless.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ AddressToStrEx(const Address: TAddress): String; }

type
 PAddressToStrEx = ^TAddressToStrEx;
 TAddressToStrEx = object(TStringExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressToStrEx.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressToStrEx', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressToStrEx.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  String(Value):=jtMHLcmn.AddressToStrEx(__Address^);
 end;

destructor TAddressToStrEx.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ StrToAddress(Source: String; var Address: TAddress): Boolean; }

type
 PStrToAddress = ^TStrToAddress;
 TStrToAddress = object(TBooleanExpression)
  _Source: PStringExpression;
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TStrToAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('StrToAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Source:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TStrToAddress.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Source: String;
  __Address: PAddress;
 begin
  _Source^.Get(ExecuteData, __Source);
  _Address^.Get(ExecuteData, __Address);

  Boolean(Value):=jtMHLcmn.StrToAddress(__Source, 
    __Address^);
 end;

destructor TStrToAddress.Done;
 begin
  Dispose(_Source, Done);
  Dispose(_Address, Done);

  inherited Done;
 end;

{ ClearAddress(var Address: TAddress); }

type
 PClearAddress = ^TClearAddress;
 TClearAddress = object(TAction)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TClearAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('ClearAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TClearAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Address: PAddress;
 begin
  _Address^.Get(Data, __Address);

  jtMHLcmn.ClearAddress(__Address^);

  Execute:=erOk;
 end;

destructor TClearAddress.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ IsCleanAddress(var Address: TAddress): Boolean; }

type
 PIsCleanAddress = ^TIsCleanAddress;
 TIsCleanAddress = object(TBooleanExpression)
  _Address: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TIsCleanAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('IsCleanAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Address:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Address^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TIsCleanAddress.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Address: PAddress;
 begin
  _Address^.Get(ExecuteData, __Address);

  Boolean(Value):=jtMHLcmn.IsCleanAddress(__Address^);
 end;

destructor TIsCleanAddress.Done;
 begin
  Dispose(_Address, Done);

  inherited Done;
 end;

{ AddressCompare(const First, Second: TAddress): Longint; }

type
 PAddressCompare = ^TAddressCompare;
 TAddressCompare = object(TNumberExpression)
  _First: PNumberExpression;
  _Second: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressCompare.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressCompare', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _First:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Second:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressCompare.Get(const ExecuteData: PExecuteData; var Value);
 var
  __First: PAddress;
  __Second: PAddress;
 begin
  _First^.Get(ExecuteData, __First);
  _Second^.Get(ExecuteData, __Second);

  Longint(Value):=Longint(jtMHLcmn.AddressCompare(__First^, 
    __Second^));
 end;

destructor TAddressCompare.Done;
 begin
  Dispose(_First, Done);
  Dispose(_Second, Done);

  inherited Done;
 end;

{ AddressEqu(const First, Second: TAddress): Boolean; }

type
 PAddressEqu = ^TAddressEqu;
 TAddressEqu = object(TBooleanExpression)
  _First: PNumberExpression;
  _Second: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TAddressEqu.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('AddressEqu', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _First:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Second:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TAddressEqu.Get(const ExecuteData: PExecuteData; var Value);
 var
  __First: PAddress;
  __Second: PAddress;
 begin
  _First^.Get(ExecuteData, __First);
  _Second^.Get(ExecuteData, __Second);

  Boolean(Value):=jtMHLcmn.AddressEqu(__First^, 
    __Second^);
 end;

destructor TAddressEqu.Done;
 begin
  Dispose(_First, Done);
  Dispose(_Second, Done);

  inherited Done;
 end;

{ PatchAddress(const Flags: Longint; const Valid: TAddress; var
   Partial: TAddress); }

type
 PPatchAddress = ^TPatchAddress;
 TPatchAddress = object(TAction)
  _Flags: PNumberExpression;
  _Valid: PNumberExpression;
  _Partial: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TPatchAddress.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PatchAddress', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Flags:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Valid:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Partial:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Partial^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TPatchAddress.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __Flags: Longint;
  __Valid: PAddress;
  __Partial: PAddress;
 begin
  _Flags^.Get(Data, __Flags);
  _Valid^.Get(Data, __Valid);
  _Partial^.Get(Data, __Partial);

  jtMHLcmn.PatchAddress(__Flags, 
    __Valid^, 
    __Partial^);

  Execute:=erOk;
 end;

destructor TPatchAddress.Done;
 begin
  Dispose(_Flags, Done);
  Dispose(_Valid, Done);
  Dispose(_Partial, Done);

  inherited Done;
 end;

{ ClearDateTime(var DateTime: TDateTime); }

type
 PClearDateTime = ^TClearDateTime;
 TClearDateTime = object(TAction)
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TClearDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('ClearDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TClearDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
 begin
  _DateTime^.Get(Data, __DateTime);

  jtMHLcmn.ClearDateTime(__DateTime^);

  Execute:=erOk;
 end;

destructor TClearDateTime.Done;
 begin
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ IsRealDateTime(var DateTime: TDateTime): Boolean; }

type
 PIsRealDateTime = ^TIsRealDateTime;
 TIsRealDateTime = object(TBooleanExpression)
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TIsRealDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('IsRealDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TIsRealDateTime.Get(const ExecuteData: PExecuteData; var Value);
 var
  __DateTime: PDateTime;
 begin
  _DateTime^.Get(ExecuteData, __DateTime);

  Boolean(Value):=jtMHLcmn.IsRealDateTime(__DateTime^);
 end;

destructor TIsRealDateTime.Done;
 begin
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ IsValidDateTime(var DateTime: TDateTime): Boolean; }

type
 PIsValidDateTime = ^TIsValidDateTime;
 TIsValidDateTime = object(TBooleanExpression)
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TIsValidDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('IsValidDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TIsValidDateTime.Get(const ExecuteData: PExecuteData; var Value);
 var
  __DateTime: PDateTime;
 begin
  _DateTime^.Get(ExecuteData, __DateTime);

  Boolean(Value):=jtMHLcmn.IsValidDateTime(__DateTime^);
 end;

destructor TIsValidDateTime.Done;
 begin
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ GetCurrentDateTime(var DateTime: TDateTime); }

type
 PGetCurrentDateTime = ^TGetCurrentDateTime;
 TGetCurrentDateTime = object(TAction)
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TGetCurrentDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetCurrentDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TGetCurrentDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
 begin
  _DateTime^.Get(Data, __DateTime);

  jtMHLcmn.GetCurrentDateTime(__DateTime^);

  Execute:=erOk;
 end;

destructor TGetCurrentDateTime.Done;
 begin
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ DateTimeToDosDateTime(var DateTime: TDateTime; var DosDateTime:
   Longint); }

type
 PDateTimeToDosDateTime = ^TDateTimeToDosDateTime;
 TDateTimeToDosDateTime = object(TAction)
  _DateTime: PNumberExpression;
  _DosDateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDateTimeToDosDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DateTimeToDosDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _DosDateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DosDateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDateTimeToDosDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
  __DosDateTime: Longint;
 begin
  _DateTime^.Get(Data, __DateTime);
  _DosDateTime^.Get(Data, __DosDateTime);

  jtMHLcmn.DateTimeToDosDateTime(__DateTime^, 
    __DosDateTime);

  _DosDateTime^.Assign(Data, __DosDateTime);

  Execute:=erOk;
 end;

destructor TDateTimeToDosDateTime.Done;
 begin
  Dispose(_DateTime, Done);
  Dispose(_DosDateTime, Done);

  inherited Done;
 end;

{ DosDateTimeToDateTime(var DosDateTime: Longint; var DateTime:
   TDateTime); }

type
 PDosDateTimeToDateTime = ^TDosDateTimeToDateTime;
 TDosDateTimeToDateTime = object(TAction)
  _DosDateTime: PNumberExpression;
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDosDateTimeToDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DosDateTimeToDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DosDateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DosDateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDosDateTimeToDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DosDateTime: Longint;
  __DateTime: PDateTime;
 begin
  _DosDateTime^.Get(Data, __DosDateTime);
  _DateTime^.Get(Data, __DateTime);

  jtMHLcmn.DosDateTimeToDateTime(__DosDateTime, 
    __DateTime^);

  _DosDateTime^.Assign(Data, __DosDateTime);

  Execute:=erOk;
 end;

destructor TDosDateTimeToDateTime.Done;
 begin
  Dispose(_DosDateTime, Done);
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ GregorianToJulian(DateTime: TDateTime): Longint; }

type
 PGregorianToJulian = ^TGregorianToJulian;
 TGregorianToJulian = object(TNumberExpression)
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGregorianToJulian.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GregorianToJulian', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGregorianToJulian.Get(const ExecuteData: PExecuteData; var Value);
 var
  __DateTime: PDateTime;
 begin
  _DateTime^.Get(ExecuteData, __DateTime);

  Longint(Value):=Longint(jtMHLcmn.GregorianToJulian(__DateTime^));
 end;

destructor TGregorianToJulian.Done;
 begin
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ JulianToGregorian(JulianDN: Longint; var Year, Month, Day: Word); }

type
 PJulianToGregorian = ^TJulianToGregorian;
 TJulianToGregorian = object(TAction)
  _JulianDN: PNumberExpression;
  _Year: PNumberExpression;
  _Month: PNumberExpression;
  _Day: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TJulianToGregorian.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('JulianToGregorian', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _JulianDN:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Year:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Year^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Month^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmComma]);

  _Day:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Day^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TJulianToGregorian.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __JulianDN: Longint;
  __Year: Longint;
  __Month: Longint;
  __Day: Longint;
 begin
  _JulianDN^.Get(Data, __JulianDN);
  _Year^.Get(Data, __Year);
  _Month^.Get(Data, __Month);
  _Day^.Get(Data, __Day);

  jtMHLcmn.JulianToGregorian(__JulianDN, 
    Word(__Year), 
    Word(__Month), 
    Word(__Day));

  _Year^.Assign(Data, __Year);
  _Month^.Assign(Data, __Month);
  _Day^.Assign(Data, __Day);

  Execute:=erOk;
 end;

destructor TJulianToGregorian.Done;
 begin
  Dispose(_JulianDN, Done);
  Dispose(_Year, Done);
  Dispose(_Month, Done);
  Dispose(_Day, Done);

  inherited Done;
 end;

{ UnixDateTimeToDateTime(SecsPast: Longint; var DateTime: TDateTime); }

type
 PUnixDateTimeToDateTime = ^TUnixDateTimeToDateTime;
 TUnixDateTimeToDateTime = object(TAction)
  _SecsPast: PNumberExpression;
  _DateTime: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TUnixDateTimeToDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UnixDateTimeToDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _SecsPast:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DateTime^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TUnixDateTimeToDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __SecsPast: Longint;
  __DateTime: PDateTime;
 begin
  _SecsPast^.Get(Data, __SecsPast);
  _DateTime^.Get(Data, __DateTime);

  jtMHLcmn.UnixDateTimeToDateTime(__SecsPast, 
    __DateTime^);

  Execute:=erOk;
 end;

destructor TUnixDateTimeToDateTime.Done;
 begin
  Dispose(_SecsPast, Done);
  Dispose(_DateTime, Done);

  inherited Done;
 end;

{ DateTimeToUnixDateTime(const DateTime: TDateTime; var SecsPast:
   Longint); }

type
 PDateTimeToUnixDateTime = ^TDateTimeToUnixDateTime;
 TDateTimeToUnixDateTime = object(TAction)
  _DateTime: PNumberExpression;
  _SecsPast: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDateTimeToUnixDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DateTimeToUnixDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DateTime:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _SecsPast:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _SecsPast^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDateTimeToUnixDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DateTime: PDateTime;
  __SecsPast: Longint;
 begin
  _DateTime^.Get(Data, __DateTime);
  _SecsPast^.Get(Data, __SecsPast);

  jtMHLcmn.DateTimeToUnixDateTime(__DateTime^, 
    __SecsPast);

  _SecsPast^.Assign(Data, __SecsPast);

  Execute:=erOk;
 end;

destructor TDateTimeToUnixDateTime.Done;
 begin
  Dispose(_DateTime, Done);
  Dispose(_SecsPast, Done);

  inherited Done;
 end;

{ DateTimeToMSGDateTime(const DT: TDateTime; var L: Longint); }

type
 PDateTimeToMSGDateTime = ^TDateTimeToMSGDateTime;
 TDateTimeToMSGDateTime = object(TAction)
  _DT: PNumberExpression;
  _L: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TDateTimeToMSGDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DateTimeToMSGDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _DT:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _L:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _L^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TDateTimeToMSGDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __DT: PDateTime;
  __L: Longint;
 begin
  _DT^.Get(Data, __DT);
  _L^.Get(Data, __L);

  jtMHLcmn.DateTimeToMSGDateTime(__DT^, 
    __L);

  _L^.Assign(Data, __L);

  Execute:=erOk;
 end;

destructor TDateTimeToMSGDateTime.Done;
 begin
  Dispose(_DT, Done);
  Dispose(_L, Done);

  inherited Done;
 end;

{ MSGDateTimeToDateTime(const A: Longint; var DT: TDateTime); }

type
 PMSGDateTimeToDateTime = ^TMSGDateTimeToDateTime;
 TMSGDateTimeToDateTime = object(TAction)
  _A: PNumberExpression;
  _DT: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TMSGDateTimeToDateTime.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('MSGDateTimeToDateTime', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _A:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _DT:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _DT^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TMSGDateTimeToDateTime.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __A: Longint;
  __DT: PDateTime;
 begin
  _A^.Get(Data, __A);
  _DT^.Get(Data, __DT);

  jtMHLcmn.MSGDateTimeToDateTime(__A, 
    __DT^);

  Execute:=erOk;
 end;

destructor TMSGDateTimeToDateTime.Done;
 begin
  Dispose(_A, Done);
  Dispose(_DT, Done);

  inherited Done;
 end;

{ DateTimeCompare(const First, Second: TDateTime): Integer; }

type
 PDateTimeCompare = ^TDateTimeCompare;
 TDateTimeCompare = object(TNumberExpression)
  _First: PNumberExpression;
  _Second: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TDateTimeCompare.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('DateTimeCompare', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _First:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Second:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TDateTimeCompare.Get(const ExecuteData: PExecuteData; var Value);
 var
  __First: PDateTime;
  __Second: PDateTime;
 begin
  _First^.Get(ExecuteData, __First);
  _Second^.Get(ExecuteData, __Second);

  Longint(Value):=Longint(jtMHLcmn.DateTimeCompare(__First^, 
    __Second^));
 end;

destructor TDateTimeCompare.Done;
 begin
  Dispose(_First, Done);
  Dispose(_Second, Done);

  inherited Done;
 end;

{ MonthStringToMonthNumber(S: String; var Month: Word); }

type
 PMonthStringToMonthNumber = ^TMonthStringToMonthNumber;
 TMonthStringToMonthNumber = object(TAction)
  _S: PStringExpression;
  _Month: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  function Execute(const Data: PExecuteData): TExecuteResult; virtual;
  destructor Done; virtual;
 end;

constructor TMonthStringToMonthNumber.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('MonthStringToMonthNumber', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  if not _Month^.Assignable then
   Tokenizer^.AssignableExpressionExpected(etNumber);

  Tokenizer^.Next([tmCloseBracket]);
 end;

function TMonthStringToMonthNumber.Execute(const Data: PExecuteData): TExecuteResult;
 var
  __S: String;
  __Month: Longint;
 begin
  _S^.Get(Data, __S);
  _Month^.Get(Data, __Month);

  jtMHLcmn.MonthStringToMonthNumber(__S, 
    Word(__Month));

  _Month^.Assign(Data, __Month);

  Execute:=erOk;
 end;

destructor TMonthStringToMonthNumber.Done;
 begin
  Dispose(_S, Done);
  Dispose(_Month, Done);

  inherited Done;
 end;

{ MonthNumberToMonthString(const Month: Word): String; }

type
 PMonthNumberToMonthString = ^TMonthNumberToMonthString;
 TMonthNumberToMonthString = object(TStringExpression)
  _Month: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TMonthNumberToMonthString.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('MonthNumberToMonthString', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Month:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TMonthNumberToMonthString.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Month: Longint;
 begin
  _Month^.Get(ExecuteData, __Month);

  String(Value):=jtMHLcmn.MonthNumberToMonthString(Word(__Month));
 end;

destructor TMonthNumberToMonthString.Done;
 begin
  Dispose(_Month, Done);

  inherited Done;
 end;

{ GenerateMSGID: String; }

type
 PGenerateMSGID = ^TGenerateMSGID;
 TGenerateMSGID = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TGenerateMSGID.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jtMHLcmn.GenerateMSGID;
 end;

{ GenerateUnixTimeMSGID: String; }

type
 PGenerateUnixTimeMSGID = ^TGenerateUnixTimeMSGID;
 TGenerateUnixTimeMSGID = object(TStringExpression)
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
 end;

procedure TGenerateUnixTimeMSGID.Get(const ExecuteData: PExecuteData; var Value);
 begin
  String(Value):=jtMHLcmn.GenerateUnixTimeMSGID;
 end;

{ UpdateCRC32(Octet: Byte; Crc: Longint): Longint; }

type
 PUpdateCRC32 = ^TUpdateCRC32;
 TUpdateCRC32 = object(TNumberExpression)
  _Octet: PNumberExpression;
  _Crc: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TUpdateCRC32.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('UpdateCRC32', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Octet:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Crc:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TUpdateCRC32.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Octet: Longint;
  __Crc: Longint;
 begin
  _Octet^.Get(ExecuteData, __Octet);
  _Crc^.Get(ExecuteData, __Crc);

  Longint(Value):=Longint(jtMHLcmn.UpdateCRC32(__Octet, 
    __Crc));
 end;

destructor TUpdateCRC32.Done;
 begin
  Dispose(_Octet, Done);
  Dispose(_Crc, Done);

  inherited Done;
 end;

{ StringCRC32(const S: String; Crc: Longint): Longint; }

type
 PStringCRC32 = ^TStringCRC32;
 TStringCRC32 = object(TNumberExpression)
  _S: PStringExpression;
  _Crc: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TStringCRC32.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('StringCRC32', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseStringExpression(Tokenizer, True);

  Tokenizer^.Next([tmComma]);

  _Crc:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TStringCRC32.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: String;
  __Crc: Longint;
 begin
  _S^.Get(ExecuteData, __S);
  _Crc^.Get(ExecuteData, __Crc);

  Longint(Value):=Longint(jtMHLcmn.StringCRC32(__S, 
    __Crc));
 end;

destructor TStringCRC32.Done;
 begin
  Dispose(_S, Done);
  Dispose(_Crc, Done);

  inherited Done;
 end;

{ PCharCRC32(S: PChar; Crc: Longint): Longint; }

type
 PPCharCRC32 = ^TPCharCRC32;
 TPCharCRC32 = object(TNumberExpression)
  _S: PNumberExpression;
  _Crc: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TPCharCRC32.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('PCharCRC32', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _S:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmComma]);

  _Crc:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TPCharCRC32.Get(const ExecuteData: PExecuteData; var Value);
 var
  __S: PChar;
  __Crc: Longint;
 begin
  _S^.Get(ExecuteData, __S);
  _Crc^.Get(ExecuteData, __Crc);

  Longint(Value):=Longint(jtMHLcmn.PCharCRC32(__S, 
    __Crc));
 end;

destructor TPCharCRC32.Done;
 begin
  Dispose(_S, Done);
  Dispose(_Crc, Done);

  inherited Done;
 end;

{ GetAttributesShortNames(const Attributes: Longint): String; }

type
 PGetAttributesShortNames = ^TGetAttributesShortNames;
 TGetAttributesShortNames = object(TStringExpression)
  _Attributes: PNumberExpression;

  constructor Init(const Tokenizer: PTokenizer; const Actions: PActions);
  procedure Get(const ExecuteData: PExecuteData; var Value); virtual;
  destructor Done; virtual;
 end;

constructor TGetAttributesShortNames.Init(const Tokenizer: PTokenizer; const Actions: PActions);
 begin
  inherited Init('GetAttributesShortNames', Actions);

  Tokenizer^.Next([tmOpenBracket]);

  _Attributes:=Actions^.ParseNumberExpression(Tokenizer, True, []);

  Tokenizer^.Next([tmCloseBracket]);
 end;

procedure TGetAttributesShortNames.Get(const ExecuteData: PExecuteData; var Value);
 var
  __Attributes: Longint;
 begin
  _Attributes^.Get(ExecuteData, __Attributes);

  String(Value):=jtMHLcmn.GetAttributesShortNames(__Attributes);
 end;

destructor TGetAttributesShortNames.Done;
 begin
  Dispose(_Attributes, Done);

  inherited Done;
 end;

function CreatorGETFILESIZE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETFILESIZE:=New(PGetFileSize, Init(Tokenizer, Actions));
 end;

function CreatorGETSTAMP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETSTAMP:=New(PGetStamp, Init(Tokenizer, Actions));
 end;

function CreatorSETATTR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSETATTR:=New(PSetAttr, Init(Tokenizer, Actions));
 end;

function CreatorSETSTAMP(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSETSTAMP:=New(PSetStamp, Init(Tokenizer, Actions));
 end;

function CreatorSTACKOVERFLOW(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTACKOVERFLOW:=New(PStackOverflow, Init('StackOverflow', Actions));
 end;

function Creator_S(const Tokenizer, Actions: Pointer): Pointer;
 begin
  Creator_S:=New(P_s, Init(Tokenizer, Actions));
 end;

function Creator_NZ(const Tokenizer, Actions: Pointer): Pointer;
 begin
  Creator_NZ:=New(P_nz, Init(Tokenizer, Actions));
 end;

function CreatorNUMBERWIDTH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorNUMBERWIDTH:=New(PNumberWidth, Init(Tokenizer, Actions));
 end;

function CreatorCOMPARELONGINT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOMPARELONGINT:=New(PCompareLongint, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKTECHINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKTECHINFO:=New(PUnpackTechInfo, Init(Tokenizer, Actions));
 end;

function CreatorPACKTECHINFO(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKTECHINFO:=New(PPackTechInfo, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKAREAFORMAT:=New(PUnpackAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorPACKAREAFORMAT(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKAREAFORMAT:=New(PPackAreaFormat, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKADDRESS:=New(PUnpackAddress, Init(Tokenizer, Actions));
 end;

function CreatorPACKADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKADDRESS:=New(PPackAddress, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKTIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKTIME:=New(PUnpackTime, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKDATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKDATE:=New(PUnpackDate, Init(Tokenizer, Actions));
 end;

function CreatorUNPACKDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNPACKDATETIME:=New(PUnpackDateTime, Init(Tokenizer, Actions));
 end;

function CreatorPACKTIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKTIME:=New(PPackTime, Init(Tokenizer, Actions));
 end;

function CreatorPACKDATE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKDATE:=New(PPackDate, Init(Tokenizer, Actions));
 end;

function CreatorPACKDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPACKDATETIME:=New(PPackDateTime, Init(Tokenizer, Actions));
 end;

function CreatorTOUCH(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOUCH:=New(PTouch, Init(Tokenizer, Actions));
 end;

function CreatorTOUCHONCE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorTOUCHONCE:=New(PTouchOnce, Init(Tokenizer, Actions));
 end;

function CreatorPSTOS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPSTOS:=New(PPstos, Init(Tokenizer, Actions));
 end;

function CreatorCHR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCHR:=New(PChr, Init(Tokenizer, Actions));
 end;

function CreatorPOS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPOS:=New(PPos, Init(Tokenizer, Actions));
 end;

function CreatorCOPY(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCOPY:=New(PCopy, Init(Tokenizer, Actions));
 end;

function CreatorDELETE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDELETE:=New(PDelete, Init(Tokenizer, Actions));
 end;

function CreatorINC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorINC:=New(PInc, Init(Tokenizer, Actions));
 end;

function CreatorDEC(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDEC:=New(PDec, Init(Tokenizer, Actions));
 end;

function CreatorCARBON(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCARBON:=New(PCarbon, Init(Tokenizer, Actions));
 end;

function CreatorSPEED(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSPEED:=New(PSpeed, Init(Tokenizer, Actions));
 end;

function CreatorIDENTIFYREADER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorIDENTIFYREADER:=New(PIdentifyReader, Init(Tokenizer, Actions));
 end;

function CreatorIDENTIFYREADERNOEXTCARE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorIDENTIFYREADERNOEXTCARE:=New(PIdentifyReaderNoExtCare, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSOFLINK(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSOFLINK:=New(PAddressOfLink, Init(Tokenizer, Actions));
 end;

function CreatorGETTOSSSOURCENAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETTOSSSOURCENAME:=New(PGetTossSourceName, Init(Tokenizer, Actions));
 end;

function CreatorGETCOMMANDWHENNAME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETCOMMANDWHENNAME:=New(PGetCommandWhenName, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSTOSTR(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSTOSTR:=New(PAddressToStr, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSTOSTRPOINTLESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSTOSTRPOINTLESS:=New(PAddressToStrPointless, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSTOSTREX(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSTOSTREX:=New(PAddressToStrEx, Init(Tokenizer, Actions));
 end;

function CreatorSTRTOADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTRTOADDRESS:=New(PStrToAddress, Init(Tokenizer, Actions));
 end;

function CreatorCLEARADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCLEARADDRESS:=New(PClearAddress, Init(Tokenizer, Actions));
 end;

function CreatorISCLEANADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorISCLEANADDRESS:=New(PIsCleanAddress, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSCOMPARE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSCOMPARE:=New(PAddressCompare, Init(Tokenizer, Actions));
 end;

function CreatorADDRESSEQU(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorADDRESSEQU:=New(PAddressEqu, Init(Tokenizer, Actions));
 end;

function CreatorPATCHADDRESS(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPATCHADDRESS:=New(PPatchAddress, Init(Tokenizer, Actions));
 end;

function CreatorCLEARDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorCLEARDATETIME:=New(PClearDateTime, Init(Tokenizer, Actions));
 end;

function CreatorISREALDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorISREALDATETIME:=New(PIsRealDateTime, Init(Tokenizer, Actions));
 end;

function CreatorISVALIDDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorISVALIDDATETIME:=New(PIsValidDateTime, Init(Tokenizer, Actions));
 end;

function CreatorGETCURRENTDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETCURRENTDATETIME:=New(PGetCurrentDateTime, Init(Tokenizer, Actions));
 end;

function CreatorDATETIMETODOSDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDATETIMETODOSDATETIME:=New(PDateTimeToDosDateTime, Init(Tokenizer, Actions));
 end;

function CreatorDOSDATETIMETODATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDOSDATETIMETODATETIME:=New(PDosDateTimeToDateTime, Init(Tokenizer, Actions));
 end;

function CreatorGREGORIANTOJULIAN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGREGORIANTOJULIAN:=New(PGregorianToJulian, Init(Tokenizer, Actions));
 end;

function CreatorJULIANTOGREGORIAN(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorJULIANTOGREGORIAN:=New(PJulianToGregorian, Init(Tokenizer, Actions));
 end;

function CreatorUNIXDATETIMETODATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUNIXDATETIMETODATETIME:=New(PUnixDateTimeToDateTime, Init(Tokenizer, Actions));
 end;

function CreatorDATETIMETOUNIXDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDATETIMETOUNIXDATETIME:=New(PDateTimeToUnixDateTime, Init(Tokenizer, Actions));
 end;

function CreatorDATETIMETOMSGDATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDATETIMETOMSGDATETIME:=New(PDateTimeToMSGDateTime, Init(Tokenizer, Actions));
 end;

function CreatorMSGDATETIMETODATETIME(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMSGDATETIMETODATETIME:=New(PMSGDateTimeToDateTime, Init(Tokenizer, Actions));
 end;

function CreatorDATETIMECOMPARE(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorDATETIMECOMPARE:=New(PDateTimeCompare, Init(Tokenizer, Actions));
 end;

function CreatorMONTHSTRINGTOMONTHNUMBER(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMONTHSTRINGTOMONTHNUMBER:=New(PMonthStringToMonthNumber, Init(Tokenizer, Actions));
 end;

function CreatorMONTHNUMBERTOMONTHSTRING(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorMONTHNUMBERTOMONTHSTRING:=New(PMonthNumberToMonthString, Init(Tokenizer, Actions));
 end;

function CreatorGENERATEMSGID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGENERATEMSGID:=New(PGenerateMSGID, Init('GenerateMSGID', Actions));
 end;

function CreatorGENERATEUNIXTIMEMSGID(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGENERATEUNIXTIMEMSGID:=New(PGenerateUnixTimeMSGID, Init('GenerateUnixTimeMSGID', Actions));
 end;

function CreatorUPDATECRC32(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorUPDATECRC32:=New(PUpdateCRC32, Init(Tokenizer, Actions));
 end;

function CreatorSTRINGCRC32(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorSTRINGCRC32:=New(PStringCRC32, Init(Tokenizer, Actions));
 end;

function CreatorPCHARCRC32(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorPCHARCRC32:=New(PPCharCRC32, Init(Tokenizer, Actions));
 end;

function CreatorGETATTRIBUTESSHORTNAMES(const Tokenizer, Actions: Pointer): Pointer;
 begin
  CreatorGETATTRIBUTESSHORTNAMES:=New(PGetAttributesShortNames, Init(Tokenizer, Actions));
 end;

{ AddJTAPIProtos }

procedure AddJTAPIProtos(const Target: PActions);
 begin
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('GETFILESIZE', CreatorGETFILESIZE)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('GETSTAMP', CreatorGETSTAMP)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('SETATTR', CreatorSETATTR)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('SETSTAMP', CreatorSETSTAMP)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('STACKOVERFLOW',
    CreatorSTACKOVERFLOW)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('_S', Creator_S)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('_NZ', Creator_NZ)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('NUMBERWIDTH', CreatorNUMBERWIDTH)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('COMPARELONGINT',
    CreatorCOMPARELONGINT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKTECHINFO', CreatorUNPACKTECHINFO)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKTECHINFO', CreatorPACKTECHINFO)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKAREAFORMAT', CreatorUNPACKAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKAREAFORMAT', CreatorPACKAREAFORMAT)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKADDRESS', CreatorUNPACKADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKADDRESS', CreatorPACKADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKTIME', CreatorUNPACKTIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKDATE', CreatorUNPACKDATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNPACKDATETIME', CreatorUNPACKDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKTIME', CreatorPACKTIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKDATE', CreatorPACKDATE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PACKDATETIME', CreatorPACKDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOUCH', CreatorTOUCH)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('TOUCHONCE', CreatorTOUCHONCE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('PSTOS', CreatorPSTOS)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('CHR', CreatorCHR)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('POS', CreatorPOS)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('COPY', CreatorCOPY)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DELETE', CreatorDELETE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('INC', CreatorINC)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DEC', CreatorDEC)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('CARBON', CreatorCARBON)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('SPEED', CreatorSPEED)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('IDENTIFYREADER',
    CreatorIDENTIFYREADER)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('IDENTIFYREADERNOEXTCARE',
    CreatorIDENTIFYREADERNOEXTCARE)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ADDRESSOFLINK',
    CreatorADDRESSOFLINK)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('GETTOSSSOURCENAME',
    CreatorGETTOSSSOURCENAME)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('GETCOMMANDWHENNAME',
    CreatorGETCOMMANDWHENNAME)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ADDRESSTOSTR', CreatorADDRESSTOSTR)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ADDRESSTOSTRPOINTLESS',
    CreatorADDRESSTOSTRPOINTLESS)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('ADDRESSTOSTREX',
    CreatorADDRESSTOSTREX)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('STRTOADDRESS', CreatorSTRTOADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('CLEARADDRESS', CreatorCLEARADDRESS)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ISCLEANADDRESS',
    CreatorISCLEANADDRESS)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('ADDRESSCOMPARE',
    CreatorADDRESSCOMPARE)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ADDRESSEQU', CreatorADDRESSEQU)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('PATCHADDRESS', CreatorPATCHADDRESS)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('CLEARDATETIME', CreatorCLEARDATETIME)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ISREALDATETIME',
    CreatorISREALDATETIME)));
  Target^.Identifiers^.AddIdentifier(imBooleanExpressionProto, New(PProtoCreator, Init('ISVALIDDATETIME',
    CreatorISVALIDDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('GETCURRENTDATETIME',
    CreatorGETCURRENTDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DATETIMETODOSDATETIME',
    CreatorDATETIMETODOSDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DOSDATETIMETODATETIME',
    CreatorDOSDATETIMETODATETIME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('GREGORIANTOJULIAN',
    CreatorGREGORIANTOJULIAN)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('JULIANTOGREGORIAN', CreatorJULIANTOGREGORIAN)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('UNIXDATETIMETODATETIME',
    CreatorUNIXDATETIMETODATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DATETIMETOUNIXDATETIME',
    CreatorDATETIMETOUNIXDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('DATETIMETOMSGDATETIME',
    CreatorDATETIMETOMSGDATETIME)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MSGDATETIMETODATETIME',
    CreatorMSGDATETIMETODATETIME)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('DATETIMECOMPARE',
    CreatorDATETIMECOMPARE)));
  Target^.Identifiers^.AddIdentifier(imActionProto, New(PProtoCreator, Init('MONTHSTRINGTOMONTHNUMBER',
    CreatorMONTHSTRINGTOMONTHNUMBER)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('MONTHNUMBERTOMONTHSTRING',
    CreatorMONTHNUMBERTOMONTHSTRING)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('GENERATEMSGID',
    CreatorGENERATEMSGID)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('GENERATEUNIXTIMEMSGID',
    CreatorGENERATEUNIXTIMEMSGID)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('UPDATECRC32', CreatorUPDATECRC32)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('STRINGCRC32', CreatorSTRINGCRC32)));
  Target^.Identifiers^.AddIdentifier(imNumberExpressionProto, New(PProtoCreator, Init('PCHARCRC32', CreatorPCHARCRC32)));
  Target^.Identifiers^.AddIdentifier(imStringExpressionProto, New(PProtoCreator, Init('GETATTRIBUTESSHORTNAMES',
    CreatorGETATTRIBUTESSHORTNAMES)));
 end;

end.
