unit ccJTSupp;

interface
uses
     PlugSIDE,

     Strings,

     Wizard,

     jtMHLcmn,

     mbAPI,

     ccAction;

type
 TDefaultNumberVariable = record
  Name: PChar;
  Value: Longint;
 end;

const
 DefaultNumberVariables: array[1..79] of TDefaultNumberVariable = (
 { jtMHL constants }
  (Name: 'MANONE'; Value: maNone),
  (Name: 'MAPRIVATE'; Value: maPrivate),
  (Name: 'MACRASH'; Value: maCrash),
  (Name: 'MARECEIVED'; Value: maReceived),
  (Name: 'MASENT'; Value: maSent),
  (Name: 'MAATTACH'; Value: maAttach),
  (Name: 'MATRANSIT'; Value: maTransit),
  (Name: 'MAORPHAN'; Value: maOrphan),
  (Name: 'MAKILL'; Value: maKill),
  (Name: 'MALOCAL'; Value: maLocal),
  (Name: 'MAHOLD'; Value: maHold),
  (Name: 'MAFRQ'; Value: maFRq),
  (Name: 'MARRQ'; Value: maRRq),
  (Name: 'MARRC'; Value: maRRc),
  (Name: 'MAARQ'; Value: maARq),
  (Name: 'MAURQ'; Value: maURq),
  (Name: 'MASCAN'; Value: maScanned),
  (Name: 'MAREAD'; Value: maRead),
  (Name: 'MFNONE'; Value: mfNone),
  (Name: 'MFNOTEXT'; Value: mfNoText),
  (Name: 'PAZONE'; Value: paZone),
  (Name: 'PANET'; Value: paNet),
  (Name: 'PANODE'; Value: paNode),
  (Name: 'PAPOINT'; Value: paPoint),
  (Name: 'PAZONENETNODE'; Value: paZoneNetNode),
  (Name: 'PAALL'; Value: paAll),
 { jtAPI constants }
  (Name: 'AACREATED'; Value: aaCreated),
  (Name: 'ASUNDEFINED'; Value: asUndefined),
  (Name: 'ASNETMAIL'; Value: asNetmail),
  (Name: 'ASLOCAL'; Value: asLocal),
  (Name: 'ASECHOMAIL'; Value: asEchomail),
  (Name: 'AFPASSTHROUGH'; Value: afPassthrough),
  (Name: 'RSNONE'; Value: rsNone),
  (Name: 'RSMINUS'; Value: rsMinus),
  (Name: 'RSVALUE'; Value: rsValue),
  (Name: 'RSSTORAGE'; Value: rsStorage),
  (Name: 'RSISEXISTS'; Value: rsIsExists),
  (Name: 'LEFNORMAL'; Value: lefNormal),
  (Name: 'LEFSORT'; Value: lefSort),
  (Name: 'LEFUPCASE'; Value: lefUpcase),
  (Name: 'LEFINCLUDE'; Value: lefInclude),
  (Name: 'LEFDUPLICATES'; Value: lefDuplicates),
  (Name: 'LEFSIMPLE'; Value: lefSimple),
  (Name: 'LEFTREATINCLUDEASWILDCARDS'; Value: lefTreatIncludeAsWildcards),
  (Name: 'TSINBOUND'; Value: tsInbound),
  (Name: 'TSTEMPINBOUND'; Value: tsTempInbound),
  (Name: 'TSBADINBOUND'; Value: tsBadInbound),
  (Name: 'TSBASEINBOUND'; Value: tsBaseInbound),
  (Name: 'TSLOCALINBOUND'; Value: tsLocalInbound),
  (Name: 'RFFNONE'; Value: rffNone),
  (Name: 'RFFMANUALPACK'; Value: rffManualPack),
  (Name: 'RFFFORCEDPACK'; Value: rffForcedPack),
  (Name: 'MCFCLONEFROMTOETC'; Value: mcfCloneFromToEtc),
  (Name: 'MCFCLONESTORAGE'; Value: mcfCloneStorage),
  (Name: 'MCFCLONETEXT'; Value: mcfCloneText),
  (Name: 'MCFCLONEAREA'; Value: mcfCloneArea),
  (Name: 'MCFCLONEALL'; Value: mcfCloneAll),
  (Name: 'MCFCLONEHEADER'; Value: mcfCloneHeader),
  (Name: 'LCFCHANGED'; Value: lcfChanged),
  (Name: 'LCFFULL'; Value: lcfFull),
  (Name: 'ACFCHANGED'; Value: acfChanged),
  (Name: 'ACFFULL'; Value: acfFull),
  (Name: 'ACSMAXLENGTH'; Value: acsMaxLength),
 { mbAPI constants }
  (Name: 'ATPASSTHROUGH'; Value: atPassthrough),
  (Name: 'ATMSG'; Value: atMSG),
  (Name: 'ATSQUISH'; Value: atSquish),
  (Name: 'ATJAM'; Value: atJam),
  (Name: 'ATHUDSON'; Value: atHudson),
  (Name: 'ATSYNCHRONET'; Value: atSynchronet),
  (Name: 'ATOUTLOOK'; Value: atOutlook),
  (Name: 'ATBAT'; Value: atBat),
  (Name: 'ATNNTP'; Value: atNNTP),
  (Name: 'ATNEW'; Value: atNew),
  (Name: 'EOOGETHIGHWATER'; Value: eooGetHighWater),
  (Name: 'EOOSETHIGHWATER'; Value: eooSetHighWater),
  (Name: 'EOONOTSCANNABLEATTRIBUTES'; Value: eooNotScannableAttributes),
  (Name: 'EOOSETSCANNEDATTRIBUTES'; Value: eooSetScannedAttributes),
  (Name: 'EOOGETLASTREAD'; Value: eooGetLastRead),
  (Name: 'EOOSETLASTREAD'; Value: eooSetLastRead));

function String2Char(const S: String): Char;
function String2CharSet(const S: String): PCharSet;

procedure AddVariables(const Target: PActions);

implementation
uses
     ccAPI,
     ccExpr;

{ String2Char }

function String2Char(const S: String): Char;
 begin
  if S = '' then
   String2Char:=' '
  else
   String2Char:=S[1];
 end;

{ MakeCharSet }

var
 TempCharSet: TCharSet;

function String2CharSet(const S: String): PCharSet;
 var
  K: Byte;
 begin
  TempCharSet:=[];

  for K:=1 to Length(S) do
   if not (S[K] in TempCharSet) then
    TempCharSet:=TempCharSet + [S[K]];

  String2CharSet:=@TempCharSet;
 end;

{ AddVariables }

procedure AddVariables(const Target: PActions);
 var
  K: Longint;
 begin
  for K:=Low(DefaultNumberVariables) to High(DefaultNumberVariables) do
   with DefaultNumberVariables[K] do
    Target^.Identifiers^.AddIdentifier(imNumberExpressionProto,
      New(PExpressionProto, Init(StrPas(Name),
        New(PConstantNumberExpression, Init(Value, Target)))));
 end;

end.