unit dchkDump;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Drivers,

     dchkCmn,
     dchkCore,

     jtMHLcmn,

     Wizard;

procedure DumpDupeBase(const Base: PString);

implementation

{ DumpDupeBase }

procedure DumpDupeBase(const Base: PString);
 var
  Area: Pointer;
  Index: xInteger;
  DupeBase: PDupeBase;
  Count: Longint;
  First: Boolean;
 function Perform(const Item: PDupeRecord): Boolean; far;
  var
   Address: TAddress;
   DT: TDateTime;
   S: String;
  begin
   if Item^.Area = Index then
    begin
     if First then
      begin
       First:=False;

       jt.LogWrite('D', '    date      time   msgidhex  body32  msgid32  link');
       jt.LogWrite('D', '----------- -------- -------- -------- -------- --------------');
      end;

     if not LinkPool^.QueryLink(Item^.Link, Address) then
      ClearAddress(Address);

     UnixDateTimeToDateTime(Item^.Time, DT);

     S:=lz(DT.Day) + ' ' +
        MonthNumberToMonthString(DT.Month) + ' ' +
        Long2Str(DT.Year) + ' ' +
        lz(DT.Hour) + ':' +
        lz(DT.Min) + ':' +
        lz(DT.Sec) + ' ' +
        HexL(Item^.MSGIDhex) + ' ' +
        HexL(Item^.Body) + ' ' +
        HexL(Item^.MSGID) + ' ';

     if IsCleanAddress(Address) then
      S:=S + '?'
     else
      S:=S + AddressToStrEx(Address);

     jt.LogWrite('D', S);

     Inc(Count);
    end;

   Perform:=jt.Cancelled;
  end;
 begin
  Area:=jt.area.Seek(Base^);

  if Area = nil then
   jt.LogWrite('?', 'Unknown area ' + Base^)
  else
   begin
    Wakeup;

    DupeBase:=GetDupeBase(Area);

    Index:=AreaPool^.QueryIndex(Area);

    jt.LogWrite('D', 'Here follows dump of ' + Base^ + ' dupebase:');

    First:=True;
    Count:=0;

    if (DupeBase = nil) or (DupeBase^.FirstThat(@Perform) = nil) then
     if Count = 0 then
      jt.LogWrite('D', 'There is no duperecords.')
     else
      begin
       jt.LogWrite('D', '----------- -------- -------- -------- -------- --------------');

       jt.LogWrite('D', 'Total: ' + Long2Str(Count) + ' record' + _s(Count) + '.');
      end;
   end;

  DisposeStr(Base);
 end;

end.