unit frACR;

interface
uses
     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     Objects,

     TossAPI,
     acrAPI,

     frCmn,
     frQueue,
     frFwdReq,

     jtMHLcmn,

     Wizard;

procedure AutoCreateFirst(var Block: TTosserAutoCreateBlock);

implementation

{ AutoCreateFirst }

procedure AutoCreateFirst(var Block: TTosserAutoCreateBlock);
 var
  Index: xInteger;
  Item: PForwardRequestQueueItem;
  Format: TAreaFormat;
  fr: PForwardRequests;
  Area: Pointer;
  AreaName: String;
 procedure Subscribe(const Link: Pointer); far;
  var
   LinkArea: Pointer;
  begin
   Debugger.Log('subscribing ' + AddressOfLink(Link) + ' to ' + AreaName);

   LinkArea:=jt.link.SeekArea(Link, Area);

   if LinkArea = nil then
    LinkArea:=jt.link.CreateLinkArea(Link, Area);

   jt.link.area.SetReadable(LinkArea, True);
   jt.link.area.SetWriteable(LinkArea, True);
   jt.link.area.SetSubscribed(LinkArea, True);
  end;
 procedure Announce;
  var
   DT: TDateTime;
   Days: Longint;
  begin
   GetCurrentDateTime(DT);

   Days:=GregorianToJulian(DT) - Item^.RequestedAt;

   if Days < 1 then
    fwdreqQueue^.NotifyRequest(frGot, Item, '')
   else
    fwdreqQueue^.NotifyRequest(frGot, Item, Long2Str(Days) + ' day' + _s(Days))
  end;
 begin
  if not fwdreqQueue^.Search(jt.msg.GetArea(Block.msg), Index) then
   Exit;

  Debugger.Log('area ' + jt.msg.GetArea(Block.msg)^ + ' from ' + AddressOfLink(Block.Link));

  Item:=fwdreqQueue^.At(Index);

  if Block.Link <> Item^.RequestedFrom then
   begin
    Debugger.Log('strange: expected from ' + AddressOfLink(Item^.RequestedFrom) + ', got from ' + AddressOfLink(Block.Link));

    Exit;
   end;

  fr:=GetForwardRequests(Item^.RequestedFrom);

  Format:=fr^.GetFormat^;

  Debugger.Log('not prepared format: ' + Long2Str(Format.Format) + ' "' + Format.Path + '"');

  acrPrepareAreaFormat(Format, Item^.Name^, @fr^.Address);

  Debugger.Log('prepared format: ' + Long2Str(Format.Format) + ' "' + Format.Path + '"');

  Area:=jt.area.Create(Item^.Name^, @Format);

  AreaName:=jt.area.GetName(Area)^;

  Debugger.Log('kernel created area ' + AreaName);

  jt.area.SetUplink(Area, fr^.Address);

  if Item^.Desc <> nil then
   jt.area.SetDesc(Area, Item^.Desc^);

  Block.Area:=Area;
  Block.Done:=True;

  jt.area.SetChanged(acfFull, 'fwdreq/area got');
  jt.link.SetChanged(lcfFull, 'fwdreq/area got');

  Debugger.Log('performing subscribes (' + Long2Str(Item^.Count) + ')');

  Item^.ForEach(@Subscribe);

  jt.LogWrite('F', AreaName + ': forward requested area got from ' + AddressToStrEx(fr^.Address));

  Announce;

  jt.area.NotifyAreaCreated(Area);

  fwdreqQueue^.Free(Item);
 end;

end.