unit frOrder;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,

     jtMHLcmn,

     frFwdReq,
     frLists,

     Wizard;

type
 PForwardRequestQuery = ^TForwardRequestQuery;
 TForwardRequestQuery = object(TObject)
  fr: PForwardRequests;
  List: PForwardRequestList;
  Item: PForwardRequestListItem;

  constructor Init(const Afr: PForwardRequests; const AList: PForwardRequestList; const AItem: PForwardRequestListItem);
 end;

 PForwardRequestQueries = ^TForwardRequestQueries;
 TForwardRequestQueries = object(TCollection)
  function Seek(const Address: TAddress): PForwardRequestQuery; virtual;
 end;

 PForwardRequestOrder = ^TForwardRequestOrder;
 TForwardRequestOrder = object(TCollection)
  procedure FreeItem(Item: Pointer); virtual;
  procedure PerformQuery(const Name: String; var Queries: PForwardRequestQueries; const Exclude: Pointer);
 end;

implementation

{ TForwardRequestQuery }

constructor TForwardRequestQuery.Init(const Afr: PForwardRequests; const AList: PForwardRequestList;
  const AItem: PForwardRequestListItem);
 begin
  inherited Init;

  fr:=Afr;
  List:=AList;
  Item:=AItem;
 end;

{ TForwardRequestQueries }

function TForwardRequestQueries.Seek(const Address: TAddress): PForwardRequestQuery;
 function Perform(const Query: PForwardRequestQuery): Boolean; far;
  begin
   Perform:=AddressEqu(Address, Query^.fr^.Address);
  end;
 begin
  Seek:=FirstThat(@Perform);
 end;

{ TForwardRequestOrder }

procedure TForwardRequestOrder.FreeItem(Item: Pointer);
 begin
 end;

procedure TForwardRequestOrder.PerformQuery(const Name: String; var Queries: PForwardRequestQueries; const Exclude: Pointer);
 procedure ProcessForwardRequests(const fr: PForwardRequests); far;
  function ProcessList(const List: PForwardRequestList): Boolean; far;
   var
    Index: xInteger;
   begin
    if List^.Search(@Name, Index) then
     begin
      Queries^.Insert(New(PForwardRequestQuery, Init(fr, List, List^.At(Index))));

      ProcessList:=True;
     end
    else
     ProcessList:=False;
   end;
  begin
   if fr^.Link <> Exclude then
    begin
     fr^.Compile(False);

     fr^.Lists^.FirstThat(@ProcessList);
    end;
  end;
 begin
  ForEach(@ProcessForwardRequests);
 end;

end.