library JTM;

uses
     PlugAPI,
     PlugSIDE,

     Objects,

     App,
     Drivers,

     jtmCmn,
     jtmTUI,

     acrAPI,
     PrioAPI,

     Wizard;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, 'JustTosserManager', 2);

  jtmPlugin:=Plugin;

  PluginSetup:=True;

  RegisterPriorityAction('jtm');
 end;

{ PluginStartup }

procedure PluginStartup; export;
 begin
 end;

{ PluginShutdown }

procedure PluginShutdown; export;
 begin
 end;

{ PluginHandleCommand }

procedure PluginHandleCommand(const Command, Param: Longint); export;
 begin
  if Command = jtmcTUI then TUI else
  if Command = jtpcLogWrite then PtuiApplication(Application)^.coreLogWrite(PLogWriteBlock(Param)^) else
  if Command = jtpcSetStatus then PtuiApplication(Application)^.coreSetStatus(PSetStatusBlock(Param)^) else
  if Command = jtpcClearStatus then PtuiApplication(Application)^.coreClearStatus(PClearStatusBlock(Param)^) else
  if Command = jtpcCancelled then PtuiApplication(Application)^.coreCancelled(PCancelledBlock(Param)^);
 end;

{ PluginHandleCmdlineSwitch }

function PluginHandleCmdlineSwitch(Switch: String): Boolean; export;
 begin
  StUpcaseEx(Switch);

  PluginHandleCmdlineSwitch:=True;

  if Switch = 'JTM' then jt.EnqueueCommand(jtmPlugin, jtmcTUI, 0, cwEarliest) else
   PluginHandleCmdlineSwitch:=False;
 end;

{ PluginShowHelp }

procedure PluginShowHelp; export;
 begin
  jt.PrintStr(' JTM                     JustTosser Manager'#13#10);
 end;

exports
 PluginSetup,
 PluginStartup,
 PluginShutdown,
 PluginHandleCommand,
 PluginHandleCmdlineSwitch,
 PluginShowHelp;

begin
 Assign(Output, '');
 Rewrite(Output);
 Assign(Input, '');
 Reset(Input);
end.