unit jtmCmn;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Drivers,

     jtMHLcmn,

     Dialogs,

     TheClip,

     Wizard;

const
 jtmPlugin      : Pointer               = nil;

 jtmcTUI                                = $1000;

 { general commands: }

 cmLogViewer                            = 50;
 cmAreasManager                         = 51;

 { internal commands: }

 cmQueryRect                            = 90;
 cmSetTitle                             = 91;
 cmResetTitle                           = 92;

 { areas manager commands: }

 cmaEditArea                            = 100;
 cmaCreateArea                          = 101;
 cmaDestroyArea                         = 102;
 cmaConvertArea                         = 103;
 cmaMakeAreaPassthrough                 = 104;
 cmaUnsubscribeAreaAndNotifyLinks       = 105;
 cmaSubscribeArea                       = 106;
 cmaUnsubscribeArea                     = 107;
 cmaRelinkArea                          = 108;

 { area editor commands: }

 cmaeMisc                               = 110;

 { area subscribers editor commands: }

 cmasEditSubscriber                     = 120;
 cmasCreateSubscriber                   = 121;
 cmasDestroySubscriber                  = 122;

 { area subscribe editor commands: }

 cmaseDefault                           = 130;
 cmaseNoChanges                         = 131;

 { additional areas manager commands: }

 cmaSelectToggle                        = $1000;
 cmaSelect                              = $1001;
 cmaSelectRegExp                        = $1002;
 cmaUnselectRegExp                      = $1003;
 cmaToggleRegExp                        = $1004;
 cmaPopupMenu                           = $1005;
 cmaMiscMenu                            = $1006;
 cmaPassthroughMenu                     = $1007;

 { miscellaneous area commands: }

 cmamMiscStart                          = $1100;
 cmamMiscEnd                            = $1200;

 cmamUplink                             = $1100;
 cmamDescription                        = $1101;

 { links selector box commands: }

 cmlsbSelectToggle                      = $1200;
 cmlsbSelect                            = $1201;

 hcDesktop                              = $0000;

(*
 { general help contexts: }

 hcDesktop                              = $0000;
 hcMenu                                 = $1000;
 hcLogViewer                            = $1001;
 hcAreasManager                         = $1002;

 { dialog help contexts: }

 hcAskRegExpDialog                      = $2000;
 hcEditAreaDialog                       = $2001;
 hcEditAreaDialogSubscribers            = $2002;
 hcEditAreaSubscriberDialog             = $2003;
 hcChooseAreaSubscriberDialog           = $2004;
 hcAreaConverter                        = $2005;
 hcAreaConvertProgress                  = $2006;
 hcAreaConvertPathProblem               = $2007;
 hcAreaConvertResults                   = $2008;
 hcMiscUplinkDialog                     = $2009;
 hcMiscDescriptionDialog                = $200A;
 hcLinksSelectorDialog                  = $200B;
 hcRelinkSelectorDialog                 = $200C;
*)

 wnAreasManager                         = 1;
 wnLogViewer                            = 9;

 kbSpace                                = $3920;
 kbGrayAsterik                          = $372A;

 hidAreasManagerSelect                  = 100;
 hidAreasManagerUnselect                = 101;
 hidAreasManagerToggle                  = 102;

 VerticalMargin                         = 6;
 NoShadow                               = True;

type
 PAreasSelected = ^TAreasSelected;
 TAreasSelected = object(TSortedCollection)
  function Compare(Key1, Key2: Pointer): xInteger; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PLinksSelected = ^TLinksSelected;
 TLinksSelected = object(TSortedCollection)
  function Compare(Key1, Key2: Pointer): xInteger; virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PtuiInputLine = ^TtuiInputLine;
 TtuiInputLine = object(TInputLine)
  procedure HandleEvent(var Event: TEvent); virtual;
 end;

function AtStyle(const Index: Longint; var id: Longint; var Name: String): Boolean;
function SeekStyle(const id: Longint; var Index: Longint): Boolean;

implementation

{ TAreasSelected }

function TAreasSelected.Compare(Key1, Key2: Pointer): xInteger;
 var
  K1: PString;
  K2: PString;
 begin
  K1:=jt.area.GetName(Key1);
  K2:=jt.area.GetName(Key2);

  if K1^ < K2^ then Compare:=-1 else
  if K1^ > K2^ then Compare:=1 else
   Compare:=0;
 end;

procedure TAreasSelected.FreeItem(Item: Pointer);
 begin
 end;

{ TLinksSelected }

function TLinksSelected.Compare(Key1, Key2: Pointer): xInteger;
 var
  A1: TAddress;
  A2: TAddress;
 begin
  jt.link.GetAddress(Key1, A1);
  jt.link.GetAddress(Key2, A2);

  Compare:=AddressCompare(A1, A2);
 end;

procedure TLinksSelected.FreeItem(Item: Pointer);
 begin
 end;

{ TtuiInputLine }

procedure TtuiInputLine.HandleEvent(var Event: TEvent);
 var
  S, D: String;
 begin
  if (Event.What = evKeyDown) and (Event.KeyCode = kbCtrlIns) then
   begin
    S:=Copy(Data^, SelStart + 1, SelEnd - SelStart);

    if S <> '' then
     SetClipboardString(S);

    ClearEvent(Event);
   end;

  if (Event.What = evKeyDown) and (Event.KeyCode = kbShiftIns) then
   begin
    S:=Data^;

    if (SelEnd - SelStart > 0) then
     begin
      Delete(S, SelStart + 1, SelEnd - SelStart);

      CurPos:=SelStart;
     end;

    GetClipboardString(D);

    S:=Copy(S, 1, CurPos) + D + Copy(S, CurPos + 1, 255);

    SelStart:=CurPos;

    SelEnd:=CurPos + Length(D);

    if SelEnd > MaxLen then
     SelEnd:=MaxLen;

    Data^:=Copy(S, 1, MaxLen);

    DrawView;

    ClearEvent(Event);
   end;

  inherited HandleEvent(Event);
 end;

{ AtStyle }

function AtStyle(const Index: Longint; var id: Longint; var Name: String): Boolean;
 procedure Style(const Aid: Longint; const AName: String);
  begin
   id:=Aid;
   Name:=AName;

   AtStyle:=True;
  end;
 begin
  if Index = 0 then Style(asNetmail, 'netmail') else
  if Index = 1 then Style(asLocal, 'local') else
  if Index = 2 then Style(asEchomail, 'echomail') else
   AtStyle:=False;
 end;

{ SeekStyle }

function SeekStyle(const id: Longint; var Index: Longint): Boolean;
 begin
  SeekStyle:=True;

  if id = asNetmail then Index:=0 else
  if id = asLocal then Index:=1 else
  if id = asEchomail then Index:=2 else
   SeekStyle:=False;
 end;

end.
