unit jtmDef;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,
     Views,
     Dialogs,

     RStream,
     Thunks,

     Wizard;

const
 MaxValue = {$IFDEF VIRTUALPASCAL} $FFFFFFFF {$ELSE}
                                       $FFFF {$ENDIF};

 AskRegExpAreasDialogDefaults: record
  Expression: String[255];
  Styles, Formats: xWord;
 end = (Expression: '.*'; Styles: asEchomail; Formats: MaxValue);

procedure LoadDialogDefaults(const Name: String; const Dialog: PDialog; const Defaults: Pointer);
procedure StoreDialogDefaults(const Name: String; const Dialog: PDialog);

implementation

{ LoadDialogDefaults }

procedure LoadDialogDefaults(const Name: String; const Dialog: PDialog; const Defaults: Pointer);
 var
  Stream: PRamStream;
  StreamDefaults: Pointer;
 begin
  if Dialog^.DataSize <> 0 then
   begin
    Stream:=New(PRamStream, Init);

    if jt.rf.Get(jt.rf.Common, 'JTM' + OSid + '.' + Name, Stream, StreamLinker) then
     if Dialog^.DataSize <> Stream^.GetSize then
      if Defaults <> nil then
       Dialog^.SetData(Defaults^)
      else
     else
      begin
       GetMem(StreamDefaults, Dialog^.DataSize);

       Stream^.Seek(0);

       Stream^.Read(StreamDefaults^, Stream^.GetSize);

       Dialog^.SetData(StreamDefaults^);

       FreeMem(StreamDefaults, Dialog^.DataSize);
      end
    else
     if Defaults <> nil then
      Dialog^.SetData(Defaults^);

    Dispose(Stream, Done);
   end;
 end;

{ StoreDialogDefaults }

procedure StoreDialogDefaults(const Name: String; const Dialog: PDialog);
 var
  Stream: PRamStream;
  StreamDefaults: Pointer;
 begin
  if Dialog^.DataSize <> 0 then
   begin
    Stream:=New(PRamStream, Init);

    GetMem(StreamDefaults, Dialog^.DataSize);

    Dialog^.GetData(StreamDefaults^);

    Stream^.Write(StreamDefaults^, Dialog^.DataSize);

    FreeMem(StreamDefaults, Dialog^.DataSize);

    jt.rf.Add(jt.rf.common, 'JTM' + OSid + '.' + Name, Stream, StreamLinker);

    Dispose(Stream, Done);
   end;
 end;

end.