unit jtmPerf;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects,

     jtMHLcmn,

     Wizard;

type
 PAreaLink = ^TAreaLink;
 TAreaLink = object(TObject)
  Link, LinkArea: Pointer;

  constructor Init(const ALink, ALinkArea: Pointer);
 end;

 PAreaLinks = ^TAreaLinks;
 TAreaLinks = object(TSortedCollection)
  constructor Init(const Area: Pointer; const ExcludeUplink: Boolean);
  function Compare(Key1, Key2: Pointer): xInteger; virtual;
  function KeyOf(Item: Pointer): Pointer; virtual;
 end;

implementation

{ TAreaLink }

constructor TAreaLink.Init(const ALink, ALinkArea: Pointer);
 begin
  inherited Init;

  Link:=ALink;
  LinkArea:=ALinkArea;
 end;

{ TAreaLinks }

constructor TAreaLinks.Init(const Area: Pointer; const ExcludeUplink: Boolean);
 var
  Link, LinkArea: Pointer;
  Address: TAddress;
  Index: xInteger;
  K: Longint;
 begin
  inherited Init(jt.link.Count, $10);

  Duplicates:=True;

  for K:=0 to jt.link.Count - 1 do
   begin
    Link:=jt.link.At(K);

    LinkArea:=jt.link.SeekArea(Link, Area);

    if (LinkArea <> nil) and jt.link.area.IsSubscribed(LinkArea) then
     Insert(New(PAreaLink, Init(Link, LinkArea)));
   end;

  if ExcludeUplink then
   begin
    jt.area.GetUplink(Area, Address);

    Link:=jt.link.Seek(Address);

    if Link <> nil then
     if Search(Link, Index) then
      AtDelete(Index);
   end;
 end;

function TAreaLinks.Compare(Key1, Key2: Pointer): xInteger;
 begin
  Compare:=CompareLongint(Longint(Key1), Longint(Key2));
 end;

function TAreaLinks.KeyOf(Item: Pointer): Pointer;
 begin
  KeyOf:=PAreaLink(Item)^.Link;
 end;

end.