unit mbAPI;

interface
uses
     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     Objects;

type
 PMessageBaseInterface = ^TMessageBaseInterface;
 TMessageBaseInterface = packed record
  FullName, ShortName: PString;
  FullNameUp, ShortNameUp: PString;
  Name: PString;
  id, AreaType: Longint;
  mbo: Pointer;

  Reserved: array[1..16] of Longint;

  Init: function(const Path: String; const Create: Boolean; const BaseType: TBaseType; var rc: String): Pointer;
  Done: procedure(const mbo: Pointer);
  Netmail: function(const mbo: Pointer): Boolean;
  Add: function(const mbo: Pointer; const Message: Pointer; var rc: String; const Flags: Longint): Boolean;
  Count: function(const mbo: Pointer): Longint;
  Load: function(const mbo: Pointer; const No: Longint; var Message: Pointer; var rc: String; const Flags: Longint): Boolean;
  Store: function(const mbo: Pointer; const No: Longint; const Message: Pointer; var rc: String;
    const Flags: Longint): Boolean;
  Kill: function(const mbo: Pointer; const No: Longint; var rc: String): Boolean;
  NoToGlobal: function(const mbo: Pointer; const No: Longint): Longint;
  GlobalToNo: function(const mbo: Pointer; const Global: Longint): Longint;
  Lock: function(const mbo: Pointer): Boolean;
  Unlock: procedure(const mbo: Pointer);

  LoadLinkInfo: procedure(const mbo: Pointer; var Block: TLoadLinkMessageBaseBlock);
  StoreLinkInfo: procedure(const mbo: Pointer; var Block: TStoreLinkMessageBaseBlock);

  ExtendedOpened: function(const mbo: Pointer; const Operation: Longint; var Data): Boolean;
  Extended: function(const Operation: Longint; var Data): Boolean;

  Pack: procedure(const Path: String; var Block: TPackMessageBaseBlock);
  KillBase: function(const Path: String; var rc: String): Boolean;
  IsBaseExists: function(const Path: String): Boolean;
 end;

{ ! ᫥騥 ⠭   祣 饣  TAreaFormat.Format!
   易  TMessageBaseInterface.AreaType, TMBI ᮮ⢥⢥ 
     jt.area.mbi()  jt.core.mbi() }

const
 atPassthrough                      = $00000000;
 atMSG                              = $00000001;
 atSquish                           = $00000002;
 atJam                              = $00000003;
 atHudson                           = $00000004;
 atSynchronet                       = $00000005;
 atOutlook                          = $00000006;
 atBat                              = $00000007;
 atNNTP                             = $00000008;
 atNew                              = $00000009;

const
 eooGetHighWater                    = $00001000;
 eooSetHighWater                    = $00001001;
 eooNotScannableAttributes          = $00001002;
 eooSetScannedAttributes            = $00001003;
 eooGetLastRead                     = $00001004;
 eooSetLastRead                     = $00001005;

implementation

end.