library mbJam;

uses
     Objects,
     Strings,

     PlugAPI,
     PlugSIDE,

     mbAPI,
     mbPLUG,

     jtMHLcmn,
     jtMHLstm,

     Dos,

     Thunks,

     RStream,

     Wizard,

     mbjmCmn,
     mbjmCore,
     mbjmPack;

const
 mbPlugin               : Pointer = nil;
 mbFullName             : String[3] = 'Jam';
 mbShortName            : String[3] = 'Jam';
 mbFullNameUp           : String[3] = 'JAM';
 mbShortNameUp          : String[3] = 'JAM';
 mbName                 : String[3] = 'JAM';

{ jmbInit }

function jmbInit(const Path: String; const Create: Boolean; const BaseType: TBaseType; var rc: String): Pointer; export;
 begin
  jmbInit:=New(PJamMessageBase, Init(Path, Create, BaseType, rc));
 end;

{ jmbPack }

procedure jmbPack(const Path: String; var Block: TPackMessageBaseBlock); export;
 begin
  PackJamBase(Path, Block);
 end;

{ jmbKillBase }

function jmbKillBase(const Path: String; var rc: String): Boolean; export;
 procedure Kill(const FName: String);
  var
   F: Text;
  begin
   if IOResult <> 0 then;

   Assign(F, FName);

   Erase(F);

   if IOResult <> 0 then
    begin
     SetFAttr(F, Archive);

     Erase(F);

     if not (InOutRes in [0, 2, 3]) then
      begin
       if rc = '' then
        rc:='unable to erase ' + FName + ', rc=#' + Long2Str(InOutRes);

       jt.LogWrite('~', 'Unable to erase ' + FName + ', rc=#' + Long2Str(IOResult));

       jmbKillBase:=False;
      end;
    end;
  end;
 begin
  jmbKillBase:=True;
  rc:='';

  Kill(ForceExtension(AddDot(Path), 'jdt'));
  Kill(ForceExtension(AddDot(Path), 'jhr'));
  Kill(ForceExtension(AddDot(Path), 'jdx'));
  Kill(ForceExtension(AddDot(Path), 'jlr'));
 end;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, 'MessageBaseJam', 2);

  mbPlugin:=Plugin;

  PluginSetup:=True;

  MessageBaseInterface.FullName:=@mbFullName;
  MessageBaseInterface.ShortName:=@mbShortName;
  MessageBaseInterface.FullNameUp:=@mbFullNameUp;
  MessageBaseInterface.ShortNameUp:=@mbShortNameUp;
  MessageBaseInterface.Name:=@mbName;

  MessageBaseInterface.AreaType:=atJam;

  MessageBaseInterface.Init:=jmbInit;
  MessageBaseInterface.Pack:=jmbPack;
  MessageBaseInterface.KillBase:=jmbKillBase;
  MessageBaseInterface.IsBaseExists:=jmbIsBaseExists;

  jt.RegisterMessageBaseInterface(@MessageBaseInterface);
 end;

{ PluginHandleConfigSwitch }

procedure PluginHandleConfigSwitch(const Keyword: String; Value: String; const Linker: Pointer); export;
 begin
  if Keyword = 'FLUSHAFTERADD' then FlushAfterAdd:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'FLUSHAFTERSTORE' then FlushAfterStore:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'HARDDELETE' then HardDelete:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'CLEANREPLYONPACK' then CleanReplyOnPack:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'RENUMBERONPACK' then RenumberOnPack:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'FIXREPLYTHREADSONPACK' then FixReplyThreadsOnPack:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'FIXLASTREADSONPACK' then FixLastreadsOnPack:=jt.linker.ParseBoolean(Linker, Value) else
   jt.linker.Error(Linker, 'syntax error');
 end;

{ PluginHandleCmdlineSwitch }

function PluginHandleCmdlineSwitch(Switch: String): Boolean; export;
 begin
  StUpcaseEx(Switch);

  PluginHandleCmdlineSwitch:=True;

  if Switch = 'FORCEJAMPACK' then ForcePacking:=True else
   PluginHandleCmdlineSwitch:=False;
 end;

exports
 PluginSetup,
 PluginHandleConfigSwitch,
 PluginHandleCmdlineSwitch;

begin
 Assign(Output, '');
 Rewrite(Output);
end.