unit mbjmCmn;

interface
uses
     jtMHLcmn,

     Objects,
     Strings,

     PlugSIDE,

     Wizard;

const
 jamSource              = $0000;
 jamDestination         = $0001;
 jamFrom                = $0002;
 jamTo                  = $0003;
 jamMSGID               = $0004;
 jamREPLY               = $0005;
 jamSubject             = $0006;
 jamPID                 = $0007;
 jamVia                 = $0008;
 jamAttach              = $0009;
 jamFRQ                 = $000B;
 jamUnknown             = $07D0;
 jamSEENBY              = $07D1;
 jamPATH                = $07D2;
 jamFLAGS               = $07D3;

 jamaNone               = $00000000;
 jamaLocal              = $00000001; { Msg created locally }
 jamaTransit            = $00000002; { Msg is in-transit }
 jamaPrivate            = $00000004; { Private }
 jamaReceived           = $00000008; { Read by addressee }
 jamaSent               = $00000010; { Sent to remote }
 jamaKill               = $00000020; { Kill when sent }
 jamaArchiveSent        = $00000040; { Archive when sent }
 jamaHold               = $00000080; { Hold for pick-up }
 jamaCrash              = $00000100; { Crash }
 jamaImmediate          = $00000200; { Send Msg now, ignore restrictions }
 jamaDirect             = $00000400; { Send directly to destination }
 jamaGate               = $00000800; { Send via gateway }
 jamaFRQ                = $00001000; { File request }
 jamaAttach             = $00002000; { File(s) attached to Msg }
 jamaTruncFile          = $00004000; { Truncate file(s) when sent }
 jamaKillFile           = $00008000; { Delete file(s) when sent }
 jamaRRQ                = $00010000; { Return receipt requested }
 jamaARQ                = $00020000; { Confirmation receipt requested }
 jamaOrphan             = $00040000; { Unknown destination }
 jamaEncrypt            = $00080000; { Msg text is encrypted }
 jamaCompress           = $00100000; { Msg text is compressed }
 jamaEscaped            = $00200000; { Msg text is seven bit ASCII }
 jamaFPU                = $00400000; { Force pickup }
 jamaTypeLocal          = $00800000; { Msg is for local use only }
 jamaTypeEcho           = $01000000; { Msg is for conference distribution }
 jamaTypeNet            = $02000000; { Msg is direct network mail }
 jamaNoDisp             = $20000000; { Msg may not be displayed to user }
 jamaLocked             = $40000000; { Msg is locked, no editing possible }
 jamaDeleted            = $80000000; { Msg is deleted }

 JamSubBufferSize       = $4000;

type
 TAttributesMapType = (amtJam, amtJTMHL);

const
 AttributesMap: array[1..13, TAttributesMapType] of Longint =
   ((jamaLocal,    maLocal),
    (jamaTransit,  maTransit),
    (jamaPrivate,  maPrivate),
    (jamaReceived, maReceived),
    (jamaSent,     maSent),
    (jamaKill,     maKill),
    (jamaHold,     maHold),
    (jamaCrash,    maCrash),
    (jamaFRq,      maFRq),
    (jamaAttach,   maAttach),
    (jamaRRq,      maRRq),
    (jamaARq,      maARq),
    (jamaOrphan,   maOrphan));

type
 PJamBaseHeader = ^TJamBaseHeader;
 TJamBaseHeader = packed record
  Signature: array[0..3] of Char;       { JAM<0> }
  CreatedAt: Longint;                   { unixtime }
  ModifyCounter: Longint;               { 1 when created }
  ActiveMessages: Longint;              { 0 when created }
  PasswordCRC32: Longint;               { -1 when created }
  BaseMessageNumber: Longint;           { 1 when created }
  HighWater: Longint;                   { 0 when created }
  Extra: array[1..996] of Char;         { 0s when created }
 end;

 PJamSubField = ^TSubField;
 TJamSubField = packed record
  ID: System.Word;
  Reserved: System.Word;
  Length: Longint;

  { data follows }
 end;

 PJamMessageHeader = ^TJamMessageHeader;
 TJamMessageHeader = packed record
  Signature: array[0..3] of Char;       { 1 }           {   4 }
  Revision: System.Word;                { 1 }           {   2 }
  Reserved: System.Word;                { 1 }           {   2 }
  SubFieldsLength: Longint;             { 1 }           {   4 }
  TimesRead: Longint;                   { 1 }           {   4 } {  16 }
  MSGIDCRC32: Longint;                  { 1 }           {   4 }
  REPLYCRC32: Longint;                  { 1 }           {   4 } {  24 }
  ReplyTo: Longint;                     { 1 }           {   4 }
  ReplyFirst: Longint;                  { 1 }           {   4 }
  ReplyNext: Longint;                   { 1 }           {   4 }
  DateWritten: Longint;                 { 1 }           {   4 }
  DateReceived: Longint;                { 1 }           {   4 }
  DateProcessed: Longint;               { 1 }           {   4 }
  MessageNumber: Longint;               {!!!}           {   4 } {  52 }
  Attributes: Longint;                  { 1 }           {   4 } {  56 }
  Attributes2: Longint;                 { 1 }
  TextOffset: Longint;                  {!!!}
  TextLength: Longint;                  { 1 }
  PasswordCRC32: Longint;               { 1 }
  Cost: Longint;                        { 1 }
 end;

 { 1 - filled by JTMHLToJam }

 { subfields follows after TJamMessageHeader }

 PJamMessageIndex = ^TJamMessageIndex;
 TJamMessageIndex = packed record
  MSGTOCRC: Longint;
  HeaderOffset: Longint;
 end;

 PJamLastRead = ^TJamLastRead;
 TJamLastRead = packed record
  NAMECRC: Longint;
  UserNumber: Longint;
  LastRead: Longint;
  HighRead: Longint;
 end;

 PSubField = ^TSubField;
 TSubField = object(TObject)
  ID: System.Word;
  Data: PChar;

  constructor Init(const AID: System.Word; const AData: PChar);
  constructor InitStr(const AID: System.Word; const AData: String);
  constructor InitPStr(const AID: System.Word; const AData: PString);
  destructor Done; virtual;
 end;

 PSubFields = ^TSubFields;
 TSubFields = object(TCollection)
  function CountSize: Longint;
  function Read(const Stream: PStream; Size: Longint; var rc: String): Boolean;
  function Write(const Stream: PStream): Boolean;
  function Get(const ID: System.Word): PChar;
 end;

const
 FlushAfterAdd          : Boolean       = False;
 FlushAfterStore        : Boolean       = False;

 HardDelete             : Boolean       = True;
 CleanReplyOnPack       : Boolean       = True;
 RenumberOnPack         : Boolean       = True;
 FixReplyThreadsOnPack  : Boolean       = True;
 FixLastreadsOnPack     : Boolean       = True;

 ForcePacking           : Boolean       = False;

function jmbIsBaseExists(const Path: String): Boolean;

implementation

{ TSubField }

constructor TSubField.Init(const AID: System.Word; const AData: PChar);
 begin
  inherited Init;

  ID:=AID;
  Data:=AData;
 end;

constructor TSubField.InitStr(const AID: System.Word; const AData: String);
 begin
  inherited Init;

  ID:=AID;
  Data:=StrAlloc(AData);
 end;

constructor TSubField.InitPStr(const AID: System.Word; const AData: PString);
 begin
  inherited Init;

  ID:=AID;

  if AData = nil then
   Data:=nil
  else
   Data:=StrAlloc(AData^);
 end;

destructor TSubField.Done;
 begin
  StrDispose(Data);

  inherited Done;
 end;

{ TSubFields }

function TSubFields.CountSize: Longint;
 var
  Size: Longint;
 procedure Perform(const SubField: PSubField); far;
  begin
   if SubField^.Data = nil then
    Inc(Size, 8)
   else
    Inc(Size, 8 + StrLen(SubField^.Data));
  end;
 begin
  Size:=0;

  ForEach(@Perform);

  CountSize:=Size;
 end;

function TSubFields.Read(const Stream: PStream; Size: Longint; var rc: String): Boolean;
 var
  ASubField: TJamSubField;
  Data: PChar;
 begin
  while Size > 0 do
   begin
    Stream^.Read(ASubField, SizeOf(ASubField));

    if Stream^.Status <> stOk then
     begin
      rc:='failed to read subfield: rc=' + Long2Str(Stream^.Status);

      Stream^.Reset;

      Read:=False;

      Exit;
     end;

    if ASubField.Length = 0 then
     Data:=nil
    else
     begin
      GetMem(Data, ASubField.Length + 1);

      Stream^.Read(Data[0], ASubField.Length);

      Data[ASubField.Length]:=#0;
     end;

    Insert(New(PSubField, Init(ASubField.ID, Data)));

    Dec(Size, 8 + ASubField.Length);
   end;

  Read:=True;
 end;

function TSubFields.Write(const Stream: PStream): Boolean;
 function Perform(const SubField: PSubField): Boolean; far;
  var
   ASubField: TJamSubField;
  begin
   ASubField.ID:=SubField^.ID;
   ASubField.Reserved:=0;

   if SubField^.Data = nil then
    ASubField.Length:=0
   else
    ASubField.Length:=StrLen(SubField^.Data);

   Stream^.Write(ASubField, SizeOf(ASubField));

   if (Stream^.Status = stOk) and (SubField^.Data <> nil) then
    Stream^.Write(SubField^.Data[0], ASubField.Length);

   Perform:=Stream^.Status <> stOk;
  end;
 begin
  Write:=FirstThat(@Perform) = nil;
 end;

function TSubFields.Get(const ID: System.Word): PChar;
 function Perform(const SubField: PSubField): Boolean; far;
  begin
   Perform:=SubField^.ID = ID;
  end;
 var
  SubField: PSubField;
 begin
  SubField:=FirstThat(@Perform);

  if SubField = nil then
   Get:=nil
  else
   Get:=SubField^.Data;
 end;

{ jmbIsBaseExists }

function jmbIsBaseExists(const Path: String): Boolean;
 begin
  jmbIsBaseExists:=ExistFile(ForceExtension(AddDot(Path), 'jdt')) or
                   ExistFile(ForceExtension(AddDot(Path), 'jhr')) or
                   ExistFile(ForceExtension(AddDot(Path), 'jdx'))
 end;

end.