unit mbmsCmn;

interface
uses
      Objects,

      jtMHLcmn,

      Wizard;

type
 TFidoMessageHeader = packed record
  FromName   : array[0..35] of Char;            { 36 }
  ToName     : array[0..35] of Char;            { 36 }
  Subject    : array[0..71] of Char;            { 72 }
  DateTime   : array[0..19] of Char;            { 20 }
  TimesRead  : System.Word;                     { 02 }
  ToNode     : System.Word;                     { 02 }
  FromNode   : System.Word;                     { 02 }
  Cost       : System.Word;                     { 02 }
  FromNet    : System.Word;                     { 02 }
  ToNet      : System.Word;                     { 02 }
  DateWritten: System.Longint;                  { 04 }
  DateArrived: System.Longint;                  { 04 } { 184 }
  ReplyTo    : System.Word;                     { 02 }
  Attributes : System.Word;                     { 02 } { 188 }
  ReplyNext  : System.Word;                     { 02 }
 end;

 PFidoMessageBaseMap = ^TFidoMessageBaseMap;
 TFidoMessageBaseMap = object(TSortedCollection)
  function Compare(Key1, Key2: Pointer): xInteger; virtual;
  destructor Done; virtual;
 end;

const
 faNone              = $0000;
 faPrivate           = $0001;
 faCrash             = $0002;
 faReceived          = $0004;
 faSent              = $0008;
 faAttach            = $0010;
 faTransit           = $0020;
 faOrphan            = $0040;
 faKill              = $0080;
 faLocal             = $0100;
 faHold              = $0200;
 faFRq               = $0800;
 faRRq               = $1000;
 faRRc               = $2000;
 faARq               = $4000;
 faURq               = $8000;

type
 TAttributesMapType  = (amtFido, amtJTMHL);

const
 AttributesMap: array[1..15, TAttributesMapType] of Longint =
  ((faPrivate,  maPrivate),
   (faCrash,    maCrash),
   (faReceived, maReceived),
   (faSent,     maSent),
   (faAttach,   maAttach),
   (faTransit,  maTransit),
   (faOrphan,   maOrphan),
   (faKill,     maKill),
   (faLocal,    maLocal),
   (faHold,     maHold),
   (faFRq,      maFRq),
   (faRRq,      maRRq),
   (faRRc,      maRRc),
   (faARq,      maARq),
   (faURq,      maURq));

implementation

{ TFidoMessageMap }

function TFidoMessageBaseMap.Compare(Key1, Key2: Pointer): xInteger;
 var
  K1: Longint absolute Key1;
  K2: Longint absolute Key2;
 begin
  Compare:=CompareLongint(K1, K2);
 
{
  if K1 < K2 then Compare:=-1 else
  if K1 > K2 then Compare:=1 else
   Compare:=0;
}
 end;

destructor TFidoMessageBaseMap.Done;
 begin
  DeleteAll;

  inherited Done;
 end;

end.