library mbMSG;

uses
     PlugAPI,
     PlugSIDE,

     mbAPI,
     mbPLUG,

     mbmsCmn,
     mbmsCore,
     mbmsPack,

     Dos,

     Wizard;

const
 mbPlugin               : Pointer = nil;
 mbFullName             : String[6] = '*.msg';
 mbShortName            : String[6] = 'msg';
 mbFullNameUp           : String[6] = '*.MSG';
 mbShortNameUp          : String[6] = 'MSG';
 mbName                 : String[6] = 'MSG';

{ fmbInit }

function fmbInit(const Path: String; const Create: Boolean; const BaseType: TBaseType; var rc: String): Pointer; export;
 begin
  fmbInit:=New(PFidoMessageBase, Init(Path, Create, BaseType, rc));
 end;

{ fmbPack }

procedure fmbPack(const Path: String; var Block: TPackMessageBaseBlock); export;
 begin
  PackFidoBase(Path, Block);
 end;

{ fmbKillBase }

function fmbKillBase(const Path: String; var rc: String): Boolean; export;
 procedure Kill(const FName: String);
  var
   F: Text;
  begin
   if IOResult <> 0 then;

   Assign(F, FName);

   Erase(F);

   if IOResult <> 0 then
    begin
     SetFAttr(F, Archive);

     Erase(F);

     if not (InOutRes in [0, 2, 3]) then
      begin
       if rc = '' then
        rc:='unable to erase ' + FName + ', rc=#' + Long2Str(InOutRes);

       jt.LogWrite('~', 'Unable to erase ' + FName + ', rc=#' + Long2Str(IOResult));

       fmbKillBase:=False;
      end;
    end;
  end;
 var
  SR: SearchRec;
  APath: String;
 begin
  fmbKillBase:=True;
  rc:='';

  APath:=AddBackSlash(Path);

  FindFirst(APath + '*.msg', AnyFile, SR);

  while DosError = 0 do
   begin
    if SR.Attr and (Directory or VolumeID) = 0 then
     Kill(APath + SR.Name);

    FindNext(SR);
   end;

  FindClose(SR);

  Kill(APath + 'lastread');

  if IOResult <> 0 then;

  APath:=RemoveBackSlash(APath);

  RmDir(APath);

  if not (InOutRes in [0, 2, 3]) then
   begin
    fmbKillBase:=False;

    rc:='unable to erase directory ' + Path + ', rc=' + Long2Str(InOutRes);

    jt.LogWrite('~', 'Unable to erase directory ' + Path + ', rc=' + Long2Str(IOResult));
   end;
 end;

{ fmbIsBaseExists }

function fmbIsBaseExists(const Path: String): Boolean; export;
 begin
  fmbIsBaseExists:=ExistDir(Path);
 end;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, 'MessageBaseMSG', 1);

  mbPlugin:=Plugin;

  PluginSetup:=True;

  MessageBaseInterface.FullName:=@mbFullName;
  MessageBaseInterface.ShortName:=@mbShortName;
  MessageBaseInterface.FullNameUp:=@mbFullNameUp;
  MessageBaseInterface.ShortNameUp:=@mbShortNameUp;
  MessageBaseInterface.Name:=@mbName;

  MessageBaseInterface.AreaType:=atMSG;

  MessageBaseInterface.Init:=fmbInit;
  MessageBaseInterface.Pack:=fmbPack;
  MessageBaseInterface.KillBase:=fmbKillBase;
  MessageBaseInterface.IsBaseExists:=fmbIsBaseExists;

  jt.RegisterMessageBaseInterface(@MessageBaseInterface);
 end;

exports
 PluginSetup;

begin
 Assign(Output, '');
 Rewrite(Output);
end.