unit mbmsPack;

interface
uses
     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     Dos,

     Objects,
     Drivers,

     Wizard;

procedure PackFidoBase(Path: String; var Block: TPackMessageBaseBlock);

implementation

{ PackFidoBase }

procedure PackFidoBase(Path: String; var Block: TPackMessageBaseBlock);
 var
  Number, Errors: Longint;
  F: Text;
 function Perform(const Message: Longint): Boolean; far;
  begin
   if Number <> Message then
    begin
     if IOResult <> 0 then;

     Assign(F, Path + Long2Str(Message) + '.msg');
     Rename(F, Path + Long2Str(Number) + '.msg');

     if InOutRes <> 0 then
      begin
       jt.LogWrite('?', jt.area.GetName(Block.Area)^ + ': unable to rename ' +
                                Path + Long2Str(Message) + '.msg to ' +
                                Path + Long2Str(Number) + '.msg, rc=' +
                                       Long2Str(IOResult));

       Inc(Errors);
      end
     else
      Errors:=0;
    end;

   Inc(Number);

   Perform:=(Errors > 10) or Block.Callback(Block.Area, Block.Param, paDoing);
  end;
 var
  Map: PNumbers;
  SR: SearchRec;
  K: Byte;
 begin
  Block.Supported:=True;

  Path:=AddBackSlash(Path);

  Map:=New(PNumbers, Init($1000, $1000));

  FindFirst(Path + '*.msg', AnyFile, SR);

  while DosError = 0 do
   begin
    if SR.Attr and (Dos.Directory or Dos.VolumeID) = 0 then
     begin
      K:=Pos('.', SR.Name);

      if K <> 0 then
       begin
        SR.Name:=Copy(SR.Name, 1, K - 1);

        if Str2Longint(SR.Name, Number) and (Number > 0) then
         Map^.Add(Number);
       end;
     end;

    FindNext(SR);
   end;

  FindClose(SR);

  Errors:=0;
  Number:=1;

  Block.Did:=Map^.FirstThat(@Perform) = nil;

  Dispose(Map, Done);
 end;

end.