library mbSquish;

uses
     Objects,
     Strings,

     PlugAPI,
     PlugSIDE,

     mbAPI,
     mbPLUG,

     jtMHLcmn,
     jtMHLstm,

     Dos,

     Thunks,

     RStream,

     Wizard,

     mbsqCmn,
     mbsqCore,
     mbsqPack;

const
 mbPlugin               : Pointer = nil;
 mbFullName             : String[6] = 'Squish';
 mbShortName            : String[6] = 'Squish';
 mbFullNameUp           : String[6] = 'SQUISH';
 mbShortNameUp          : String[6] = 'SQUISH';
 mbName                 : String[6] = 'SQUISH';

{ smbInit }

function smbInit(const Path: String; const Create: Boolean; const BaseType: TBaseType; var rc: String): Pointer; export;
 begin
  smbInit:=New(PSquishMessageBase, Init(Path, Create, BaseType, rc));
 end;

{ smbPack }

procedure smbPack(const Path: String; var Block: TPackMessageBaseBlock); export;
 begin
  PackSquishBase(Path, Block);
 end;

{ smbKillBase }

function smbKillBase(const Path: String; var rc: String): Boolean; export;
 procedure Kill(const FName: String);
  var
   F: Text;
  begin
   if IOResult <> 0 then;

   Assign(F, FName);

   Erase(F);

   if IOResult <> 0 then
    begin
     SetFAttr(F, Archive);

     Erase(F);

     if not (InOutRes in [0, 2, 3]) then
      begin
       if rc = '' then
        rc:='unable to erase ' + FName + ', rc=#' + Long2Str(InOutRes);

       jt.LogWrite('~', 'Unable to erase ' + FName + ', rc=#' + Long2Str(IOResult));

       smbKillBase:=False;
      end;
    end;
  end;
 begin
  smbKillBase:=True;
  rc:='';

  Kill(ForceExtension(AddDot(Path), 'sqd'));
  Kill(ForceExtension(AddDot(Path), 'sqi'));
  Kill(ForceExtension(AddDot(Path), 'sql'));
 end;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, 'MessageBaseSquish', 2);

  mbPlugin:=Plugin;

  PluginSetup:=True;

  MessageBaseInterface.FullName:=@mbFullName;
  MessageBaseInterface.ShortName:=@mbShortName;
  MessageBaseInterface.FullNameUp:=@mbFullNameUp;
  MessageBaseInterface.ShortNameUp:=@mbShortNameUp;
  MessageBaseInterface.Name:=@mbName;

  MessageBaseInterface.AreaType:=atSquish;

  MessageBaseInterface.Init:=smbInit;
  MessageBaseInterface.Pack:=smbPack;
  MessageBaseInterface.KillBase:=smbKillBase;
  MessageBaseInterface.IsBaseExists:=smbIsBaseExists;

  jt.RegisterMessageBaseInterface(@MessageBaseInterface);

  jt.area.RegisterNotifyAreaDestroyed(Plugin);
 end;

{ PluginShutdown }

procedure PluginShutdown; export;
 begin
  jt.rf.Destroy(SquishResourceFile);
 end;

{ PluginHandleCommand }

procedure PluginHandleCommand(const Command, Param: Longint); export;
 var
  Linker: Pointer absolute Param;
 begin
  if Command = jtpcPluginSectionEnd then
   begin
    if SquishResourceFile = nil then
     jt.linker.Error(Linker, 'LINKERCACHE was not defined');
   end else
  if Command = jtpcanDestroyed then
   jt.rf.Remove(SquishResourceFile, 'SquishLinkerCache.' + jt.area.GetName(Pointer(Param))^);
 end;

{ PluginHandleConfigSwitch }

procedure PluginHandleConfigSwitch(const Keyword: String; Value: String; const Linker: Pointer); export;
 begin
  if Keyword = 'FLUSHAFTERADD' then FlushAfterAdd:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'FLUSHAFTERSTORE' then FlushAfterStore:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'LINKERCACHE' then
   begin
    if SquishResourceFile <> nil then
     jt.linker.Error(Linker, 'redefinition of LINKERCACHE');

    SquishResourceFile:=jt.rf.Create(jt.linker.ParseStringToken(Linker, Value), rffNone);

    if SquishResourceFile = nil then
     jt.linker.Error(Linker, 'failed to initialize LINKERCACHE');
   end
  else
   jt.linker.Error(Linker, 'syntax error');
 end;

exports
 PluginSetup,
 PluginShutdown,
 PluginHandleCommand,
 PluginHandleConfigSwitch;

begin
 Assign(Output, '');
 Rewrite(Output);
end.