{&StdCall-,OrgName+}
library Outbound;

{ todo:

  1. netmail packing (bundles)
  2. netmailappend: in session & afterflush - where is the difference?
}

uses
     PlugSIDE,
     PlugAPI,

     Objects,

     Wizard,

     OutbCmn,
     OutbOB,
     OutbCche,
     OutbSess,
     OutbQue,

     ccAPI;

{ omlParse }

procedure omlParse(var Block: TomlParseBlock);
 var
  Token, TokenU: String;
  Flavour: TobFlavour;
  Mode: TobMode;
  Format, Outprocessor: Pointer;
 begin
  Mode:=DistinguishMode(Block.om);

  Token:=jt.GetCommaToken(Block.id);

  jt.st.Add(Block.st, obomlQueue, Pointer(1), nil);
  jt.st.Add(Block.st, obomlFlavour, Pointer(ofNormal), nil);
  jt.st.Add(Block.st, obomlPackEchomail, Pointer(1), nil);

  while Token <> '' do
   begin
    TokenU:=StUpcase(Token);

    if Copy(TokenU, 1, 7) = 'FORMAT:' then
     begin
      Delete(TokenU, 1, 7);

      Format:=jt.fmt.w.Seek(TokenU);

      if Format = nil then
       begin
        Block.rc:='unknown format writer "' + TokenU + '"';

        Exit;
       end;

      jt.st.Add(Block.st, obomlFormat, Format, nil);
     end else
    if Copy(TokenU, 1, 8) = 'OUTPROC:' then
     begin
      Delete(TokenU, 1, 8);

      Outprocessor:=jt.fmt.op.Seek(TokenU);

      if Outprocessor = nil then
       begin
        Block.rc:='unknown format outprocessor "' + TokenU + '"';

        Exit;
       end;

      jt.st.Add(Block.st, obomlOutprocessor, Outprocessor, nil);
     end else
    if TokenU = 'NEVERINQUEUE' then jt.st.Add(Block.st, obomlQueue, Pointer(0), nil) else
    if TokenU = 'KILL' then jt.st.Add(Block.st, obomlKill, Pointer(1), nil) else
    if TokenU = 'NOPACKECHOMAIL' then jt.st.Add(Block.st, obomlPackEchomail, Pointer(0), nil) else
    if TokenU = 'ALWAYSNEWBUNDLE' then jt.st.Add(Block.st, obomlAlwaysNewBundle, Pointer(1), nil) else
    if Copy(TokenU, 1, 4) = 'DIR:' then
     begin
      if Mode <> omBox then
       begin
        Block.rc:='DIR: parameter acceptable only for BOX mode';

        Exit;
       end;

      Token:=FExpand(Copy(Token, 5, 255));

      if not jt.CreateDirectory(Token) then
       begin
        Block.rc:='unable to create directory ' + Token;

        Exit;
       end;

      jt.st.Add(Block.st, obomlDirectory, jt.NewStr(Token), jt.svc.stString);
     end else
    if Copy(TokenU, 1, 8) = 'FLAVOUR:' then
     begin
      Delete(TokenU, 1, 8);

      if (TokenU = 'H') or (TokenU = 'HOLD') then Flavour:=ofHold else
      if (TokenU = 'N') or (TokenU = 'NORMAL') then Flavour:=ofNormal else
      if (TokenU = 'D') or (TokenU = 'DIR') or (TokenU = 'DIRECT') then Flavour:=ofDirect else
      if (TokenU = 'C') or (TokenU = 'CRA') or (TokenU = 'CRASH') then Flavour:=ofCrash else
      if (TokenU = 'I') or (TokenU = 'IMM') or (TokenU = 'IMMEDIATE') then Flavour:=ofImmediate else
       begin
        Block.rc:='unknown flavour "' + TokenU + '"';

        Exit;
       end;

      if not (Flavour in ob[Mode].Flavours) then
       begin
        Block.rc:=ob[Mode].Name + ' does not allow flavour ' + obfName[Flavour];

        Exit;
       end;

      jt.st.Add(Block.st, obomlFlavour, Pointer(Flavour), nil);
     end
    else
     begin
      Block.rc:='unknown parameter "' + Token + '"';

      Exit;
     end;

    Token:=jt.GetCommaToken(Block.id);
   end;

  if (Block.om = ob[omBOX].om) and (jt.st.Get(Block.st, obomlDirectory) = nil) then
   begin
    Block.rc:='DIR:pathname expected';

    Exit;
   end;

  if ob[Mode].Kill then
   jt.st.Add(Block.st, obomlKill, Pointer(1), nil);

  Inc(ob[Mode].Refs);

  Block.Done:=True;
 end;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 var
  obMode: TobMode;
  vars: Pointer;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, obName, obVersion);

  obPlugin:=Plugin;

  for obMode:=Low(obMode) to High(obMode) do
   begin
    ob[obMode].om:=jt.om.Register(ob[obMode].Name, obPlugin);

    if ob[obMode].om = nil then
     begin
      jt.SetError('"' + ob[obMode].Name + '" already registered');

      Break;
     end;
   end;

  InitCCAPI;

  if ccAvailable then
   begin
    ccoaQueueBeforePack:=New(PccHook, Init('OAQUEUEBEFOREPACK'));
    ccoaQueuePack:=New(PccHook, Init('OAQUEUEPACK'));

    with ccoaQueuePack^ do
     begin
      AddConstant('PACKETFNAME', etString);
      AddConstant('BUNDLEFNAME', etString);
      AddConstant('LINK', etNumber);
     end;
   end;

  PluginSetup:=True;
 end;

{ PluginStartup }

procedure PluginStartup; export;
 var
  K: TobMode;
 begin
  obErrors:=New(POutboundErrors, Init($10, $10));

  obSessions:=New(PSessions, Init($10, $10));

  InitBundleNameCache;

  for K:=Low(TobMode) to High(TobMode) do
   if (ob[K].Root <> nil) and (ob[K].Refs <> 0) then
    if ob[K].Root^ = '' then
     begin
      jt.SetError(Long2Str(ob[K].Refs) + ' reference(s) to ' + ob[K].Name + ' when no ' + ob[K].Name + ' root defined ' +
       '(check plugins.ctl#' + obName + ')');

      Exit;
     end
    else
     if not jt.CreateDirectory(ob[K].Root^) then
      begin
       jt.SetError('unable to create directory ' + ob[K].Root^);

       Exit;
      end;

  if PacketsQueue = '' then
   begin
    jt.SetError('plugins.ctl#fts.PacketsQueue not defined');

    Exit;
   end;

  if not jt.CreateDirectory(PacketsQueue) then
   begin
    jt.SetError('unable to create directory ' + PacketsQueue);

    Exit;
   end;

  jt.EnqueueCommand(obPlugin, obFlushQueue, 0, cwBeforeShutdown);

  if FlushQueueAfterToss then
   jt.EnqueueCommand(obPlugin, obFlushQueue, 0, cwAfterToss);
 end;

{ PluginShutdown }

procedure PluginShutdown; export;
 begin
  DoneBundleNameCache;

  Dispose(obSessions, Done);

  Dispose(obErrors, Done);

  if ccAvailable then
   begin
    Dispose(ccoaQueuePack, Done);
    Dispose(ccoaQueueBeforePack, Done);
   end;

  obErrors:=nil;
 end;

{ PluginHandleCommand }

procedure PluginHandleCommand(const Command, Param: Longint); export;
 procedure DumpError(const Error: PString); far;
  begin
   if Error <> nil then
    jt.Report(Error^, True);
  end;
 begin
  if Command = jtpcomsExportMessage then omsExportMessage(PomsExportMessageBlock(Param)^) else
  if Command = jtpcomsGetBusy then omsGetBusy(PomsGetBusyBlock(Param)^) else
  if Command = jtpcomsSetBusy then omsSetBusy(PomsSetBusyBlock(Param)^) else
  if Command = jtpcomsInit then omsInit(PomsInitBlock(Param)^) else
  if Command = jtpcomlParse then omlParse(PomlParseBlock(Param)^) else
  if Command = jtpcomsDone then omsDone(PomsDoneBlock(Param)^) else
  if Command = obFlushQueue then FlushQueue;

  if (obErrors <> nil) and (obErrors^.Count > 0) then
   begin
    obErrors^.ForEach(@DumpError);

    obErrors^.FreeAll;
   end;
 end;

{ PluginHandleConfigSwitch }

procedure PluginHandleConfigSwitch(const Keyword: String; Value: String; const Linker: Pointer); export;
 begin
  if Keyword = 'PACKETSQUEUE' then PacketsQueue:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'BSO' then RootBSO:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'TBOX' then RootTBOX:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'LBSO' then RootLBSO:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'TLBOX' then RootTLBOX:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'LBOX' then RootLBOX:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'ASO' then RootASO:=AddBackSlash(FExpand(jt.linker.ParseStringToken(Linker, Value))) else
  if Keyword = 'FLUSHQUEUEAFTERTOSS' then FlushQueueAfterToss:=jt.linker.ParseBoolean(Linker, Value) else
  if Keyword = 'BUNDLENAMECASE' then
   begin
    Value:=jt.linker.ParseWord(Linker, Value);

    StUpcaseEx(Value);

    if Value = 'LOWER' then BundleNameCase:=bncLower else
    if Value = 'UPPER' then BundleNameCase:=bncUpper else
     jt.linker.Error(Linker, 'invalid value "' + Value + '" of BUNDLENAMECASE switch');
   end
  else
   jt.linker.Error(Linker, 'unknown keyword');
 end;

{ PluginHandleCmdlineSwitch }

function PluginHandleCmdlineSwitch(Switch: String): Boolean; export;
 begin
  StUpcaseEx(Switch);

  PluginHandleCmdlineSwitch:=True;

  if Switch = 'HOLDPACK' then HoldPack:=True else
   PluginHandleCmdlineSwitch:=False;
 end;

{ PluginShowHelp }

procedure PluginShowHelp; export;
 begin
  jt.PrintStr(' HOLDPACK         do not perform packing in this run'#13#10);
 end;

exports
 PluginSetup,
 PluginStartup,
 PluginShutdown,
 PluginHandleCommand,
 PluginHandleConfigSwitch,
 PluginHandleCmdlineSwitch;

begin
 Assign(Output, '');
 Rewrite(Output);
end.
