unit OutbSess;

{
  姠.

  ᯮp netmail'.

  0 = startup
  1 = opennetmailwriter
  2 = writing
  3 = closenetmailwriter
  4 = queue

  ExportNetmailMessage:
  BSO/LBSO/ASO:
   0. if (busy) queue=1
   1. if (queue) create_pkt_in_queue
      if !(queue) append/create_?ut
   2. perform writing
   3. if (queue) close_pkt_in_queue
                 if !(busy) append/create_?ut
      if !(queue) close_?ut
   4. if !(busy) append/create_?ut

  TBOX/BOX/TLBOX/LBOX
    1. if (queue) create_pkt_in_queue
       if !(queue) create_pkt_in_box_root
    2. perform writing
    3. if (queue) close_pkt_in_queue;
                  move_to_box_root
       if !(queue) close_pkt_in_box_root
    4. boxes're never being busy ;)
}

{$IFDEF VIRTUALPASCAL}
 {$DEFINE LFN}
{$ENDIF}

interface
uses
     Objects,
     Dos,

     OutbCmn,

     ccAPI,

     PlugAPI,
     PlugSIDE,

     jtMHLcmn,

     OutbCche,

     Wizard;

type
 PZeroBundles = ^TZeroBundles;
 TZeroBundles = object(TStringCollection)
  procedure Add(const FName: String);
  procedure Kill(var Changed: Boolean; const OutboundFiles: PCollection);
 end;

 PSession = ^TSession;
 TSession = object(TObject)
  Outprocessor: PFormatOutprocessor;
  FromAddress: TAddress;
  ToAddress: TAddress;
  Password: String;
  Flavour: TobFlavour;
  Writer: PFormatWriter;
  Flags: Longint;
  Mode: TobMode;
  Link: Pointer;
  oml: Pointer;
  om: Pointer;
  ob: PObject;

  constructor Init(const Aoml: Pointer; const AFromAddress, AToAddress: TAddress; const APassword: String);
  destructor Done; virtual;
 public
  function GetBusy: Boolean; virtual;
  function SetBusy(const Busy: Boolean): Boolean; virtual;
  function ExportMessage(const msg: Pointer): Boolean; virtual;
 public
  NetmailWriter, EchomailWriter: Pointer;
  NetmailFName, EchomailFName: String;
  NetmailDirectly: Boolean;

  function CreateOutbound: Boolean;
  function ExportNetmailMessage(const msg: Pointer): Boolean;
  function ExportEchomailMessage(const msg: Pointer): Boolean;
  function CreateEchomailWriter: Boolean;
  procedure DestroyEchomailWriter;
  function CreateNetmailWriter: Boolean;
  procedure DestroyNetmailWriter;
  procedure MoveToQueue(const FName: String);
  procedure MoveToRoot(var FName: String);
  procedure Outprocess(Source: String; const Pack: Boolean);
  procedure ThinkInBundleName(var Bundle: String; var Add: Boolean; var OutboundFiles, ZeroBundles: PCollection;
   const Force: Boolean);
  procedure ThinkOutBundleName(var Bundle: String; var Add: Boolean; var OutboundFiles, ZeroBundles: PCollection;
   const Success: Boolean; OutboundFilesChanged: Boolean; const ForceKill: Boolean);
  function AppendNetmail(const Source: String; const Reader: PFormatReader): Boolean;
 end;

 PSessions = ^TSessions;
 TSessions = object(TCollection)
  procedure FreeItem(Item: Pointer); virtual;
 public
  function Using(FName: String): Boolean;
 end;

type
 TNameFormat = (nfCRC, nfHash);

const
 BundleNameCase         : (bncUpper, bncLower) = bncLower;

 LastBundleChars        : String[36]           = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';

 DefaultNameFormat                             = nfCRC;

 obSessions             : PSessions            = nil;

implementation
uses
     OutbOB;

{ rol }

{$IFDEF VIRTUALPASCAL}
function rol(Value: Longint): Longint; assembler;
 asm
  mov eax, [Value]

  rol eax, 1
 end;
{$ELSE}
function rol(Value: Longint): Longint; assembler;
 asm
  mov dx, word ptr Value+2
  mov ax, word ptr Value

  rol dx, 1
  rol ax, 1
 end;
{$ENDIF}

{ TZeroBundles }

procedure TZeroBundles.Add(const FName: String);
 var
  Index: xInteger;
 begin
  if (FName <> '') and not Search(@FName, Index) then
   AtInsert(Index, NewStr(FName));
 end;

procedure TZeroBundles.Kill(var Changed: Boolean; const OutboundFiles: PCollection);
 procedure Perform(const FName: PString); far;
  function Lookup(const OutboundFile: POutboundFile): Boolean; far;
   begin
    Lookup:=StUpcase(FName^) = StUpcase(OutboundFile^.FName^);
   end;
  var
   OutboundFile: POutboundFile;
   F: Text;
  begin
   if GetFileSize(FName^) = 0 then
    begin
     if IOResult <> 0 then;

     Assign(F, FName^);

     Erase(F);

     if InOutRes <> 0 then
      jt.LogWrite(obLetterError, 'Unable to kill ' + FName^ + ', rc=' + Long2Str(IOResult))
     else
      begin
       OutboundFile:=POutboundFiles(OutboundFiles)^.FirstThat(@Lookup);

       if OutboundFile <> nil then
        begin
         OutboundFiles^.Free(OutboundFile);

         Changed:=True;
        end;
      end;
    end;
  end;
 begin
  ForEach(@Perform);

  FreeAll;
 end;

{ TSession }

constructor TSession.Init(const Aoml: Pointer; const AFromAddress, AToAddress: TAddress; const APassword: String);
 var
  omlst: Pointer;
 begin
  inherited Init;

  oml:=Aoml;

  omlst:=jt.om.l.st(oml);

  om:=jt.om.l.OM(oml);

  FromAddress:=AFromAddress;
  ToAddress:=AToAddress;

  Password:=APassword;

  Flavour:=TobFlavour(jt.st.Get(omlst, obomlFlavour));

  if not CreateOutbound then
   begin
    inherited Done;

    Fail;
   end;

  Flags:=osfNone or (Longint(jt.om.l.Hash(oml)) shl 16);

  Writer:=jt.st.Get(omlst, obomlFormat);

  if Writer = nil then
   Writer:=jt.fmt.DefaultFormatWriter;

  Outprocessor:=jt.st.Get(omlst, obomlOutprocessor);

  if Outprocessor = nil then
   Outprocessor:=jt.fmt.DefaultFormatOutprocessor;

  if LongBool(jt.st.Get(omlst, obomlQueue)) then Inc(Flags, osfQueue);
  if LongBool(jt.st.Get(omlst, obomlKill)) then Inc(Flags, osfKill);
  if LongBool(jt.st.Get(omlst, obomlPackEchomail)) then Inc(Flags, osfPackEchomail);
  if LongBool(jt.st.Get(omlst, obomlAlwaysNewBundle)) then Inc(Flags, osfAlwaysNewBundle);

  Link:=jt.link.Seek(ToAddress);

  obSessions^.Insert(@Self);
 end;

destructor TSession.Done;
 begin
  obSessions^.Delete(@Self);

  DestroyEchomailWriter;
  DestroyNetmailWriter;

  Dispose(ob, Done);

  inherited Done;
 end;

{ public methods }

function TSession.GetBusy: Boolean;
 begin
  GetBusy:=POutbound(ob)^.GetBusy;
 end;

function TSession.SetBusy(const Busy: Boolean): Boolean;
 begin
  SetBusy:=POutbound(ob)^.SetBusy(Busy);
 end;

function TSession.ExportMessage(const msg: Pointer): Boolean;
 begin
  if jt.msg.GetArea(msg) = nil then
   ExportMessage:=ExportNetmailMessage(msg)
  else
   ExportMessage:=ExportEchomailMessage(msg);
 end;

{ public methods }

function TSession.CreateOutbound: Boolean;
 begin
  Mode:=DistinguishMode(om);

  case Mode of
   omBSO  : ob:=New(PBSO, Init(@Self));
   omTBOX : ob:=New(PTBOX, Init(@Self));
   omBOX  : ob:=New(PBOX, Init(@Self));
   {$IFDEF LFN}
   omLBSO : ob:=New(PLBSO, Init(@Self));
   omTLBOX: ob:=New(PTLBOX, Init(@Self));
   omLBOX : ob:=New(PLBOX, Init(@Self));
   omASO  : ob:=New(PASO, Init(@Self));
   {$ENDIF LFN}
  else
   ob:=nil;
  end;

  CreateOutbound:=ob <> nil;
 end;

function TSession.ExportNetmailMessage(const msg: Pointer): Boolean;
 var
  rc: String;
 begin
  if (NetmailWriter = nil) and not CreateNetmailWriter then
   begin
    ExportNetmailMessage:=False;

    Exit;
   end;

  if not Writer^.Write(NetmailWriter, msg, rc) then
   begin
    jt.Report('Unable to write msg to ' + NetmailFName + ' (' + Writer^.Name^ + '): ' + rc, True);

    ExportNetmailMessage:=False;

    DestroyNetmailWriter;

    Exit;
   end;

  ExportNetmailMessage:=True;
 end;

function TSession.ExportEchomailMessage(const msg: Pointer): Boolean;
 var
  rc: String;
  MaxSize: Longint;
 begin
  if (EchomailWriter = nil) and not CreateEchomailWriter then
   begin
    ExportEchomailMessage:=False;

    Exit;
   end;

  if not Writer^.Write(EchomailWriter, msg, rc) then
   begin
    jt.Report('Unable to write msg to ' + EchomailFName + ' (' + Writer^.Name^ + '): ' + rc, True);

    ExportEchomailMessage:=False;

    DestroyEchomailWriter;

    Exit;
   end;

  if Link <> nil then
   begin
    MaxSize:=jt.link.GetMaxPacketSize(Link);

    if (MaxSize > 0) and (Writer^.GetSize(EchomailWriter) > MaxSize) then
     DestroyEchomailWriter;
   end;

  ExportEchomailMessage:=True;
 end;

function TSession.CreateEchomailWriter: Boolean;
 var
  rc: String;
 begin
  repeat
   if Flags and osfQueue <> 0 then
    EchomailFName:=PacketsQueue + GenerateMSGID + '.' + Writer^.Extension^
   else
    EchomailFName:=POutbound(ob)^.PurePath + GenerateMSGID + '.' + Writer^.Extension^;
  until not ExistFile(EchomailFName);

  EchomailWriter:=Writer^.Create(EchomailFName, rc, FromAddress, ToAddress, Password, Flags or (jt.om.l.Hash(oml) shr 16));

  if EchomailWriter = nil then
   begin
    jt.Report('Unable to create ' + EchomailFName + ' (' + Writer^.Name^ + '): ' + rc, True);

    CreateEchomailWriter:=False;
   end
  else
   CreateEchomailWriter:=True;
 end;

procedure TSession.DestroyEchomailWriter;
 begin
  if EchomailWriter <> nil then
   begin
    Writer^.Close(EchomailWriter);

    EchomailWriter:=nil;

    if Flags and osfQueue = 0 then
     if GetBusy or not SetBusy(True) then
      MoveToQueue(EchomailFName)
     else
      begin
       Outprocess(EchomailFName, True);

       SetBusy(False);
      end;

    EchomailFName:='';
   end;
 end;

function TSession.CreateNetmailWriter: Boolean;
 var
  Queued: Boolean;
  rc: String;
 begin
  NetmailDirectly:=False;
  Queued:=False;

  if Flags and osfQueue = 0 then
   if GetBusy or not SetBusy(True) then
    begin
     repeat
      NetmailFName:=PacketsQueue + GenerateMSGID + '.' + Writer^.Extension^;
     until not ExistFile(NetmailFName);

     Queued:=True;
    end
   else
    begin
     NetmailFName:=POutbound(ob)^.NetmailPacketName;

     if NetmailFName = '' then
      begin
       SetBusy(False);

       repeat
        NetmailFName:=POutbound(ob)^.PurePath + GenerateMSGID + '.' + Writer^.Extension^;
       until not ExistFile(NetmailFName);
      end
     else
      if FileLocked(NetmailFName) then
       begin
        SetBusy(False);

        repeat
         NetmailFName:=PacketsQueue + GenerateMSGID + '.' + Writer^.Extension^;
        until not ExistFile(NetmailFName);

        Queued:=True;
       end
      else
       NetmailDirectly:=True;
    end
  else
   repeat
    NetmailFName:=PacketsQueue + GenerateMSGID + '.' + Writer^.Extension^;
   until not ExistFile(NetmailFName);

  if ExistFile(NetmailFName) then
   NetmailWriter:=Writer^.Append(NetmailFName, rc)
  else
   if Queued then
    NetmailWriter:=Writer^.Create(NetmailFName, rc, FromAddress, ToAddress, Password, Flags or osfNetmail or osfQueue or
     (jt.om.l.Hash(oml) shr 16))
   else
    NetmailWriter:=Writer^.Create(NetmailFName, rc, FromAddress, ToAddress, Password, Flags or osfNetmail and not osfQueue or
     (jt.om.l.Hash(oml) shr 16));

  if NetmailWriter = nil then
   begin
    jt.Report('Unable to create ' + NetmailFName + ' (' + Writer^.Name^ + '): ' + rc, True);

    CreateNetmailWriter:=False;
   end
  else
   CreateNetmailWriter:=True;
 end;

procedure TSession.DestroyNetmailWriter;
 begin
  if NetmailWriter <> nil then
   begin
    Writer^.Close(NetmailWriter);

    NetmailWriter:=nil;

    if NetmailDirectly then
     SetBusy(False);
   end;
 end;

procedure TSession.MoveToQueue(const FName: String);
 var
  rc: Longint;
 begin
  if StUpcase(AddBackSlash(JustPathName(FName))) <> StUpcase(PacketsQueue) then
   begin
    jt.MoveFile(FName, PacketsQueue + JustFileName(FName), rc);

    if rc <> 0 then
     jt.Report('Unable to move ' + FName + ' to ' + PacketsQueue + JustFileName(FName) + ', rc=' + Long2Str(rc), True);
   end;
 end;

procedure TSession.MoveToRoot(var FName: String);
 var
  rc: Longint;
 begin
  if StUpcase(AddBackSlash(JustPathName(FName))) <> StUpcase(POutbound(ob)^.PurePath) then
   begin
    jt.MoveFile(FName, POutbound(ob)^.PurePath + JustFileName(FName), rc);

    if rc <> 0 then
     jt.Report('Unable to move ' + FName + ' to ' +
      POutbound(ob)^.PurePath + JustFileName(FName) + ', rc=' + Long2Str(rc), True)
    else
     FName:=POutbound(ob)^.PurePath + JustFileName(FName);
   end;
 end;

procedure TSession.Outprocess(Source: String; const Pack: Boolean);
 var
  Files, Zeros: PCollection;
  Destination: String;
  Add, Did: Boolean;
 begin
  ThinkInBundleName(Destination, Add, Files, Zeros, False);

  if ccAvailable then
   begin
    ccoaQueuePack^.AddConstant('PACKETFNAME', etString)^.SetString(Source);
    ccoaQueuePack^.AddConstant('BUNDLEFNAME', etString)^.SetString(Destination);
    ccoaQueuePack^.AddConstant('LINK', etNumber)^.SetNumber(Longint(Link));

    ccoaQueuePack^.Execute;
   end;

  if not Pack or (Link = nil) or not Outprocessor^.Outprocess(Source, Destination, jt.link.GetArchiver(Link)) then
   begin
    MoveToRoot(Source);

    Add:=True;

    ThinkOutBundleName(Source, Add, Files, Zeros, True, True, True);
   end
  else
   ThinkOutBundleName(Destination, Add, Files, Zeros, True, False, False);
 end;

procedure TSession.ThinkInBundleName(var Bundle: String; var Add: Boolean; var OutboundFiles, ZeroBundles: PCollection;
  const Force: Boolean);
 var
  CurrentDayOfWeek, PreviousDayOfWeek: Integer;
  GeneralHash, Hash, MaxSize: Longint;
  ThisDateTime: TDateTime;
 procedure Prepare;
  var
   DT: TDateTime;
  begin
   OutboundFiles:=POutbound(ob)^.GetFiles;

   ZeroBundles:=New(PZeroBundles, Init($10, $10));

   GetCurrentDateTime(ThisDateTime);

   Bundle:='';

   { // generate hash }

   GeneralHash:=StringCRC32(AddressToStrEx(FromAddress) + '~' + AddressToStrEx(ToAddress), $FFFFFFFF);

   Hash:=GeneralHash;

   { // calculate this day of week }

   GetCurrentDateTime(DT);

   CurrentDayOfWeek:=DayOfWeek(DT.Year, DT.Month, DT.Day);

   { // and previous day of week }

   PreviousDayOfWeek:=CurrentDayOfWeek - 1;

   if PreviousDayOfWeek < 0 then
    PreviousDayOfWeek:=6;

   { // query maxbundlesize }

   if Link = nil then
    MaxSize:=0
   else
    MaxSize:=jt.link.GetMaxBundleSize(Link);
  end;
 function PerformCase(const S: String): String;
  begin
   case BundleNameCase of
    bncLower: PerformCase:=StLocase(S);
    bncUpper: PerformCase:=StUpcase(S);
   end;
  end;
 function CreateName(const NameFormat: TNameFormat): String;
  begin
   case NameFormat of
    nfCRC: CreateName:=HexL(GeneralHash);
    nfHash:
     begin
      Hash:=rol(Hash);

      CreateName:=HexL(Hash);
     end;
   end;
  end;
 function DayOfWeekName(const DayOfWeek: Integer): String;
  begin
   case DayOfWeek of
    0: DayOfWeekName:='su';
    1: DayOfWeekName:='mo';
    2: DayOfWeekName:='tu';
    3: DayOfWeekName:='we';
    4: DayOfWeekName:='th';
    5: DayOfWeekName:='fr';
    6: DayOfWeekName:='sa';
   else
    DayOfWeekName:='gl';
   end;
  end;
 function LookupThisDayBundle(const OutboundFile: POutboundFile): Boolean; far;
  var
   FileDateTime: Longint;
   DateTime: Dos.DateTime;
  begin
   if (OutboundFile^.Flavour = Flavour) and IsArcmail(OutboundFile^.FName^) then
    begin
     FileDateTime:=GetFileDate(OutboundFile^.FName^);

     if FileDateTime = -1 then
      LookupThisDayBundle:=False
     else
      begin
       UnpackTime(FileDateTime, DateTime);

       LookupThisDayBundle:=(DateTime.Year = ThisDateTime.Year) and
                            (DateTime.Month = ThisDateTime.Month) and
                            (DateTime.Day = ThisDateTime.Day);
      end;
    end
   else
    LookupThisDayBundle:=False;
  end;
 function LookupExists(const OutboundFile: POutboundFile): Boolean; far;
  begin
   LookupExists:=StUpcase(Bundle) = StUpcase(OutboundFile^.FName^);
  end;
 var
  OutboundFile: POutboundFile;
  FileDateTime: DateTime;
  LastBundleChar, K: Byte;
  Size: Longint;
  Distort: Boolean;
  SR: SearchRec;
  Ch: Char;
 begin
  { // prepare }

  Prepare;

  { // looking for last "this day" bundle }

  if (Flags and osfAlwaysNewBundle <> 0) or Force then
   OutboundFile:=nil
  else
   OutboundFile:=OutboundFiles^.LastThat(@LookupThisDayBundle);

  if OutboundFile <> nil then
   begin
    Size:=GetFileSize(OutboundFile^.FName^);

    if Size = -1 then
     OutboundFile:=nil
    else
     if (MaxSize > 0) and (Size > MaxSize) then
      OutboundFile:=nil;

    if (OutboundFile <> nil) and not FileLocked(OutboundFile^.FName^) then
     begin
      Add:=False;

      Bundle:=OutboundFile^.FName^;

      Exit;
     end;
   end;

  { // template for new bundle name }

  Bundle:=POutbound(ob)^.PurePath + PerformCase(CreateName(DefaultNameFormat) + '.' + DayOfWeekName(CurrentDayOfWeek));

  { // lookup for yesterday ZERO bundles }

  FindFirst(ForceExtension(Bundle, DayOfWeekName(PreviousDayOfWeek) + '?'), AnyFile, SR);

  while DosError = 0 do
   begin
    if (SR.Attr and (Directory or VolumeID) = 0) and (Length(JustExtension(SR.Name)) = 3) and (SR.Size = 0) then
     PZeroBundles(ZeroBundles)^.Add(POutbound(ob)^.PurePath + SR.Name);

    FindNext(SR);
   end;

  FindClose(SR);

  { // lookup for "this day" ZERO bundles and last char of name }

  LastBundleChar:=0;

  FindFirst(Bundle + '?', AnyFile, SR);

  while DosError = 0 do
   begin
    if (SR.Attr and (Dos.Directory or Dos.VolumeID) = 0) and (Length(JustExtension(SR.Name)) = 3) then
     begin
      UnpackTime(SR.Time, FileDateTime);

      if (SR.Size = 0) and
         ((FileDateTime.Year <> ThisDateTime.Year) or
          (FileDateTime.Month <> ThisDateTime.Month) or
          (FileDateTime.Day <> ThisDateTime.Day)) then
       PZeroBundles(ZeroBundles)^.Add(POutbound(ob)^.PurePath + SR.Name)
      else
       begin
        if SR.Size = 0 then
         PZeroBundles(ZeroBundles)^.Add(POutbound(ob)^.PurePath + SR.Name);

        Ch:=Upcase(SR.Name[Length(SR.Name)]);

        K:=Pos(Ch, LastBundleChars);

        if K > LastBundleChar then
         LastBundleChar:=K;
       end;
     end;

    FindNext(SR);
   end;

  FindClose(SR);

  { // generate first-time last bundle char }

  Inc(LastBundleChar);

  if LastBundleChar > Length(LastBundleChars) then
   Bundle:=POutbound(ob)^.PurePath + CreateName(nfHash) + '.' + PerformCase(DayOfWeekName(CurrentDayOfWeek) +
    LastBundleChars[1])
  else
   Bundle:=Bundle + PerformCase(LastBundleChars[LastBundleChar]);

  repeat
   { // if this bundle doesn't exists... }

   FindFirst(Bundle, AnyFile, SR);

   Distort:=False;

   if DosError <> 0 then
    if LongBool(jt.st.Get(jt.om.l.st(oml), obomlKill)) and BundleNameCache^.Was(ToAddress, Bundle) then
     Distort:=True
    else
     begin
      FindClose(SR);

      Break;
     end;

   UnpackTime(SR.Time, FileDateTime);

   Size:=SR.Size;

   FindClose(SR);

   { // ouch. however, it's exists... }

   if not Distort and (SR.Size = 0) then
    begin
     PZeroBundles(ZeroBundles)^.Add(Bundle);

     Distort:=True;
    end;

   { // locked? }

   Distort:=Distort or FileLocked(Bundle);

   { // too large bundle for us? }

   Distort:=Distort or ((MaxSize > 0) and (Size > MaxSize));

   { // not "this day" bundle? }

   Distort:=Distort or ((ThisDateTime.Year <> FileDateTime.Year) or
                        (ThisDateTime.Month <> FileDateTime.Month) or
                        (ThisDateTime.Day <> FileDateTime.Day));

   if Distort then
    begin
     { // distort extension, if all lastchars exhausted - create new hashname }

     if not DistortFileExtensionLastLetter(Bundle, True) then
      Bundle:=POutbound(ob)^.PurePath + CreateName(nfHash) + '.' + DayOfWeekName(CurrentDayOfWeek) + LastBundleChars[1];

     { // apply case after distortion }

     Bundle:=AddBackSlash(JustPathName(Bundle)) + PerformCase(JustFileName(Bundle));
    end;
  until not Distort;

  { // check existance in ?lo }

  Add:=OutboundFiles^.FirstThat(@LookupExists) = nil;
 end;

procedure TSession.ThinkOutBundleName(var Bundle: String; var Add: Boolean; var OutboundFiles, ZeroBundles: PCollection;
  const Success: Boolean; OutboundFilesChanged: Boolean; const ForceKill: Boolean);
 var
  FileMode: TobFileMode;
 begin
  if Success then
   begin
    if Add then
     begin
      if ForceKill or LongBool(jt.st.Get(jt.om.l.st(oml), obomlKill)) then
       FileMode:=ofmKill
      else
       FileMode:=ofmTruncate;

      OutboundFiles^.Insert(New(POutboundFile, Init(Flavour, FileMode, Bundle)));

      OutboundFilesChanged:=True;
     end;

    PZeroBundles(ZeroBundles)^.Kill(OutboundFilesChanged, OutboundFiles);

    if OutboundFilesChanged and (POutbound(ob)^.Capabilities and ocSetFiles <> 0) then
     POutbound(ob)^.SetFiles(POutboundFiles(OutboundFiles), True);
   end;

  Dispose(OutboundFiles, Done);

  Dispose(ZeroBundles, Done);
 end;

function TSession.AppendNetmail(const Source: String; const Reader: PFormatReader): Boolean;
 var
  AFrom, ATo: TAddress;
  APassword, rc, Target: String;
  AFlags: Longint;
  NetmailReader, NetmailAppender, msg: Pointer;
  Kill: Boolean;
  F: Text;
 begin
  AppendNetmail:=False;

  Target:=POutbound(ob)^.NetmailPacketName;

  if ExistFile(Target) then
   NetmailAppender:=Writer^.Append(Target, rc)
  else
   NetmailAppender:=Writer^.Create(Target, rc, FromAddress, ToAddress, Password, Flags or osfNetmail);

  if NetmailAppender = nil then
   begin
    jt.Report('Unable to append netmail packet - failed to append/create ' + Target + ' (' + Writer^.Name^ + '): ' + rc, True);

    Exit;
   end;

  NetmailReader:=Reader^.Open(Source, rc, AFrom, ATo, APassword, AFlags);

  if NetmailReader = nil then
   begin
    jt.Report('Unable to append netmail packet - failed to open ' + Source + ' (' + Reader^.Name^ + '): ' + rc, True);

    Exit;
   end;

  Kill:=False;

  repeat
   if not Reader^.Read(NetmailReader, msg, rc) then
    begin
     jt.Report('Unable to append netmail packet - failed to read ' + Source + ' (' + Reader^.Name^ + '): ' + rc, True);

     Break;
    end;

   if msg = nil then
    begin
     AppendNetmail:=True;

     Kill:=True;

     Break;
    end;

   if not Writer^.Write(NetmailAppender, msg, rc) then
    begin
     jt.Report('Unable to append netmail packet - failed to write ' + Target + ' (' + Writer^.Name^ + '): ' + rc, True);

     jt.msg.Destroy(msg);

     Break;
    end;

   jt.msg.Destroy(msg);
  until False;

  Writer^.Close(NetmailAppender);
  Reader^.Close(NetmailReader);

  if Kill then
   begin
    if IOResult <> 0 then;

    Assign(F, Source);

    Erase(F);

    if InOutRes <> 0 then
     jt.LogWrite('!', 'Failed to erase ' + Source + ', rc=' + Long2Str(IOResult));
   end;
 end;

{ TSessions }

procedure TSessions.FreeItem(Item: Pointer);
 begin
 end;

{ public methods }

function TSessions.Using(FName: String): Boolean;
 function CheckUsing(const Session: PSession): Boolean; far;
  begin
   CheckUsing:=(StUpcase(Session^.EchomailFName) = FName) or
               (StUpcase(Session^.NetmailFName) = FName);
  end;
 begin
  StUpcaseEx(FName);

  Using:=FirstThat(@CheckUsing) <> nil;
 end;

end.
