unit PackPack;

interface
uses
     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     Wizard;

var
 Roller: TRoller;

function PackArea(const Area: Pointer; var BeforePack, AfterPack: Longint; const Current, Total: Longint): Boolean;

function PackAreaCallback(const Area: Pointer; const Param: Pointer; const Action: TPackAreaAction): Boolean; export;

implementation

type
 PPackAreaBlock = ^TPackAreaBlock;
 TPackAreaBlock = packed record
  Current, Total: Longint;
  Timer: Longint;
 end;

{ PackStatus }

procedure PackStatus(const Action: TPackAreaAction; const Area: Pointer; const Block: TPackAreaBlock);
 var
  Percent: String;
 begin
  Percent:=jt.Percent(Block.Current, Block.Total);

  case Action of
   paStarting: jt.SetTitle(jt.area.GetName(Area)^ + ' ' + Percent + ' (opening)');
   paDoing: jt.SetTitle(jt.area.GetName(Area)^ + ' ' + Percent + ' (packing)');
   paFinishing: jt.SetTitle(jt.area.GetName(Area)^ + ' ' + Percent + ' (closing)');
  end;

  if Action = paDoing then
   jt.SetStatus(jt.area.GetName(Area)^ + ' ' + Percent + ' ' + Roller.GetRoller)
  else
   jt.SetStatus(jt.area.GetName(Area)^ + ' ' + Percent);
 end;

{ PackAreaCallback }

function PackAreaCallback(const Area: Pointer; const Param: Pointer; const Action: TPackAreaAction): Boolean;
 const
  Timeout = 100;
 var
  Block: PPackAreaBlock absolute Param;
 begin
  case Action of
   paLocked:
    begin
     jt.LogWrite('?', jt.area.GetName(Area)^ + ' is locked, packing holded');

     PackAreaCallback:=False;
    end;
   paUnsupported: PackAreaCallback:=False;
   paStarting, paFinishing:
    begin
     PackStatus(Action, Area, Block^);

     PackAreaCallback:=True;
    end;
   paDoing:
    if Clock - Block^.Timer > Timeout then
     begin
      PackStatus(Action, Area, Block^);

      Block^.Timer:=Clock;

      PackAreaCallback:=jt.Cancelled;
     end
    else
     PackAreaCallback:=False;
  end;
 end;

{ PackArea }

function PackArea(const Area: Pointer; var BeforePack, AfterPack: Longint; const Current, Total: Longint): Boolean;
 var
  Block: TPackAreaBlock;
 begin
  Block.Current:=Current;
  Block.Total:=Total;
  Block.Timer:=Clock;

  PackArea:=jt.area.Pack(Area, BeforePack, AfterPack, PackAreaCallback, @Block);
 end;

end.