unit PlugSIDE;

interface
uses
     Objects,
     Strings,

     Wizard,

     Thunks,

     jtMHLcmn;

const             { area actions }
 aaCreated      = $00000001;

                  { area style }
 asUndefined    = $00000000;
 asNetmail      = $00000001;
 asLocal        = $00000002;
 asEchomail     = $00000004;

                  { area format }
 afPassthrough  = $00000000;

                  { restriction flags }
 rsNone         = $00000000;
 rsMinus        = $00000001;
 rsValue        = $00000002;
 rsStorage      = $00000004;
 rsIsExists     = $00000008;

                  { listex flags }
 lefNormal      = $00000000;
 lefSort        = $00000001;
 lefUpcase      = $00000002;
 lefInclude     = $00000004;
 lefOptimize    = $00000008; { obsolete }
 lefDuplicates  = $00000010;
 lefSimple      = $00000020;
 lefTreatIncludeAsWildcards     = $00000040;

                  { toss source }
 tsInbound      = $00000000;
 tsTempInbound  = $00000001;
 tsBadInbound   = $00000002;
 tsBaseInbound  = $00000003;
 tsLocalInbound = $00000004;

                  { resource file flags }
 rffNone        = $00000000;
 rffManualPack  = $00000001;
 rffForcedPack  = $00000002;

                          { msg clone flags }
 mcfCloneFromToEtc      = $00000001; { msg from, to, subj, attrs, datetime }
 mcfCloneStorage        = $00000002; { msg storage }
 mcfCloneText           = $00000004; { msg body }
 mcfCloneArea           = $00000008; { msg area }

 mcfCloneAll            = mcfCloneFromToEtc or mcfCloneStorage or mcfCloneText or mcfCloneArea;
 mcfCloneHeader         = mcfCloneAll and not mcfCloneText;

                          { SetChanged flags / links }
 lcfChanged             = $00000001;
 lcfFull                = $00000002; { while the same as lcfChanged, maybe later? :}

                          { SetChanged flags / areas }
 acfChanged             = $00000001;
 acfFull                = $00000002; { causes full export (incl. areaexp & so one) }

 acsMaxLength           = 4;         { RWPU }

type
 PPString = ^PString;
 PPointer = ^Pointer;
 PBoolean = ^Boolean;

 PPluginInformation = ^TPluginInformation;
 TPluginInformation = record
  Name: String;
  Version: Longint;
  KernelVersion: Longint;
  APIVersion: Longint;
 end;

 TPluginSetup = function(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean;
 TPluginStartup = procedure;
 TPluginShutdown = procedure;
 TPluginHandleCmdlineSwitch = function(Switch: String): Boolean;
 TPluginHandleCommand = procedure(const Command, Param: Longint);
 TPluginHandleConfigSwitch = procedure(const Keyword: String; Value: String; const Linker: Pointer);
 TPluginShowHelp = procedure;
 TPluginHandleAreaSwitch = function(const Area: Pointer; const Keyword: String; Value: String; const Linker: Pointer): Boolean;
 TPluginHandleLinkSwitch = function(const Link: Pointer; const Keyword: String; Value: String; const Linker: Pointer): Boolean;
 TPluginExportAreaSwitches = procedure(const Area, Linker: Pointer);
 TPluginExportLinkSwitches = procedure(const Area, Linker: Pointer);
 TPluginExportAreasHeader = procedure(const Linker: Pointer);
 TPluginExportLinksHeader = procedure(const Linker: Pointer);

 TStorageAction = (saDestroy, saClone, saInfo);

 PStorageService = ^TStorageService;
 TStorageService = function(const Action: TStorageAction; const Data: Pointer): Pointer;

 TRestrictionValueParser = procedure(const Keyword, Linker, st: Pointer; Value: String);
 TRestrictionCallback = function(const st, Param: Pointer; const Value: String): Boolean;

 TBaseType = (btNetmail, btEchomail, btLocal);

 PAreaActionType = ^TAreaActionType;
 TAreaActionType = Longint;

 TPackAreaAction = (paLocked, paUnsupported, paStarting, paDoing, paFinishing);
 TPackAreaCallback = function(const Area: Pointer; const Param: Pointer; const Action: TPackAreaAction): Boolean;

 PPackMessageBaseBlock = ^TPackMessageBaseBlock;
 TPackMessageBaseBlock = packed record
  Supported: Boolean;                   { filled by message base plugin }
  Did: Boolean;                         { filled by message base plugin }
  Area: Pointer;                        { filled by caller }
  Callback: TPackAreaCallback;          { filled by caller }
  Param: Pointer;                       { filled by caller }
  BeforePack, AfterPack: Longint;       { filled by message base plugin }
 end;

 TDisposeLoadLinkMessageBase = procedure(const Additional: Pointer);
 TAddLoadLinkMessageBase = function(const Param: Pointer; const No, Global, MSGIDCRC, REPLYCRC: Longint;
   const Additional: Pointer): Boolean;

 PLoadLinkMessageBaseBlock = ^TLoadLinkMessageBaseBlock;
 TLoadLinkMessageBaseBlock = packed record
  Supported: Boolean;                      { filled by message base plugin }
  Did: Boolean;                            { filled by message base plugin }
  Param: Pointer;                          { filled by caller }
  Dispose: TDisposeLoadLinkMessageBase;    { filled by message base plugin }
  Add: TAddLoadLinkMessageBase;            { filled by caller }
  Flags: Longint;                          { filled by message base plugin }
  BranchLimit: Longint;                    { filled by message base plugin }
  Area: Pointer;                           { filled by caller }
 end;

 TStoreLinkMessageBaseCallback = function(const Param: Pointer): Boolean;

 PStoreLinkMessageBaseBlock = ^TStoreLinkMessageBaseBlock;
 TStoreLinkMessageBaseBlock = packed record
  Supported: Boolean;                      { filled by message base plugin }
  Did: Boolean;                            { filled by message base plugin }
  Count: Longint;                          { filled by caller }
  Items: PItemList;                        { filled by caller }
  Root: Pointer;                           { filled by caller }
  Callback: TStoreLinkMessageBaseCallback; { filled by caller }
  Param: Pointer;                          { filled by caller }
 end;

 PLogWriteBlock = ^TLogWriteBlock;
 TLogWriteBlock = packed record
  Symbol: Char;
  Message: PString;
  Core: Boolean;
 end;

 PSetStatusBlock = ^TSetStatusBlock;
 TSetStatusBlock = packed record
  Status: PString;
  Suffix: PString;
  Core: Boolean;
 end;

 PClearStatusBlock = ^TClearStatusBlock;
 TClearStatusBlock = packed record
  Core: Boolean;
 end;

 PCancelledBlock = ^TCancelledBlock;
 TCancelledBlock = packed record
  Cancelled: Boolean;
  Core: Boolean;
 end;

 PAreaFormat = ^TAreaFormat;
 TAreaFormat = record
  Style, Format: Longint;
  Path: String;
 end;

 TTossMessage = procedure(msg: Pointer);
 TTossMessageToLinks = procedure(const Amsg, Area, ALink: Pointer);
 TTossToBadmail = procedure(const Amsg: Pointer; const Reason: String);


 PCommandWhen = ^TCommandWhen;
 TCommandWhen = (cwBeforePlugins,       { before plugins.ctl parse }

                 cwPluginsLoaded,       { after all plugins started up }

                 cwBeforeStartup,
                 cwStartup,
                 cwAfterStartup,

                 cwEarliest,            { here you may start to work }

                 cwBeforeToss,
                 cwToss,                { tosser works here }
                 cwScan,                { scanner works here }
                 cwAfterToss,           { here outbounds flushes queue }

                 cwPurge,               { purger works here }
                 cwLink,                { linkor works here }

                 cwLatest,              { here you _must_ stop to work }

                 cwBeforeFlush,         { while you may call tossmessage... }
                 cwFlush,               { here outbounds flushes queue,
                                          NO tossmessage calls from this
                                          moment! }

                 cwBeforeExport,        { before configs export }
                 cwExportAreas,         { if areas changed }
                 cwExportAreasFull,     { if areas changed FULL }
                 cwExportLinks,         { if links changed }
                 cwExportLinksFull,     { if links changed FULL }
                 cwAfterExport,         { after configs export }

                 cwBeforeShutdown,
                 cwShutdown,
                 cwAfterShutdown
                );

 TLinkPassword = (lpIn, lpOut);

 PTechInfo = ^TTechInfo;
 TTechInfo = packed record
  Net, Node: System.Integer;
 end;

 PLinkAreaCallbackBlock = ^TLinkAreaCallbackBlock;
 TLinkAreaCallbackBlock = packed record
  Value: Boolean;
  linkarea, link, area: Pointer;
 end;

 PomlParseBlock = ^TomlParseBlock;
 TomlParseBlock = packed record
  Done: Boolean;
  om: Pointer;
  oml: Pointer;
  id: String;
  rc: String;
  st: Pointer;
 end;

 PomsInitBlock = ^TomsInitBlock;
 TomsInitBlock = packed record
  oml: Pointer;
  st: Pointer;
  Session: Pointer;
  FromAddress: TAddress;
  ToAddress: TAddress;
  Password: String;
  Done: Boolean;
 end;

 PomsDoneBlock = ^TomsDoneBlock;
 TomsDoneBlock = packed record
  oml: Pointer;
  st: Pointer;
  Session: Pointer;
  Address: TAddress;
 end;

 PomsGetBusyBlock = ^TomsGetBusyBlock;
 TomsGetBusyBlock = packed record
  oml: Pointer;
  st: Pointer;
  Session: Pointer;
  Busy: Boolean;
 end;

 PomsSetBusyBlock = ^TomsSetBusyBlock;
 TomsSetBusyBlock = packed record
  oml: Pointer;
  st: Pointer;
  Session: Pointer;
  Busy: Boolean;
  Done: Boolean;
 end;

 PomsExportMessageBlock = ^TomsExportMessageBlock;
 TomsExportMessageBlock = packed record
  oml: Pointer;
  st: Pointer;
  Session: Pointer;
  msg: Pointer;
  Done: Boolean;
 end;

 PCallbacks = ^TCallbacks;
 TCallbacks = object(TCollection)
  constructor Init(const AName: String);
  constructor Clone(const Source: PCallbacks);
  destructor Done; virtual;
  procedure FreeItem(Item: Pointer); virtual;
  procedure Insert(Item: Pointer); virtual;
  procedure Simple(const Command, Param: Longint);
  function ChainedBoolean(const Command: Longint; const Param: Pointer; const Invert: Boolean): Pointer;
  function ChainedPointer(const Command: Longint; const Param: Pointer; const Invert: Boolean): Pointer;
  procedure Add(const Plugin: Pointer);
 private
  Name: PString;
  Debug, DebugFixed: Boolean;

  procedure CheckDebug;
  procedure DebugWrite(const S: String);
 end;

 PServiceBlock = ^TServiceBlock;
 TServiceBlock = packed record
  Done: Boolean;
  Command, Value: String;
  Param: Longint;

  Result: Longint;

  Error: Boolean;
  RC: String;
 end;

 PFormatWriter = ^TFormatWriter;

 PFormatReader = ^TFormatReader;
 TFormatReader = packed record
  Extension: PString; { no dot, upcased }
  Name: PString; { upcased }
  Plugin: Pointer;
  st: Pointer;
  AssociatedWriter: PFormatWriter;

  Open: function(const FName: String; var rc: String; var FromA, ToA: TAddress; var Password: String;
   var Flags: Longint): Pointer;
  Read: function(const reader: Pointer; var msg: Pointer; var rc: String): Boolean;
  GetSize: function(const reader: Pointer): Longint;
  GetPos: function(const reader: Pointer): Longint;
  Close: procedure(const reader: Pointer);
  Ident: function(const FName: String): Boolean;
  IsOur: function(const FName: String): Boolean;
 end;

 TFormatWriter = packed record
  Extension: PString; { no dot, upcased }
  Name: PString; { upcased }
  Plugin: Pointer;
  st: Pointer;
  AssociatedReader: PFormatReader;

  Create: function(const AFName: String; var rc: String; const FromA, ToA: TAddress; const Password: String;
   const Flags: Longint): Pointer;
  Append: function(const AFName: String; var rc: String): Pointer;
  Write: function(const writer: Pointer; const msg: Pointer; var rc: String): Boolean;
  GetSize: function(const writer: Pointer): Longint;
  Close: procedure(const writer: Pointer);
 end;

 PFormatPreprocessor = ^TFormatPreprocessor;
 TFormatPreprocessor = packed record
  Name: PString; { upcased }
  Plugin: Pointer;
  st: Pointer;

  Preprocess: function(const FName: String): Boolean;
  IsOur: function(const FName: String): Boolean;
 end;

 PFormatOutprocessor = ^TFormatOutprocessor;
 TFormatOutprocessor = packed record
  Name: PString; { upcased }
  Plugin: Pointer;
  st: Pointer;

  Outprocess: function(const Source, Destination: String; const Archiver: Pointer): Boolean;
 end;

 PStrings = ^TStrings;
 TStrings = object(TCollection)
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PAddresses = ^TAddresses;
 TAddresses = object(TCollection)
  function Seek(const Address: TAddress): PAddress; virtual;
  procedure Add(const Address: TAddress); virtual;
  procedure FreeItem(Item: Pointer); virtual;
 end;

const
 jtpcNothing                    = $0000;

                                  { general }
 jtpcPluginLoaded               = $0001;
 jtpcExecuteService             = $0002;
 jtpcExportAreas                = $0003;

                                  { linker }
 jtpcValidateRestriction        = $0010;
 jtpcAreaSectionStart           = $0011;
 jtpcAreaSectionEnd             = $0012;
 jtpcLinkSectionStart           = $0013;
 jtpcLinkSectionEnd             = $0014;
 jtpcPluginSectionStart         = $0015;
 jtpcPluginSectionEnd           = $0016;

                                  { linkarea hooks }
 jtpcIsReadable                 = $0020;
 jtpcIsWriteable                = $0021;
 jtpcIsPassive                  = $0022;
 jtpcIsSubscribed               = $0023;

                                  { toss // oml }
 jtpcomlParse                   = $0030;

                                  { toss // oms }
 jtpcomsInit                    = $0040;
 jtpcomsDone                    = $0041;
 jtpcomsGetBusy                 = $0042;
 jtpcomsSetBusy                 = $0043;
 jtpcomsExportMessage           = $0044;

                                  { area notify }
 jtpcanCreated                  = $0050;
 jtpcanChanged                  = $0051;
 jtpcanDestroyed                = $0052;

                                  { screen hooks }
 jtpcLogWrite                   = $0060;
 jtpcSetStatus                  = $0061;
 jtpcClearStatus                = $0062;
 jtpcCancelled                  = $0063;

function StrAlloc(const S: String): PChar;

function GetTossSourceName(const Source: Longint): String; {*}
function GetCommandWhenName(const When: TCommandWhen): String; {*}

procedure SetupAPI(const JTAPI: Pointer);
procedure SetupPlugInfo(const PlugInfo: PPluginInformation; const Name: String; const Version: Longint);

function stStrings(const Action: TStorageAction; const Data: Pointer): Pointer; export;
function stAddresses(const Action: TStorageAction; const Data: Pointer): Pointer; export;

implementation
uses
     PlugAPI;

{ TCallbacks }

constructor TCallbacks.Init(const AName: String);
 begin
  inherited Init($0, $10);

  Name:=NewStr(AName);
 end;

constructor TCallbacks.Clone(const Source: PCallbacks);
 procedure DoClone(const Plugin: Pointer); far;
  begin
   Insert(Plugin);
  end;
 begin
  inherited Init(Source^.Count, $10);

  Source^.ForEach(@DoClone);
 end;

destructor TCallbacks.Done;
 begin
  DisposeStr(Name);

  inherited Done;
 end;

procedure TCallbacks.FreeItem(Item: Pointer);
 begin
 end;

procedure TCallbacks.Insert(Item: Pointer);
 begin
  if IndexOf(Item) = -1 then
   inherited Insert(Item);
 end;

procedure TCallbacks.Add(const Plugin: Pointer);
 begin
  Insert(Plugin);
 end;

procedure TCallbacks.Simple(const Command, Param: Longint);
 procedure Perform(const Plugin: Pointer); far;
  var
   PluginHandleCommand: TPluginHandleCommand;
  begin
   jt.plugs.GetPluginHandleCommand(Plugin, PluginHandleCommand);

   if Debug then
    DebugWrite(jt.plugs.GetPluginName(Plugin)^);

   PluginHandleCommand(Command, Param);
  end;
 begin
  if Count > 0 then
   begin
    CheckDebug;

    if Debug then
     DebugWrite('simple cmd=' + HexL(Command) + ' param=' + HexL(Param));

    ForEach(@Perform);
   end;
 end;

function TCallbacks.ChainedBoolean(const Command: Longint; const Param: Pointer; const Invert: Boolean): Pointer;
 var
  ChainDone: PBoolean absolute Param;
 function Perform(const Plugin: Pointer): Boolean; far;
  var
   PluginHandleCommand: TPluginHandleCommand;
  begin
   jt.plugs.GetPluginHandleCommand(Plugin, PluginHandleCommand);

   if Debug then
    DebugWrite(jt.plugs.GetPluginName(Plugin)^);

   PluginHandleCommand(Command, Longint(Param));

   if Debug and (ChainDone^ xor Invert) then
    DebugWrite('chain done');

   Perform:=ChainDone^ xor Invert;
  end;
 begin
  CheckDebug;

  if Count > 0 then
   begin
    if Debug then
     DebugWrite('chained bool cmd=' + HexL(Command) + ' param=' + HexPtr(Param) + ' inv=' + Long2Str(Byte(Invert)));

    ChainedBoolean:=FirstThat(@Perform);
   end
  else
   ChainedBoolean:=nil;
 end;

function TCallbacks.ChainedPointer(const Command: Longint; const Param: Pointer; const Invert: Boolean): Pointer;
 var
  ChainDone: PPointer absolute Param;
 function Perform(const Plugin: Pointer): Boolean; far;
  var
   PluginHandleCommand: TPluginHandleCommand;
  begin
   jt.plugs.GetPluginHandleCommand(Plugin, PluginHandleCommand);

   if Debug then
    DebugWrite(jt.plugs.GetPluginName(Plugin)^);

   PluginHandleCommand(Command, Longint(Param));

   if Debug and ((ChainDone^ = nil) xor Invert) then
    DebugWrite('chain done; ptr=' + HexPtr(ChainDone^));

   Perform:=(ChainDone^ = nil) xor Invert;
  end;
 begin
  CheckDebug;

  if Count > 0 then
   begin
    if Debug then
     DebugWrite('chained ptr cmd=' + HexL(Command) + ' param=' + HexPtr(Param) + ' inv=' + Long2Str(Byte(Invert)));

    ChainedPointer:=FirstThat(@Perform);
{
    if Debug then
     DebugWrite('chained ptr cmd=' + HexL(Command) + ' did');
}
   end
  else
   ChainedPointer:=nil;
 end;

{ private methods }

procedure TCallbacks.CheckDebug;
 begin
  if not DebugFixed then
   begin
    DebugFixed:=True;

    if Name <> nil then
     Debug:=LongBool(jt.st.Get(jt.st.globalst, 'DebugCallback.' + Name^));
   end;
 end;

procedure TCallbacks.DebugWrite(const S: String);
 begin
  if Name = nil then
   jt.LogWrite('~', 'cbc: ' + S)
  else
   jt.LogWrite('~', 'cbc(' + Name^ + '): ' + S);
 end;

{ TStrings }

procedure TStrings.FreeItem(Item: Pointer);
 begin
  DisposeStr(Item);
 end;

{ TAddresses }

function TAddresses.Seek(const Address: TAddress): PAddress;
 function Perform(const AAddress: PAddress): Boolean; far;
  begin
   Perform:=AddressEqu(AAddress^, Address);
  end;
 begin
  Seek:=FirstThat(@Perform);
 end;

procedure TAddresses.Add(const Address: TAddress);
 var
  AAddress: PAddress;
 begin
  if Seek(Address) = nil then
   begin
    New(AAddress);

    AAddress^:=Address;

    Insert(AAddress);
   end;
 end;

procedure TAddresses.FreeItem(Item: Pointer);
 begin
  Dispose(PAddress(Item));
 end;

{ StrAlloc }

function StrAlloc(const S: String): PChar;
 var
  P: PChar;
 begin
  GetMem(P, Length(S) + 1);

  StrPCopy(P, S);

  StrAlloc:=P;
 end;

{ GetTossSourceName }

function GetTossSourceName(const Source: Longint): String;
 begin
  case Source of
   tsInbound: GetTossSourceName:='inbound';
   tsTempInbound: GetTossSourceName:='tempinbound';
   tsBadInbound: GetTossSourceName:='badinbound';
   tsBaseInbound: GetTossSourceName:='baseinbound';
   tsLocalInbound: GetTossSourceName:='localinbound';
  else
   GetTossSourceName:='inbound ' + Long2Str(Source);
  end;
 end;

{ GetCommandWhenName }

function GetCommandWhenName(const When: TCommandWhen): String;
 var
  Raw: Integer absolute When;
 begin
  case When of
   cwBeforePlugins: GetCommandWhenName:='cwBeforePlugins';

   cwPluginsLoaded: GetCommandWhenName:='cwPluginsLoaded';

   cwBeforeStartup: GetCommandWhenName:='cwBeforeStartup';
   cwStartup: GetCommandWhenName:='cwStartup';
   cwAfterStartup: GetCommandWhenName:='cwAfterStartup';

   cwEarliest: GetCommandWhenName:='cwEarliest';

   cwBeforeToss: GetCommandWhenName:='cwBeforeToss';
   cwToss: GetCommandWhenName:='cwToss';
   cwScan: GetCommandWhenName:='cwScan';
   cwAfterToss: GetCommandWhenName:='cwAfterToss';

   cwPurge: GetCommandWhenName:='cwPurge';
   cwLink: GetCommandWhenName:='cwLink';

   cwLatest: GetCommandWhenName:='cwLatest';

   cwBeforeFlush: GetCommandWhenName:='cwBeforeFlush';
   cwFlush: GetCommandWhenName:='cwFlush';

   cwBeforeExport: GetCommandWhenName:='cwBeforeExport';
   cwExportAreas: GetCommandWhenName:='cwExportAreas';
   cwExportAreasFull: GetCommandWhenName:='cwExportAreasFull';
   cwExportLinks: GetCommandWhenName:='cwExportLinks';
   cwExportLinksFull: GetCommandWhenName:='cwExportLinksFull';
   cwAfterExport: GetCommandWhenName:='cwAfterExport';

   cwBeforeShutdown: GetCommandWhenName:='cwBeforeShutdown';
   cwShutdown: GetCommandWhenName:='cwShutdown';
   cwAfterShutdown: GetCommandWhenName:='cwAfterShutdown';
  else
   GetCommandWhenName:='unknown ' + Long2Str(Raw);
  end;
 end;

{ SetupAPI }

procedure SetupAPI(const JTAPI: Pointer);
 type
  PJTAPI = ^TJTAPI;
 begin
  jt:=PJTAPI(JTAPI)^;
 end;

{ SetupPlugInfo }

{$I BUILD.INC}

procedure SetupPlugInfo(const PlugInfo: PPluginInformation; const Name: String; const Version: Longint);
 begin
  PlugInfo^.Name:=Name;
  PlugInfo^.Version:=Version;
  PlugInfo^.KernelVersion:=BuildNumber;
  PlugInfo^.APIVersion:=APIVersion;
 end;

{ stStrings }

function stStrings(const Action: TStorageAction; const Data: Pointer): Pointer;
 var
  O: PObject absolute Data;
 begin
  case Action of
   saDestroy: Dispose(O, Done);
   saClone: stStrings:=nil;
   saInfo: stStrings:=jt.NewStr('strings');
  end;
 end;

{ stAddresses }

function stAddresses(const Action: TStorageAction; const Data: Pointer): Pointer;
 var
  O: PObject absolute Data;
 begin
  case Action of
   saDestroy: Dispose(O, Done);
   saClone: stAddresses:=nil;
   saInfo: stAddresses:=jt.NewStr('addresses');
  end;
 end;

end.