unit ScanAPI;

interface
uses
     PlugAPI,
     PlugSIDE;

type
 TScannerAction = (saMessageScanFirst,
                   saMessageScan,
                   saMessageScanLast,

                   saMessageScanGeneral);

 PScanMessageBlock = ^TScanMessageBlock;
 TScanMessageBlock = packed record
  Area: Pointer;
  msg: Pointer;
  Did: Boolean;
 end;

 PRegisterScannerCallbackBlock = ^TRegisterScannerCallbackBlock;
 TRegisterScannerCallbackBlock = packed record
  Plugin: Pointer;
  Action: TScannerAction;
  Next: PRegisterScannerCallbackBlock;
 end;

const
 ScannerActionNames: array[TScannerAction] of PChar = (
                   'saMessageScanFirst',
                   'saMessageScan',
                   'saMessageScanLast',

                   'saMessageScanGeneral');

 scRegisterCallback                     = $5000;

 scMessageScanFirst                     = $5010;
 scMessageScan                          = $5011;
 scMessageScanLast                      = $5012;

 scMessageScanGeneral                   = $5020;

procedure RegisterScannerCallback(const Plugin: Pointer; const Action: TScannerAction);

procedure DisposeScannerCallbacks;

implementation

const
 Blocks: PRegisterScannerCallbackBlock = nil;

{ RegisterScannerCallback }

procedure RegisterScannerCallback(const Plugin: Pointer; const Action: TScannerAction);
 var
  Block: PRegisterScannerCallbackBlock;
 begin
  New(Block);

  Block^.Plugin:=Plugin;
  Block^.Action:=Action;
  Block^.Next:=Blocks;

  jt.EnqueueCommandEx('Scanner', scRegisterCallback, Longint(Block), cwAfterStartup);

  Blocks:=Block;
 end;

{ DisposeScannerCallbacks }

procedure DisposeScannerCallbacks;
 var
  Block, ABlock: PRegisterScannerCallbackBlock;
 begin
  Block:=Blocks;

  while Block <> nil do
   begin
    ABlock:=Block^.Next;

    Dispose(Block);

    Block:=ABlock;
   end;
 end;

end.