unit TossAPI;

interface
uses
     PlugAPI,
     PlugSIDE,

     Objects;

type
 TTosserAction = (taAutoCreateFirst,
                  taAutoCreate,
                  taAutoCreateLast,

                  taAreaCreatedFirst,
                  taAreaCreated,
                  taAreaCreatedLast,

                  taMessageTossFirst,
                  taMessageToss,
                  taMessageTossLast,

                  taMessageTossBaseFirst,
                  taMessageTossBase,
                  taMessageTossBaseLast,

                  taMessageTossToLink,
                  taMessageTossToLinkDistinguishHostOML,

                  taNetmailMessageTossFirst,
                  taNetmailMessageToss,
                  taNetmailMessageTossLast,

                  taMessageTossGeneral,

                  taMessageTossFilter,

                  taMessageTossToLinkNoClone);

 PRegisterTosserCallbackBlock = ^TRegisterTosserCallbackBlock;
 TRegisterTosserCallbackBlock = packed record
  Plugin: Pointer;
  Action: TTosserAction;
  Next: PRegisterTosserCallbackBlock;
 end;

 PTosserAutoCreateBlock = ^TTosserAutoCreateBlock;
 TTosserAutoCreateBlock = packed record
  Done: Boolean;
  Area: Pointer;
  Link: Pointer;
  msg: Pointer;
 end;

 PTossMessageBlock = ^TTossMessageBlock;
 TTossMessageBlock = packed record
  Area: Pointer;
  Link: Pointer;
  msg: Pointer;
 end;

 PTossMessageToLinkBlock = ^TTossMessageToLinkBlock;
 TTossMessageToLinkBlock = packed record
  Link: Pointer;
  msg: Pointer;
 end;

 PNetmailMessageTossBlock = ^TNetmailMessageTossBlock;
 TNetmailMessageTossBlock = packed record
  Done: Boolean;
  msg: Pointer;
 end;

 PTossMessageToLinkDistinguishHostOMLBlock = ^TTossMessageToLinkDistinguishHostOMLBlock;
 TTossMessageToLinkDistinguishHostOMLBlock = packed record
  Link: Pointer;
  msg: Pointer;
  Host: PString;
  oml: Pointer;
 end;

const
 TosserActionNames: array[TTosserAction] of PChar = (
                  'taAutoCreateFirst',
                  'taAutoCreate',
                  'taAutoCreateLast',

                  'taAreaCreatedFirst',
                  'taAreaCreated',
                  'taAreaCreatedLast',

                  'taMessageTossFirst',
                  'taMessageToss',
                  'taMessageTossLast',

                  'taMessageTossBaseFirst',
                  'taMessageTossBase',
                  'taMessageTossBaseLast',

                  'taMessageTossToLink',
                  'taMessageTossToLinkDistinguishHostOML',

                  'taNetmailMessageTossFirst',
                  'taNetmailMessageToss',
                  'taNetmailMessageTossLast',

                  'taMessageTossGeneral',

                  'taMessageTossFilter',

                  'taMessageTossToLinkNoClone');

 { "p" ,   p TossAPI ppp -
    Tosser' }

 tcRegisterCallback                     = $4000;
 tcRegisterSessionHost                  = $4001;

 { ᫥騥  "p"   , ᫨  ppp
   ᮮ⢥騥 callback' }

 { tcAutoCreate* 믮 p ᨭ "⭮"   ⪥
    ᮧ.  ⢥ pp 㪠뢠 㪠⥫ 
   TTosserAutoCreateBlock: Link, msg - ,  p p諮 쬮
    ᠬ 쬮 ᮮ⢥⢥;  砥, ᫨   p訫
   ᮧ ,  Area   p᢮ 㪠⥫  ᮧ ,
    Done ⠢  True; ᫨ p訫  ᮧ - 祣 
    㦭 :) }

 tcAutoCreateFirst                      = $4010; { TTosserAutoCreateBlock }
 tcAutoCreate                           = $4011; { TTosserAutoCreateBlock }
 tcAutoCreateLast                       = $4012; { TTosserAutoCreateBlock }

 { tcAreaCreated* 믮 ᫥ ᯥ譮 ᮧ  p 
   p稪 tcAutoCreate*, pp -  ,    tcAutoCreate*,
    p   }

 tcAreaCreatedFirst                     = $4020; { TTosserAutoCreateBlock }
 tcAreaCreated                          = $4021; { TTosserAutoCreateBlock }
 tcAreaCreatedLast                      = $4022; { TTosserAutoCreateBlock }

 tcMessageTossFirst                     = $4030; { TTossMessageBlock }
 tcMessageToss                          = $4031; { TTossMessageBlock }
 tcMessageTossLast                      = $4032; { TTossMessageBlock }

 tcMessageTossBaseFirst                 = $4040; { TTossMessageBlock }
 tcMessageTossBase                      = $4041; { TTossMessageBlock }
 tcMessageTossBaseLast                  = $4042; { TTossMessageBlock }

 tcMessageTossToLink                    = $4050; { TTossMessageToLinkBlock }
 tcMessageTossToLinkDistinguishHostOML  = $4060; { TTossMessageToLinkDistinguishHostOMLBlock }

 tcNetmailMessageTossFirst              = $4070; { TNetmailMessageTossBlock }
 tcNetmailMessageToss                   = $4071; { TNetmailMessageTossBlock }
 tcNetmailMessageTossLast               = $4072; { TNetmailMessageTossBlock }

 tcMessageTossGeneral                   = $4080; { TTossMessageBlock }

 tcMessageTossFilter                    = $4090; { TTossMessageBlock }

 tcMessageTossToLinkNoClone             = $40A0; { TTossMessageToLinkBlock }

const
 TosserActionCommands: array[TTosserAction] of Longint =
                 (tcAutoCreateFirst,
                  tcAutoCreate,
                  tcAutoCreateLast,

                  tcAreaCreatedFirst,
                  tcAreaCreated,
                  tcAreaCreatedLast,

                  tcMessageTossFirst,
                  tcMessageToss,
                  tcMessageTossLast,

                  tcMessageTossBaseFirst,
                  tcMessageTossBase,
                  tcMessageTossBaseLast,

                  tcMessageTossToLink,
                  tcMessageTossToLinkDistinguishHostOML,

                  tcNetmailMessageTossFirst,
                  tcNetmailMessageToss,
                  tcNetmailMessageTossLast,

                  tcMessageTossGeneral,

                  tcMessageTossFilter,

                  tcMessageTossToLinkNoClone);

{
 RegisterTosserCallback 㦭 뢠  PluginStartup  p㣨 ,
 ,   砥,  p⪨ p p cwAfterStartup
 ( Tosser p  ppp  callback).
}

procedure RegisterTosserCallback(const Plugin: Pointer; const Action: TTosserAction);

{
 DisposeTosserCallbacks 㦭 뢠, ᫨  맢   
 RegisterTosserCallback,   ᮧ memory leak' :)

 뢠 DisposeTosserCallbacks  ᥣ  PluginShutdown.
}

procedure DisposeTosserCallbacks;

{
 RegisterSessionHost 㦭 뢠  pp樨 ᢮  ᨨ
 (ᯮ p ᨭ ᮮ饭  ).

 뢠 RegisterSessionHost 㦭  PluginStartup  p㣨 ,
 ,   砥,  p⪨ p p cwAfterStartup
}

procedure RegisterSessionHost(const Host: String);

implementation

const
 Blocks: PRegisterTosserCallbackBlock = nil;

{ RegisterTosserCallback }

procedure RegisterTosserCallback(const Plugin: Pointer; const Action: TTosserAction);
 var
  Block: PRegisterTosserCallbackBlock;
 begin
  New(Block);

  Block^.Plugin:=Plugin;
  Block^.Action:=Action;
  Block^.Next:=Blocks;

  jt.EnqueueCommandEx('Tosser', tcRegisterCallback, Longint(Block), cwAfterStartup);

  Blocks:=Block;
 end;

{ DisposeTosserCallbacks }

procedure DisposeTosserCallbacks;
 var
  Block, ABlock: PRegisterTosserCallbackBlock;
 begin
  Block:=Blocks;

  while Block <> nil do
   begin
    ABlock:=Block^.Next;

    Dispose(Block);

    Block:=ABlock;
   end;
 end;

{ RegisterSessionHost }

procedure RegisterSessionHost(const Host: String);
 begin
  jt.EnqueueCommandEx('Tosser', tcRegisterSessionHost, Longint(jt.NewStr(Host)), cwAfterStartup);
 end;

end.