unit TossBad;

interface
uses
     PlugAPI,
     PlugSIDE,

     Thunks,

     TossTB,
     TossCmn,

     ccAPI,

     jtMHLcmn,

     Wizard;

const
 KludgeAREA     = #1'AREA: ';
 KludgeFROM     = #1'FROM: ';
 KludgeREASON   = #1'REASON: ';

 KludgeAREA2    =   'AREA: ';
 KludgeFROM2    =   'FROM: ';
 KludgeREASON2  =   'REASON: ';

procedure TossToBadmail(const Amsg: Pointer; const Reason: String); export;
procedure TossBadmail;

implementation

{ TossToBadmail }

procedure TossToBadmail(const Amsg: Pointer; const Reason: String);
 var
  msg, msgp, varmsg: Pointer;
  Source, Destination: PStreamThunk;
  Address: PAddress;
  rc: String;
 begin
  TossingStatus('badmail');

  msg:=jt.msg.Clone(Amsg, mcfCloneHeader);

  msgp:=jt.msg.CreateParser(msg, False);

  Address:=jt.st.Get(jt.msg.st(msg), 'Packet.From');

  if Address = nil then
   Address:=@NullAddress;

  jt.msg.p.PutString(msgp, KludgeAREA + jt.msg.GetArea(msg)^);
  jt.msg.p.PutString(msgp, KludgeFROM + AddressToStrEx(Address^));
  jt.msg.p.PutString(msgp, KludgeREASON + Reason);

  Source:=New(PStreamThunk, Init(jt.msg.GetText(Amsg), jt.StreamLinker, False));
  Destination:=New(PStreamThunk, Init(jt.msg.GetText(msg), jt.StreamLinker, False));

  Source^.Seek(0);
  Destination^.Seek(Destination^.GetSize);
  Destination^.CopyFrom(Source^, Source^.GetSize);

  Dispose(Destination, Done);
  Dispose(Source, Done);

  jt.msg.DestroyParser(msgp);

  if ccAvailable then
   with cctaBadMessageToss^ do
    begin
     AddVariable('MSG', etNumber)^.SetNumber(Longint(msg));

     Execute;

     msg:=Pointer(AddVariable('MSG', etNumber)^.GetNumber);
    end;

  if msg <> nil then
   begin
    if not TossToBase(msg, jt.area.SeekBadmail, rc) then
     begin
      jt.LogWrite('?', 'Failed to toss to ' + jt.area.GetName(jt.area.SeekBadmail)^ + ': ' + rc + ', recycling via ' +
       GetTossSourceName(tsBaseInbound));

      Recycle(BaseRecycler, BaseRecyclerSessions, msg);
     end;

    jt.msg.Destroy(msg);
   end;
 end;

{ TossBadmail }

procedure TossBadmail;
 var
  AreaToKill, FromToKill, ReasonToKill: String;
 procedure RemoveKludgePrefix(var ToKill, S: String);
  var
   K: Byte;
  begin
   K:=Pos(':', S);

   if K <> 0 then
    begin
     ToKill:=S;

     Delete(S, 1, K);

     TrimEx(S);
    end;
  end;
 var
  mb, msg, msgp, st: Pointer;
  rc, Area, From, Reason, Password: String;
  Countdown, No: Longint;
  FromAddress, ToAddress: TAddress;
  SourceArea, SourceLink: Pointer;
 begin
  if not jt.area.Lock(jt.area.SeekBadmail, mb, rc) then
   begin
    jt.LogWrite('?', 'Failed to open ' + jt.area.GetName(jt.area.SeekBadmail)^ + ': ' + rc);

    Exit;
   end;

  CheckTossingStarted;

  Countdown:=jt.mb.Count(mb);

  jt.LogWrite('T', #0'Tossing ' + jt.area.GetName(jt.area.SeekBadmail)^ + ' (' + Long2Str(Countdown) + ' msgs)');

  No:=0;

  while Countdown > 0 do
   begin
    if jt.mb.Load(mb, No, msg, rc, mfNone) then
     begin
      msgp:=jt.msg.CreateParser(msg, False);

      if (jt.msg.p.GetKludge(msgp, KludgeAREA, Area) or jt.msg.p.GetKludge(msgp, KludgeAREA2, Area)) and
         (jt.msg.p.GetKludge(msgp, KludgeFROM, From) or jt.msg.p.GetKludge(msgp, KludgeFROM2, From)) and
         (jt.msg.p.GetKludge(msgp, KludgeREASON, Reason) or jt.msg.p.GetKludge(msgp, KludgeREASON2, Reason)) then
       begin
        RemoveKludgePrefix(AreaToKill, Area);
        RemoveKludgePrefix(FromToKill, From);
        RemoveKludgePrefix(ReasonToKill, Reason);

        ClearAddress(FromAddress);

        if not StrToAddress(From, FromAddress) then
         begin
          jt.LogWrite('?', 'Invalid @FROM kludge in msg ' + Long2Str(No) + ' of ' + jt.area.GetName(jt.area.SeekBadmail)^);

          jt.msg.DestroyParser(msgp);

          jt.msg.Destroy(msg);

          Inc(No);
         end
        else
         begin
          SourceLink:=jt.link.Seek(FromAddress);

          if SourceLink = nil then
           begin
            jt.LogWrite('?', 'Unknown link ' + AddressToStrEx(FromAddress) + ' in msg ' + Long2Str(No) + ' of ' +
             jt.area.GetName(jt.area.SeekBadmail)^);

            jt.msg.DestroyParser(msgp);

            jt.msg.Destroy(msg);

            Inc(No);
           end
          else
           begin
            jt.msg.SetArea(msg, Area);

            st:=jt.msg.st(msg);

            jt.link.GetAka(SourceLink, ToAddress);
            jt.link.GetInPassword(SourceLink, Password);

            jt.st.Add(st, 'Packet.From', jt.NewAddress(FromAddress), jt.svc.stAddress);
            jt.st.Add(st, 'Packet.To', jt.NewAddress(ToAddress), jt.svc.stAddress);
            jt.st.Add(st, 'Packet.Password', jt.NewStr(Password), jt.svc.stString);
            jt.st.Add(st, 'Source', Pointer(tsInbound), nil);

            if not jt.mb.Kill(mb, No, rc) then
             begin
              jt.LogWrite('?', 'Failed to kill msg#' + Long2Str(No) + ' of ' +
               jt.area.GetName(jt.area.SeekBadmail)^ + ': ' + rc);

              jt.msg.DestroyParser(msgp);

              jt.msg.Destroy(msg);

              Inc(No);
             end
            else
             begin
              jt.msg.p.DeleteKludge(msgp, AreaToKill);
              jt.msg.p.DeleteKludge(msgp, FromToKill);
              jt.msg.p.DeleteKludge(msgp, ReasonToKill);

              jt.msg.DestroyParser(msgp);

              jt.tossscan.TossMessage(msg);
             end;
           end;
         end;
       end
      else
       begin
        jt.msg.DestroyParser(msgp);

        jt.msg.Destroy(msg);
       end;
     end
    else
     begin
      jt.LogWrite('?', 'Failed to open msg#' + Long2Str(No) + ' of ' + jt.area.GetName(jt.area.SeekBadmail)^ + ': ' + rc);

      Inc(No);
     end;

    Dec(Countdown);
   end;

  jt.area.Unlock(jt.area.SeekBadmail, mb);
 end;

end.