unit TossEcho;

interface
uses
     jtMHLcmn,

     PlugAPI,
     PlugSIDE,
     PlugUTIL,

     Objects,

     Wizard,

     TossCmn,
     TossBad,
     TossNet,
     TossACR,
     TossAPI,
     TossTB,
     TossTL;

procedure TossEchomail(Amsg: Pointer);

implementation

const
 Debugger: TDebugger = (Enabled: False; Prefix: 'dbgTEcore');

{ TossEchomail }

procedure TossEchomail(Amsg: Pointer);
 var
  Uplink, LinkArea, AArea, msgst, areast, msgclone: Pointer;
  FromAddress, Address, TempAddress: TAddress;
  Password, AreaName, rc: String;
  PerformCallbacks: Boolean;
  TossStatusPrefix: PString;
  Source: Longint;
  Format: TAreaFormat;
  tmb: TTossMessageBlock;
 procedure CheckPacketFromAndTo;
  var
   st: Pointer;
  begin
   st:=jt.msg.st(tmb.msg);

   if jt.st.Get(st, 'Packet.From') = nil then
    begin
     jt.core.GetMainAddress(TempAddress);

     jt.st.Add(st, 'Packet.From', jt.NewAddress(TempAddress), jt.svc.stAddress);
    end;

   if jt.st.Get(st, 'Packet.To') = nil then
    begin
     jt.core.GetMainAddress(TempAddress);

     jt.st.Add(st, 'Packet.To', jt.NewAddress(TempAddress), jt.svc.stAddress);
    end;
  end;
 begin
  tmb.Area:=nil;
  tmb.Link:=nil;
  tmb.msg:=Amsg;

  msgst:=jt.msg.st(tmb.msg);

  Source:=Longint(jt.st.Get(msgst, 'Source'));

  if (Source = tsBaseInbound) or (Source = tsLocalInbound) then
   begin
    ClearAddress(FromAddress);

    tmb.Link:=nil;
   end
  else
   begin
    CheckPacketFromAndTo;

    FromAddress:=PAddress(jt.st.Get(msgst, 'Packet.From'))^;

    tmb.Link:=jt.link.Seek(FromAddress);

    if tmb.Link = nil then
     begin
      jt.LogWrite('!', 'Unknown link ' + AddressToStrEx(FromAddress));

      Recycle(BadRecycler, BadRecyclerSessions, tmb.msg);

      Exit;
     end;

    jt.link.GetInPassword(tmb.Link, Password);

    if not jt.ComparePasswords(Password, GetPString(jt.st.Get(msgst, 'Packet.Password')), tmb.Link) then
     begin
      jt.LogWrite('!', 'Got wrong pwd "' + GetPString(jt.st.Get(msgst, 'Packet.Password')) + '" from ' +
       AddressToStrEx(FromAddress) + ', expected "' + Password + '"');

      Recycle(BadRecycler, BadRecyclerSessions, tmb.msg);

      Exit;
     end;
   end;

  AreaName:=jt.msg.GetArea(tmb.msg)^;

  tmb.Area:=jt.area.Seek(AreaName);

  if (tmb.Area = nil) and (jt.area.killed.Seek(AreaName) <> nil) then
   begin
    CheckPacketFromAndTo;

    TossToBadmail(tmb.msg, 'dead area');

    Exit;
   end;

  if tmb.Area <> nil then
   begin
    jt.area.GetFormat(tmb.Area, Format);

    if Format.Style = asNetmail then
     begin
      TossNetmail(tmb.msg);

      Exit;
     end;
   end;

  CheckPacketFromAndTo;

  if tmb.Area = nil then
   if (Source = tsBaseInbound) or (Source = tsLocalInbound) then
    begin
     TossToBadmail(tmb.msg, 'unknown area while tossing from ' + GetTossSourceName(Source));

     Exit;
    end
   else
    if not AutoCreate(tmb.msg, tmb.Link, tmb.Area) then
     begin
      TossToBadmail(tmb.msg, 'unknown area');

      Exit;
     end;

  if tmb.Link <> nil then
   begin
    LinkArea:=jt.link.SeekArea(tmb.Link, tmb.Area);

    if (LinkArea = nil) or not jt.link.area.IsSubscribed(LinkArea) then
     begin
      TossToBadmail(tmb.msg, 'link is not subscribed');

      Exit;
     end;

    if not jt.link.area.IsWriteable(LinkArea) then
     begin
      TossToBadmail(tmb.msg, 'link has no access to write in this area');

      Exit;
     end;
   end;

  TossStatusPrefix:=jt.st.Get(msgst, 'TossStatusPrefix');

  if TossStatusPrefix <> nil then
   TossingStatus(TossStatusPrefix^ + ' (' + AreaName + ')')
  else
   TossingStatus(AreaName);

  PerformCallbacks:=not LongBool(jt.st.Get(msgst, 'NoCallbacks'));

  if Debugger.Enabled then
   begin
    Debugger.Log('msg ' + HexPtr(tmb.msg) + '; cbc=' + Long2Str(Byte(PerformCallbacks)) + '; src=' +
     GetTossSourceName(Source));

    Debugger.Log('pickupti');
   end;

  jt.msg.ti.PickupTechInfo(tmb.msg);

  if Debugger.Enabled then
   begin
    Debugger.Log('msg=' + HexPtr(tmb.msg) + '; area=' + HexPtr(tmb.Area) + '; link=' + HexPtr(tmb.Link));

    Debugger.Log('filters');
   end;

  Callbacks[taMessageTossFilter]^.ChainedPointer(tcMessageTossFilter, @tmb, False);

  if Debugger.Enabled then
   Debugger.Log('tossgeneral');

  if tmb.Area <> nil then
   Callbacks[taMessageTossGeneral]^.ChainedPointer(tcMessageTossGeneral, @tmb, False);

  if PerformCallbacks and (tmb.Area <> nil) and (tmb.msg <> nil) then
   case Source of
    tsBaseInbound:;
    tsLocalInbound:
     begin
      if Debugger.Enabled then
       Debugger.Log('doti');

      jt.area.GetUplink(tmb.Area, Address);

      if IsCleanAddress(Address) then
       jt.msg.ti.DoTechInfo(nil, tmb.Area, tmb.msg, nil)
      else
       begin
        Uplink:=jt.link.Seek(Address);

        if Uplink = nil then
         jt.msg.ti.DoTechInfo(nil, tmb.Area, tmb.msg, nil)
        else
         begin
          jt.link.GetAka(Uplink, Address);

          jt.msg.ti.DoTechInfo(nil, tmb.Area, tmb.msg, @Address);
         end;
       end;
     end;
   else
    if Debugger.Enabled then
     Debugger.Log('doti');

    jt.msg.ti.DoTechInfo(tmb.Link, tmb.Area, tmb.msg, nil);
   end;

  if (tmb.Area <> nil) and PerformCallbacks and (Source <> tsBaseInbound) then
   begin
    if Debugger.Enabled then
     Debugger.Log('tossfirst/*/last');

    if Callbacks[taMessageTossFirst]^.ChainedPointer(tcMessageTossFirst, @tmb, False) = nil then
    if Callbacks[taMessageToss]^.ChainedPointer(tcMessageToss, @tmb, False) = nil then
     Callbacks[taMessageTossLast]^.ChainedPointer(tcMessageTossLast, @tmb, False);
   end;

  if tmb.Area <> nil then
   begin
    areast:=jt.area.st(tmb.Area);

    jt.area.GetFormat(tmb.Area, Format);

    Amsg:=tmb.msg;

    if Format.Format <> afPassthrough then
     begin
      if Debugger.Enabled then
       Debugger.Log('tosstbclone');

      msgclone:=jt.msg.Clone(tmb.msg, mcfCloneAll);

      AArea:=tmb.Area;

      tmb.msg:=msgclone;

      if (Source <> tsBaseInbound) and PerformCallbacks then
       begin
        if Debugger.Enabled then
         Debugger.Log('tossbasefirst/*/last');

        if Callbacks[taMessageTossBaseFirst]^.ChainedPointer(tcMessageTossBaseFirst, @tmb, False) = nil then
        if Callbacks[taMessageTossBase]^.ChainedPointer(tcMessageTossBase, @tmb, False) = nil then
         Callbacks[taMessageTossBaseLast]^.ChainedPointer(tcMessageTossBaseLast, @tmb, False);
       end;

      if tmb.Area <> nil then
       begin
        if Debugger.Enabled then
         Debugger.Log('dropti');

        jt.msg.ti.DropTechInfo(msgclone);

        if Debugger.Enabled then
         Debugger.Log('tosstb1');

        if not TossToBase(msgclone, tmb.Area, rc) then
         begin
          if Debugger.Enabled then
           Debugger.Log('tosstb/failed');

          jt.LogWrite('?', 'Failed to toss to ' + jt.area.GetName(tmb.Area)^ + ': ' + rc + ', recycling via ' +
           GetTossSourceName(tsBaseInbound));

          Recycle(BaseRecycler, BaseRecyclerSessions, msgclone);
         end
        else
         begin
          if Debugger.Enabled then
           Debugger.Log('tosstb/ok');

          if not LongBool(jt.st.Get(msgst, 'Don''tAddToImportList')) then
           jt.list.Add(jt.list.ImportList, jt.area.GetName(tmb.Area)^);
         end;
       end;

      jt.msg.Destroy(msgclone);

      tmb.Area:=AArea;
     end;

    if Source <> tsBaseInbound then
     begin
      if Debugger.Enabled then
       Debugger.Log('tosstl: msg=' + HexPtr(Amsg) + '; area=' + HexPtr(tmb.Area) + '; link=' + HexPtr(tmb.Link));

      jt.tossscan.TossMessageToLinks(Amsg, tmb.Area, tmb.Link);
     end;
   end;

  if Debugger.Enabled then
   Debugger.Log('toss/finished');
 end;

end.
