unit TossNet;

interface
uses
     PlugAPI,
     PlugSIDE,

     TossCmn,
     TossAPI,
     TossTB,

     jtMHLcmn,

     Wizard;

procedure TossNetmail(const msg: Pointer);

implementation

{ TossNetmail }

procedure TossNetmail(const msg: Pointer);
 var
  PacketFromEmpty, PacketToEmpty: Boolean;
  msgst, msgp: Pointer;
  FromAddress, ToAddress: TAddress;
  Source: Longint;
  Block: TNetmailMessageTossBlock;
  Area: Pointer;
  rc: String;
 begin
  TossingStatus('netmail');

  if jt.msg.GetArea(msg) = nil then
   Area:=jt.area.SeekNetmail
  else
   begin
    Area:=jt.area.Seek(jt.msg.GetArea(msg)^);

    if Area = nil then
     Area:=jt.area.SeekNetmail;

    jt.msg.SetArea(msg, '');
   end;

  msgst:=jt.msg.st(msg);

  PacketFromEmpty:=jt.st.Get(msgst, 'Packet.From') = nil;
  PacketToEmpty:=jt.st.Get(msgst, 'Packet.To') = nil;

  if PacketFromEmpty or PacketToEmpty then
   begin
    msgp:=jt.msg.CreateParser(msg, True);

    jt.msg.p.GetFromAndToAddress(msgp, FromAddress, ToAddress);

    if PacketFromEmpty then
     jt.st.Add(msgst, 'Packet.From', jt.NewAddress(FromAddress), jt.svc.stAddress);

    if PacketFromEmpty then
     jt.st.Add(msgst, 'Packet.To', jt.NewAddress(ToAddress), jt.svc.stAddress);

    jt.msg.DestroyParser(msgp);
   end;

  Source:=Longint(jt.st.Get(msgst, 'Source'));

  if (Source <> tsBaseInbound) and jt.rests.Check(restProhibitNetmailToss, jt.st.Get(msgst, 'Packet.From'), nil) then
   begin
    Recycle(NetmailRecycler, NetmailRecyclerSessions, msg);

    Exit;
   end;

  if Source <> tsBaseInbound then
   begin
    if Source <> tsLocalInbound then
     jt.msg.SetAttributes(msg, jt.msg.GetAttributes(msg) and not (maCrash or
                                                                  maReceived or
                                                                  maSent or
                                                                  maTransit or
                                                                  maOrphan or
                                                                  maLocal or
                                                                  maHold));

    msgp:=jt.msg.CreateParser(msg, True);

    ClearAddress(ToAddress);

    jt.msg.p.GetToAddress(msgp, ToAddress);

    if not jt.core.IsOurAddress(ToAddress) then
     jt.msg.SetAttributes(msg, jt.msg.GetAttributes(msg) or maTransit);

    jt.msg.DestroyParser(msgp);

    Block.Done:=False;
    Block.msg:=msg;

    if (Callbacks[taNetmailMessageTossFirst]^.ChainedBoolean(tcNetmailMessageTossFirst, @Block, False) <> nil) or
       (Callbacks[taNetmailMessageToss]^.ChainedBoolean(tcNetmailMessageToss, @Block, False) <> nil) or
       (Callbacks[taNetmailMessageTossLast]^.ChainedBoolean(tcNetmailMessageTossLast, @Block, False) <> nil) then
        Exit;
   end;

  if not TossToBase(msg, Area, rc) then
   begin
    jt.LogWrite('?', 'Failed to toss to ' + jt.area.GetName(jt.area.SeekNetmail)^ + ': ' + rc + ', recycling via ' +
     GetTossSourceName(tsBaseInbound));

    Recycle(BaseRecycler, BaseRecyclerSessions, msg);
   end;
 end;

end.