unit TossTL;

interface
uses
     Objects,

     PlugAPI,
     PlugSIDE,

     TossCmn,
     TossAPI,

     jtMHLcmn,

     Wizard;

procedure TossToLinks(const Amsg, Area, ALink: Pointer); export;

implementation

{ TossToLinks }

procedure TossToLinks(const Amsg, Area, ALink: Pointer);
 var
  Clone, First: Boolean;
  msg, msgst: Pointer;
 procedure TossToLink(const Link: Pointer);
  var
   FromAddress, ToAddress: TAddress;
   Password: String;
   Host: PString;
   linkst, LinkArea, oml: Pointer;
   TossMessageToLinkBlock: TTossMessageToLinkBlock;
   TossMessageToLinkDistinguishHostOMLBlock: TTossMessageToLinkDistinguishHostOMLBlock;
   WasInSeenby: Boolean;
   K: Longint;
  begin
   linkst:=jt.link.st(Link);

   WasInSeenby:=LongBool(jt.st.Get(linkst, 'WasInSeenby'));

   jt.st.Remove(linkst, 'WasInSeenby');

   if Link = ALink then
    Exit;

   if WasInSeenby then
    begin
     jt.link.GetAddress(Link, ToAddress);

     if jt.rests.Check(restAlreadyInSeenbyReport, @ToAddress, jt.area.GetName(Area)) then
      jt.LogWrite('>', jt.area.GetName(Area)^ + '  ' + AddressToStrEx(ToAddress) + ': already in seenby');

     Exit;
    end;

   LinkArea:=jt.link.SeekArea(Link, Area);

   if (LinkArea = nil) or
      not jt.link.area.IsSubscribed(LinkArea) or
          jt.link.area.IsPassive(LinkArea) or
      not jt.link.area.IsReadable(LinkArea) then
    Exit;

   if Callbacks[taMessageTossToLinkNoClone]^.Count > 0 then
    begin
     TossMessageToLinkBlock.Link:=Link;
     TossMessageToLinkBlock.msg:=Amsg;

     Callbacks[taMessageTossToLinkNoClone]^.Simple(tcMessageTossToLinkNoClone, Longint(@TossMessageToLinkBlock));
    end;

   { tosstlnoclone call here }

   if Clone then
    begin
     msg:=jt.msg.Clone(Amsg, mcfCloneAll);

     msgst:=jt.msg.st(msg);
    end;

   if Clone or First then
    begin
     jt.msg.ti.DropTechInfo(msg);

     First:=False;
    end;

   jt.link.GetAka(Link, FromAddress);
   jt.st.Add(msgst, 'Packet.From', jt.NewAddress(FromAddress), jt.svc.stAddress);

   jt.link.GetAddress(Link, ToAddress);
   jt.st.Add(msgst, 'Packet.To', jt.NewAddress(ToAddress), jt.svc.stAddress);

   jt.link.GetOutPassword(Link, Password);
   jt.st.Add(msgst, 'Packet.Password', jt.NewStr(Password), jt.svc.stString);

   if Clone then
    begin
     TossMessageToLinkBlock.Link:=Link;
     TossMessageToLinkBlock.msg:=msg;

     Callbacks[taMessageTossToLink]^.Simple(tcMessageTossToLink, Longint(@TossMessageToLinkBlock));
    end;

   TossMessageToLinkDistinguishHostOMLBlock.Link:=Link;
   TossMessageToLinkDistinguishHostOMLBlock.msg:=msg;
   TossMessageToLinkDistinguishHostOMLBlock.Host:=nil;
   TossMessageToLinkDistinguishHostOMLBlock.oml:=nil;

   Callbacks[taMessageTossToLinkDistinguishHostOML]^.Simple(tcMessageTossToLinkDistinguishHostOML,
    Longint(@TossMessageToLinkDistinguishHostOMLBlock));

   if TossMessageToLinkDistinguishHostOMLBlock.Host = nil then
    TossMessageToLinkDistinguishHostOMLBlock.Host:=@DefaultEchomailSessionHost;

   if TossMessageToLinkDistinguishHostOMLBlock.oml = nil then
    TossMessageToLinkDistinguishHostOMLBlock.oml:=jt.link.oml(Link);

   with TossMessageToLinkDistinguishHostOMLBlock do
    RecycleLink(oml, Link, msg, Host^, FromAddress, ToAddress, Password);

   if Clone then
    jt.msg.Destroy(msg);
  end;
 var
  K: Longint;
 begin
  Clone:=Callbacks[taMessageTossToLink]^.Count <> 0;

  if not Clone then
   begin
    msg:=Amsg;

    msgst:=jt.msg.st(msg);

    First:=True;
   end;

  for K:=0 to jt.link.Count - 1 do
   TossToLink(jt.link.At(K));
 end;

end.