library Y2kFixer;

uses
     PlugAPI,
     PlugSIDE,

     TossAPI,

     Dos,

     Objects,

     jtMHLcmn,

     Wizard;

const
 y2kfName                               = 'Y2kFixer';
 y2kfVersion                            = 1;

 y2kfPlugin             : Pointer       = nil;
 y2kfNoBullshit         : Pointer       = nil;

 y2kfGathered           : Boolean       = False;

 y2kfLastYearFactor                     = 1;
 y2kfNextYearFactor                     = 2;

var
 CurYear, CurMonth, CurDay              : xWord;
 CurHour, CurMin, CurSec                : xWord;
 CurTemp                                : xWord;

{ FixMessage }

procedure FixMessage(const msg: Pointer; const Area: Pointer; const Netmail: Boolean);
 function DateTimeToString(const DT: TDateTime): String;
  begin
   DateTimeToString:=lz(DT.Day) + '/' + lz(DT.Month) + '/' + Long2Str(DT.Year) + ' ' +
                     lz(DT.Hour) + ':' + lz(DT.Min) + ':' + lz(DT.Sec);
  end;
 var
  DT, OriginalDT: TDateTime;
  Bullshit: String;
  msgp: Pointer;
  Address, Aka: TAddress;
 begin
  if not y2kfGathered then
   begin
    GetDate(CurYear, CurMonth, CurDay, CurTemp);
    GetTime(CurHour, CurMin, CurSec, CurTemp);

    y2kfGathered:=True;
   end;

  jt.msg.GetWritten(msg, DT);
  jt.msg.GetWritten(msg, OriginalDT);

  with DT do
   begin
    if (Year < CurYear - y2kfLastYearFactor) or (Year > CurYear + y2kfNextYearFactor) then
     Year:=CurYear;

    if Month <  1 then Month:=CurMonth;
    if Month > 12 then Month:=CurMonth;

    if Day   <  1 then Day:=CurDay;
    if Day   > 31 then Day:=CurDay;

    if Hour  <  0 then Hour:=CurHour;
    if Hour  > 23 then Hour:=CurHour;

    if Min   <  0 then Min:=CurMin;
    if Min   > 59 then Min:=CurMin;

    if Sec   <  0 then Sec:=CurSec;
    if Sec   > 59 then Sec:=CurSec;
   end;

  if DateTimeCompare(DT, OriginalDT) <> 0 then
   begin
    Bullshit:='Y2K: ' + DateTimeToString(OriginalDT) + ' -> ' + DateTimeToString(DT);

    jt.LogWrite('2', Bullshit + ' in ' + jt.area.GetName(Area)^);

    if not jt.rests.Check(y2kfNoBullshit, nil, jt.area.GetName(Area)) then
     begin
      msgp:=jt.msg.CreateParser(msg, Netmail);

      if Netmail then
       begin
        ClearAddress(Address);

        jt.msg.p.GetFromAddress(msgp, Address);

        jt.GetNetmailAka(Address, Aka);
       end
      else
       jt.area.GetAka(Area, Aka);

      jt.msg.p.AddKludge(msgp, #1 + Bullshit + ' at ' + AddressToStrEx(Aka));

      jt.msg.DestroyParser(msgp);
     end;

    jt.msg.SetWritten(msg, DT);
   end;
 end;

{ Toss }

procedure Toss(var Block: TTossMessageBlock);
 begin
  if Block.Area <> nil then
   FixMessage(Block.msg, Block.Area, False);
 end;

{ TossNetmail }

procedure TossNetmail(var Block: TNetmailMessageTossBlock);
 begin
  FixMessage(Block.msg, jt.area.SeekNetmail, False);
 end;

{ PluginSetup }

function PluginSetup(const JTAPI: Pointer; const PlugInfo: PPluginInformation; const Plugin: Pointer): Boolean; export;
 begin
  SetupAPI(JTAPI);

  SetupPlugInfo(PlugInfo, y2kfName, y2kfVersion);

  y2kfPlugin:=Plugin;

  y2kfNoBullshit:=jt.rests.Add('y2kNoBullshit', rsMinus);

  PluginSetup:=True;
 end;

{ PluginStartup }

procedure PluginStartup; export;
 begin
  RegisterTosserCallback(y2kfPlugin, taMessageTossLast);
  RegisterTosserCallback(y2kfPlugin, taNetmailMessageTossLast);
 end;

{ PluginShutdown }

procedure PluginShutdown; export;
 begin
  DisposeTosserCallbacks;
 end;

{ PluginHandleCommand }

procedure PluginHandleCommand(const Command, Param: Longint); export;
 begin
  if Command = tcMessageTossLast then Toss(PTossMessageBlock(Param)^) else
  if Command = tcNetmailMessageTossLast then TossNetmail(PNetmailMessageTossBlock(Param)^);
 end;

exports
 PluginSetup,
 PluginStartup,
 PluginShutdown,
 PluginHandleCommand;

begin
 Assign(Output, '');
 Rewrite(Output);
end.
